/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_inst *e = f_new_inst(FI_EMPTY);

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  struct f_inst *s = f_new_inst_da(FI_EA_SET, dyn);
  s->a1.p = e;
  return s;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst(FI_CONSTANT);
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->fi_code == FI_CONSTANT_INDIRECT) {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst(FI_CONSTANT_INDIRECT);
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT_INDIRECT);

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->fi_code = FI_LC_CONSTRUCT;
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_path_mask *t)
{
  struct f_path_mask *tt;
  for (tt = t; tt; tt = tt->next) {
    if (tt->kind == PM_ASN_EXPR) {
      struct f_inst *mrv = f_new_inst(FI_PATHMASK_CONSTRUCT);
      mrv->a1.p = t;
      return mrv;
    }
  }

  NEW_F_VAL;
  val->type = T_PATH_MASK;
  val->val.path_mask = t;

  struct f_inst *rv = f_new_inst(FI_CONSTANT_INDIRECT);
  rv->a1.p = val;

  return rv;
}


/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from ../../proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}


/* Line 371 of yacc.c  */
#line 706 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     NMA = 277,
     DEFINE = 278,
     ON = 279,
     OFF = 280,
     YES = 281,
     NO = 282,
     S = 283,
     MS = 284,
     US = 285,
     PORT = 286,
     LOG = 287,
     SYSLOG = 288,
     ALL = 289,
     DEBUG = 290,
     TRACE = 291,
     INFO = 292,
     REMOTE = 293,
     WARNING = 294,
     ERROR = 295,
     AUTH = 296,
     FATAL = 297,
     BUG = 298,
     STDERR = 299,
     SOFT = 300,
     TIMEFORMAT = 301,
     ISO = 302,
     OLD = 303,
     SHORT = 304,
     LONG = 305,
     BASE = 306,
     NAME = 307,
     CONFIRM = 308,
     UNDO = 309,
     CHECK = 310,
     TIMEOUT = 311,
     LATENCY = 312,
     LIMIT = 313,
     WATCHDOG = 314,
     CONFIGURE = 315,
     DOWN = 316,
     KERNEL = 317,
     PERSIST = 318,
     SCAN = 319,
     TIME = 320,
     LEARN = 321,
     DEVICE = 322,
     ROUTES = 323,
     GRACEFUL = 324,
     RESTART = 325,
     KRT_SOURCE = 326,
     KRT_METRIC = 327,
     MERGE = 328,
     PATHS = 329,
     TABLE = 330,
     METRIC = 331,
     KRT_PREFSRC = 332,
     KRT_REALM = 333,
     KRT_SCOPE = 334,
     KRT_MTU = 335,
     KRT_WINDOW = 336,
     KRT_RTT = 337,
     KRT_RTTVAR = 338,
     KRT_SSTRESH = 339,
     KRT_CWND = 340,
     KRT_ADVMSS = 341,
     KRT_REORDERING = 342,
     KRT_HOPLIMIT = 343,
     KRT_INITCWND = 344,
     KRT_RTO_MIN = 345,
     KRT_INITRWND = 346,
     KRT_QUICKACK = 347,
     KRT_LOCK_MTU = 348,
     KRT_LOCK_WINDOW = 349,
     KRT_LOCK_RTT = 350,
     KRT_LOCK_RTTVAR = 351,
     KRT_LOCK_SSTRESH = 352,
     KRT_LOCK_CWND = 353,
     KRT_LOCK_ADVMSS = 354,
     KRT_LOCK_REORDERING = 355,
     KRT_LOCK_HOPLIMIT = 356,
     KRT_LOCK_RTO_MIN = 357,
     KRT_FEATURE_ECN = 358,
     KRT_FEATURE_ALLFRAG = 359,
     ROUTER = 360,
     ID = 361,
     PROTOCOL = 362,
     TEMPLATE = 363,
     PREFERENCE = 364,
     DISABLED = 365,
     DIRECT = 366,
     INTERFACE = 367,
     IMPORT = 368,
     EXPORT = 369,
     FILTER = 370,
     NONE = 371,
     VRF = 372,
     STATES = 373,
     FILTERS = 374,
     RECEIVE = 375,
     ACTION = 376,
     WARN = 377,
     BLOCK = 378,
     DISABLE = 379,
     KEEP = 380,
     FILTERED = 381,
     PASSWORD = 382,
     FROM = 383,
     PASSIVE = 384,
     TO = 385,
     EVENTS = 386,
     PACKETS = 387,
     PROTOCOLS = 388,
     INTERFACES = 389,
     ALGORITHM = 390,
     KEYED = 391,
     HMAC = 392,
     MD5 = 393,
     SHA1 = 394,
     SHA256 = 395,
     SHA384 = 396,
     SHA512 = 397,
     PRIMARY = 398,
     STATS = 399,
     COUNT = 400,
     FOR = 401,
     COMMANDS = 402,
     PREEXPORT = 403,
     NOEXPORT = 404,
     GENERATE = 405,
     ROA = 406,
     LISTEN = 407,
     BGP = 408,
     V6ONLY = 409,
     DUAL = 410,
     ADDRESS = 411,
     PASSWORDS = 412,
     DESCRIPTION = 413,
     SORTED = 414,
     RELOAD = 415,
     IN = 416,
     OUT = 417,
     MRTDUMP = 418,
     MESSAGES = 419,
     RESTRICT = 420,
     MEMORY = 421,
     IGP_METRIC = 422,
     CLASS = 423,
     DSCP = 424,
     WAIT = 425,
     MAX = 426,
     FLUSH = 427,
     AS = 428,
     SHOW = 429,
     STATUS = 430,
     SUMMARY = 431,
     ROUTE = 432,
     SYMBOLS = 433,
     ADD = 434,
     DELETE = 435,
     DUMP = 436,
     RESOURCES = 437,
     SOCKETS = 438,
     NEIGHBORS = 439,
     ATTRIBUTES = 440,
     EVAL = 441,
     ECHO = 442,
     ENABLE = 443,
     FUNCTION = 444,
     PRINT = 445,
     PRINTN = 446,
     UNSET = 447,
     RETURN = 448,
     ACCEPT = 449,
     REJECT = 450,
     QUITBIRD = 451,
     INT = 452,
     BOOL = 453,
     IP = 454,
     PREFIX = 455,
     PAIR = 456,
     QUAD = 457,
     EC = 458,
     LC = 459,
     SET = 460,
     STRING = 461,
     BGPMASK = 462,
     BGPPATH = 463,
     CLIST = 464,
     ECLIST = 465,
     LCLIST = 466,
     IF = 467,
     THEN = 468,
     ELSE = 469,
     CASE = 470,
     TRUE = 471,
     FALSE = 472,
     RT = 473,
     RO = 474,
     UNKNOWN = 475,
     GENERIC = 476,
     GW = 477,
     NET = 478,
     MASK = 479,
     PROTO = 480,
     SOURCE = 481,
     SCOPE = 482,
     CAST = 483,
     DEST = 484,
     IFNAME = 485,
     IFINDEX = 486,
     LEN = 487,
     DEFINED = 488,
     CONTAINS = 489,
     RESET = 490,
     PREPEND = 491,
     FIRST = 492,
     LAST = 493,
     LAST_NONAGGREGATED = 494,
     MATCH = 495,
     ROA_CHECK = 496,
     EMPTY = 497,
     WHERE = 498,
     BFD = 499,
     MIN = 500,
     IDLE = 501,
     RX = 502,
     TX = 503,
     INTERVAL = 504,
     MULTIPLIER = 505,
     MULTIHOP = 506,
     NEIGHBOR = 507,
     DEV = 508,
     LOCAL = 509,
     AUTHENTICATION = 510,
     SIMPLE = 511,
     METICULOUS = 512,
     SESSIONS = 513,
     HOLD = 514,
     CONNECT = 515,
     RETRY = 516,
     KEEPALIVE = 517,
     STARTUP = 518,
     VIA = 519,
     NEXT = 520,
     HOP = 521,
     SELF = 522,
     DEFAULT = 523,
     PATH = 524,
     START = 525,
     DELAY = 526,
     FORGET = 527,
     AFTER = 528,
     BGP_PATH = 529,
     BGP_LOCAL_PREF = 530,
     BGP_MED = 531,
     BGP_ORIGIN = 532,
     BGP_NEXT_HOP = 533,
     BGP_ATOMIC_AGGR = 534,
     BGP_AGGREGATOR = 535,
     BGP_COMMUNITY = 536,
     BGP_EXT_COMMUNITY = 537,
     RR = 538,
     RS = 539,
     CLIENT = 540,
     CLUSTER = 541,
     AS4 = 542,
     ADVERTISE = 543,
     IPV4 = 544,
     CAPABILITIES = 545,
     PREFER = 546,
     OLDER = 547,
     MISSING = 548,
     LLADDR = 549,
     DROP = 550,
     IGNORE = 551,
     REFRESH = 552,
     INTERPRET = 553,
     COMMUNITIES = 554,
     BGP_ORIGINATOR_ID = 555,
     BGP_CLUSTER_LIST = 556,
     IGP = 557,
     GATEWAY = 558,
     RECURSIVE = 559,
     MED = 560,
     TTL = 561,
     SECURITY = 562,
     DETERMINISTIC = 563,
     SECONDARY = 564,
     ALLOW = 565,
     AWARE = 566,
     LINK = 567,
     EXTENDED = 568,
     SETKEY = 569,
     BGP_LARGE_COMMUNITY = 570,
     LIVED = 571,
     STALE = 572,
     CEASE = 573,
     HIT = 574,
     ADMINISTRATIVE = 575,
     SHUTDOWN = 576,
     PEER = 577,
     CONFIGURATION = 578,
     CHANGE = 579,
     DECONFIGURED = 580,
     CONNECTION = 581,
     REJECTED = 582,
     COLLISION = 583,
     OF = 584,
     MRT = 585,
     FILENAME = 586,
     PERIOD = 587,
     ALWAYS = 588,
     OSPF = 589,
     AREA = 590,
     OSPF_METRIC1 = 591,
     OSPF_METRIC2 = 592,
     OSPF_TAG = 593,
     OSPF_ROUTER_ID = 594,
     RFC1583COMPAT = 595,
     STUB = 596,
     TICK = 597,
     COST = 598,
     COST2 = 599,
     RETRANSMIT = 600,
     HELLO = 601,
     TRANSMIT = 602,
     PRIORITY = 603,
     DEAD = 604,
     TYPE = 605,
     BROADCAST = 606,
     BCAST = 607,
     NONBROADCAST = 608,
     NBMA = 609,
     POINTOPOINT = 610,
     PTP = 611,
     POINTOMULTIPOINT = 612,
     PTMP = 613,
     STRICT = 614,
     CRYPTOGRAPHIC = 615,
     ELIGIBLE = 616,
     POLL = 617,
     NETWORKS = 618,
     HIDDEN = 619,
     VIRTUAL = 620,
     ONLY = 621,
     BUFFER = 622,
     LARGE = 623,
     NORMAL = 624,
     STUBNET = 625,
     TAG = 626,
     EXTERNAL = 627,
     LSADB = 628,
     ECMP = 629,
     WEIGHT = 630,
     NSSA = 631,
     TRANSLATOR = 632,
     STABILITY = 633,
     GLOBAL = 634,
     LSID = 635,
     INSTANCE = 636,
     REAL = 637,
     NETMASK = 638,
     LENGTH = 639,
     LSA = 640,
     SUPPRESSION = 641,
     TOPOLOGY = 642,
     STATE = 643,
     PIPE = 644,
     MODE = 645,
     OPAQUE = 646,
     TRANSPARENT = 647,
     RIP = 648,
     INFINITY = 649,
     UPDATE = 650,
     GARBAGE = 651,
     MULTICAST = 652,
     VERSION = 653,
     SPLIT = 654,
     HORIZON = 655,
     POISON = 656,
     REVERSE = 657,
     ZERO = 658,
     PLAINTEXT = 659,
     RIP_METRIC = 660,
     RIP_TAG = 661,
     STATIC = 662,
     PROHIBIT = 663,
     MULTIPATH = 664,
     BLACKHOLE = 665,
     UNREACHABLE = 666
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 634 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct mrt_dump_data *md;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 1191 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1219 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  72
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3556

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  433
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  278
/* YYNRULES -- Number of rules.  */
#define YYNRULES  993
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1896

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   666

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     424,   425,    29,    27,   429,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   426,   423,
      23,    22,    24,   430,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   431,     2,   432,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   427,     2,   428,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    30,    33,    36,    38,    40,    42,    44,    46,    47,
      49,    51,    52,    55,    58,    60,    62,    65,    68,    70,
      72,    74,    76,    77,    79,    80,    85,    88,    89,    91,
      94,    96,    98,   102,   104,   108,   110,   112,   114,   116,
     118,   120,   122,   124,   126,   131,   135,   137,   139,   141,
     143,   146,   151,   155,   159,   163,   167,   171,   175,   180,
     184,   188,   193,   199,   203,   207,   212,   215,   216,   218,
     219,   221,   224,   227,   228,   231,   234,   238,   241,   245,
     249,   254,   257,   261,   265,   269,   272,   277,   283,   285,
     289,   291,   293,   295,   300,   301,   304,   307,   310,   312,
     314,   320,   321,   323,   327,   331,   332,   341,   343,   348,
     350,   352,   353,   355,   358,   362,   363,   366,   369,   372,
     375,   378,   381,   385,   389,   393,   398,   401,   404,   408,
     411,   414,   416,   418,   420,   421,   424,   427,   430,   433,
     436,   438,   440,   444,   448,   449,   451,   453,   456,   457,
     459,   463,   465,   469,   471,   472,   475,   478,   481,   484,
     488,   492,   496,   502,   503,   507,   509,   511,   515,   517,
     521,   523,   525,   527,   529,   531,   533,   535,   537,   541,
     543,   547,   549,   551,   556,   558,   559,   563,   568,   570,
     573,   574,   580,   586,   592,   598,   603,   608,   613,   618,
     621,   624,   627,   630,   633,   636,   639,   642,   645,   648,
     652,   656,   661,   667,   669,   670,   674,   679,   684,   685,
     688,   692,   696,   700,   703,   706,   709,   712,   716,   720,
     723,   726,   728,   730,   732,   737,   738,   742,   746,   750,
     751,   753,   755,   760,   761,   764,   767,   770,   773,   776,
     779,   782,   783,   786,   796,   806,   811,   815,   819,   823,
     827,   831,   835,   839,   843,   847,   852,   854,   856,   860,
     861,   863,   868,   873,   878,   882,   887,   892,   897,   902,
     905,   907,   909,   911,   913,   914,   916,   917,   922,   925,
     927,   929,   931,   933,   935,   937,   939,   941,   943,   945,
     947,   949,   951,   953,   956,   959,   960,   964,   966,   970,
     972,   974,   976,   979,   983,   986,   991,   992,   998,   999,
    1001,  1003,  1006,  1008,  1012,  1014,  1016,  1018,  1020,  1022,
    1026,  1028,  1030,  1034,  1036,  1038,  1040,  1042,  1048,  1056,
    1062,  1070,  1080,  1088,  1094,  1102,  1108,  1120,  1122,  1124,
    1127,  1129,  1137,  1147,  1155,  1163,  1173,  1181,  1191,  1199,
    1209,  1217,  1233,  1235,  1237,  1239,  1241,  1245,  1247,  1249,
    1251,  1253,  1257,  1259,  1263,  1265,  1269,  1273,  1275,  1278,
    1281,  1288,  1290,  1294,  1295,  1300,  1304,  1306,  1310,  1314,
    1318,  1321,  1326,  1329,  1332,  1335,  1336,  1339,  1342,  1343,
    1345,  1347,  1349,  1351,  1353,  1355,  1357,  1361,  1365,  1367,
    1373,  1381,  1389,  1391,  1392,  1397,  1399,  1401,  1403,  1405,
    1407,  1409,  1411,  1413,  1415,  1417,  1419,  1423,  1427,  1431,
    1435,  1439,  1443,  1447,  1451,  1455,  1459,  1463,  1467,  1471,
    1475,  1479,  1482,  1487,  1489,  1491,  1493,  1495,  1498,  1501,
    1505,  1509,  1516,  1520,  1524,  1528,  1532,  1536,  1542,  1550,
    1557,  1564,  1571,  1578,  1583,  1592,  1597,  1599,  1601,  1603,
    1605,  1607,  1609,  1611,  1612,  1614,  1618,  1620,  1624,  1625,
    1627,  1632,  1639,  1644,  1648,  1654,  1660,  1665,  1672,  1676,
    1679,  1685,  1691,  1700,  1709,  1718,  1727,  1730,  1732,  1735,
    1738,  1741,  1742,  1746,  1752,  1753,  1754,  1757,  1762,  1767,
    1772,  1775,  1778,  1781,  1783,  1785,  1787,  1790,  1793,  1797,
    1801,  1802,  1806,  1807,  1811,  1816,  1820,  1821,  1824,  1827,
    1828,  1831,  1832,  1835,  1840,  1846,  1849,  1850,  1854,  1858,
    1860,  1864,  1866,  1870,  1872,  1876,  1879,  1882,  1885,  1888,
    1891,  1894,  1898,  1902,  1906,  1912,  1919,  1924,  1931,  1936,
    1943,  1948,  1953,  1959,  1966,  1970,  1974,  1979,  1985,  1991,
    1997,  2003,  2009,  2014,  2019,  2025,  2031,  2037,  2043,  2049,
    2055,  2061,  2067,  2074,  2081,  2088,  2094,  2101,  2110,  2117,
    2124,  2131,  2137,  2144,  2149,  2155,  2160,  2165,  2171,  2176,
    2182,  2187,  2193,  2199,  2205,  2211,  2217,  2224,  2230,  2236,
    2243,  2251,  2259,  2267,  2273,  2279,  2285,  2290,  2295,  2298,
    2300,  2303,  2306,  2308,  2311,  2314,  2319,  2320,  2324,  2330,
    2335,  2336,  2340,  2344,  2348,  2351,  2355,  2358,  2362,  2366,
    2368,  2371,  2375,  2378,  2383,  2387,  2390,  2394,  2396,  2399,
    2404,  2405,  2409,  2412,  2414,  2417,  2421,  2425,  2429,  2433,
    2436,  2440,  2441,  2447,  2448,  2454,  2457,  2460,  2462,  2467,
    2469,  2471,  2472,  2476,  2479,  2482,  2485,  2491,  2494,  2495,
    2499,  2500,  2503,  2506,  2510,  2513,  2516,  2520,  2523,  2526,
    2529,  2531,  2535,  2538,  2541,  2544,  2547,  2550,  2553,  2557,
    2560,  2563,  2566,  2569,  2572,  2575,  2578,  2581,  2585,  2589,
    2593,  2596,  2600,  2603,  2607,  2611,  2616,  2621,  2624,  2627,
    2630,  2634,  2638,  2642,  2645,  2649,  2653,  2657,  2662,  2665,
    2668,  2670,  2671,  2674,  2678,  2680,  2681,  2683,  2686,  2687,
    2690,  2691,  2693,  2697,  2698,  2699,  2702,  2703,  2707,  2708,
    2712,  2713,  2717,  2721,  2726,  2733,  2740,  2747,  2755,  2762,
    2770,  2776,  2777,  2780,  2784,  2787,  2791,  2795,  2798,  2802,
    2805,  2808,  2812,  2816,  2822,  2827,  2832,  2835,  2837,  2840,
    2845,  2848,  2851,  2852,  2856,  2862,  2863,  2864,  2867,  2870,
    2873,  2876,  2879,  2882,  2885,  2889,  2893,  2897,  2901,  2905,
    2909,  2913,  2917,  2921,  2925,  2928,  2932,  2936,  2941,  2945,
    2948,  2951,  2953,  2955,  2957,  2959,  2961,  2962,  2966,  2967,
    2971,  2976,  2983,  2990,  2993,  2997,  3001,  3007,  3013,  3018,
    3021,  3025,  3029,  3033,  3035,  3038,  3043,  3047,  3051,  3055,
    3058,  3061,  3064,  3067,  3070,  3072,  3076,  3077,  3080,  3081,
    3085,  3090,  3092,  3094,  3096,  3098,  3100,  3102,  3104,  3106,
    3108,  3110,  3112,  3114,  3116,  3118,  3120,  3122,  3124,  3126,
    3128,  3130,  3132,  3134,  3136,  3138,  3140,  3142,  3144,  3146,
    3148,  3150,  3152,  3154,  3156,  3158,  3160,  3162,  3164,  3166,
    3168,  3170,  3172,  3174,  3176,  3178,  3180,  3182,  3184,  3186,
    3188,  3190,  3192,  3194,  3196,  3198,  3200,  3202,  3204,  3206,
    3208,  3210,  3212,  3214,  3216,  3218,  3220,  3222,  3225,  3228,
    3231,  3233,  3236,  3238,  3241,  3244,  3246,  3249,  3253,  3257,
    3261,  3265,  3269,  3273,  3277,  3279,  3281,  3283,  3285,  3287,
    3289,  3291,  3293,  3295,  3297,  3299,  3301,  3303,  3305,  3307,
    3309,  3311,  3313,  3315,  3317,  3319,  3321,  3323,  3325,  3327,
    3329,  3331,  3333,  3335,  3337,  3339,  3341,  3343,  3345,  3347,
    3349,  3351,  3353,  3355,  3357,  3359,  3361,  3363,  3365,  3367,
    3369,  3371,  3373,  3375
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     434,     0,    -1,   435,     3,    -1,     4,   706,    -1,    -1,
     435,   705,    -1,    34,    19,    22,   603,   423,    -1,    15,
      -1,   424,   603,   425,    -1,    19,    -1,   437,    39,    -1,
     437,    40,    -1,   437,    41,    -1,   437,    -1,    35,    -1,
      37,    -1,    36,    -1,    38,    -1,    -1,    18,    -1,    19,
      -1,    -1,    31,    19,    -1,   440,   444,    -1,   442,    -1,
     440,    -1,    30,   437,    -1,   426,   440,    -1,    20,    -1,
      20,    -1,    19,    -1,    20,    -1,    -1,    20,    -1,    -1,
      43,   451,   452,   423,    -1,    63,   446,    -1,    -1,   446,
      -1,    44,   450,    -1,    55,    -1,    45,    -1,   427,   453,
     428,    -1,   454,    -1,   453,   429,   454,    -1,    46,    -1,
      47,    -1,    48,    -1,    49,    -1,    50,    -1,    51,    -1,
      52,    -1,    53,    -1,    54,    -1,   174,   144,   509,   423,
      -1,   174,   446,   423,    -1,   188,    -1,   118,    -1,    62,
      -1,    43,    -1,   456,    20,    -1,   456,    20,   437,    20,
      -1,   456,    58,    60,    -1,   456,    58,    61,    -1,   456,
      59,    60,    -1,   456,    59,    61,    -1,    57,   457,   423,
      -1,    46,    68,   439,    -1,    46,    68,    69,   438,    -1,
      70,    50,   438,    -1,    70,    67,   438,    -1,    71,   466,
     467,     3,    -1,    71,    56,   466,   467,     3,    -1,    71,
      64,     3,    -1,    71,    65,     3,    -1,    71,    66,   466,
       3,    -1,    72,     3,    -1,    -1,    20,    -1,    -1,    67,
      -1,    67,   437,    -1,   485,    73,    -1,    -1,    69,   437,
      -1,    74,   439,    -1,    75,    76,   437,    -1,    77,   439,
      -1,    78,    79,   439,    -1,    80,    81,   439,    -1,    84,
      85,   439,   469,    -1,   485,    78,    -1,    75,    76,   437,
      -1,   154,   448,   443,    -1,    73,    86,   437,    -1,    87,
     437,    -1,   116,   117,   475,   423,    -1,   116,   117,   139,
     500,   423,    -1,    15,    -1,   424,   603,   425,    -1,    17,
      -1,    18,    -1,    19,    -1,   163,   164,   477,   423,    -1,
      -1,   477,   478,    -1,   167,   440,    -1,    42,   437,    -1,
     165,    -1,   166,    -1,    80,    81,   181,   437,   423,    -1,
      -1,   170,    -1,    86,    19,   480,    -1,   162,    86,    19,
      -1,    -1,   483,   162,   442,   182,    15,   184,    15,   423,
      -1,   482,    -1,   482,   427,   483,   428,    -1,   118,    -1,
     119,    -1,    -1,    19,    -1,   139,    19,    -1,    19,   139,
      19,    -1,    -1,   120,   437,    -1,   121,   439,    -1,    46,
     506,    -1,   174,   509,    -1,   124,   488,    -1,   125,   488,
      -1,   131,    69,   490,    -1,   124,    69,   490,    -1,   125,
      69,   490,    -1,   124,   136,   137,   439,    -1,   128,   446,
      -1,    86,   491,    -1,   116,   117,   475,    -1,   169,   446,
      -1,   126,   568,    -1,   569,    -1,    45,    -1,   127,    -1,
      -1,   132,   133,    -1,   132,   134,    -1,   132,    81,    -1,
     132,   135,    -1,   437,   489,    -1,    36,    -1,    19,    -1,
      46,   144,   506,    -1,    46,   158,   437,    -1,    -1,    20,
      -1,   443,    -1,    20,   443,    -1,    -1,    28,    -1,   493,
     495,   494,    -1,   496,    -1,   497,   429,   496,    -1,   497,
      -1,    -1,   499,   497,    -1,   179,   437,    -1,   180,   437,
      -1,   485,   122,    -1,   502,   486,   427,    -1,   503,   487,
     423,    -1,   503,   505,   423,    -1,   503,    66,   323,   439,
     423,    -1,    -1,   123,   504,   497,    -1,    45,    -1,    36,
      -1,   427,   507,   428,    -1,   508,    -1,   507,   429,   508,
      -1,   129,    -1,    79,    -1,   130,    -1,   145,    -1,   142,
      -1,   143,    -1,    45,    -1,    36,    -1,   427,   510,   428,
      -1,   511,    -1,   510,   429,   511,    -1,   129,    -1,   175,
      -1,   168,   427,   513,   428,    -1,   514,    -1,    -1,   514,
     423,   513,    -1,   515,   427,   516,   428,    -1,   515,    -1,
     138,   446,    -1,    -1,   161,   139,   445,   423,   516,    -1,
     161,   141,   445,   423,   516,    -1,   205,   139,   445,   423,
     516,    -1,   205,   141,   445,   423,   516,    -1,   139,   445,
     423,   516,    -1,   141,   445,   423,   516,    -1,   117,   437,
     423,   516,    -1,   146,   517,   423,   516,    -1,   147,   149,
      -1,   147,   150,    -1,   147,   151,    -1,   147,   152,    -1,
     147,   153,    -1,   148,   149,    -1,   148,   150,    -1,   148,
     151,    -1,   148,   152,    -1,   148,   153,    -1,   185,   186,
       3,    -1,   185,   177,     3,    -1,   185,   144,   559,     3,
      -1,   185,   144,    45,   559,     3,    -1,    19,    -1,    -1,
     185,   145,     3,    -1,   185,   145,   187,     3,    -1,   185,
     188,   526,     3,    -1,    -1,   526,   442,    -1,   526,   157,
     443,    -1,   526,    86,    19,    -1,   526,   126,   568,    -1,
     526,   569,    -1,   526,    45,    -1,   526,   154,    -1,   526,
     137,    -1,   526,   527,    19,    -1,   526,   118,    19,    -1,
     526,   155,    -1,   526,   156,    -1,   159,    -1,   125,    -1,
     160,    -1,   185,   162,   529,     3,    -1,    -1,   529,   530,
     442,    -1,   529,   184,    15,    -1,   529,    86,    19,    -1,
      -1,   172,    -1,   157,    -1,   185,   189,   532,     3,    -1,
      -1,   532,    86,    -1,   532,   200,    -1,   532,   126,    -1,
     532,   118,    -1,   532,   119,    -1,   532,   162,    -1,   532,
      19,    -1,    -1,    86,    19,    -1,   190,   162,   442,   182,
      15,   184,    15,   533,     3,    -1,   191,   162,   442,   182,
      15,   184,    15,   533,     3,    -1,   183,   162,   533,     3,
      -1,   192,   193,     3,    -1,   192,   194,     3,    -1,   192,
     142,     3,    -1,   192,   145,     3,    -1,   192,   195,     3,
      -1,   192,   196,     3,    -1,   192,    79,     3,    -1,   192,
     144,     3,    -1,   197,   603,     3,    -1,   198,   547,   548,
       3,    -1,    45,    -1,    36,    -1,   427,   453,   428,    -1,
      -1,    15,    -1,   135,   558,   448,     3,    -1,   199,   558,
     448,     3,    -1,    81,   558,   448,     3,    -1,   171,   558,
       3,    -1,   171,   172,   558,     3,    -1,   171,   173,   558,
       3,    -1,    46,   558,   506,     3,    -1,   174,   558,   509,
       3,    -1,   176,     3,    -1,    19,    -1,    45,    -1,    20,
      -1,    19,    -1,    -1,    20,    -1,    -1,   126,    19,   561,
     567,    -1,   197,   603,    -1,   208,    -1,   209,    -1,   210,
      -1,   211,    -1,   212,    -1,   213,    -1,   214,    -1,   215,
      -1,   217,    -1,   218,    -1,   219,    -1,   220,    -1,   221,
      -1,   222,    -1,   563,   216,    -1,   563,    19,    -1,    -1,
     564,   423,   565,    -1,   564,    -1,   564,   423,   566,    -1,
     571,    -1,    19,    -1,   567,    -1,   254,   603,    -1,   424,
     566,   425,    -1,   424,   425,    -1,   565,   427,   574,   428,
      -1,    -1,   200,    19,   573,   570,   571,    -1,    -1,   575,
      -1,   609,    -1,   575,   609,    -1,   609,    -1,   427,   574,
     428,    -1,    18,    -1,    15,    -1,    17,    -1,   577,    -1,
      16,    -1,   424,   603,   425,    -1,    19,    -1,    15,    -1,
     424,   603,   425,    -1,    17,    -1,   577,    -1,    16,    -1,
     603,    -1,   424,   580,   429,   580,   425,    -1,   424,   580,
     429,   580,     7,   580,   425,    -1,   424,   580,   429,    29,
     425,    -1,   424,   580,     7,   580,   429,   580,   425,    -1,
     424,   580,     7,   580,   429,   580,     7,   580,   425,    -1,
     424,   580,     7,   580,   429,    29,   425,    -1,   424,    29,
     429,   580,   425,    -1,   424,    29,   429,   580,     7,   580,
     425,    -1,   424,    29,   429,    29,   425,    -1,   424,   580,
     429,   580,   425,     7,   424,   580,   429,   580,   425,    -1,
     229,    -1,   230,    -1,   231,    15,    -1,   232,    -1,   424,
     582,   429,   580,   429,   580,   425,    -1,   424,   582,   429,
     580,   429,   580,     7,   580,   425,    -1,   424,   582,   429,
     580,   429,    29,   425,    -1,   424,   580,   429,   580,   429,
     580,   425,    -1,   424,   580,   429,   580,   429,   580,     7,
     580,   425,    -1,   424,   580,   429,   580,   429,    29,   425,
      -1,   424,   580,   429,   580,     7,   580,   429,    29,   425,
      -1,   424,   580,   429,    29,   429,    29,   425,    -1,   424,
     580,     7,   580,   429,    29,   429,    29,   425,    -1,   424,
      29,   429,    29,   429,    29,   425,    -1,   424,   580,   429,
     580,   429,   580,   425,     7,   424,   580,   429,   580,   429,
     580,   425,    -1,   581,    -1,   583,    -1,   584,    -1,   578,
      -1,   578,     7,   578,    -1,   581,    -1,   583,    -1,   584,
      -1,   579,    -1,   579,     7,   579,    -1,   585,    -1,   587,
     429,   585,    -1,   586,    -1,   588,   429,   586,    -1,    18,
      30,    15,    -1,   589,    -1,   589,    27,    -1,   589,    28,
      -1,   589,   427,    15,   429,    15,   428,    -1,   590,    -1,
     591,   429,   590,    -1,    -1,   592,   588,   426,   574,    -1,
     592,     6,   574,    -1,   601,    -1,   424,   603,   425,    -1,
      13,   595,    14,    -1,    30,   596,    30,    -1,    15,   595,
      -1,    15,     7,    15,   595,    -1,    29,   595,    -1,   430,
     595,    -1,   593,   595,    -1,    -1,    15,   596,    -1,   430,
     596,    -1,    -1,    15,    -1,   227,    -1,   228,    -1,    20,
      -1,   577,    -1,   589,    -1,    17,    -1,   431,   587,   432,
      -1,   431,   591,   432,    -1,    16,    -1,   424,   603,   429,
     603,   425,    -1,   424,   582,   429,   603,   429,   603,   425,
      -1,   424,   603,   429,   603,   429,   603,   425,    -1,   594,
      -1,    -1,    19,   424,   608,   425,    -1,    19,    -1,   139,
      -1,   233,    -1,   234,    -1,   236,    -1,   237,    -1,   238,
      -1,   239,    -1,   240,    -1,   241,    -1,   242,    -1,   424,
     603,   425,    -1,   603,    27,   603,    -1,   603,    28,   603,
      -1,   603,    29,   603,    -1,   603,    30,   603,    -1,   603,
      11,   603,    -1,   603,    12,   603,    -1,   603,    22,   603,
      -1,   603,    10,   603,    -1,   603,    23,   603,    -1,   603,
       9,   603,    -1,   603,    24,   603,    -1,   603,     8,   603,
      -1,   603,    25,   603,    -1,   603,    26,   603,    -1,    32,
     603,    -1,   244,   424,   603,   425,    -1,   601,    -1,   597,
      -1,   598,    -1,   120,    -1,   599,   602,    -1,   599,   710,
      -1,   603,    33,   210,    -1,   603,    33,   243,    -1,   603,
      33,   235,   424,   603,   425,    -1,   603,    33,   248,    -1,
     603,    33,   249,    -1,   603,    33,   250,    -1,    27,   253,
      27,    -1,    28,   253,    28,    -1,    28,    28,   253,    28,
      28,    -1,    28,    28,    28,   253,    28,    28,    28,    -1,
     247,   424,   603,   429,   603,   425,    -1,   190,   424,   603,
     429,   603,   425,    -1,   191,   424,   603,   429,   603,   425,
      -1,   126,   424,   603,   429,   603,   425,    -1,   252,   424,
      19,   425,    -1,   252,   424,    19,   429,   603,   429,   603,
     425,    -1,    19,   424,   608,   425,    -1,   207,    -1,   205,
      -1,   206,    -1,    51,    -1,   201,    -1,   202,    -1,   603,
      -1,    -1,   605,    -1,   605,   429,   606,    -1,   603,    -1,
     603,   429,   607,    -1,    -1,   607,    -1,   223,   603,   224,
     576,    -1,   223,   603,   224,   576,   225,   576,    -1,    19,
      22,   603,   423,    -1,   204,   603,   423,    -1,   599,   710,
      22,   603,   423,    -1,   599,   602,    22,   603,   423,    -1,
     120,    22,   603,   423,    -1,   203,   424,   599,   710,   425,
     423,    -1,   604,   606,   423,    -1,   600,   423,    -1,   226,
     603,   427,   592,   428,    -1,   599,   710,    33,   253,   423,
      -1,   599,   710,    33,   247,   424,   603,   425,   423,    -1,
     599,   710,    33,   190,   424,   603,   425,   423,    -1,   599,
     710,    33,   191,   424,   603,   425,   423,    -1,   599,   710,
      33,   126,   424,   603,   425,   423,    -1,   485,   255,    -1,
     487,    -1,   123,   620,    -1,   262,   621,    -1,   263,   625,
      -1,    -1,   612,   611,   423,    -1,   610,   486,   427,   612,
     428,    -1,    -1,    -1,   260,   438,    -1,   256,   258,   260,
     438,    -1,   256,   259,   260,   438,    -1,   257,   259,   260,
     438,    -1,   261,   437,    -1,   140,   439,    -1,   266,   617,
      -1,   512,    -1,   127,    -1,   267,    -1,   147,   149,    -1,
     147,   150,    -1,   268,   147,   149,    -1,   268,   147,   150,
      -1,    -1,   618,   616,   423,    -1,    -1,   427,   618,   428,
      -1,   614,   498,   619,   615,    -1,   614,   619,   615,    -1,
      -1,    31,    19,    -1,   264,   446,    -1,    -1,   265,   440,
      -1,    -1,   262,   439,    -1,   440,   622,   623,   624,    -1,
     185,   255,   269,   522,     3,    -1,   485,   164,    -1,    -1,
     628,    42,   437,    -1,   628,   184,   437,    -1,   439,    -1,
     427,   630,   428,    -1,   631,    -1,   630,   429,   631,    -1,
     329,    -1,   211,    69,   330,    -1,   331,   332,    -1,   333,
     336,    -1,   331,   246,    -1,   337,   338,    -1,   334,   335,
      -1,   337,   339,    -1,   173,   340,   193,    -1,   627,   486,
     427,    -1,   632,   487,   423,    -1,   632,   265,   184,   437,
     423,    -1,   632,   265,   440,   184,   437,   423,    -1,   632,
     263,   628,   423,    -1,   632,   263,   440,   441,   628,   423,
      -1,   632,   123,    20,   423,    -1,   632,   294,   297,   117,
     475,   423,    -1,   632,   294,   296,   423,    -1,   632,   295,
     296,   423,    -1,   632,   270,    76,   437,   423,    -1,   632,
     274,   270,    76,   437,   423,    -1,   632,   122,   423,    -1,
     632,   262,   423,    -1,   632,   262,   437,   423,    -1,   632,
     276,   277,   278,   423,    -1,   632,   276,   277,   136,   423,
      -1,   632,   304,   305,   278,   423,    -1,   632,   304,   305,
     306,   423,    -1,   632,   304,   305,   307,   423,    -1,   632,
     314,   122,   423,    -1,   632,   314,   315,   423,    -1,   632,
     280,    87,   439,   423,    -1,   632,   316,    87,   439,   423,
      -1,   632,   313,    87,   439,   423,    -1,   632,   302,   303,
     439,   423,    -1,   632,   319,   316,   439,   423,    -1,   632,
     279,   287,   437,   423,    -1,   632,   279,   286,   437,   423,
      -1,   632,   237,   167,   440,   423,    -1,   632,   281,   282,
      76,   437,   423,    -1,   632,   271,   282,    76,   437,   423,
      -1,   632,   271,   272,    76,   437,   423,    -1,   632,   273,
      76,   437,   423,    -1,   632,    51,   283,    76,   437,   423,
      -1,   632,    51,   181,    76,   437,   429,   437,   423,    -1,
     632,   135,   284,    51,   439,   423,    -1,   632,   135,   284,
     329,   629,   423,    -1,   632,   199,   188,   308,   439,   423,
      -1,   632,   199,   298,   439,   423,    -1,   632,   199,   324,
     175,   439,   423,    -1,   632,   301,   439,   423,    -1,   632,
     299,   300,   439,   423,    -1,   632,   138,   446,   423,    -1,
     632,   325,   439,   423,    -1,   632,   188,    69,   437,   423,
      -1,   632,   140,   439,   423,    -1,   632,   309,   310,   439,
     423,    -1,   632,   320,   439,   423,    -1,   632,   190,    85,
     258,   423,    -1,   632,   190,    85,   259,   423,    -1,   632,
     190,    85,   439,   423,    -1,   632,   321,   286,   439,   423,
      -1,   632,   321,   265,   184,   423,    -1,   632,   321,   265,
     184,   437,   423,    -1,   632,    80,    81,   439,   423,    -1,
     632,    80,    81,   322,   423,    -1,   632,    80,    81,    76,
     437,   423,    -1,   632,    61,   327,    80,    81,   439,   423,
      -1,   632,    61,   327,    80,    81,   322,   423,    -1,   632,
      61,   327,   328,    76,   437,   423,    -1,   632,   313,    86,
     491,   423,    -1,   632,   317,   318,   439,   423,    -1,   632,
      66,   323,   439,   423,    -1,   632,   255,   439,   423,    -1,
     632,   255,    80,   423,    -1,   485,   341,    -1,   487,    -1,
      86,    20,    -1,   126,   568,    -1,   569,    -1,   342,   446,
      -1,   343,   437,    -1,   344,   190,   280,   439,    -1,    -1,
     635,   634,   423,    -1,   633,   486,   427,   635,   428,    -1,
     341,   192,   638,     3,    -1,    -1,   638,    86,   491,    -1,
     638,    86,    20,    -1,   638,   126,   568,    -1,   638,   569,
      -1,   638,   141,   446,    -1,   485,   345,    -1,   639,   486,
     427,    -1,   640,   641,   423,    -1,   487,    -1,   351,   439,
      -1,   352,   116,   439,    -1,   385,   439,    -1,   385,   439,
      69,   437,    -1,    84,   383,   439,    -1,   353,   437,    -1,
     392,   117,   437,    -1,   643,    -1,   346,   475,    -1,   642,
     427,   644,   428,    -1,    -1,   644,   645,   423,    -1,   352,
     439,    -1,   387,    -1,   187,   439,    -1,   279,   387,   439,
      -1,   279,   354,   437,    -1,   279,   355,   437,    -1,   352,
     354,   437,    -1,   388,   439,    -1,   388,   389,   437,    -1,
      -1,   374,   646,   427,   657,   428,    -1,    -1,   383,   647,
     427,   657,   428,    -1,   381,   648,    -1,   123,   670,    -1,
     652,    -1,   649,   427,   650,   428,    -1,   649,    -1,   442,
      -1,    -1,   650,   651,   423,    -1,   375,   439,    -1,   187,
     439,    -1,   354,   437,    -1,   655,   665,   427,   653,   428,
      -1,   655,   665,    -1,    -1,   653,   654,   423,    -1,    -1,
     357,   437,    -1,   356,   437,    -1,   358,   282,   437,    -1,
     181,   437,    -1,   360,   437,    -1,   360,   156,   437,    -1,
     266,   127,    -1,   266,   267,    -1,   266,   371,    -1,   512,
      -1,   376,   323,   475,    -1,   354,   437,    -1,   357,   437,
      -1,   373,   437,    -1,   356,   437,    -1,   181,   437,    -1,
     360,   437,    -1,   360,   156,   437,    -1,   361,   362,    -1,
     361,   363,    -1,   361,   364,    -1,   361,   365,    -1,   361,
     366,    -1,   361,   367,    -1,   361,   368,    -1,   361,   369,
      -1,   393,   362,   439,    -1,   367,   394,   439,    -1,   358,
     282,   437,    -1,   359,   437,    -1,   370,   364,   439,    -1,
     352,   439,    -1,    66,   323,   439,    -1,   385,   386,   437,
      -1,   323,   396,   397,   439,    -1,   195,   427,   661,   428,
      -1,   266,   127,    -1,   266,   267,    -1,   266,   371,    -1,
     258,   378,   380,    -1,   258,   378,   379,    -1,   258,   378,
     437,    -1,   259,   501,    -1,   259,   359,   437,    -1,   259,
     395,   437,    -1,   317,   318,   439,    -1,   317,   318,   259,
     377,    -1,   255,   439,    -1,   320,   439,    -1,   512,    -1,
      -1,   657,   658,    -1,   659,   660,   423,    -1,   442,    -1,
      -1,   375,    -1,   382,   437,    -1,    -1,   661,   663,    -1,
      -1,   372,    -1,   440,   662,   423,    -1,    -1,    -1,   392,
     437,    -1,    -1,   497,   667,   665,    -1,    -1,   668,   656,
     423,    -1,    -1,   427,   668,   428,    -1,   664,   666,   669,
      -1,   185,   345,   522,     3,    -1,   185,   345,   195,   522,
     447,     3,    -1,   185,   345,   123,   522,   447,     3,    -1,
     185,   345,   398,   522,   447,     3,    -1,   185,   345,   398,
      45,   522,   447,     3,    -1,   185,   345,   399,   522,   447,
       3,    -1,   185,   345,   399,    45,   522,   447,     3,    -1,
     185,   345,   384,   679,     3,    -1,    -1,   679,   390,    -1,
     679,   346,   475,    -1,   679,   323,    -1,   679,   361,    15,
      -1,   679,   391,   475,    -1,   679,   278,    -1,   679,   116,
     475,    -1,   679,    19,    -1,   485,   400,    -1,   680,   486,
     427,    -1,   681,   487,   423,    -1,   681,   333,    86,    19,
     423,    -1,   681,   401,   402,   423,    -1,   681,   401,   403,
     423,    -1,   485,   404,    -1,   487,    -1,   385,   439,    -1,
     385,   439,    69,   437,    -1,   405,   437,    -1,   123,   692,
      -1,    -1,   684,   683,   423,    -1,   682,   486,   427,   684,
     428,    -1,    -1,    -1,    87,   437,    -1,   401,   408,    -1,
     401,   362,    -1,   140,   439,    -1,   167,   440,    -1,    42,
     437,    -1,   409,   437,    -1,   409,   377,   439,    -1,   410,
     411,   439,    -1,   412,   413,   439,    -1,    66,   414,   439,
      -1,   406,    76,   437,    -1,    67,    76,   437,    -1,   407,
      76,   437,    -1,   385,   386,   437,    -1,   258,   378,   437,
      -1,   259,   395,   437,    -1,   259,   501,    -1,   259,   359,
     437,    -1,   317,   318,   439,    -1,   317,   318,   259,   377,
      -1,    66,   323,   439,    -1,   255,   439,    -1,   266,   689,
      -1,   512,    -1,   127,    -1,   415,    -1,   371,    -1,   149,
      -1,    -1,   690,   688,   423,    -1,    -1,   427,   690,   428,
      -1,   686,   498,   691,   687,    -1,   185,   404,   145,   522,
     447,     3,    -1,   185,   404,   195,   522,   447,     3,    -1,
     485,   418,    -1,   695,   486,   427,    -1,   696,   487,   423,
      -1,   696,    66,   323,   439,   423,    -1,   696,   313,    86,
     491,   423,    -1,   696,   700,   703,   423,    -1,   188,   442,
      -1,   275,   440,   441,    -1,   698,   386,   437,    -1,   698,
     255,   439,    -1,   698,    -1,   699,   698,    -1,   697,   275,
     440,   441,    -1,   697,   275,    20,    -1,   697,   420,   699,
      -1,   697,   315,   440,    -1,   697,   306,    -1,   697,   206,
      -1,   697,   421,    -1,   697,   422,    -1,   697,   419,    -1,
     609,    -1,   255,   439,   423,    -1,    -1,   702,   701,    -1,
      -1,   427,   702,   428,    -1,   185,   418,   522,     3,    -1,
     423,    -1,   436,    -1,   449,    -1,   455,    -1,   458,    -1,
     459,    -1,   474,    -1,   476,    -1,   479,    -1,   481,    -1,
     484,    -1,   707,    -1,   492,    -1,   560,    -1,   562,    -1,
     572,    -1,   460,    -1,   461,    -1,   462,    -1,   463,    -1,
     464,    -1,   465,    -1,   518,    -1,   519,    -1,   520,    -1,
     521,    -1,   523,    -1,   524,    -1,   525,    -1,   528,    -1,
     531,    -1,   534,    -1,   535,    -1,   536,    -1,   537,    -1,
     538,    -1,   539,    -1,   540,    -1,   541,    -1,   542,    -1,
     543,    -1,   544,    -1,   545,    -1,   546,    -1,   549,    -1,
     550,    -1,   551,    -1,   552,    -1,   553,    -1,   554,    -1,
     555,    -1,   556,    -1,   557,    -1,   626,    -1,   637,    -1,
     671,    -1,   672,    -1,   673,    -1,   674,    -1,   675,    -1,
     676,    -1,   677,    -1,   678,    -1,   693,    -1,   694,    -1,
     704,    -1,   708,   428,    -1,   709,   428,    -1,   503,   428,
      -1,   613,    -1,   632,   428,    -1,   636,    -1,   640,   428,
      -1,   681,   428,    -1,   685,    -1,   696,   428,    -1,   468,
     486,   427,    -1,   708,   487,   423,    -1,   708,   470,   423,
      -1,   708,   473,   423,    -1,   471,   486,   427,    -1,   709,
     487,   423,    -1,   709,   472,   423,    -1,    82,    -1,    83,
      -1,    88,    -1,    89,    -1,    90,    -1,    91,    -1,    92,
      -1,    93,    -1,    94,    -1,    95,    -1,    96,    -1,    97,
      -1,    98,    -1,    99,    -1,   100,    -1,   101,    -1,   102,
      -1,   103,    -1,   104,    -1,   105,    -1,   106,    -1,   107,
      -1,   108,    -1,   109,    -1,   110,    -1,   111,    -1,   112,
      -1,   113,    -1,   114,    -1,   115,    -1,   178,    -1,     5,
      -1,   288,    -1,   285,    -1,   289,    -1,   287,    -1,   286,
      -1,   290,    -1,   291,    -1,   292,    -1,   311,    -1,   312,
      -1,   293,    -1,   326,    -1,   347,    -1,   348,    -1,   349,
      -1,   350,    -1,   416,    -1,   417,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   841,   841,   842,   845,   847,   855,   864,   865,   866,
     873,   874,   875,   883,   884,   885,   886,   887,   888,   894,
     895,   902,   903,   907,   914,   915,   919,   923,   930,   938,
     939,   946,   947,   951,   952,   958,   967,   968,   972,   977,
     978,   982,   983,   987,   988,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1006,  1007,  1017,  1018,  1019,  1020,
    1023,  1024,  1025,  1026,  1027,  1028,  1032,  1038,  1039,  1040,
    1041,  1049,  1052,  1059,  1062,  1065,  1068,  1072,  1073,  1077,
    1078,  1079,  1087,  1092,  1093,  1097,  1098,  1102,  1109,  1110,
    1111,  1123,  1128,  1132,  1146,  1147,  1161,  1162,  1166,  1167,
    1168,  1169,  1176,  1190,  1192,  1194,  1198,  1199,  1200,  1201,
    1206,  1212,  1213,  1217,  1225,  1229,  1231,  1237,  1238,  1245,
    1246,  1250,  1256,  1260,  1269,  1278,  1280,  1284,  1285,  1286,
    1287,  1288,  1289,  1290,  1291,  1292,  1293,  1294,  1295,  1296,
    1300,  1301,  1302,  1303,  1307,  1308,  1309,  1310,  1311,  1315,
    1321,  1325,  1333,  1334,  1342,  1350,  1351,  1352,  1356,  1357,
    1361,  1366,  1367,  1371,  1373,  1381,  1385,  1386,  1392,  1399,
    1400,  1401,  1402,  1406,  1414,  1420,  1421,  1422,  1426,  1427,
    1431,  1432,  1433,  1434,  1435,  1436,  1442,  1443,  1444,  1448,
    1449,  1453,  1454,  1460,  1461,  1464,  1466,  1470,  1471,  1475,
    1495,  1496,  1497,  1498,  1499,  1500,  1501,  1502,  1503,  1507,
    1508,  1509,  1510,  1511,  1512,  1513,  1514,  1515,  1516,  1522,
    1525,  1528,  1531,  1535,  1536,  1539,  1542,  1546,  1550,  1555,
    1561,  1568,  1573,  1578,  1583,  1587,  1591,  1595,  1604,  1612,
    1616,  1623,  1624,  1625,  1630,  1634,  1641,  1648,  1652,  1660,
    1661,  1662,  1667,  1671,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1685,  1690,  1698,  1705,  1712,  1720,  1722,  1724,  1726,
    1728,  1730,  1732,  1734,  1737,  1741,  1747,  1748,  1749,  1753,
    1754,  1760,  1762,  1764,  1766,  1768,  1770,  1774,  1778,  1781,
    1785,  1786,  1787,  1791,  1792,  1793,  1801,  1801,  1811,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1851,  1862,  1863,  1870,  1871,  1878,
    1887,  1891,  1895,  1916,  1917,  1921,  1933,  1933,  1949,  1950,
    1953,  1954,  1958,  1961,  1970,  1983,  1984,  1985,  1986,  1987,
    1991,  1999,  2000,  2001,  2002,  2003,  2007,  2010,  2011,  2012,
    2013,  2014,  2015,  2016,  2017,  2018,  2019,  2024,  2025,  2026,
    2027,  2031,  2032,  2033,  2037,  2038,  2039,  2040,  2041,  2042,
    2043,  2044,  2049,  2050,  2051,  2052,  2053,  2057,  2058,  2059,
    2060,  2061,  2065,  2066,  2070,  2071,  2075,  2082,  2083,  2084,
    2085,  2092,  2093,  2096,  2097,  2104,  2116,  2117,  2121,  2122,
    2126,  2127,  2128,  2129,  2130,  2131,  2135,  2136,  2137,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,  2149,  2150,  2154,
    2155,  2156,  2157,  2167,  2171,  2193,  2205,  2206,  2207,  2208,
    2209,  2210,  2211,  2212,  2213,  2214,  2218,  2219,  2220,  2221,
    2222,  2223,  2224,  2225,  2226,  2227,  2228,  2229,  2230,  2231,
    2232,  2233,  2234,  2236,  2237,  2238,  2240,  2242,  2244,  2246,
    2247,  2248,  2249,  2250,  2251,  2261,  2262,  2263,  2264,  2265,
    2266,  2267,  2268,  2270,  2271,  2274,  2296,  2297,  2298,  2299,
    2300,  2301,  2305,  2308,  2309,  2310,  2318,  2324,  2332,  2333,
    2337,  2342,  2350,  2358,  2363,  2367,  2373,  2377,  2382,  2383,
    2384,  2391,  2392,  2393,  2394,  2395,  2401,  2413,  2414,  2415,
    2416,  2419,  2421,  2425,  2429,  2443,  2463,  2464,  2465,  2466,
    2467,  2468,  2469,  2470,  2474,  2475,  2476,  2477,  2478,  2479,
    2482,  2484,  2487,  2489,  2493,  2496,  2501,  2502,  2503,  2507,
    2508,  2512,  2513,  2516,  2535,  2541,  2568,  2570,  2571,  2576,
    2577,  2581,  2582,  2586,  2587,  2588,  2589,  2590,  2591,  2592,
    2593,  2594,  2598,  2599,  2600,  2601,  2602,  2603,  2609,  2610,
    2611,  2612,  2613,  2614,  2615,  2616,  2617,  2618,  2619,  2620,
    2621,  2622,  2623,  2624,  2625,  2626,  2627,  2628,  2629,  2630,
    2631,  2632,  2633,  2634,  2635,  2636,  2637,  2638,  2639,  2640,
    2641,  2642,  2643,  2644,  2645,  2646,  2647,  2648,  2654,  2655,
    2656,  2657,  2658,  2659,  2660,  2661,  2662,  2663,  2664,  2665,
    2666,  2667,  2668,  2669,  2670,  2671,  2672,  2673,  2684,  2690,
    2691,  2692,  2693,  2694,  2695,  2696,  2699,  2701,  2705,  2708,
    2712,  2713,  2714,  2715,  2716,  2717,  2724,  2734,  2735,  2739,
    2740,  2741,  2742,  2743,  2744,  2745,  2746,  2747,  2750,  2765,
    2768,  2770,  2774,  2775,  2776,  2777,  2778,  2779,  2780,  2781,
    2782,  2783,  2783,  2784,  2784,  2785,  2786,  2787,  2791,  2792,
    2796,  2804,  2806,  2810,  2811,  2812,  2816,  2817,  2820,  2822,
    2825,  2826,  2827,  2828,  2829,  2830,  2831,  2832,  2833,  2834,
    2835,  2838,  2858,  2859,  2860,  2861,  2862,  2863,  2864,  2865,
    2866,  2867,  2868,  2869,  2870,  2871,  2872,  2873,  2874,  2875,
    2876,  2877,  2878,  2879,  2880,  2881,  2882,  2883,  2884,  2885,
    2886,  2887,  2888,  2889,  2890,  2891,  2892,  2893,  2894,  2895,
    2896,  2899,  2901,  2904,  2906,  2915,  2917,  2918,  2921,  2923,
    2927,  2928,  2931,  2941,  2962,  2964,  2968,  2968,  2971,  2973,
    2976,  2978,  2982,  2987,  2990,  2993,  2998,  3001,  3006,  3009,
    3013,  3017,  3020,  3021,  3022,  3023,  3024,  3025,  3026,  3027,
    3033,  3040,  3041,  3042,  3047,  3048,  3054,  3067,  3068,  3069,
    3070,  3071,  3074,  3076,  3080,  3084,  3107,  3137,  3138,  3139,
    3140,  3141,  3142,  3143,  3147,  3148,  3149,  3150,  3151,  3152,
    3153,  3154,  3155,  3156,  3157,  3158,  3159,  3160,  3161,  3162,
    3163,  3164,  3168,  3169,  3170,  3171,  3174,  3176,  3179,  3181,
    3185,  3191,  3194,  3201,  3208,  3209,  3210,  3211,  3212,  3215,
    3225,  3234,  3238,  3244,  3245,  3249,  3254,  3260,  3263,  3268,
    3269,  3270,  3271,  3272,  3276,  3277,  3280,  3282,  3285,  3287,
    3291,  3298,  3298,  3298,  3298,  3298,  3298,  3298,  3298,  3298,
    3298,  3298,  3298,  3298,  3298,  3298,  3298,  3299,  3299,  3299,
    3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,
    3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,
    3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,
    3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,
    3299,  3299,  3299,  3299,  3299,  3299,  3299,  3300,  3300,  3300,
    3300,  3300,  3300,  3300,  3300,  3300,  3300,  3301,  3301,  3301,
    3301,  3302,  3302,  3302,  3303,  3303,  3303,  3303,  3303,  3303,
    3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,
    3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,
    3303,  3303,  3303,  3303,  3303,  3304,  3304,  3305,  3306,  3307,
    3308,  3309,  3310,  3311,  3312,  3313,  3314,  3315,  3316,  3316,
    3316,  3316,  3316,  3316
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "VRF", "STATES",
  "FILTERS", "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP",
  "FILTERED", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS",
  "PROTOCOLS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1",
  "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "FOR",
  "COMMANDS", "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED",
  "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY",
  "IGP_METRIC", "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "AWARE", "LINK",
  "EXTENDED", "SETKEY", "BGP_LARGE_COMMUNITY", "LIVED", "STALE", "CEASE",
  "HIT", "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE",
  "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF", "MRT",
  "FILENAME", "PERIOD", "ALWAYS", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL",
  "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL",
  "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA", "SUPPRESSION",
  "TOPOLOGY", "STATE", "PIPE", "MODE", "OPAQUE", "TRANSPARENT", "RIP",
  "INFINITY", "UPDATE", "GARBAGE", "MULTICAST", "VERSION", "SPLIT",
  "HORIZON", "POISON", "REVERSE", "ZERO", "PLAINTEXT", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa", "pxlen",
  "datetime", "text", "opttext", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "debug_unix", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT",
  "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cfg_name", "cfg_timeout", "kern_proto_start",
  "kern_mp_limit", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "gr_opts", "tab_sorted", "newtab", "roa_table_start", "roa_table_opts",
  "roa_table", "proto_start", "proto_name", "proto_item", "imexport",
  "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "export_mode",
  "cmd_SHOW_ROA", "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args",
  "roa_table_arg", "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def",
  "$@1", "filter_eval", "type", "one_decl", "decls", "declsn",
  "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "cnum", "pair_item", "ec_kind",
  "ec_item", "lc_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_finish",
  "bfd_iface_item", "bfd_auth_type", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_nbr_opts",
  "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag", "bgp_proto",
  "mrt_proto_start", "mrt_proto_item", "mrt_proto_opts", "mrt_proto",
  "cmd_MRT_DUMP", "mrt_dump_args", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_proto_start",
  "rip_proto_item", "rip_proto_opts", "rip_proto", "rip_iface_start",
  "rip_iface_finish", "rip_iface_item", "rip_auth", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface", "cmd_SHOW_RIP_INTERFACES",
  "cmd_SHOW_RIP_NEIGHBORS", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,    59,    40,    41,    58,   123,   125,    44,
      63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   433,   434,   434,   435,   435,   436,   437,   437,   437,
     438,   438,   438,   439,   439,   439,   439,   439,   439,   440,
     440,   441,   441,   442,   443,   443,   444,   444,   445,   446,
     446,   447,   447,   448,   448,   449,   450,   450,   451,   451,
     451,   452,   452,   453,   453,   454,   454,   454,   454,   454,
     454,   454,   454,   454,   455,   455,   456,   456,   456,   456,
     457,   457,   457,   457,   457,   457,   458,   459,   459,   459,
     459,   460,   461,   462,   463,   464,   465,   466,   466,   467,
     467,   467,   468,   469,   469,   470,   470,   470,   470,   470,
     470,   471,   472,   472,   473,   473,   474,   474,   475,   475,
     475,   475,   475,   476,   477,   477,   478,   478,   478,   478,
     479,   480,   480,   481,   482,   483,   483,   484,   484,   485,
     485,   486,   486,   486,   486,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     488,   488,   488,   488,   489,   489,   489,   489,   489,   490,
     490,   491,   492,   492,   493,   494,   494,   494,   495,   495,
     496,   497,   497,   498,   499,   500,   501,   501,   502,   503,
     503,   503,   503,   504,   505,   506,   506,   506,   507,   507,
     508,   508,   508,   508,   508,   508,   509,   509,   509,   510,
     510,   511,   511,   512,   512,   513,   513,   514,   514,   515,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   517,
     517,   517,   517,   517,   517,   517,   517,   517,   517,   518,
     519,   520,   521,   522,   522,   523,   524,   525,   526,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   527,   527,   527,   528,   529,   529,   529,   529,   530,
     530,   530,   531,   532,   532,   532,   532,   532,   532,   532,
     532,   533,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   547,   547,   548,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   558,   558,   559,   559,   559,   561,   560,   562,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   564,   565,   565,   566,   566,   567,
     568,   568,   569,   570,   570,   571,   573,   572,   574,   574,
     575,   575,   576,   576,   577,   578,   578,   578,   578,   578,
     578,   579,   579,   579,   579,   579,   580,   581,   581,   581,
     581,   581,   581,   581,   581,   581,   581,   582,   582,   582,
     582,   583,   583,   583,   584,   584,   584,   584,   584,   584,
     584,   584,   585,   585,   585,   585,   585,   586,   586,   586,
     586,   586,   587,   587,   588,   588,   589,   590,   590,   590,
     590,   591,   591,   592,   592,   592,   593,   593,   594,   594,
     595,   595,   595,   595,   595,   595,   596,   596,   596,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   598,
     598,   598,   598,   599,   600,   601,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   604,   604,   604,   604,
     604,   604,   605,   606,   606,   606,   607,   607,   608,   608,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   609,   610,   611,   611,   611,
     611,   612,   612,   613,   614,   615,   616,   616,   616,   616,
     616,   616,   616,   616,   617,   617,   617,   617,   617,   617,
     618,   618,   619,   619,   620,   621,   622,   622,   622,   623,
     623,   624,   624,   625,   626,   627,   628,   628,   628,   629,
     629,   630,   630,   631,   631,   631,   631,   631,   631,   631,
     631,   631,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   633,   634,
     634,   634,   634,   634,   634,   634,   635,   635,   636,   637,
     638,   638,   638,   638,   638,   638,   639,   640,   640,   641,
     641,   641,   641,   641,   641,   641,   641,   641,   642,   643,
     644,   644,   645,   645,   645,   645,   645,   645,   645,   645,
     645,   646,   645,   647,   645,   645,   645,   645,   648,   648,
     649,   650,   650,   651,   651,   651,   652,   652,   653,   653,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   655,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   657,   657,   658,   659,   660,   660,   660,   661,   661,
     662,   662,   663,   664,   665,   665,   667,   666,   668,   668,
     669,   669,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   679,   679,   679,   679,   679,   679,   679,   679,
     680,   681,   681,   681,   681,   681,   682,   683,   683,   683,
     683,   683,   684,   684,   685,   686,   687,   688,   688,   688,
     688,   688,   688,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   688,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   689,   689,   689,   689,   690,   690,   691,   691,
     692,   693,   694,   695,   696,   696,   696,   696,   696,   697,
     698,   698,   698,   699,   699,   700,   700,   700,   700,   700,
     700,   700,   700,   700,   701,   701,   702,   702,   703,   703,
     704,   705,   705,   705,   705,   705,   705,   705,   705,   705,
     705,   705,   705,   705,   705,   705,   705,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   707,   707,   707,
     707,   707,   707,   707,   707,   707,   707,   708,   708,   708,
     708,   709,   709,   709,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     4,     5,     3,     3,     4,     2,     0,     1,     0,
       1,     2,     2,     0,     2,     2,     3,     2,     3,     3,
       4,     2,     3,     3,     3,     2,     4,     5,     1,     3,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     2,     3,     0,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     4,     2,     2,     3,     2,
       2,     1,     1,     1,     0,     2,     2,     2,     2,     2,
       1,     1,     3,     3,     0,     1,     1,     2,     0,     1,
       3,     1,     3,     1,     0,     2,     2,     2,     2,     3,
       3,     3,     5,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     4,     4,     4,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     1,     1,     4,     0,     3,     3,     3,     0,
       1,     1,     4,     0,     2,     2,     2,     2,     2,     2,
       2,     0,     2,     9,     9,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     3,     0,
       1,     4,     4,     4,     3,     4,     4,     4,     4,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     3,     1,     3,     1,
       1,     1,     2,     3,     2,     4,     0,     5,     0,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     5,     7,     5,
       7,     9,     7,     5,     7,     5,    11,     1,     1,     2,
       1,     7,     9,     7,     7,     9,     7,     9,     7,     9,
       7,    15,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     4,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     5,
       7,     7,     1,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     4,     1,     1,     1,     1,     2,     2,     3,
       3,     6,     3,     3,     3,     3,     3,     5,     7,     6,
       6,     6,     6,     4,     8,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     1,     3,     0,     1,
       4,     6,     4,     3,     5,     5,     4,     6,     3,     2,
       5,     5,     8,     8,     8,     8,     2,     1,     2,     2,
       2,     0,     3,     5,     0,     0,     2,     4,     4,     4,
       2,     2,     2,     1,     1,     1,     2,     2,     3,     3,
       0,     3,     0,     3,     4,     3,     0,     2,     2,     0,
       2,     0,     2,     4,     5,     2,     0,     3,     3,     1,
       3,     1,     3,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     5,     6,     4,     6,     4,     6,
       4,     4,     5,     6,     3,     3,     4,     5,     5,     5,
       5,     5,     4,     4,     5,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     6,     5,     6,     8,     6,     6,
       6,     5,     6,     4,     5,     4,     4,     5,     4,     5,
       4,     5,     5,     5,     5,     5,     6,     5,     5,     6,
       7,     7,     7,     5,     5,     5,     4,     4,     2,     1,
       2,     2,     1,     2,     2,     4,     0,     3,     5,     4,
       0,     3,     3,     3,     2,     3,     2,     3,     3,     1,
       2,     3,     2,     4,     3,     2,     3,     1,     2,     4,
       0,     3,     2,     1,     2,     3,     3,     3,     3,     2,
       3,     0,     5,     0,     5,     2,     2,     1,     4,     1,
       1,     0,     3,     2,     2,     2,     5,     2,     0,     3,
       0,     2,     2,     3,     2,     2,     3,     2,     2,     2,
       1,     3,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       2,     3,     2,     3,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     4,     2,     2,
       1,     0,     2,     3,     1,     0,     1,     2,     0,     2,
       0,     1,     3,     0,     0,     2,     0,     3,     0,     3,
       0,     3,     3,     4,     6,     6,     6,     7,     6,     7,
       5,     0,     2,     3,     2,     3,     3,     2,     3,     2,
       2,     3,     3,     5,     4,     4,     2,     1,     2,     4,
       2,     2,     0,     3,     5,     0,     0,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     4,     3,     2,
       2,     1,     1,     1,     1,     1,     0,     3,     0,     3,
       4,     6,     6,     2,     3,     3,     5,     5,     4,     2,
       3,     3,     3,     1,     2,     4,     3,     3,     3,     2,
       2,     2,     2,     2,     1,     3,     0,     2,     0,     3,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       1,     2,     1,     2,     2,     1,     2,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   423,     0,     0,
       0,   877,   878,   879,   880,   881,   882,   883,   884,   885,
     886,   887,   888,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,   899,   900,   901,   902,   903,   904,   905,
     906,   907,   908,   909,   910,   911,   912,   913,   914,   915,
     916,   917,   918,   919,   920,   921,   922,   923,   924,   925,
     926,     3,     1,     2,     0,     0,     0,     0,     0,     0,
       0,     0,   119,   120,     0,     0,     0,     0,   423,     0,
     861,   862,   863,   864,   865,   866,   121,   121,   867,   868,
     869,   870,   117,   871,     0,   873,   121,   125,   874,   875,
     876,   121,   930,   121,   125,   121,   932,   121,   125,   121,
     125,   121,   935,   121,   125,     5,   872,   125,   125,   290,
     292,   291,     0,    78,    77,     0,     0,    77,    79,    76,
      34,    34,     0,     0,     0,     0,   289,   261,   294,     0,
     245,     0,     0,   228,   253,     0,   224,     0,   224,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   405,
     409,   418,   415,   334,   425,   412,     0,     0,   408,   423,
     456,     0,     0,     0,   410,   411,     0,     0,     0,   423,
       0,   413,   414,   422,   454,   455,     0,   453,     0,   277,
     276,     0,   279,    34,   640,     0,    30,    29,    37,    40,
      38,     0,    18,     0,     0,    59,    58,    57,    56,     0,
       0,     0,     0,     0,   111,     0,   296,     0,   104,     0,
       0,   298,   326,   122,     0,     0,     0,   115,    82,    91,
     168,   545,   506,   628,   646,   780,   786,   833,     0,     0,
       0,     0,     0,     0,    18,   173,     0,     0,     0,     0,
       0,     0,   929,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
      18,     0,   546,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,    18,     0,    18,   931,     0,     0,
       0,     0,     0,    18,     0,     0,    18,     0,   933,   649,
       0,     0,   657,     0,     0,     0,   934,     0,     0,     0,
       0,     0,     0,   936,     0,     0,   858,     0,    18,     0,
      18,     0,     0,     0,     0,   927,     0,     0,     0,     0,
      34,   928,     0,     0,   176,   175,     0,     0,    79,    73,
      74,     0,    80,     0,    33,     0,     0,     0,     0,   284,
     187,   186,     0,     0,     0,     0,   293,   295,   294,     0,
     225,     0,   249,   220,   219,     0,     0,   224,   223,   224,
     224,   771,   224,   224,     0,   224,   224,     0,    19,    20,
       0,     0,     0,   272,   268,   273,   269,   266,   267,   270,
     271,   405,   425,   405,   423,   405,   405,     0,   396,     0,
     423,     0,     0,     0,   408,   408,     0,   451,   423,   423,
     423,   423,   423,     0,   357,   358,     0,   360,     0,     0,
     335,   338,   336,   340,   423,   337,   375,   372,   373,   374,
     382,     0,   387,   391,     0,   975,   944,   945,   946,   947,
     948,   949,   950,   951,   952,   953,   954,   955,   956,   957,
     958,   959,   960,   961,   962,   963,   964,   965,   966,   967,
     968,   969,   970,   971,   972,   973,   426,   974,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   977,   980,   979,
     976,   978,   981,   982,   983,   986,   984,   985,   987,   988,
     989,   990,   991,   992,   993,   457,   458,   274,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,     0,    45,    46,    47,    48,    49,    50,    51,
      52,    53,     0,    43,   280,     0,     0,     0,   423,     0,
      39,    41,     0,     0,     7,     9,    14,    16,    15,    17,
       0,   423,    13,    67,   152,   153,    60,     0,     0,    66,
       0,    69,    70,     0,   112,   113,    98,   100,   101,   102,
     164,   423,     0,   315,   114,     0,     0,    55,     0,     0,
     123,   937,   941,     0,   169,   128,    18,   151,   137,     0,
     126,   127,   154,   142,     0,   315,   143,     0,   423,   130,
     141,     0,   131,   136,     0,   139,   129,   170,   171,   511,
     562,     0,     0,     0,    18,    18,   574,     0,     0,     0,
       0,     0,    18,     0,    18,     0,     0,     0,     0,   575,
       0,    21,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,    18,     0,
      18,     0,    18,     0,    18,     0,     0,    18,    18,    18,
       0,     0,    18,     0,   563,   636,   647,    18,   658,   650,
      18,   655,   652,     0,   648,   660,   781,     0,     0,     0,
     782,   792,   834,    18,   839,     0,   835,   850,     0,   849,
       0,   853,     0,   851,   852,   856,     0,     0,    85,     0,
      87,    18,    18,    18,    95,   939,   940,   938,     0,     0,
     943,   942,   181,   180,   182,   184,   185,   183,     0,   178,
     287,     0,    75,    81,    71,   283,   281,   285,   286,   191,
     192,     0,   189,   288,   262,   265,     0,   221,   226,   244,
       0,   251,   250,     0,     0,   227,   234,     0,     0,   242,
     315,   236,   235,   239,   240,     0,   241,   243,   229,     0,
     233,   252,   260,   254,   257,   258,   256,   259,   255,     0,
      32,    32,     0,   224,    32,   224,    32,   763,    32,    32,
     860,     0,     0,    23,     0,     0,     0,   400,   402,     0,
     403,   404,   398,   386,   486,   489,     0,   465,     0,     0,
     466,   406,   407,   399,     0,     0,     0,     0,     0,     0,
     359,   423,   436,   423,     0,     0,     0,   346,     0,     0,
     416,   388,   389,     0,     0,   417,   448,   446,   444,   441,
     442,   443,   445,   447,   449,   450,   437,   438,   439,   440,
     459,     0,   460,   462,   463,   464,   278,     0,   275,   282,
     639,     0,   315,     0,   644,     0,    36,     0,    35,    68,
       0,     0,    62,    63,    64,    65,    10,    11,    12,     0,
     154,     0,     0,    96,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,     0,
       0,   297,   319,     0,   108,   109,     0,   103,   105,    54,
       0,   315,   124,     0,   118,     0,   138,   158,   161,   174,
     150,   144,   133,   320,   321,   140,    18,   322,   134,   132,
     125,     0,     0,     0,     0,     0,     0,     0,     0,   568,
      18,    18,   605,   608,     0,     0,     0,     0,    18,     0,
      18,     0,   627,   626,   576,     0,   546,     0,     0,   566,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   570,     0,   571,     0,   603,     0,     0,
       0,     0,     0,     0,     0,   582,   583,     0,     0,     0,
     610,     0,     0,   606,   125,   654,   651,     0,   656,     0,
       0,   784,   785,   125,     0,     0,   846,    21,   848,     0,
     843,   847,   423,   838,    94,    86,    88,    89,    83,    92,
      25,    24,    93,   177,     0,    72,   188,     0,   222,   248,
     247,   246,   231,   238,   232,   230,   237,   544,    31,     0,
       0,   770,   779,     0,   777,   774,     0,     0,   772,     0,
      32,     0,    32,     0,     0,     0,    26,    27,     0,     0,
     405,   397,   423,   475,     0,     0,   423,   423,   423,   452,
     423,   473,   423,     0,     0,   423,   423,   423,   423,   339,
     334,   423,   376,   383,     0,     0,   392,   423,    44,   642,
     641,   643,   645,     6,    42,     8,    61,   110,   165,    97,
      99,   314,   313,   315,   423,   107,   106,   324,   317,     0,
     327,     0,   172,   159,     0,   154,     0,   149,   135,   514,
     514,     0,   513,   507,     0,     0,     0,    18,     0,   625,
       0,   618,   617,     0,     0,   549,     0,   607,   611,   612,
     613,     0,   601,     0,   591,    22,     0,   547,   548,   564,
       0,   572,     0,     0,   595,     0,   578,   577,   590,   589,
     584,     0,     0,   604,   587,   579,   580,   581,   609,   623,
     586,   585,   624,   588,   615,     0,   614,     0,   315,     0,
       0,     0,   638,   629,   632,     0,   653,   753,    18,     0,
      18,   671,     0,     0,   673,   663,    18,   659,     0,   677,
     754,   783,   795,    18,     0,   794,   787,     0,   836,   837,
     845,    21,    18,     0,   844,     0,   479,     0,   480,   481,
       0,   423,   477,   478,   476,   423,   423,    18,   859,     0,
       0,   423,   854,   857,     0,    90,   179,   190,   765,   764,
     778,   773,   775,   776,     0,   766,     0,   768,   831,   832,
       0,     0,   401,   487,     0,   467,     0,     0,     0,     0,
       0,   423,   419,   423,     0,     0,   346,     0,     0,     0,
       0,     0,     0,     0,   316,     0,   423,   330,     0,   323,
       0,   155,   156,   160,   162,   147,   145,   146,   148,   154,
     508,   532,   509,   536,   510,   512,     0,   596,     0,     0,
       0,   619,   598,     0,     0,   553,     0,     0,     0,     0,
       0,   551,   599,   600,   602,   567,   565,   594,   593,   573,
     592,   569,   616,   630,   631,   633,   634,     0,   637,   154,
     676,   664,     0,     0,    18,     0,   662,     0,     0,   680,
     675,   679,     0,     0,   669,   661,     0,   687,   154,   791,
     788,   790,   793,   840,   842,   841,   423,   423,   423,   423,
       0,     0,     0,     0,     0,     0,   499,   482,   484,     0,
      84,   767,   769,   261,   261,     0,   472,   470,   471,   469,
     423,     0,     0,   355,     0,   423,   353,   423,   349,     0,
     423,   347,   423,   423,     0,   461,   325,   331,   318,     0,
     157,   163,   532,   530,   515,     0,     0,   539,     0,   621,
     620,   622,     0,     0,   557,   555,   556,   559,   558,   560,
     550,     0,    18,   756,   760,   666,   667,   665,   668,   741,
     701,   681,   741,   670,   755,   688,   828,     0,     0,     0,
       0,     0,   493,   423,   393,   855,   423,   423,     0,   423,
     498,     0,     0,   468,     0,   420,   421,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   390,     0,
     515,     0,   535,   537,   538,     0,   541,   597,   561,   554,
     552,   635,   754,   758,   762,     0,     0,     0,   690,   826,
     796,   789,   492,   424,   496,     0,   423,   490,   332,     0,
       0,     0,     0,     0,     0,     0,     0,   485,   263,   264,
     474,   370,   354,   352,     0,   423,   350,   368,   348,     0,
     423,   366,   423,   364,   363,   423,   361,     0,   534,     0,
      18,     0,     0,     0,     0,     0,     0,   533,   523,   194,
     198,     0,   540,    18,   543,   757,     0,   672,   744,   742,
     745,    18,     0,    18,   678,     0,   674,     0,     0,     0,
       0,     0,     0,   686,   700,     0,     0,   830,     0,     0,
     423,   423,   341,   345,   343,   423,   500,   344,   380,   377,
     378,   379,   384,     0,   495,   494,   423,   423,   423,   423,
     501,     0,     0,     0,     0,     0,     0,     0,   116,   199,
     521,   195,     0,     0,     0,   516,   520,   524,     0,   525,
       0,   522,   200,   531,   542,     0,     0,     0,    18,     0,
       0,     0,     0,    18,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   761,   740,
       0,   746,     0,     0,   684,   685,   683,   682,   694,   697,
     698,   699,   692,   691,     0,     0,   695,   689,     0,     0,
       0,     0,    18,     0,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   829,   821,     0,   497,
     333,   491,   395,   346,     0,   423,     0,     0,     0,     0,
       0,   369,   351,   367,   423,   365,   423,   362,     0,     0,
       0,     0,     0,   526,   527,     0,     0,     0,     0,     0,
       0,     0,     0,    18,   706,   748,   738,     0,     0,     0,
       0,     0,   733,   727,   728,   729,    18,   739,     0,   722,
     702,   705,   703,     0,   720,     0,   707,   709,   710,   711,
     712,   713,   714,   715,   716,    18,    18,   704,     0,    18,
     759,   747,   743,   693,   696,   802,    18,    18,     0,   797,
     800,   801,   819,     0,     0,     0,   814,   822,   825,   824,
     823,   820,    18,     0,   799,   798,     0,     0,    18,   803,
      18,    18,   827,   342,   423,   381,   394,   385,     0,     0,
       0,     0,     0,     0,   193,   195,   517,   518,   519,   528,
     529,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   197,   723,     0,   731,   730,   732,   166,   167,
     734,   735,     0,   736,    18,   719,   708,   718,   721,   724,
     717,   818,   807,   809,   812,   815,   813,     0,   816,   811,
     808,   810,   804,   805,   806,     0,   505,   503,   504,   502,
     356,   423,   196,   200,   200,   200,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   200,     0,     0,     0,
       0,   726,   750,   749,   737,   725,   817,     0,   207,   205,
     206,   208,   200,   200,   200,   200,   751,     0,   423,   201,
     202,   203,   204,   752,     0,   371
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    91,   562,   571,   563,   400,   956,  1021,
    1022,   793,  1803,   210,  1039,   365,    92,   550,   211,   553,
     542,   543,    93,   219,   220,    94,    95,    21,    22,    23,
      24,    25,    26,   138,   363,    96,  1235,   346,    97,   352,
     347,    98,   582,    99,   585,   908,   100,   575,   101,   102,
     593,   103,   104,   235,   263,   609,  1117,   922,   598,   105,
     917,  1283,  1114,   918,  1401,  1402,   880,   881,  1722,   106,
     107,   602,   264,   357,   728,   729,   373,   741,   742,  1538,
    1698,  1539,  1540,  1712,  1807,    27,    28,    29,    30,   394,
      31,    32,    33,   385,   769,    34,   382,   754,    35,   386,
     375,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,   202,   545,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   132,   379,   108,   583,   109,
     898,   899,   900,  1109,   924,   925,   610,   911,   902,   110,
     588,  1275,  1276,  1497,   191,   446,  1578,   825,   447,   826,
     448,   449,   450,  1582,   451,  1583,   192,   453,   454,  1499,
     416,   193,   417,   426,   194,   195,   196,  1230,   197,   515,
    1266,  1231,  1368,  1369,   805,   806,  1277,   111,  1124,   930,
     112,  1289,  1472,  1541,  1611,  1471,  1404,  1290,  1292,  1407,
    1476,  1544,  1294,    58,   113,   642,  1136,  1310,  1311,   114,
     115,  1185,   994,   116,    59,   547,   117,   118,   320,   321,
     322,   999,  1198,  1337,  1342,  1340,  1341,  1486,  1555,  1199,
    1488,  1565,  1200,  1640,  1485,  1549,  1550,  1643,  1814,  1887,
    1873,  1329,  1347,  1424,  1482,  1546,  1484,  1330,    60,    61,
      62,    63,    64,    65,    66,    67,   782,   119,   120,   121,
    1207,  1003,   122,  1348,  1567,  1678,  1771,  1566,  1490,  1349,
      68,    69,   123,   124,   335,  1010,  1011,   336,  1233,  1012,
     706,    70,   125,    71,   126,   127,   128,   516
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1523
static const yytype_int16 yypact[] =
{
      97,  3215,   175,   782,   646,   982,   186,   646,   646,   798,
     646,   224,   110,   924,   130,   139,  1030,  1851,   161,   646,
     148, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,   345,   804,   398,   749,   559,   303,
     374,   379, -1523, -1523,   401,   476,   426,   399,  1851,   605,
   -1523, -1523, -1523, -1523, -1523, -1523,    87,    87, -1523, -1523,
   -1523, -1523,   218, -1523,   993, -1523,    87,  3053, -1523, -1523,
   -1523,    87, -1523,    87,  2831,    87, -1523,    87,  2857,    87,
    3069,    87, -1523,    87,  2904, -1523, -1523,  2735,  3100, -1523,
   -1523, -1523,   162, -1523,   633,   684,   699,   633,   651, -1523,
     737,   737,   646,   646,   757,   195, -1523,   686,   916,   100,
   -1523,   783,   805, -1523, -1523,   546,   286,   373,   830,   567,
     567,   848,   855,   881,   886,   889,   891,   900,   902,   103,
   -1523, -1523, -1523,   833,   496, -1523,   669,    50,    26,  1851,
   -1523,   509,   519,   527, -1523, -1523,   529,   531,   538,  1061,
     124, -1523, -1523, -1523, -1523, -1523,  2417, -1523,  2760, -1523,
   -1523,  1952,   953,   737, -1523,   951, -1523, -1523,   912, -1523,
   -1523,     8,   222,   162,   259, -1523, -1523, -1523, -1523,   467,
     555,   259,   259,   802,   811,   193, -1523,   986, -1523,   195,
     580,  2984, -1523,   876,  1015,   602,   609, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,   617,   162,
     742,  1044,   956,   259,   842, -1523,   484,   871,   643,  1028,
     643,   195, -1523,   677,   688,   665,   687,    -8,   789,   799,
    1043,   703,  1115,   854,   643,   842,  1074,  1076,   310,   996,
     740,   142,   567,   339,  1092,   279,  1095,   903,   899,   430,
    1091,   915,   433,   914,   911,   842,   909,   908,   905,   660,
     -66,  1129,   904,   920,   842,   298,   842, -1523,   794,   791,
     815,   838,    98,   842,  1111,   259,   842,  1121, -1523, -1523,
     820,   818, -1523,   822,  1153,   419, -1523,   831,   826,   841,
     935,   567,  1179, -1523,   849,   781,   844,  1187,   842,  1207,
     842,  1205,  1206,  1201,   259, -1523,   872,   873,   874,  1223,
     737, -1523,   888,   893, -1523, -1523,  1011,  1301,   651, -1523,
   -1523,  1306,   259,  1309, -1523,  1311,  1315,  1316,  1317, -1523,
   -1523, -1523,   232,  1321,  1308,  1326, -1523, -1523,   851,  1328,
   -1523,  1340,   800, -1523, -1523,  3285,   788,   830, -1523,   830,
     830, -1523,   301,   346,  1341,   830,   830,  1343, -1523, -1523,
      25,  1165,  1166, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,    23, -1523,   103,  1851,   103,   103,  1335, -1523,  1336,
    1337,  1331,   181,  1332,    26,    26,  1329,  1333,  1851,  1851,
    1851,  1851,  1851,  1349, -1523, -1523,  1347, -1523,   947,    64,
   -1523, -1523, -1523, -1523,  1003, -1523,  1372, -1523, -1523, -1523,
   -1523,    53,    68, -1523,   198, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1135, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,   520, -1523, -1523,  1377,  1378,   615,  1851,   643,
   -1523, -1523,  1952,   965, -1523, -1523, -1523, -1523, -1523, -1523,
     259,  1851, -1523, -1523, -1523, -1523,   259,   898,   925, -1523,
     573, -1523, -1523,   259, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,  1851,   967,  2427, -1523,    77,   968, -1523,   970,  1373,
   -1523, -1523, -1523,   -98, -1523, -1523,   842, -1523, -1523,    98,
   -1523, -1523, -1523, -1523,   389,  3103, -1523,  1258,  1851, -1523,
   -1523,   389, -1523, -1523,   389, -1523, -1523, -1523, -1523, -1523,
   -1523,  1320,  1323,    48,   842,   217, -1523,   983,    12,   985,
     987,   259,   287,  1099,   842,  1241,   567,   995,   997, -1523,
    1008,  1388,   -13,   259,  1249,   259,  1368,  1371,   259,  1379,
      -7,   259,   259,   842,  1380,  1025,  1344,  1026,   842,  1037,
     842,   299,   842,  1044,   842,  1050,  1051,   842,   842,   842,
    1055,  1278,   842,  1056, -1523, -1523, -1523,   842, -1523, -1523,
     842, -1523,  1411,   259, -1523, -1523, -1523,  1463,  1068,  1070,
   -1523, -1523, -1523,   842, -1523,  1044, -1523, -1523,   946, -1523,
     567, -1523,  1219, -1523, -1523, -1523,  1073,   259, -1523,   259,
   -1523,   842,   842,   842, -1523, -1523, -1523, -1523,   259,   567,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,   572, -1523,
   -1523,  1495, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,   611, -1523, -1523, -1523, -1523,  1496, -1523, -1523, -1523,
    1481, -1523, -1523,  1489,   567, -1523, -1523,  1487,  1488, -1523,
    3103, -1523, -1523, -1523, -1523,   567, -1523, -1523, -1523,  1493,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1505,
    1497,  1497,   816,   830,  1497,   830,  1497, -1523,  1497,  1497,
   -1523,   259,   567, -1523,  1500,  1501,  1503, -1523, -1523,   901,
   -1523, -1523, -1523, -1523,   158, -1523,  1094, -1523,  1269,  1498,
   -1523, -1523, -1523, -1523,   192,   344,   570,   984,   670,   333,
   -1523,  1851, -1523,  1851,  1096,    21,  1100,  1122,   177,   265,
   -1523, -1523, -1523,  1508,  1506, -1523,  2544,  2544,  2544,  3339,
    3339,  2544,  2544,  2544,  2544,  2544,   812,   812,  1333,  1333,
   -1523,  1110, -1523, -1523, -1523, -1523, -1523,  1952, -1523, -1523,
   -1523,  1023,  3103,   643, -1523,  1442, -1523,   631, -1523, -1523,
    1252,  1515, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1116,
   -1523,  1118,  1413, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,   102,  1120,
    1119, -1523, -1523,   259, -1523, -1523,   567, -1523, -1523, -1523,
    2327,  2427, -1523,   567, -1523,  1125, -1523,  1510, -1523,  1124,
   -1523,  1417, -1523, -1523, -1523, -1523,   842,  2984, -1523, -1523,
    2993,   259,   259,  1475,  1484,  1134,   259,  1138,  1139, -1523,
     842,    47, -1523, -1523,  1140,  1144,  1145,  1150,   842,  1151,
     842,  1154, -1523, -1523, -1523,  1561, -1523,   259,   259, -1523,
    1160,   259,  1163,   259,   259,  1164,   259,  1167,  1168,  1169,
    1170,  1171,   259, -1523,    98, -1523,  1172, -1523,  1173,  1175,
    1176,  1178,  1185,  1186,  1188, -1523, -1523,  1195,  1197,  1198,
   -1523,   366,  1199, -1523,  2929, -1523, -1523,   259, -1523,   949,
    1200, -1523, -1523,  2715,  1204,  1208, -1523,  1388, -1523,   567,
    -124,  1219,  2377, -1523, -1523, -1523, -1523, -1523,  1541, -1523,
      25, -1523, -1523, -1523,  1011, -1523, -1523,   232, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1625,
    1630, -1523, -1523,    98, -1523, -1523,    98,  1619, -1523,    98,
    1497,  1632,  1497,  1635,  1636,  1637, -1523, -1523,  1452,  1470,
     103, -1523,  1851, -1523,  1627,  1628,  1851,  1851,  1851, -1523,
    1851, -1523,  1851,   698,   125,  1385,  1851,  1587,  1851, -1523,
   -1523,  1851, -1523, -1523,  1218,   833, -1523,  1851, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1124, -1523,
   -1523, -1523, -1523,  2427,  2514, -1523, -1523, -1523,  1235,  1237,
   -1523,  1482, -1523, -1523,  1007, -1523,   731, -1523, -1523, -1523,
   -1523,   567, -1523, -1523,  1243,  1238,  1245,   364,   259, -1523,
    1246, -1523, -1523,  1247,   969, -1523,  1248, -1523, -1523, -1523,
   -1523,  1250, -1523,  1251, -1523, -1523,    63, -1523, -1523, -1523,
    1253, -1523,  1255,  1256, -1523,  1257, -1523, -1523, -1523, -1523,
   -1523,  1260,  1261, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  1262, -1523,  1063,  3103,   643,
     259,  1485, -1523, -1523, -1523,  1263, -1523, -1523,   842,  -131,
     522, -1523,  1358,   567, -1523, -1523,   600, -1523,  1267, -1523,
    1299, -1523, -1523,   842,   259, -1523, -1523,  1270, -1523, -1523,
   -1523,  1388,   842,   259,  -124,    45, -1523,  1670, -1523, -1523,
    1271,  1851, -1523, -1523, -1523,  1851,  1851,   842, -1523,  2417,
    1273,  1633, -1523, -1523,   259, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,  1691, -1523,  1695, -1523, -1523, -1523,
    1684,  1687, -1523, -1523,  1675, -1523,  1887,  1964,  2021,  2058,
     741,  1851, -1523,  1851,   409,    14,  2984,  1275,   411,    33,
    1276,  1122,  1693,  2109, -1523,  1281,    93, -1523,  2427, -1523,
    1696,   567, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,  1279, -1523,    69, -1523, -1523,   259, -1523,  1287,  1297,
    1298, -1523, -1523,  1382,  1654, -1523,   159,  1389,  1403,   746,
     674, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1444, -1523, -1523,
   -1523, -1523,   259,   259,   842,   259, -1523,  1312,    98, -1523,
   -1523,  1313,  1314,   259, -1523, -1523,   259,  1324, -1523, -1523,
    1673, -1523, -1523, -1523, -1523, -1523,  1851,  1337,  1851, -1523,
    2357,  2596,   772,  1327,  1721,   407, -1523,  2984,  1325,  1334,
   -1523, -1523, -1523,   686,   686,  1724, -1523, -1523, -1523, -1523,
    1851,  2135,  2161, -1523,  1726,  1851, -1523,  1699, -1523,  1727,
    1851,  1751,  1717,  1768,  1338, -1523, -1523, -1523, -1523,  1576,
   -1523,  1124,  1279, -1523, -1523,  1744,   643,  1499,  1342, -1523,
   -1523, -1523,  1586,  1459, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,   969,   842,  1124,  1355, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523,  1363,   259,  2383,  1366,
    2409,  2582, -1523,  1729, -1523, -1523,  1851,  1851,   727,  1633,
   -1523,  1789,  1790, -1523,  2192, -1523, -1523,  1369,  1374,   425,
      24,  1376,   513,  1381,  1383,    36,  1386,    38, -1523,  1787,
   -1523,   801, -1523, -1523, -1523,   567,  1542, -1523, -1523, -1523,
   -1523, -1523,  1299, -1523, -1523,    32,   365,    39,   809, -1523,
   -1523, -1523, -1523, -1523, -1523,  1387,  2514,  1578, -1523,    31,
    2439,  2465,  1393,  1394,  1396,  1397,  1384, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,  1777,  1851, -1523, -1523, -1523,  1781,
    1851, -1523,  1851,  1806, -1523,  1851, -1523,  1399, -1523,   643,
     842,  1400,   860,  1567,   259,   259,   393, -1523, -1523, -1523,
    1401,  1406, -1523,   842, -1523, -1523,  3023, -1523, -1523, -1523,
     241,   842,   259,   842, -1523,  1410, -1523,   259,   163,   259,
     259,  1548,   219, -1523, -1523,  1412,  2657, -1523,  1419,  1408,
    1729,   108, -1523, -1523, -1523,  1003, -1523, -1523,  1833, -1523,
   -1523, -1523, -1523,    90, -1523, -1523,  1851,  1851,  1851,  1851,
   -1523,  1420,  1422,  1426,  1415,  1428,  1431,  1432, -1523, -1523,
   -1523,  1725,  1599,  1602,  1612, -1523, -1523, -1523,   971, -1523,
    1728, -1523,   758, -1523, -1523,  1550,   259,  1447,   842,  1504,
     -15,   212,  1558,   842,  1490,   842,   259,   259,   259,  1605,
     259,   289,  1407,  1507,  1520,   259,  1514,  1529, -1523, -1523,
    1469, -1523,   259,  1479, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,   259,   259, -1523, -1523,   259,   -93,
    1817,   259,   842,   567,   842,  1525,   488,   -29,  1588,  1518,
      86,  1829,  1842,   449,  1511,  1512, -1523, -1523,  1516, -1523,
   -1523, -1523, -1523,  2218,   311,   108,   320,  2244,  2275,  2305,
    2331, -1523, -1523, -1523,  1851, -1523,  1851, -1523,  1491,  1517,
     259,   259,   259, -1523, -1523,  1010,   259,  1901,  1901,  1035,
     408,   536,  1509,   842, -1523, -1523, -1523,   363,   259,   259,
     259,   259, -1523, -1523, -1523, -1523,   613, -1523,  1526, -1523,
   -1523, -1523, -1523,   259, -1523,   259, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,   842,   842, -1523,   259,   842,
   -1523, -1523, -1523, -1523, -1523, -1523,   842,   842,   259, -1523,
   -1523, -1523, -1523,   259,   259,   259, -1523, -1523, -1523, -1523,
   -1523, -1523,   795,   259, -1523, -1523,   259,   259,   842, -1523,
     842,   842, -1523, -1523,  1851, -1523, -1523, -1523,  1519,  1524,
    1527,  1530,  1513,  1528, -1523,  1725, -1523, -1523, -1523, -1523,
   -1523,  1531, -1523,  1533,  1537,  1039,  1222,  1539,  1901,  1901,
    1901,  1901, -1523, -1523,    42, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,  1547, -1523,   842, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1551, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  2218, -1523, -1523, -1523, -1523,
   -1523,  1851, -1523,   758,   758,   758, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523,   758,  1540,  1543,  1544,
    1545, -1523,  1557, -1523, -1523, -1523, -1523,  1536, -1523, -1523,
   -1523, -1523,   758,   758,   758,   758, -1523,  1555,  1851, -1523,
   -1523, -1523, -1523, -1523,  1523, -1523
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1523, -1523, -1523, -1523,   -76,  -213,  -236,  -277,  -926,  -152,
    -751, -1523, -1137,   -84,  -394,   104, -1523, -1523, -1523, -1523,
    1418,  1084, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523,   510,  1591, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,  -310, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523,  1735,  -101,  1722, -1523,   134,  -257, -1523,
   -1523, -1523, -1523,   865,  -592,   634, -1523, -1523,   315, -1523,
   -1523, -1523, -1523,   -50, -1523,   959,   263, -1523,   957,  -812,
     190, -1522, -1523,  -352, -1523, -1523, -1523, -1523, -1523,  -126,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
    -178, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  1098,  1629, -1523, -1523, -1523,
   -1523,  -841,   906,   730,  1427,  -706,  -369, -1523,  1102, -1523,
   -1523, -1336, -1523,   444,  -189,  1189,   332, -1042, -1369,  1830,
   -1270, -1234,  1192,   336, -1523, -1523,  -179,  1190, -1523, -1523,
   -1523, -1523,  -391,   760, -1523, -1523,  -997, -1523,  -165,   796,
     -17, -1523, -1523,   574,   964,   671, -1000, -1523, -1523, -1523,
   -1523,   907,   564, -1523, -1523, -1523,   635, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  1079, -1523, -1523,   618, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,   604, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,   556, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  1029, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1164
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -489
static const yytype_int16 yytable[] =
{
     198,   445,   678,   230,   418,   641,   644,   401,   402,   572,
     919,   452,  1232,   308,  1035,  1229,   770,   319,   601,   327,
     797,  1385,   798,   334,   800,   801,   348,   353,  1076,   957,
     796,  1515,   397,  1265,  1267,  1269,  1270,  1571,   411,   630,
    1390,   424,   412,  1522,   638,  1525,  1572,  1573,  1574,  1080,
     398,   399,   413,   551,  1034,   791,   665,   398,   399,   659,
     398,   399,   554,   940,   913,  1365,   555,  1356,   670,  1108,
     673,   231,   518,   519,   520,   521,   522,   679,   422,  1699,
     682,  1210,   556,   557,   558,   559,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   831,   832,   532,  1767,  -329,
    1405,     1,   708,   380,   710,   957,   233,  1229,  -329,  -329,
    -329,  -329,  1215,   576,  -328,   577,   578,   579,   411,   903,
    1768,  1101,   412,  -328,  -328,  -328,  -328,  1215,   933,   967,
    1579,  1212,   413,   518,   519,   520,   521,   522,   565,   440,
     441,   442,   173,   443,  1216,   570,   570,   523,   524,   525,
     526,   527,   528,   529,   530,   531,  1091,   554,   532,  1216,
    1569,   555,   427,   564,  1718,  1719,   518,   519,   520,   521,
     522,   958,   439,   621,   613,    72,   615,   600,   864,   694,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   139,
     629,   532,   440,   441,   442,  1080,   443,   199,   354,   595,
     518,   519,   520,   521,   522,   640,   200,   355,   576,   808,
     577,   578,   579,  1217,   523,   524,   525,   526,   527,   528,
     529,   530,   531,  1332,  1333,   532,   234,   146,  1217,  1580,
    1756,   370,   554,   768,   554,  1682,   555,   554,   555,   681,
     371,   555,   904,   905,   906,   366,   418,   958,   418,   666,
     418,   418,   556,   557,   558,   559,  1334,   556,   557,   558,
     559,   779,  1213,   780,   781,  1581,   784,   786,   714,   788,
     789,   968,   147,  1699,   554,   622,  1397,  1495,   555,  1229,
     440,   441,   442,  1080,   443,  1353,   733,   381,  1098,   916,
    1649,   560,   159,   936,  1218,  1219,  1220,  1221,  1222,  1223,
    1224,   160,   554,   423,   554,   388,   555,   546,   555,  1218,
    1219,  1220,  1221,  1222,  1223,  1224,  1225,  1579,  1102,  1226,
     388,  1757,   556,   557,   558,   559,  1572,  1573,  1574,  1080,
     914,  1225,   580,  1406,  1226,  1572,  1573,  1574,  1080,  1723,
     204,   941,  1769,  1458,  1720,  1460,   783,   869,  1462,  1786,
    1465,  1467,   518,   519,   520,   521,   522,   398,   399,   951,
     915,   739,  1441,  1282,   205,   388,   523,   524,   525,   526,
     527,   528,   529,   530,   531,  1655,   934,   532,   554,   554,
    1721,   554,   555,   555,   223,   555,  1770,  1040,   935,   938,
    1051,   785,  1053,   224,  1054,  1055,   947,   799,   949,   556,
     557,   558,   559,   804,   554,  1414,   983,   740,   555,   389,
     959,   814,   815,   816,   817,   818,  1580,   971,   206,   207,
     226,  1007,   976,  1008,   978,   920,   982,   827,   984,  1447,
    1650,   987,   988,   989,   809,   552,   992,  1108,  1005,  1386,
    1448,   995,  1020,  1498,   996,  1735,  1229,   414,  1774,  1516,
    1077,   792,  1581,   415,   719,  1575,   425,  1004,  1391,  1576,
    1547,  1523,  1392,  1526,   554,   866,   212,  1556,   555,  1357,
    1871,   561,  1324,  1592,  1134,  1016,  1017,  1018,  1594,  1724,
    1595,   390,   829,  1597,   570,   830,  1315,   566,  1020,   822,
     871,  1415,   586,   823,  1775,   833,   225,   879,   633,  1229,
     907,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,  1057,  1685,  -329,   395,  1686,
    1607,  -329,   581,   643,   616,   567,   568,   414,   921,   603,
    1400,   865,  -328,   415,  1651,   921,  -328,   554,   921,   937,
    1608,   555,   213,   229,   870,   945,   946,  1808,   444,  1809,
    1262,   646,  1551,   604,  1263,   944,   214,   556,   557,   558,
     559,   647,   227,   671,   882,   639,   561,   960,   396,   962,
    1498,  1804,   965,  1229,  1229,   969,   970,   979,   518,   519,
     520,   521,   522,  1725,   672,   398,   399,  1062,   201,   356,
     228,   927,   523,   524,   525,   526,   527,   528,   529,   530,
     531,  1081,  1031,   532,  1090,   980,   981,   998,   634,   221,
     605,   606,   876,   877,   878,   554,  1641,   581,   860,   555,
     607,  1066,   372,  1642,   232,  1184,   222,   834,   554,  1106,
     835,  1014,   555,  1015,   635,   556,   557,   558,   559,   445,
     445,   561,  1019,   561,   358,   237,   561,   361,   556,   557,
     558,   559,  1792,   133,  1793,   452,  1244,  1050,  1246,  1052,
    1609,  1610,   206,   207,  1162,   129,   130,  1718,  1719,  1252,
     391,  1867,  1868,  1869,  1870,  1810,  1564,  1811,   518,   519,
     520,   521,   522,   561,   392,   393,  1298,   359,  1229,   444,
    1118,   131,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   861,   360,   532,  1133,  1135,   518,   519,   520,   521,
     522,   561,  1141,   561,  1143,  1056,   651,   652,   362,  1552,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   655,
     656,   532,  1211,  1240,  1639,  1784,  1241,  1423,   608,  1243,
    1553,   862,  1815,  1816,  1575,   928,   663,   664,   929,   518,
     519,   520,   521,   522,  1677,   554,   863,   364,  1071,   555,
     369,  1111,  1072,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   374,  1067,   532,   556,   557,   558,   559,  1092,
     518,   519,   520,   521,   522,    73,   383,   561,   561,  1174,
     561,   771,   215,  1554,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   749,  1073,   532,  1074,   772,   384,  1877,
     554,   216,  1285,   561,   555,   387,    74,   129,   130,  1041,
     637,   688,   689,   206,   207,    75,  1778,  1105,    76,  1123,
     556,   557,   558,   559,  1383,  1042,  1388,  1020,  1384,    77,
    1389,   530,   531,   131,  1293,   532,  1894,  1764,   208,   388,
    1513,   403,    78,  1502,  1514,  1125,  1126,   554,   404,   209,
    1130,   555,    79,   419,  1286,  1287,  1288,   217,    80,   608,
     376,   377,  1822,   561,   773,  1706,  1335,   556,   557,   558,
     559,  1147,  1148,  1765,   405,  1150,   750,  1152,  1153,   406,
    1155,  1299,   407,  1183,   408,   418,  1161,  1707,    81,  1708,
      82,    83,  1206,   409,  1709,   410,   774,   775,    84,   518,
     519,   520,   521,   522,   776,  1175,   603,  1503,  1504,  1710,
     420,  1186,   421,   523,   524,   525,   526,   527,   528,   529,
     530,   531,  1043,   428,   532,   376,   377,   218,  1518,  1529,
     611,  1530,  1519,   429,    85,    86,   561,  1529,   856,   857,
     777,   430,  1331,   431,  1336,   432,    87,   751,   872,   873,
    1344,   378,   433,  1711,   398,   399,  1006,  1350,   544,  1531,
     142,   143,   752,   548,  1505,   549,  1354,  1531,   569,    88,
    1506,   574,    89,   573,   753,   874,   875,   697,   778,  1343,
    1557,  1363,   518,   519,   520,   521,   522,   605,   606,  1068,
    1023,  1024,   133,   587,  1020,   584,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   589,   169,   532,   170,   171,
     172,   173,   174,   175,   561,   398,   399,  1281,  1430,   591,
     176,   177,   824,   178,   590,   179,   592,   561,   134,  1026,
    1027,  1339,   597,  1089,   594,   804,   135,   136,   137,  1256,
    1257,  1258,  1300,  1259,  1837,  1260,   698,  1532,  1533,  1094,
     857,  1534,  1535,   597,  1271,   596,   238,  1536,   148,   149,
    1273,   239,  1187,   599,   169,  1558,   170,   171,   172,   173,
     174,   175,   597,  1323,  1418,  1419,   150,   699,   176,   177,
     722,   178,   619,   179,  1044,  1325,   700,   614,  1427,  1070,
     617,   151,  1420,  1421,  1326,   140,   141,   144,   145,   161,
     152,   618,   153,   154,   620,   240,   623,   203,  1602,  1603,
    1703,  1704,   624,   180,   625,   608,   626,  1261,  1351,   181,
     518,   519,   520,   521,   522,   627,  1188,  1355,   628,  1045,
     723,   724,  1303,   631,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   725,   726,   532,   727,   241,  1370,  1799,
    1800,   632,  1046,   636,   561,  1559,  1560,  1561,   645,  1562,
    1380,   648,   162,   649,   163,   164,   650,  1047,   653,   155,
    1304,   180,  1805,  1806,   811,   812,  1481,   181,  1856,  1857,
    1858,  1859,  1860,   182,   183,  1451,  1452,   654,  1542,  1444,
     701,   702,   703,   704,  1360,    90,  1048,  1049,  1361,  1362,
     657,   658,   660,   661,  1367,   662,   667,   674,   675,   561,
    1408,   677,   668,   165,   166,   167,   168,   680,  1189,  1537,
     184,   185,   434,   435,   436,   437,   669,  1563,   683,   687,
     367,   368,   676,   684,  1381,   685,  1382,   186,   242,   686,
     187,   182,   183,   691,   690,   188,  1425,  1426,   693,  1428,
     518,   519,   520,   521,   522,   695,   561,  1433,   692,   156,
    1434,   705,   696,   707,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   709,   711,   532,   713,   712,   184,   185,
     434,   435,   436,   437,  1600,   715,   716,   717,  1305,   718,
    1306,  1190,  1307,  1308,   730,   186,  1309,  1614,   187,   732,
    1577,   720,   734,   188,   735,  1644,   721,  1646,   736,   737,
     738,  1605,  1474,  1191,   743,  1192,  1061,   744,   157,   745,
    1193,   747,  1194,  1548,   243,  1548,  1195,  1196,   244,  1438,
     804,  1440,   158,   748,   787,   850,   790,   794,   795,   802,
     169,   803,   170,   171,   172,   173,   174,   175,   807,   813,
     810,  1491,   820,  1454,   176,   177,   532,   178,   819,   179,
     851,  1861,  1862,  1863,  1864,  1865,   821,  1197,   852,   828,
     858,   859,  1716,   853,   854,   855,  1761,  1727,   868,  1729,
     883,   909,   912,   245,   910,   926,   931,   246,   169,   932,
     170,   171,   172,   173,   174,   175,   939,   948,   942,  1069,
     943,   247,   176,   177,  1264,   178,   950,   179,   952,   955,
     953,   518,   519,   520,   521,   522,  1760,   189,  1762,  1500,
    1501,   954,  1367,   961,   190,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   963,  1599,   532,   964,   973,   975,
     518,   519,   520,   521,   522,   966,   972,   180,   570,  1606,
     977,   974,   991,   181,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   985,   986,   532,  1645,  1813,   990,   993,
     997,  1648,  1000,  1652,  1653,   189,  1656,  1796,  1797,  1798,
    1823,  1001,   190,  1002,  1009,  1577,  1013,  1577,  1025,  1028,
    1029,  1878,  1879,  1880,  1030,   180,  1032,  1033,  1037,  1827,
    1828,   181,  1036,  1830,  1881,  1058,  1059,  1038,  1060,  1063,
    1831,  1832,  1064,  1084,  1085,  1075,  1065,   182,   183,  1078,
    1889,  1890,  1891,  1892,  1087,  1096,  1838,  1872,  1113,  1097,
    1714,  1099,  1842,  1103,  1843,  1844,  1104,  1079,  1112,  1116,
    1730,  1731,  1732,  1115,  1734,  1736,  1127,  1129,  1683,  1747,
    1128,  1131,  1132,  1137,   184,   185,  1751,  1138,  1139,  1687,
    1688,  1689,  1690,  1140,  1142,   182,   183,  1144,  1753,  1754,
    1145,   186,  1755,  1149,   187,  1759,  1151,  1154,  1875,   188,
    1156,  1157,  1158,  1159,  1160,  1163,  1164,  1779,  1165,  1166,
     169,  1167,   170,   171,   172,   173,   174,   175,  1168,  1169,
    1234,  1170,   184,   185,   176,   177,  1268,   178,  1171,   179,
    1172,  1173,  1176,  1201,   570,   570,   570,  1208,  1238,   186,
    1801,  1209,   187,  1239,  1242,  1245,  1250,   188,  1247,  1248,
    1249,  1817,  1818,  1819,  1820,  1821,   169,  1272,   170,   171,
     172,   173,   174,   175,  1251,  1254,  1255,  1825,  1278,  1826,
     176,   177,  1279,   178,  1280,   179,  1295,  1296,  1297,  1301,
    1302,  1312,  1829,  1313,  1314,  1327,  1316,  1095,  1317,  1318,
    1319,  1338,  1833,  1320,  1321,  1322,  1328,  1834,  1835,  1836,
    1345,  1346,  1358,  1352,  1371,  1359,  1366,  1839,  1372,  1373,
    1840,  1841,  1374,  1375,  1387,  1393,  1403,   180,  1394,  1396,
    1409,  1399,   169,   181,   170,   171,   172,   173,   174,   175,
    1410,  1411,  1412,  1413,  1422,  1416,   176,   177,  1459,   178,
     169,   179,   170,   171,   172,   173,   174,   175,  1417,  1429,
    1431,  1432,  1437,  1446,   176,   177,  1464,   178,  1215,   179,
    1445,  1435,  1453,   180,  1449,  1457,  1461,  1450,  1463,   181,
    1469,   189,  -488,  1473,  1475,  1477,  1468,  1845,   190,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,   182,   183,  1478,
    1216,   169,  1483,   170,   171,   172,   173,   174,   175,  1479,
    1489,  1493,  1508,  1509,  1511,   176,   177,  1466,   178,  1512,
     179,  1517,  1527,  1570,  1543,  1520,  1591,  1590,  1521,   189,
    1593,  1524,  1568,  1596,   184,   185,   190,  1586,  1587,   180,
    1588,  1589,  1598,   182,   183,   181,  1604,  1601,  1612,  1613,
    1654,   186,   236,  1647,   187,  1657,  1680,   180,  1100,   188,
    1684,   248,  1679,   181,  1694,  1691,   265,  1692,   266,  1217,
     309,  1693,   310,  1695,   323,  1696,   328,  1697,   329,  1700,
     184,   185,  1701,  1529,   169,  1093,   170,   171,   172,   173,
     174,   175,  1702,  1713,  1715,  1705,  1726,   186,   176,   177,
     187,   178,  1717,   179,  1746,   188,  1728,  1733,   180,   182,
     183,  1749,  1750,  1758,   181,   518,   519,   520,   521,   522,
    1748,  1745,  1752,  1763,  1773,  1776,  1772,   182,   183,   523,
     524,   525,   526,   527,   528,   529,   530,   531,  1777,  1794,
     532,  1802,  1780,  1824,  1874,  1781,   184,   185,  1876,  1886,
    1218,  1219,  1220,  1221,  1222,  1223,  1224,  1812,  1850,  1782,
    1795,  1088,  1846,   186,   184,   185,   187,  1847,  1895,   731,
    1848,   188,  1225,  1849,  1853,  1226,  1854,  1851,   182,   183,
    1855,   186,  1866,  1882,   187,  1888,  1883,  1884,  1885,   188,
     867,   180,   518,   519,   520,   521,   522,   181,  1893,   612,
    1284,  1766,  1436,  1236,  1237,  1852,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   184,   185,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   746,  1398,  1274,
     901,   189,   186,  1110,  1681,   187,  1785,  1082,   190,   438,
     188,  1083,  1787,  1507,  1086,  1364,  1253,  1291,  1439,   518,
     519,   520,   521,   522,  1528,  1146,  1487,  1470,  1545,  1480,
    1214,   182,   183,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,     0,   532,     0,  -483,   189,     0,     0,
       0,     0,     0,     0,   190,     0,   518,   519,   520,   521,
     522,     0,     0,     0,     0,     0,     0,     0,   184,   185,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
       0,   532,     0,     0,     0,   186,     0,     0,   187,     0,
       0,     0,     0,   188,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   522,     0,   189,     0,     0,     0,     0,     0,     0,
     190,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   189,   532,   518,   519,   520,   521,   522,   190,     0,
       0,     0,     0,     0,     0,     0,  1496,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,     0,   532,   518,
     519,   520,   521,   522,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   189,     0,   532,     0,     0,     0,     0,   190,
     518,   519,   520,   521,   522,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,     0,   532,   518,   519,   520,   521,
     522,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
       0,   532,   518,   519,   520,   521,   522,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   189,     0,   532,     0,     0,
       0,     0,   190,   518,   519,   520,   521,   522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,     0,   532,     0,
       0,     0,  1376,   518,   519,   520,   521,   522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,     0,   532,   518,
     519,   520,   521,   522,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,     0,   532,   518,   519,   520,   521,   522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,  1377,
     532,   518,   519,   520,   521,   522,  1215,     0,     0,     0,
       0,     0,     0,     0,     0,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,     0,   532,   518,   519,   520,
     521,   522,   455,     0,     0,     0,     0,     0,  1216,     0,
       0,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,     0,   532,     0,     0,     0,  1378,   518,   519,   520,
     521,   522,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,     0,   532,   518,   519,   520,   521,   522,     0,     0,
       0,     0,     0,  1379,     0,     0,     0,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,  1217,   532,   456,
     457,     0,     0,     0,     0,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,  1215,  1395,   884,   885,   886,   887,   888,
     889,   890,   891,     0,   892,   893,   894,   895,   896,   897,
       0,     0,  -489,  -489,  -489,     0,   486,     0,     0,     0,
    1455,     0,     0,     0,     0,  1216,  -489,  -489,  -489,  -489,
    -489,   528,   529,   530,   531,     0,     0,   532,  1218,  1219,
    1220,  1221,  1222,  1223,  1224,     0,  1456,   455,     0,     0,
       0,     0,     0,     0,     0,   487,     0,     0,     0,     0,
    1225,     0,     0,  1226,   518,   519,   520,   521,   522,     0,
       0,     0,     0,     0,     0,     0,     0,  1510,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,     0,   532,
       0,     0,  1227,     0,  1217,   884,   885,   886,   887,   888,
     889,   890,   891,  1783,   892,   893,   894,   895,   896,   897,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
       0,     0,     0,     0,   456,   457,     0,     0,     0,  1788,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,     0,  1658,
    1789,     0,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     0,     0,     0,     0,  1218,  1219,  1220,  1221,  1222,
    1223,  1224,     0,  1659,  1660,     0,     0,     0,   506,   507,
    1790,     0,     0,     0,     0,     0,     0,  1225,     0,     0,
    1226,     0,     0,   508,  1661,     0,     0,     0,     0,     0,
       0,     0,  1107,     0,     0,     0,  1791,     0,     0,     0,
     487,   249,     0,   517,   509,   510,   511,   512,   518,   519,
     520,   521,   522,     0,     0,     0,     0,     0,     0,     0,
    1442,   249,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,     0,   532,     0,  1529,     0,  1662,     0,     0,
       0,   251,     0,     0,     0,  1228,  1492,     0,   337,   338,
     339,     0,   340,   341,     0,   342,     0,     0,     0,   343,
    1443,   251,   344,     0,  1663,  1531,     0,     0,     0,     0,
       0,   252,  1494,   513,   514,   253,   254,     0,  1202,   256,
     257,     0,     0,   258,     0,     0,   259,     0,     0,     0,
       0,   252,     0,     0,     0,   253,   254,     0,     0,   256,
     257,     0,  1584,   258,     0,     0,   259,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     0,   249,     0,     0,
       0,     0,   267,     0,   260,     0,     0,     0,  1585,   261,
       0,     0,   268,   506,   507,     0,     0,   269,     0,     0,
       0,     0,     0,   249,   260,     0,     0,     0,   508,   261,
       0,   270,  1664,     0,     0,  1665,  1666,   251,     0,     0,
       0,     0,     0,  1667,     0,     0,     0,     0,     0,   509,
     510,   511,   512,     0,     0,     0,     0,     0,     0,     0,
       0,   311,  -328,   251,     0,     0,     0,   252,     0,     0,
     249,   253,   254,   271,   272,   256,   257,     0,     0,   258,
       0,     0,   259,     0,     0,     0,   273,     0,     0,   274,
     330,   275,     0,   252,  1668,   249,     0,   253,   254,     0,
       0,   256,   257,     0,     0,   258,     0,     0,   259,     0,
     251,     0,   518,   519,   520,   521,   522,     0,   513,   514,
     260,     0,     0,     0,     0,   261,   523,   524,   525,   526,
     527,   528,   529,   530,   531,  1177,     0,   532,     0,   276,
     252,   277,     0,     0,   253,   254,   260,     0,   256,   257,
     278,   261,   258,     0,     0,   259,     0,     0,     0,   249,
       0,     0,  1669,     0,     0,   252,     0,     0,     0,   253,
     254,     0,     0,   256,   257,  1178,     0,   258,  1670,     0,
     259,     0,     0,  1671,  1672,     0,  1673,  1674,   279,  1675,
       0,     0,     0,   260,     0,     0,     0,     0,   261,   251,
       0,     0,     0,     0,     0,  1676,   280,     0,     0,  1615,
       0,     0,   331,   281,   282,     0,   283,     0,   260,   249,
    1203,   284,   285,   261,   286,   287,     0,   288,     0,   252,
     289,   290,   291,   253,   254,   249,  1119,   256,   257,   250,
    1204,   258,   923,     0,   259,   292,   293,     0,     0,     0,
     294,     0,   295,   296,     0,   297,     0,     0,     0,   251,
     298,     0,     0,  1205,   299,   300,   249,   301,   302,     0,
     303,   304,   305,     0,     0,   251,   306,     0,     0,     0,
       0,  1529,   260,   345,     0,     0,     0,   261,     0,   252,
       0,     0,     0,   253,   254,   349,   255,   256,   257,     0,
       0,   258,     0,   608,   259,   252,   251,     0,     0,   253,
     254,  1531,     0,   256,   257,     0,     0,   258,     0,     0,
     259,     0,     0,   312,  1616,     0,     0,     0,   313,   314,
     315,     0,     0,     0,     0,     0,   252,   332,  1617,     0,
     253,   254,   260,     0,   256,   257,     0,   261,   258,     0,
       0,   259,     0,     0,     0,     0,     0,     0,   260,     0,
       0,     0,   316,   261,     0,     0,     0,     0,     0,   317,
       0,     0,     0,     0,   350,  1120,  1121,     0,     0,   307,
       0,     4,     0,     0,     0,     0,     0,     0,     0,   260,
       0,  1179,  1180,  1181,   261,     0,     0,     0,  1618,     0,
       0,  1619,  1620,     0,     0,   318,     5,     6,   755,  1621,
       0,     0,     0,     0,     0,     0,     7,     0,     0,     0,
       0,     0,     0,   398,   399,     0,     0,     0,     0,     0,
       0,   884,   885,   886,   887,   888,   889,   890,   891,     0,
     892,   893,   894,   895,   896,   897,     0,     0,     0,     0,
     756,     0,   333,     0,     0,     0,     0,     0,     0,     0,
    1622,     0,     0,  1623,     0,     0,  1624,   518,   519,   520,
       8,     0,     0,     0,     0,     0,     0,  1182,     0,     0,
       0,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   757,   532,     0,     0,  1625,     0,  1626,     0,  1627,
    1628,  1629,  1630,  1631,  1632,     0,     9,     0,     0,    10,
    1633,    11,     0,  1634,     0,     0,  1635,     0,    12,     0,
      13,     0,   324,   758,     0,    14,    15,    16,  1636,     0,
     759,   760,    17,    18,    19,     0,  1637,     0,     0,     0,
       0,  1122,   761,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   762,
     763,   764,   765,     0,   766,   767,     0,     0,     0,     0,
       0,  1638,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     325,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   262,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   326,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   351,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   608,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    20
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1523)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-489)))

static const yytype_int16 yycheck[] =
{
      17,   190,   312,    87,   169,   282,   283,   159,   160,   222,
     602,   190,  1012,   114,   765,  1012,   385,   118,   254,   120,
     411,     7,   413,   124,   415,   416,   127,   128,     7,    42,
       7,     7,   158,  1075,  1076,  1077,  1078,     6,    15,   275,
       7,    15,    19,     7,   280,     7,    15,    16,    17,    18,
      18,    19,    29,    45,   760,    30,   122,    18,    19,   295,
      18,    19,    15,    51,   162,  1229,    19,    22,   304,   910,
     306,    88,     8,     9,    10,    11,    12,   313,    28,  1601,
     316,  1007,    35,    36,    37,    38,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    27,    28,    33,   127,     6,
      31,     4,   338,     3,   340,    42,    19,  1104,    15,    16,
      17,    18,    19,    15,     6,    17,    18,    19,    15,    42,
     149,    19,    19,    15,    16,    17,    18,    19,    80,   136,
    1499,   255,    29,     8,     9,    10,    11,    12,   214,    15,
      16,    17,    18,    19,    51,   221,   222,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   862,    15,    33,    51,
    1496,    19,   179,   213,   179,   180,     8,     9,    10,    11,
      12,   184,   189,   181,   258,     0,   260,   253,   547,   331,
      22,    23,    24,    25,    26,    27,    28,    29,    30,     3,
     274,    33,    15,    16,    17,    18,    19,    36,    36,   249,
       8,     9,    10,    11,    12,   281,    45,    45,    15,    28,
      17,    18,    19,   120,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   354,   355,    33,   139,     3,   120,  1499,
     323,    36,    15,   385,    15,  1571,    19,    15,    19,   315,
      45,    19,   165,   166,   167,   141,   411,   184,   413,   315,
     415,   416,    35,    36,    37,    38,   387,    35,    36,    37,
      38,   387,   386,   389,   390,  1499,   392,   393,   344,   395,
     396,   278,   162,  1795,    15,   283,  1276,  1441,    19,  1276,
      15,    16,    17,    18,    19,  1211,   362,   187,   880,   599,
     127,    69,   162,    76,   201,   202,   203,   204,   205,   206,
     207,   162,    15,   253,    15,    19,    19,   203,    19,   201,
     202,   203,   204,   205,   206,   207,   223,  1686,   216,   226,
      19,   414,    35,    36,    37,    38,    15,    16,    17,    18,
     428,   223,   139,   264,   226,    15,    16,    17,    18,   127,
     192,   329,   371,  1385,   359,  1387,    45,   560,  1390,  1685,
    1392,  1393,     8,     9,    10,    11,    12,    18,    19,   636,
     596,   129,  1359,  1114,    19,    19,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   156,   328,    33,    15,    15,
     395,    15,    19,    19,    81,    19,   415,   781,   624,   625,
     784,    45,   786,    19,   788,   789,   632,   414,   634,    35,
      36,    37,    38,   420,    15,   246,   663,   175,    19,   123,
     423,   428,   429,   430,   431,   432,  1686,   653,    19,    20,
      19,   698,   658,   700,   660,    36,   662,   444,   664,    22,
     267,   667,   668,   669,   253,   427,   672,  1278,   695,   425,
      33,   677,   719,  1443,   680,   156,  1443,   424,   362,   425,
     429,   426,  1686,   430,   350,   424,   430,   693,   425,   428,
     428,   425,   429,   425,    15,   549,    68,   428,    19,   424,
     428,   424,  1178,  1515,   427,   711,   712,   713,  1520,   267,
    1522,   195,   429,  1525,   560,   432,   423,    20,   765,   425,
     566,   332,   229,   429,   408,   427,   117,   573,   188,  1496,
     423,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   792,   426,   424,   145,   429,
     127,   428,   424,   184,   261,    58,    59,   424,   604,    45,
    1281,   548,   424,   430,   371,   611,   428,    15,   614,   322,
     147,    19,   144,   144,   561,   258,   259,   139,   424,   141,
     425,   272,   187,    69,   429,   631,   158,    35,    36,    37,
      38,   282,    86,   265,   581,   423,   424,   643,   195,   645,
    1570,  1708,   648,  1570,  1571,   651,   652,   278,     8,     9,
      10,    11,    12,   371,   286,    18,    19,   429,   427,   427,
     164,   608,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   424,   754,    33,   861,   306,   307,   683,   298,    50,
     126,   127,    39,    40,    41,    15,   375,   424,     3,    19,
     136,   429,   427,   382,    19,   994,    67,   429,    15,   906,
     432,   707,    19,   709,   324,    35,    36,    37,    38,   828,
     829,   424,   718,   424,   134,   427,   424,   137,    35,    36,
      37,    38,  1694,    20,  1696,   834,  1050,   783,  1052,   785,
     267,   268,    19,    20,   974,    19,    20,   179,   180,  1060,
     384,  1808,  1809,  1810,  1811,   139,  1488,   141,     8,     9,
      10,    11,    12,   424,   398,   399,   322,     3,  1685,   424,
     926,    45,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    86,     3,    33,   940,   941,     8,     9,    10,    11,
      12,   424,   948,   424,   950,   791,   286,   287,    67,   354,
      22,    23,    24,    25,    26,    27,    28,    29,    30,   296,
     297,    33,  1009,  1043,  1546,   424,  1046,  1329,   254,  1049,
     375,   126,   379,   380,   424,   611,    86,    87,   614,     8,
       9,    10,    11,    12,  1566,    15,   141,    20,   425,    19,
       3,   913,   429,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    86,   429,    33,    35,    36,    37,    38,   863,
       8,     9,    10,    11,    12,     3,     3,   424,   424,   423,
     424,     3,    43,   428,    22,    23,    24,    25,    26,    27,
      28,    29,    30,     3,   821,    33,   823,    19,     3,  1851,
      15,    62,    81,   424,    19,   269,    34,    19,    20,     3,
      80,   402,   403,    19,    20,    43,   377,   903,    46,   930,
      35,    36,    37,    38,   425,    19,   425,  1114,   429,    57,
     429,    29,    30,    45,  1121,    33,  1888,   359,    44,    19,
     425,     3,    70,   126,   429,   931,   932,    15,     3,    55,
     936,    19,    80,    30,   133,   134,   135,   118,    86,   254,
      19,    20,   259,   424,    86,   117,   354,    35,    36,    37,
      38,   957,   958,   395,     3,   961,    86,   963,   964,     3,
     966,  1127,     3,   994,     3,  1060,   972,   139,   116,   141,
     118,   119,  1003,     3,   146,     3,   118,   119,   126,     8,
       9,    10,    11,    12,   126,   991,    45,   190,   191,   161,
     424,   997,   253,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   116,   424,    33,    19,    20,   188,   425,   138,
      69,   140,   429,   424,   162,   163,   424,   138,   428,   429,
     162,   424,  1188,   424,  1190,   424,   174,   157,    60,    61,
    1196,    45,   424,   205,    18,    19,    20,  1203,    15,   168,
     172,   173,   172,    22,   247,    63,  1212,   168,   423,   197,
     253,   170,   200,   181,   184,    60,    61,   206,   200,   389,
     181,  1227,     8,     9,    10,    11,    12,   126,   127,   429,
     428,   429,    20,   423,  1281,    19,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   139,    13,    33,    15,    16,
      17,    18,    19,    20,   424,    18,    19,    20,  1338,   427,
      27,    28,    29,    30,    19,    32,   427,   424,    56,   428,
     429,  1193,    19,    20,   427,  1062,    64,    65,    66,  1066,
    1067,  1068,  1128,  1070,   259,  1072,   275,   256,   257,   428,
     429,   260,   261,    19,  1081,   323,    73,   266,   144,   145,
    1087,    78,   123,   117,    13,   266,    15,    16,    17,    18,
      19,    20,    19,    20,   338,   339,   162,   306,    27,    28,
      79,    30,   427,    32,   278,  1179,   315,    69,  1334,   429,
     423,   177,   428,   429,  1180,     7,     8,     9,    10,    79,
     186,   423,   188,   189,   427,   122,   327,    19,   258,   259,
     149,   150,   323,   120,    81,   254,   423,   429,  1204,   126,
       8,     9,    10,    11,    12,    20,   187,  1213,   284,   323,
     129,   130,   173,    69,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   142,   143,    33,   145,   164,  1234,   149,
     150,    85,   346,   167,   424,   356,   357,   358,    76,   360,
     429,    76,   142,   270,   144,   145,   277,   361,    87,   255,
     211,   120,   147,   148,   424,   425,  1422,   126,   149,   150,
     151,   152,   153,   190,   191,  1373,  1374,   282,  1475,   427,
     419,   420,   421,   422,  1221,   423,   390,   391,  1225,  1226,
     296,   300,   303,   305,  1231,   310,    87,   423,   427,   424,
    1296,   383,   318,   193,   194,   195,   196,   116,   279,   428,
     227,   228,   229,   230,   231,   232,   316,   428,   117,    86,
     142,   143,   427,   423,  1261,   427,  1263,   244,   255,   427,
     247,   190,   191,   427,   423,   252,  1332,  1333,   323,  1335,
       8,     9,    10,    11,    12,    86,   424,  1343,   427,   345,
    1346,   427,   423,    86,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    76,    79,    33,    85,    81,   227,   228,
     229,   230,   231,   232,  1530,   423,   423,   423,   329,    76,
     331,   352,   333,   334,     3,   244,   337,  1543,   247,     3,
    1499,   423,     3,   252,     3,  1551,   423,  1553,     3,     3,
       3,  1534,  1406,   374,     3,   376,   425,    19,   404,     3,
     381,     3,   383,  1485,   341,  1487,   387,   388,   345,  1356,
    1357,  1358,   418,     3,     3,   210,     3,   182,   182,    14,
      13,    15,    15,    16,    17,    18,    19,    20,    27,    30,
      28,  1437,    15,  1380,    27,    28,    33,    30,    19,    32,
     235,   149,   150,   151,   152,   153,   429,   428,   243,     7,
       3,     3,  1618,   248,   249,   250,  1663,  1623,   423,  1625,
     423,   423,    19,   400,   424,   137,    76,   404,    13,    76,
      15,    16,    17,    18,    19,    20,   423,   308,   423,   425,
     423,   418,    27,    28,    29,    30,   175,    32,   423,    31,
     423,     8,     9,    10,    11,    12,  1662,   424,  1664,  1446,
    1447,   423,  1449,   184,   431,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    76,  1529,    33,    76,   423,   423,
       8,     9,    10,    11,    12,    76,    76,   120,  1534,  1535,
     423,   117,   184,   126,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   423,   423,    33,  1552,  1713,   423,   423,
      69,  1557,    19,  1559,  1560,   424,  1562,  1700,  1701,  1702,
    1726,   423,   431,   423,   275,  1684,   423,  1686,     3,     3,
      19,  1853,  1854,  1855,    15,   120,    19,    19,     3,  1745,
    1746,   126,    19,  1749,  1866,    15,    15,    20,    15,   425,
    1756,  1757,   253,    15,    18,   429,    28,   190,   191,   429,
    1882,  1883,  1884,  1885,   424,    20,  1772,  1814,    28,   423,
    1616,   423,  1778,   423,  1780,  1781,   427,   425,   423,   132,
    1626,  1627,  1628,   429,  1630,  1631,    81,   423,  1575,  1635,
      76,   423,   423,   423,   227,   228,  1642,   423,   423,  1586,
    1587,  1588,  1589,   423,   423,   190,   191,   423,  1654,  1655,
      19,   244,  1658,   423,   247,  1661,   423,   423,  1824,   252,
     423,   423,   423,   423,   423,   423,   423,  1673,   423,   423,
      13,   423,    15,    16,    17,    18,    19,    20,   423,   423,
      69,   423,   227,   228,    27,    28,    29,    30,   423,    32,
     423,   423,   423,   423,  1700,  1701,  1702,   423,     3,   244,
    1706,   423,   247,     3,    15,     3,   184,   252,     3,     3,
       3,  1717,  1718,  1719,  1720,  1721,    13,   429,    15,    16,
      17,    18,    19,    20,   184,    28,    28,  1733,   423,  1735,
      27,    28,   425,    30,   182,    32,   423,   429,   423,   423,
     423,   423,  1748,   423,   423,   190,   423,   425,   423,   423,
     423,   323,  1758,   423,   423,   423,   423,  1763,  1764,  1765,
     423,   392,    22,   423,     3,   424,   423,  1773,     3,    15,
    1776,  1777,    15,    28,   429,   429,   427,   120,    15,   428,
     423,    15,    13,   126,    15,    16,    17,    18,    19,    20,
     423,   423,   340,    69,   280,   336,    27,    28,    29,    30,
      13,    32,    15,    16,    17,    18,    19,    20,   335,   427,
     427,   427,    69,    22,    27,    28,    29,    30,    19,    32,
     423,   427,    28,   120,   429,    29,    29,   423,     7,   126,
     184,   424,   425,    19,   265,   423,   428,  1784,   431,   362,
     363,   364,   365,   366,   367,   368,   369,   190,   191,   193,
      51,    13,   427,    15,    16,    17,    18,    19,    20,   330,
     427,   425,     3,     3,   425,    27,    28,    29,    30,   425,
      32,   425,    15,   225,   262,   424,    29,   423,   425,   424,
      29,   425,   425,     7,   227,   228,   431,   424,   424,   120,
     424,   424,   423,   190,   191,   126,   259,   427,   427,   423,
     282,   244,    97,   423,   247,   423,   428,   120,   425,   252,
       7,   106,   423,   126,   429,   425,   111,   425,   113,   120,
     115,   425,   117,   425,   119,   424,   121,   425,   123,   260,
     227,   228,   260,   138,    13,   423,    15,    16,    17,    18,
      19,    20,   260,   323,   427,   147,   318,   244,    27,    28,
     247,    30,   378,    32,   364,   252,   396,   282,   120,   190,
     191,   362,   423,    76,   126,     8,     9,    10,    11,    12,
     386,   394,   423,   378,   386,    76,   318,   190,   191,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    76,   428,
      33,    20,   411,   397,   377,   413,   227,   228,   377,   372,
     201,   202,   203,   204,   205,   206,   207,   428,   425,   423,
     423,   857,   423,   244,   227,   228,   247,   423,   425,   358,
     423,   252,   223,   423,   423,   226,   423,   429,   190,   191,
     423,   244,   423,   423,   247,   429,   423,   423,   423,   252,
     552,   120,     8,     9,    10,    11,    12,   126,   423,   257,
    1115,  1666,  1348,  1024,  1027,  1795,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   227,   228,    33,    46,    47,
      48,    49,    50,    51,    52,    53,    54,   378,  1278,  1103,
     583,   424,   244,   911,  1570,   247,  1684,   828,   431,   189,
     252,   829,  1686,  1449,   834,  1229,  1062,  1120,  1357,     8,
       9,    10,    11,    12,  1470,   956,  1432,  1402,  1482,  1421,
    1011,   190,   191,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,    -1,   423,   424,    -1,    -1,
      -1,    -1,    -1,    -1,   431,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,   228,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,    -1,    -1,    -1,   244,    -1,    -1,   247,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,
      11,    12,    -1,   424,    -1,    -1,    -1,    -1,    -1,    -1,
     431,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,   424,    33,     8,     9,    10,    11,    12,   431,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   424,    -1,    33,    -1,    -1,    -1,    -1,   431,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   424,    -1,    33,    -1,    -1,
      -1,    -1,   431,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,    -1,
      -1,    -1,   425,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,   425,
      33,     8,     9,    10,    11,    12,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,     8,     9,    10,
      11,    12,     5,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,    -1,   425,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,   425,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,   120,    33,    82,
      83,    -1,    -1,    -1,    -1,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,    19,   425,   208,   209,   210,   211,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,   222,
      -1,    -1,     8,     9,    10,    -1,   139,    -1,    -1,    -1,
     425,    -1,    -1,    -1,    -1,    51,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,   201,   202,
     203,   204,   205,   206,   207,    -1,   425,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,
     223,    -1,    -1,   226,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
      -1,    -1,   255,    -1,   120,   208,   209,   210,   211,   212,
     213,   214,   215,   425,   217,   218,   219,   220,   221,   222,
     233,   234,    -1,   236,   237,   238,   239,   240,   241,   242,
      -1,    -1,    -1,    -1,    82,    83,    -1,    -1,    -1,   425,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,    -1,    42,
     425,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,    -1,    -1,    -1,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,    66,    67,    -1,    -1,    -1,   311,   312,
     425,    -1,    -1,    -1,    -1,    -1,    -1,   223,    -1,    -1,
     226,    -1,    -1,   326,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   425,    -1,    -1,    -1,   425,    -1,    -1,    -1,
     178,    46,    -1,     3,   347,   348,   349,   350,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,    46,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,   138,    -1,   140,    -1,    -1,
      -1,    86,    -1,    -1,    -1,   428,   423,    -1,    73,    74,
      75,    -1,    77,    78,    -1,    80,    -1,    -1,    -1,    84,
     224,    86,    87,    -1,   167,   168,    -1,    -1,    -1,    -1,
      -1,   116,   423,   416,   417,   120,   121,    -1,   123,   124,
     125,    -1,    -1,   128,    -1,    -1,   131,    -1,    -1,    -1,
      -1,   116,    -1,    -1,    -1,   120,   121,    -1,    -1,   124,
     125,    -1,   423,   128,    -1,    -1,   131,   285,   286,   287,
     288,   289,   290,   291,   292,   293,    -1,    46,    -1,    -1,
      -1,    -1,    51,    -1,   169,    -1,    -1,    -1,   423,   174,
      -1,    -1,    61,   311,   312,    -1,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    46,   169,    -1,    -1,    -1,   326,   174,
      -1,    80,   255,    -1,    -1,   258,   259,    86,    -1,    -1,
      -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,   347,
     348,   349,   350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,   428,    86,    -1,    -1,    -1,   116,    -1,    -1,
      46,   120,   121,   122,   123,   124,   125,    -1,    -1,   128,
      -1,    -1,   131,    -1,    -1,    -1,   135,    -1,    -1,   138,
      66,   140,    -1,   116,   317,    46,    -1,   120,   121,    -1,
      -1,   124,   125,    -1,    -1,   128,    -1,    -1,   131,    -1,
      86,    -1,     8,     9,    10,    11,    12,    -1,   416,   417,
     169,    -1,    -1,    -1,    -1,   174,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    86,    -1,    33,    -1,   188,
     116,   190,    -1,    -1,   120,   121,   169,    -1,   124,   125,
     199,   174,   128,    -1,    -1,   131,    -1,    -1,    -1,    46,
      -1,    -1,   385,    -1,    -1,   116,    -1,    -1,    -1,   120,
     121,    -1,    -1,   124,   125,   126,    -1,   128,   401,    -1,
     131,    -1,    -1,   406,   407,    -1,   409,   410,   237,   412,
      -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    86,
      -1,    -1,    -1,    -1,    -1,   428,   255,    -1,    -1,    66,
      -1,    -1,   188,   262,   263,    -1,   265,    -1,   169,    46,
     385,   270,   271,   174,   273,   274,    -1,   276,    -1,   116,
     279,   280,   281,   120,   121,    46,   123,   124,   125,    66,
     405,   128,    19,    -1,   131,   294,   295,    -1,    -1,    -1,
     299,    -1,   301,   302,    -1,   304,    -1,    -1,    -1,    86,
     309,    -1,    -1,   428,   313,   314,    46,   316,   317,    -1,
     319,   320,   321,    -1,    -1,    86,   325,    -1,    -1,    -1,
      -1,   138,   169,   428,    -1,    -1,    -1,   174,    -1,   116,
      -1,    -1,    -1,   120,   121,    75,   123,   124,   125,    -1,
      -1,   128,    -1,   254,   131,   116,    86,    -1,    -1,   120,
     121,   168,    -1,   124,   125,    -1,    -1,   128,    -1,    -1,
     131,    -1,    -1,   346,   181,    -1,    -1,    -1,   351,   352,
     353,    -1,    -1,    -1,    -1,    -1,   116,   313,   195,    -1,
     120,   121,   169,    -1,   124,   125,    -1,   174,   128,    -1,
      -1,   131,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,   385,   174,    -1,    -1,    -1,    -1,    -1,   392,
      -1,    -1,    -1,    -1,   154,   262,   263,    -1,    -1,   428,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,
      -1,   342,   343,   344,   174,    -1,    -1,    -1,   255,    -1,
      -1,   258,   259,    -1,    -1,   428,    71,    72,     3,   266,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,   222,    -1,    -1,    -1,    -1,
      45,    -1,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,    -1,    -1,   320,    -1,    -1,   323,     8,     9,    10,
     135,    -1,    -1,    -1,    -1,    -1,    -1,   428,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    86,    33,    -1,    -1,   352,    -1,   354,    -1,   356,
     357,   358,   359,   360,   361,    -1,   171,    -1,    -1,   174,
     367,   176,    -1,   370,    -1,    -1,   373,    -1,   183,    -1,
     185,    -1,   333,   118,    -1,   190,   191,   192,   385,    -1,
     125,   126,   197,   198,   199,    -1,   393,    -1,    -1,    -1,
      -1,   428,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,    -1,    -1,    -1,
      -1,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     401,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   341
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   434,   435,    46,    71,    72,    81,   135,   171,
     174,   176,   183,   185,   190,   191,   192,   197,   198,   199,
     341,   460,   461,   462,   463,   464,   465,   518,   519,   520,
     521,   523,   524,   525,   528,   531,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   626,   637,
     671,   672,   673,   674,   675,   676,   677,   678,   693,   694,
     704,   706,     0,     3,    34,    43,    46,    57,    70,    80,
      86,   116,   118,   119,   126,   162,   163,   174,   197,   200,
     423,   436,   449,   455,   458,   459,   468,   471,   474,   476,
     479,   481,   482,   484,   485,   492,   502,   503,   560,   562,
     572,   610,   613,   627,   632,   633,   636,   639,   640,   680,
     681,   682,   685,   695,   696,   705,   707,   708,   709,    19,
      20,    45,   558,    20,    56,    64,    65,    66,   466,     3,
     558,   558,   172,   173,   558,   558,     3,   162,   144,   145,
     162,   177,   186,   188,   189,   255,   345,   404,   418,   162,
     162,    79,   142,   144,   145,   193,   194,   195,   196,    13,
      15,    16,    17,    18,    19,    20,    27,    28,    30,    32,
     120,   126,   190,   191,   227,   228,   244,   247,   252,   424,
     431,   577,   589,   594,   597,   598,   599,   601,   603,    36,
      45,   427,   547,   558,   192,    19,    19,    20,    44,    55,
     446,   451,    68,   144,   158,    43,    62,   118,   188,   456,
     457,    50,    67,    81,    19,   117,    19,    86,   164,   144,
     446,   603,    19,    19,   139,   486,   486,   427,    73,    78,
     122,   164,   255,   341,   345,   400,   404,   418,   486,    46,
      66,    86,   116,   120,   121,   123,   124,   125,   128,   131,
     169,   174,   428,   487,   505,   486,   486,    51,    61,    66,
      80,   122,   123,   135,   138,   140,   188,   190,   199,   237,
     255,   262,   263,   265,   270,   271,   273,   274,   276,   279,
     280,   281,   294,   295,   299,   301,   302,   304,   309,   313,
     314,   316,   317,   319,   320,   321,   325,   428,   487,   486,
     486,    84,   346,   351,   352,   353,   385,   392,   428,   487,
     641,   642,   643,   486,   333,   401,   428,   487,   486,   486,
      66,   188,   313,   428,   487,   697,   700,    73,    74,    75,
      77,    78,    80,    84,    87,   428,   470,   473,   487,    75,
     154,   428,   472,   487,    36,    45,   427,   506,   466,     3,
       3,   466,    67,   467,    20,   448,   448,   558,   558,     3,
      36,    45,   427,   509,    86,   533,    19,    20,    45,   559,
       3,   187,   529,     3,     3,   526,   532,   269,    19,   123,
     195,   384,   398,   399,   522,   145,   195,   522,    18,    19,
     440,   442,   442,     3,     3,     3,     3,     3,     3,     3,
       3,    15,    19,    29,   424,   430,   593,   595,   601,    30,
     424,   253,    28,   253,    15,   430,   596,   603,   424,   424,
     424,   424,   424,   424,   229,   230,   231,   232,   582,   603,
      15,    16,    17,    19,   424,   577,   578,   581,   583,   584,
     585,   587,   589,   590,   591,     5,    82,    83,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   139,   178,   233,   234,
     236,   237,   238,   239,   240,   241,   242,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   311,   312,   326,   347,
     348,   349,   350,   416,   417,   602,   710,     3,     8,     9,
      10,    11,    12,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    33,    46,    47,    48,    49,    50,    51,    52,
      53,    54,   453,   454,    15,   548,   448,   638,    22,    63,
     450,    45,   427,   452,    15,    19,    35,    36,    37,    38,
      69,   424,   437,   439,   506,   437,    20,    58,    59,   423,
     437,   438,   438,   181,   170,   480,    15,    17,    18,    19,
     139,   424,   475,   561,    19,   477,   509,   423,   573,   139,
      19,   427,   427,   483,   427,   506,   323,    19,   491,   117,
     437,   439,   504,    45,    69,   126,   127,   136,   254,   488,
     569,    69,   488,   446,    69,   446,   509,   423,   423,   427,
     427,   181,   283,   327,   323,    81,   423,    20,   284,   446,
     439,    69,    85,   188,   298,   324,   167,    80,   439,   423,
     437,   440,   628,   184,   440,    76,   272,   282,    76,   270,
     277,   286,   287,    87,   282,   296,   297,   296,   300,   439,
     303,   305,   310,    86,    87,   122,   315,    87,   318,   316,
     439,   265,   286,   439,   423,   427,   427,   383,   475,   439,
     116,   437,   439,   117,   423,   427,   427,    86,   402,   403,
     423,   427,   427,   323,   442,    86,   423,   206,   275,   306,
     315,   419,   420,   421,   422,   427,   703,    86,   439,    76,
     439,    79,    81,    85,   437,   423,   423,   423,    76,   448,
     423,   423,    79,   129,   130,   142,   143,   145,   507,   508,
       3,   467,     3,   437,     3,     3,     3,     3,     3,   129,
     175,   510,   511,     3,    19,     3,   559,     3,     3,     3,
      86,   157,   172,   184,   530,     3,    45,    86,   118,   125,
     126,   137,   154,   155,   156,   157,   159,   160,   442,   527,
     569,     3,    19,    86,   118,   119,   126,   162,   200,   522,
     522,   522,   679,    45,   522,    45,   522,     3,   522,   522,
       3,    30,   426,   444,   182,   182,     7,   595,   595,   603,
     595,   595,    14,    15,   603,   607,   608,    27,    28,   253,
      28,   596,   596,    30,   603,   603,   603,   603,   603,    19,
      15,   429,   425,   429,    29,   580,   582,   603,     7,   429,
     432,    27,    28,   427,   429,   432,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     210,   235,   243,   248,   249,   250,   428,   429,     3,     3,
       3,    86,   126,   141,   569,   603,   446,   453,   423,   438,
     603,   437,    60,    61,    60,    61,    39,    40,    41,   437,
     499,   500,   603,   423,   208,   209,   210,   211,   212,   213,
     214,   215,   217,   218,   219,   220,   221,   222,   563,   564,
     565,   567,   571,    42,   165,   166,   167,   423,   478,   423,
     424,   570,    19,   162,   428,   439,   475,   493,   496,   497,
      36,   437,   490,    19,   567,   568,   137,   603,   490,   490,
     612,    76,    76,    80,   328,   439,    76,   322,   439,   423,
      51,   329,   423,   423,   437,   258,   259,   439,   308,   439,
     175,   440,   423,   423,   423,    31,   441,    42,   184,   423,
     437,   184,   437,    76,    76,   437,    76,   136,   278,   437,
     437,   439,    76,   423,   117,   423,   439,   423,   439,   278,
     306,   307,   439,   491,   439,   423,   423,   439,   439,   439,
     423,   184,   439,   423,   635,   439,   439,    69,   437,   644,
      19,   423,   423,   684,   439,   491,    20,   440,   440,   275,
     698,   699,   702,   423,   437,   437,   439,   439,   439,   437,
     440,   442,   443,   428,   429,     3,   428,   429,     3,    19,
      15,   442,    19,    19,   568,   443,    19,     3,    20,   447,
     447,     3,    19,   116,   278,   323,   346,   361,   390,   391,
     522,   447,   522,   447,   447,   447,   437,   440,    15,    15,
      15,   425,   429,   425,   253,    28,   429,   429,   429,   425,
     429,   425,   429,   603,   603,   429,     7,   429,   429,   425,
      18,   424,   578,   585,    15,    18,   590,   424,   454,    20,
     491,   568,   446,   423,   428,   425,    20,   423,   497,   423,
     425,    19,   216,   423,   427,   437,   440,   425,   564,   566,
     571,   442,   423,    28,   495,   429,   132,   489,   439,   123,
     262,   263,   428,   487,   611,   437,   437,    81,    76,   423,
     437,   423,   423,   439,   427,   439,   629,   423,   423,   423,
     423,   439,   423,   439,   423,    19,   628,   437,   437,   423,
     437,   423,   437,   437,   423,   437,   423,   423,   423,   423,
     423,   437,   475,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   437,   423,    86,   126,   342,
     343,   344,   428,   487,   569,   634,   437,   123,   187,   279,
     352,   374,   376,   381,   383,   387,   388,   428,   645,   652,
     655,   423,   123,   385,   405,   428,   487,   683,   423,   423,
     441,   440,   255,   386,   698,    19,    51,   120,   201,   202,
     203,   204,   205,   206,   207,   223,   226,   255,   428,   599,
     600,   604,   609,   701,    69,   469,   508,   511,     3,     3,
     475,   475,    15,   475,   447,     3,   447,     3,     3,     3,
     184,   184,   595,   607,    28,    28,   603,   603,   603,   603,
     603,   429,   425,   429,    29,   580,   603,   580,    29,   580,
     580,   603,   429,   603,   565,   574,   575,   609,   423,   425,
     182,    20,   443,   494,   496,    81,   133,   134,   135,   614,
     620,   614,   621,   440,   625,   423,   429,   423,   322,   439,
     437,   423,   423,   173,   211,   329,   331,   333,   334,   337,
     630,   631,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,    20,   568,   446,   437,   190,   423,   664,
     670,   439,   354,   355,   387,   354,   439,   646,   323,   442,
     648,   649,   647,   389,   439,   423,   392,   665,   686,   692,
     439,   437,   423,   441,   439,   437,    22,   424,    22,   424,
     603,   603,   603,   439,   602,   710,   423,   603,   605,   606,
     437,     3,     3,    15,    15,    28,   425,   425,   425,   425,
     429,   603,   603,   425,   429,     7,   425,   429,   425,   429,
       7,   425,   429,   429,    15,   425,   428,   609,   566,    15,
     443,   497,   498,   427,   619,    31,   264,   622,   437,   423,
     423,   423,   340,    69,   246,   332,   336,   335,   338,   339,
     428,   429,   280,   497,   666,   437,   437,   439,   437,   427,
     475,   427,   427,   437,   437,   427,   498,    69,   603,   608,
     603,   599,   423,   224,   427,   423,    22,    22,    33,   429,
     423,   533,   533,    28,   603,   425,   425,    29,   580,    29,
     580,    29,   580,     7,    29,   580,    29,   580,   428,   184,
     619,   618,   615,    19,   446,   265,   623,   423,   193,   330,
     631,   439,   667,   427,   669,   657,   650,   657,   653,   427,
     691,   437,   423,   425,   423,   710,   427,   576,   609,   592,
     603,   603,   126,   190,   191,   247,   253,   606,     3,     3,
     425,   425,   425,   425,   429,     7,   425,   425,   425,   429,
     424,   425,     7,   425,   425,     7,   425,    15,   615,   138,
     140,   168,   256,   257,   260,   261,   266,   428,   512,   514,
     515,   616,   440,   262,   624,   665,   668,   428,   442,   658,
     659,   187,   354,   375,   428,   651,   428,   181,   266,   356,
     357,   358,   360,   428,   512,   654,   690,   687,   425,   574,
     225,     6,    15,    16,    17,   424,   428,   577,   579,   581,
     583,   584,   586,   588,   423,   423,   424,   424,   424,   424,
     423,    29,   580,    29,   580,   580,     7,   580,   423,   446,
     439,   427,   258,   259,   259,   438,   437,   127,   147,   267,
     268,   617,   427,   423,   439,    66,   181,   195,   255,   258,
     259,   266,   317,   320,   323,   352,   354,   356,   357,   358,
     359,   360,   361,   367,   370,   373,   385,   393,   428,   512,
     656,   375,   382,   660,   439,   437,   439,   423,   437,   127,
     267,   371,   437,   437,   282,   156,   437,   423,    42,    66,
      67,    87,   140,   167,   255,   258,   259,   266,   317,   385,
     401,   406,   407,   409,   410,   412,   428,   512,   688,   423,
     428,   576,   574,   603,     7,   426,   429,   603,   603,   603,
     603,   425,   425,   425,   429,   425,   424,   425,   513,   514,
     260,   260,   260,   149,   150,   147,   117,   139,   141,   146,
     161,   205,   516,   323,   437,   427,   439,   378,   179,   180,
     359,   395,   501,   127,   267,   371,   318,   439,   396,   439,
     437,   437,   437,   282,   437,   156,   437,   362,   363,   364,
     365,   366,   367,   368,   369,   394,   364,   437,   386,   362,
     423,   437,   423,   437,   437,   437,   323,   414,    76,   437,
     439,   440,   439,   378,   359,   395,   501,   127,   149,   371,
     415,   689,   318,   386,   362,   408,    76,    76,   377,   437,
     411,   413,   423,   425,   424,   579,   574,   586,   425,   425,
     425,   425,   580,   580,   428,   423,   438,   438,   438,   149,
     150,   437,    20,   445,   445,   147,   148,   517,   139,   141,
     139,   141,   428,   439,   661,   379,   380,   437,   437,   437,
     437,   437,   259,   439,   397,   437,   437,   439,   439,   437,
     439,   439,   439,   437,   437,   437,   437,   259,   439,   437,
     437,   437,   439,   439,   439,   603,   423,   423,   423,   423,
     425,   429,   513,   423,   423,   423,   149,   150,   151,   152,
     153,   149,   150,   151,   152,   153,   423,   445,   445,   445,
     445,   428,   440,   663,   377,   439,   377,   580,   516,   516,
     516,   516,   423,   423,   423,   423,   372,   662,   429,   516,
     516,   516,   516,   423,   580,   425
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 841 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 842 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 855 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 865 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 866 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 873 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000000; }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 874 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 875 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 883 "cf-parse.y"
    { (yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 884 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 885 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 886 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 887 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 888 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 895 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 902 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 903 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 907 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 915 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 919 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 923 "cf-parse.y"
    {
     (yyval.i) = ipa_masklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 930 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 939 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[(1) - (1)].s)).s;
   }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 947 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 951 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 952 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 958 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 967 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 968 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 972 "cf-parse.y"
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = rf_file(f);
   }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 977 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 978 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 982 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 983 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 987 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 988 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 992 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 993 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 994 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 995 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 996 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 997 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 998 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 999 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 1000 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 1006 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 1007 "cf-parse.y"
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = rf_fileno(f);
   }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 1017 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 1018 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 1019 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 1020 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 1023 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 1024 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 1025 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 1026 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 1027 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){NULL, NULL, 0}; }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 1028 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 1038 "cf-parse.y"
    { new_config->latency_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 1039 "cf-parse.y"
    { new_config->latency_limit = (yyvsp[(4) - (4)].i32); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 1040 "cf-parse.y"
    { new_config->watchdog_warning = (yyvsp[(3) - (3)].i32); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 1041 "cf-parse.y"
    { new_config->watchdog_timeout = ((yyvsp[(3) - (3)].i32) + 999999) TO_S; }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 1050 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 1053 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 1060 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 1063 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 1066 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 1069 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 1072 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 1077 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 1078 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 1079 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 1087 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 1092 "cf-parse.y"
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 1093 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) <= 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 1097 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 1098 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 1102 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 1109 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 1110 "cf-parse.y"
    { THIS_KRT->graceful_restart = (yyvsp[(3) - (3)].i); }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 1111 "cf-parse.y"
    {
      THIS_KRT->merge_paths = (yyvsp[(3) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[(3) - (4)].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 1123 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1128 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 1132 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 1146 "cf-parse.y"
    { THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i); }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1147 "cf-parse.y"
    { THIS_KRT->sys.metric = (yyvsp[(2) - (2)].i); }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1161 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1162 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1166 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1167 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1169 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 1176 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[(1) - (1)].s)).i;
#ifndef IPV6
     else if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[(1) - (1)].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1198 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1199 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1200 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1201 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1206 "cf-parse.y"
    { new_config->gr_wait = (yyvsp[(4) - (5)].i); }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1212 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1213 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1217 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 1225 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1231 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1245 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1246 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1250 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1256 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1260 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[(2) - (2)].s)->class != SYM_TEMPLATE) && ((yyvsp[(2) - (2)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(2) - (2)].s)->def);
   }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1269 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1280 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1284 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1285 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1286 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1287 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1288 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1289 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1290 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1291 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1292 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1293 "cf-parse.y"
    { this_proto->vrf = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1294 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1295 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 1296 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1300 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1302 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1303 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1307 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1308 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 1309 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1310 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1311 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 1315 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1321 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1325 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1333 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1334 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1342 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1350 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1351 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 1352 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 1356 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 1357 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1371 "cf-parse.y"
    { iface_patt_check(); }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1373 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1385 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1386 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1392 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 1402 "cf-parse.y"
    { DIRECT_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1406 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1420 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 1421 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1422 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1427 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1431 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1432 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1433 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1434 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1435 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 1436 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1442 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1443 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1444 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1449 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1453 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1454 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1475 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->length = strlen((yyvsp[(2) - (2)].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1495 "cf-parse.y"
    { }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1496 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1497 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1498 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1499 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1500 "cf-parse.y"
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[(2) - (4)].time); }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1501 "cf-parse.y"
    { this_p_item->gento = this_p_item->accto = (yyvsp[(2) - (4)].time); }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1502 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1503 "cf-parse.y"
    { this_p_item->alg = (yyvsp[(2) - (4)].i); }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1507 "cf-parse.y"
    { (yyval.i) = ALG_MD5; }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1508 "cf-parse.y"
    { (yyval.i) = ALG_SHA1; }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1509 "cf-parse.y"
    { (yyval.i) = ALG_SHA256; }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1510 "cf-parse.y"
    { (yyval.i) = ALG_SHA384; }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1511 "cf-parse.y"
    { (yyval.i) = ALG_SHA512; }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1512 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_MD5; }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1513 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA1; }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1514 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA256; }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1515 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA384; }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1516 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA512; }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1523 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1526 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1529 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1532 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1536 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1540 "cf-parse.y"
    { if_show(); }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1543 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1547 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1550 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1555 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1561 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1568 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1573 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1578 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1583 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1587 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1591 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1595 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1604 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1612 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1616 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1623 "cf-parse.y"
    { (yyval.i) = RSEM_PREEXPORT; }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1624 "cf-parse.y"
    { (yyval.i) = RSEM_EXPORT; }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1625 "cf-parse.y"
    { (yyval.i) = RSEM_NOEXPORT; }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1631 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1634 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1641 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1648 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1652 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1660 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1661 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1662 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1668 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1671 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1674 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1675 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1676 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1677 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1678 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1679 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1680 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1685 "cf-parse.y"
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1690 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1699 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1706 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1713 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1721 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1723 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1725 "cf-parse.y"
    { io_log_dump(); cli_msg(0, ""); }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1727 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1729 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1731 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1733 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1735 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1738 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1741 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1747 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1748 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1749 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1753 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1754 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1761 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[(3) - (4)].t)); }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1763 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[(3) - (4)].t)); }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1765 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[(3) - (4)].t)); }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1767 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1769 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1771 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1775 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1779 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1782 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1785 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1786 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 1787 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1791 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1792 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1793 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1801 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1802 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1811 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1815 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1816 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1817 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 1818 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 1819 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 1820 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 1821 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1822 "cf-parse.y"
    { (yyval.i) = T_LC; }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1823 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 1824 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1825 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1826 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1827 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.i) = T_LCLIST; }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1829 "cf-parse.y"
    {
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1851 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1862 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 1863 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 1870 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 1871 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1878 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 1887 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 1895 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst(FI_PRINT_AND_DIE);	/* ACCEPT */
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst(FI_PRINT_AND_DIE);	/* REJECT */
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst(FI_CONDITION);			/* IF */
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1916 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 1917 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 1921 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst(FI_CLEAR_LOCAL_VARS);
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 1933 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1936 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name);
     cf_pop_scope();
   }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 1949 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 1950 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1953 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 1954 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 1958 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 1961 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 1970 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 1983 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 1984 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 1985 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 1986 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 1987 "cf-parse.y"
    {
     (yyval.v) = f_eval((yyvsp[(2) - (3)].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 1991 "cf-parse.y"
    {
     if (!cf_symbol_is_constant((yyvsp[(1) - (1)].s))) cf_error("%s: constant expected", (yyvsp[(1) - (1)].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[(1) - (1)].s)))) cf_error("%s: set-incompatible type", (yyvsp[(1) - (1)].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[(1) - (1)].s)->def);
   }
    break;

  case 341:
/* Line 1792 of yacc.c  */
#line 1999 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 2000 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 2001 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 2002 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 2003 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 2007 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 2010 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 2011 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 2012 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), 0, CC_ALL); }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 2013 "cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 2014 "cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 2015 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, CC_ALL); }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 2016 "cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 2017 "cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 2018 "cf-parse.y"
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 2020 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (11)].i32), (yyvsp[(8) - (11)].i32), (yyvsp[(4) - (11)].i32), (yyvsp[(10) - (11)].i32)); }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 2024 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 2025 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 2026 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 2027 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 2031 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 2032 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 2033 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 2037 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 2038 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 2039 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, LC_ALL); }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 2040 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), 0, LC_ALL); }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 2041 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), 0, LC_ALL, 0, LC_ALL); }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 2042 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), 0, LC_ALL, 0, LC_ALL); }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 2045 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (15)].i32), (yyvsp[(10) - (15)].i32), (yyvsp[(4) - (15)].i32), (yyvsp[(12) - (15)].i32), (yyvsp[(6) - (15)].i32), (yyvsp[(14) - (15)].i32)); }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 2052 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 2053 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 2060 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 2061 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2066 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2071 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2075 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2082 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2083 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2084 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2085 "cf-parse.y"
    {
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2092 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 2093 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 2096 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2097 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2104 "cf-parse.y"
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 2116 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 2117 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 2121 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 2122 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2126 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2127 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(4) - (4)].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[(1) - (4)].i); (yyval.h)->val2 = (yyvsp[(3) - (4)].i); }
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 2128 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2129 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; }
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 2130 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2131 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2135 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2136 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2137 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2141 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2142 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2143 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2144 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2145 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2146 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2147 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2148 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2149 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2150 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2154 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2155 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2156 "cf-parse.y"
    { (yyval.x) = f_generate_lc((yyvsp[(2) - (7)].x), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2157 "cf-parse.y"
    { (yyval.x) = f_generate_path_mask((yyvsp[(1) - (1)].h)); }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2171 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2193 "cf-parse.y"
    {
     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); break;
       case SYM_VARIABLE: (yyval.x) = f_new_inst(FI_VARIABLE); break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2205 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	1); }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2206 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	1); }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2207 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_PREFIX,     SA_NET,	0); }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2208 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	0); }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2209 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	0); }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2210 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	1); }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2211 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTC,   SA_CAST,	0); }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2212 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	1); }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2213 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	1); }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2214 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	0); }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2218 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2219 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_ADD);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2220 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_SUBTRACT);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2221 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_MULTIPLY);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2222 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_DIVIDE);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2223 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AND);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2224 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_OR);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 2225 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EQ);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2226 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_NEQ);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2227 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2228 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2229 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2230 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2231 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_MATCH);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2232 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_NOT_MATCH);(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2233 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_NOT);	(yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2234 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_DEFINED);	(yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2236 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 2237 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 2238 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2240 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PREF_GET); }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2242 "cf-parse.y"
    { (yyval.x) = f_new_inst_sa(FI_RTA_GET, (yyvsp[(2) - (2)].fsa)); }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2244 "cf-parse.y"
    { (yyval.x) = f_new_inst_da(FI_EA_GET, (yyvsp[(2) - (2)].fda)); }
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 2246 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_IP); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 2247 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LENGTH); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 2248 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_IP_MASK); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 2249 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 2250 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 2251 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 2261 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_PATH; }
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 2262 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_CLIST; }
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 2263 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_ECLIST; }
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 2264 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_LCLIST; }
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 2265 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2266 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2267 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2268 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 2270 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 2271 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 2274 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 2296 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2297 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2298 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 2299 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 2300 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2301 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 2305 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PRINT); (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 2308 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2309 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2310 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2318 "cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 2324 "cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 2332 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 2333 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 2337 "cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2342 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst(FI_CONDITION);
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2350 "cf-parse.y"
    {
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2358 "cf-parse.y"
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN);
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2363 "cf-parse.y"
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[(2) - (5)].fda));
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 2367 "cf-parse.y"
    {
     (yyval.x) = f_new_inst_sa(FI_RTA_SET, (yyvsp[(2) - (5)].fsa));
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2373 "cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_PREF_SET);
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2377 "cf-parse.y"
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[(4) - (6)].fda));
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 2382 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PRINT_AND_DIE); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 2383 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2384 "cf-parse.y"
    {
      (yyval.x) = f_new_inst(FI_SWITCH);
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2391 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].fda)); }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2392 "cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, 'x', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2393 "cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'a', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 2394 "cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'd', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 2395 "cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'f', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 2402 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 2429 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 2443 "cf-parse.y"
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 2463 "cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].i32); }
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 2464 "cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2465 "cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 2466 "cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 2467 "cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); }
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2468 "cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2469 "cf-parse.y"
    { BFD_IFACE->auth_type = (yyvsp[(2) - (2)].i); }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2470 "cf-parse.y"
    {}
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2474 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_NONE; }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2475 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_SIMPLE; }
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 2476 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
    break;

  case 527:
/* Line 1792 of yacc.c  */
#line 2477 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
    break;

  case 528:
/* Line 1792 of yacc.c  */
#line 2478 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 2479 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2497 "cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; }
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 2501 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 2502 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 2503 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 2507 "cf-parse.y"
    { (yyval.a) = IPA_NONE; }
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 2508 "cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); }
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2512 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2513 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 2517 "cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
}
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 2536 "cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); }
    break;

  case 545:
/* Line 1792 of yacc.c  */
#line 2541 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[(1) - (2)].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
 }
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 2570 "cf-parse.y"
    { BGP_CFG->remote_port = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Invalid port number");  }
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 2571 "cf-parse.y"
    { BGP_CFG->remote_as = (yyvsp[(3) - (3)].i); }
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 2576 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i) ? ~(1 << 7) : 0; }
    break;

  case 550:
/* Line 1792 of yacc.c  */
#line 2577 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 2582 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 553:
/* Line 1792 of yacc.c  */
#line 2586 "cf-parse.y"
    { (yyval.i) = 1 << 0; }
    break;

  case 554:
/* Line 1792 of yacc.c  */
#line 2587 "cf-parse.y"
    { (yyval.i) = 1 << 1; }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 2588 "cf-parse.y"
    { (yyval.i) = 1 << 2; }
    break;

  case 556:
/* Line 1792 of yacc.c  */
#line 2589 "cf-parse.y"
    { (yyval.i) = 1 << 3; }
    break;

  case 557:
/* Line 1792 of yacc.c  */
#line 2590 "cf-parse.y"
    { (yyval.i) = 1 << 4; }
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 2591 "cf-parse.y"
    { (yyval.i) = 1 << 5; }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2592 "cf-parse.y"
    { (yyval.i) = 1 << 6; }
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 2593 "cf-parse.y"
    { (yyval.i) = 1 << 7; }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 2594 "cf-parse.y"
    { (yyval.i) = 1 << 8; }
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 2600 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 2601 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 2603 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     if ((yyvsp[(4) - (6)].iface)) BGP_CFG->iface = (yyvsp[(4) - (6)].iface);
   }
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 2609 "cf-parse.y"
    { BGP_CFG->iface = if_get_by_name((yyvsp[(3) - (4)].t)); }
    break;

  case 569:
/* Line 1792 of yacc.c  */
#line 2610 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 570:
/* Line 1792 of yacc.c  */
#line 2611 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 2612 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 2613 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 573:
/* Line 1792 of yacc.c  */
#line 2614 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 574:
/* Line 1792 of yacc.c  */
#line 2615 "cf-parse.y"
    { BGP_CFG->multihop = 0; }
    break;

  case 575:
/* Line 1792 of yacc.c  */
#line 2616 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 576:
/* Line 1792 of yacc.c  */
#line 2617 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 577:
/* Line 1792 of yacc.c  */
#line 2618 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 578:
/* Line 1792 of yacc.c  */
#line 2619 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 2620 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2621 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2622 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 2623 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 2624 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 2625 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 2626 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 2627 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2628 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 2629 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2630 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 2631 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 2632 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 2633 "cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 2634 "cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2635 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 2636 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 2637 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2638 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2639 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2640 "cf-parse.y"
    { BGP_CFG->disable_after_cease = (yyvsp[(5) - (6)].i); }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2641 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2642 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2643 "cf-parse.y"
    { BGP_CFG->enable_extended_messages = (yyvsp[(5) - (6)].i); }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2644 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 2645 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2646 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2647 "cf-parse.y"
    { BGP_CFG->setkey = (yyvsp[(3) - (4)].i); }
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 2648 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 2654 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 2655 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2656 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2657 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_RX; }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2658 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_TX; }
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 2659 "cf-parse.y"
    { BGP_CFG->add_path = (yyvsp[(4) - (5)].i) ? ADD_PATH_FULL : 0; }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2660 "cf-parse.y"
    { BGP_CFG->allow_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 2661 "cf-parse.y"
    { BGP_CFG->allow_local_as = -1; }
    break;

  case 616:
/* Line 1792 of yacc.c  */
#line 2662 "cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 2663 "cf-parse.y"
    { BGP_CFG->gr_mode = (yyvsp[(4) - (5)].i); }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 2664 "cf-parse.y"
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 2665 "cf-parse.y"
    { BGP_CFG->gr_time = (yyvsp[(5) - (6)].i); }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 2666 "cf-parse.y"
    { BGP_CFG->llgr_mode = (yyvsp[(6) - (7)].i); }
    break;

  case 621:
/* Line 1792 of yacc.c  */
#line 2667 "cf-parse.y"
    { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 2668 "cf-parse.y"
    { BGP_CFG->llgr_time = (yyvsp[(6) - (7)].i); }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2669 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 2670 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 2671 "cf-parse.y"
    { BGP_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2672 "cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); }
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 2673 "cf-parse.y"
    { BGP_CFG->bfd = BGP_BFD_GRACEFUL; cf_check_bfd(1); }
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 2685 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_mrt, (yyvsp[(1) - (2)].i));
}
    break;

  case 630:
/* Line 1792 of yacc.c  */
#line 2691 "cf-parse.y"
    { MRT_CFG->table_expr = (yyvsp[(2) - (2)].t); }
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 2692 "cf-parse.y"
    { MRT_CFG->filter = (yyvsp[(2) - (2)].f); }
    break;

  case 632:
/* Line 1792 of yacc.c  */
#line 2693 "cf-parse.y"
    { MRT_CFG->filter = (yyvsp[(1) - (1)].f); }
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 2694 "cf-parse.y"
    { MRT_CFG->filename = (yyvsp[(2) - (2)].t); }
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 2695 "cf-parse.y"
    { MRT_CFG->period = (yyvsp[(2) - (2)].i); }
    break;

  case 635:
/* Line 1792 of yacc.c  */
#line 2696 "cf-parse.y"
    { MRT_CFG->always_add_path = (yyvsp[(4) - (4)].i); }
    break;

  case 638:
/* Line 1792 of yacc.c  */
#line 2705 "cf-parse.y"
    { mrt_check_config(this_proto); }
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 2709 "cf-parse.y"
    { mrt_dump_cmd((yyvsp[(3) - (4)].md)); }
    break;

  case 640:
/* Line 1792 of yacc.c  */
#line 2712 "cf-parse.y"
    { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 2713 "cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->table_ptr = (yyvsp[(3) - (3)].r)->table; }
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 2714 "cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->table_expr = (yyvsp[(3) - (3)].t); }
    break;

  case 643:
/* Line 1792 of yacc.c  */
#line 2715 "cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->filter = (yyvsp[(3) - (3)].f); }
    break;

  case 644:
/* Line 1792 of yacc.c  */
#line 2716 "cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (2)].md); (yyval.md)->filter = (yyvsp[(2) - (2)].f); }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 2717 "cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->filename = (yyvsp[(3) - (3)].t); }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 2724 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 2740 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 2741 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 652:
/* Line 1792 of yacc.c  */
#line 2742 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 2743 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 654:
/* Line 1792 of yacc.c  */
#line 2744 "cf-parse.y"
    { OSPF_CFG->merge_external = (yyvsp[(3) - (3)].i); }
    break;

  case 655:
/* Line 1792 of yacc.c  */
#line 2745 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 2746 "cf-parse.y"
    { OSPF_CFG->instance_id = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<0) || ((yyvsp[(3) - (3)].i)>255)) cf_error("Instance ID must be in range 0-255"); }
    break;

  case 658:
/* Line 1792 of yacc.c  */
#line 2750 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 2765 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 2774 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 2775 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 664:
/* Line 1792 of yacc.c  */
#line 2776 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 2777 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 2778 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 2779 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2780 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2781 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 2782 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 671:
/* Line 1792 of yacc.c  */
#line 2783 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 673:
/* Line 1792 of yacc.c  */
#line 2784 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 2796 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 2810 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 684:
/* Line 1792 of yacc.c  */
#line 2811 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 685:
/* Line 1792 of yacc.c  */
#line 2812 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 686:
/* Line 1792 of yacc.c  */
#line 2816 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 2817 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 2826 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 692:
/* Line 1792 of yacc.c  */
#line 2827 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); }
    break;

  case 693:
/* Line 1792 of yacc.c  */
#line 2828 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 694:
/* Line 1792 of yacc.c  */
#line 2829 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); }
    break;

  case 695:
/* Line 1792 of yacc.c  */
#line 2830 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 696:
/* Line 1792 of yacc.c  */
#line 2831 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 2832 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 2833 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 2834 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 2835 "cf-parse.y"
    { ospf_check_auth(); }
    break;

  case 701:
/* Line 1792 of yacc.c  */
#line 2839 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 2858 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 703:
/* Line 1792 of yacc.c  */
#line 2859 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 2860 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 705:
/* Line 1792 of yacc.c  */
#line 2861 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); }
    break;

  case 706:
/* Line 1792 of yacc.c  */
#line 2862 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); }
    break;

  case 707:
/* Line 1792 of yacc.c  */
#line 2863 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 708:
/* Line 1792 of yacc.c  */
#line 2864 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 709:
/* Line 1792 of yacc.c  */
#line 2865 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 2866 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 2867 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 712:
/* Line 1792 of yacc.c  */
#line 2868 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 713:
/* Line 1792 of yacc.c  */
#line 2869 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 714:
/* Line 1792 of yacc.c  */
#line 2870 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 2871 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 2872 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 717:
/* Line 1792 of yacc.c  */
#line 2873 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 718:
/* Line 1792 of yacc.c  */
#line 2874 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
    break;

  case 719:
/* Line 1792 of yacc.c  */
#line 2875 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 720:
/* Line 1792 of yacc.c  */
#line 2876 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 721:
/* Line 1792 of yacc.c  */
#line 2877 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 722:
/* Line 1792 of yacc.c  */
#line 2878 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 723:
/* Line 1792 of yacc.c  */
#line 2879 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 724:
/* Line 1792 of yacc.c  */
#line 2880 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 725:
/* Line 1792 of yacc.c  */
#line 2881 "cf-parse.y"
    { OSPF_PATT->link_lsa_suppression = (yyvsp[(4) - (4)].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 2883 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
    break;

  case 728:
/* Line 1792 of yacc.c  */
#line 2884 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
    break;

  case 729:
/* Line 1792 of yacc.c  */
#line 2885 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 2886 "cf-parse.y"
    { OSPF_PATT->rx_buffer = 0; }
    break;

  case 731:
/* Line 1792 of yacc.c  */
#line 2887 "cf-parse.y"
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
    break;

  case 732:
/* Line 1792 of yacc.c  */
#line 2888 "cf-parse.y"
    { OSPF_PATT->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 2889 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 2890 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 735:
/* Line 1792 of yacc.c  */
#line 2891 "cf-parse.y"
    { OSPF_PATT->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 736:
/* Line 1792 of yacc.c  */
#line 2892 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 737:
/* Line 1792 of yacc.c  */
#line 2893 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 2894 "cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 2895 "cf-parse.y"
    { OSPF_PATT->bsd_secondary = (yyvsp[(2) - (2)].i); }
    break;

  case 740:
/* Line 1792 of yacc.c  */
#line 2896 "cf-parse.y"
    { ospf_check_auth(); }
    break;

  case 744:
/* Line 1792 of yacc.c  */
#line 2907 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 746:
/* Line 1792 of yacc.c  */
#line 2917 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 747:
/* Line 1792 of yacc.c  */
#line 2918 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 2927 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 751:
/* Line 1792 of yacc.c  */
#line 2928 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 752:
/* Line 1792 of yacc.c  */
#line 2932 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 753:
/* Line 1792 of yacc.c  */
#line 2941 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 2964 "cf-parse.y"
    { OSPF_PATT->instance_id = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Instance ID must be in range 0-255"); }
    break;

  case 756:
/* Line 1792 of yacc.c  */
#line 2968 "cf-parse.y"
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 2982 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 763:
/* Line 1792 of yacc.c  */
#line 2988 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 764:
/* Line 1792 of yacc.c  */
#line 2991 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 765:
/* Line 1792 of yacc.c  */
#line 2994 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 766:
/* Line 1792 of yacc.c  */
#line 2999 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 767:
/* Line 1792 of yacc.c  */
#line 3002 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 768:
/* Line 1792 of yacc.c  */
#line 3007 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 769:
/* Line 1792 of yacc.c  */
#line 3010 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 770:
/* Line 1792 of yacc.c  */
#line 3014 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 771:
/* Line 1792 of yacc.c  */
#line 3017 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 772:
/* Line 1792 of yacc.c  */
#line 3020 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 773:
/* Line 1792 of yacc.c  */
#line 3021 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 774:
/* Line 1792 of yacc.c  */
#line 3022 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 775:
/* Line 1792 of yacc.c  */
#line 3023 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 776:
/* Line 1792 of yacc.c  */
#line 3024 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 777:
/* Line 1792 of yacc.c  */
#line 3025 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 778:
/* Line 1792 of yacc.c  */
#line 3026 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 779:
/* Line 1792 of yacc.c  */
#line 3027 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 780:
/* Line 1792 of yacc.c  */
#line 3033 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 783:
/* Line 1792 of yacc.c  */
#line 3042 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 784:
/* Line 1792 of yacc.c  */
#line 3047 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 785:
/* Line 1792 of yacc.c  */
#line 3048 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 786:
/* Line 1792 of yacc.c  */
#line 3055 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[(1) - (2)].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
    break;

  case 788:
/* Line 1792 of yacc.c  */
#line 3068 "cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (2)].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 789:
/* Line 1792 of yacc.c  */
#line 3069 "cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 790:
/* Line 1792 of yacc.c  */
#line 3070 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(2) - (2)].i); }
    break;

  case 795:
/* Line 1792 of yacc.c  */
#line 3084 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
    break;

  case 796:
/* Line 1792 of yacc.c  */
#line 3107 "cf-parse.y"
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
    break;

  case 797:
/* Line 1792 of yacc.c  */
#line 3137 "cf-parse.y"
    { RIP_IFACE->metric = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Metric must be in range 1-255"); }
    break;

  case 798:
/* Line 1792 of yacc.c  */
#line 3138 "cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
    break;

  case 799:
/* Line 1792 of yacc.c  */
#line 3139 "cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
    break;

  case 800:
/* Line 1792 of yacc.c  */
#line 3140 "cf-parse.y"
    { RIP_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 801:
/* Line 1792 of yacc.c  */
#line 3141 "cf-parse.y"
    { RIP_IFACE->address = (yyvsp[(2) - (2)].a); }
    break;

  case 802:
/* Line 1792 of yacc.c  */
#line 3142 "cf-parse.y"
    { RIP_IFACE->port = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid port number"); }
    break;

  case 803:
/* Line 1792 of yacc.c  */
#line 3143 "cf-parse.y"
    { RIP_IFACE->version = (yyvsp[(2) - (2)].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[(2) - (2)].i) != RIP_V1) && ((yyvsp[(2) - (2)].i) != RIP_V2)) cf_error("Unsupported version");
			}
    break;

  case 804:
/* Line 1792 of yacc.c  */
#line 3147 "cf-parse.y"
    { RIP_IFACE->version_only = (yyvsp[(3) - (3)].i); }
    break;

  case 805:
/* Line 1792 of yacc.c  */
#line 3148 "cf-parse.y"
    { RIP_IFACE->split_horizon = (yyvsp[(3) - (3)].i); }
    break;

  case 806:
/* Line 1792 of yacc.c  */
#line 3149 "cf-parse.y"
    { RIP_IFACE->poison_reverse = (yyvsp[(3) - (3)].i); }
    break;

  case 807:
/* Line 1792 of yacc.c  */
#line 3150 "cf-parse.y"
    { RIP_IFACE->check_zero = (yyvsp[(3) - (3)].i); }
    break;

  case 808:
/* Line 1792 of yacc.c  */
#line 3151 "cf-parse.y"
    { RIP_IFACE->update_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Update time must be positive"); }
    break;

  case 809:
/* Line 1792 of yacc.c  */
#line 3152 "cf-parse.y"
    { RIP_IFACE->timeout_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Timeout time must be positive"); }
    break;

  case 810:
/* Line 1792 of yacc.c  */
#line 3153 "cf-parse.y"
    { RIP_IFACE->garbage_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Garbage time must be positive"); }
    break;

  case 811:
/* Line 1792 of yacc.c  */
#line 3154 "cf-parse.y"
    { RIP_IFACE->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 812:
/* Line 1792 of yacc.c  */
#line 3155 "cf-parse.y"
    { RIP_IFACE->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("RX length must be in range 256-65535"); }
    break;

  case 813:
/* Line 1792 of yacc.c  */
#line 3156 "cf-parse.y"
    { RIP_IFACE->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 814:
/* Line 1792 of yacc.c  */
#line 3157 "cf-parse.y"
    { RIP_IFACE->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 815:
/* Line 1792 of yacc.c  */
#line 3158 "cf-parse.y"
    { RIP_IFACE->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 816:
/* Line 1792 of yacc.c  */
#line 3159 "cf-parse.y"
    { RIP_IFACE->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 817:
/* Line 1792 of yacc.c  */
#line 3160 "cf-parse.y"
    { RIP_IFACE->ttl_security = 2; }
    break;

  case 818:
/* Line 1792 of yacc.c  */
#line 3161 "cf-parse.y"
    { RIP_IFACE->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 819:
/* Line 1792 of yacc.c  */
#line 3162 "cf-parse.y"
    { RIP_IFACE->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 820:
/* Line 1792 of yacc.c  */
#line 3163 "cf-parse.y"
    { RIP_IFACE->auth_type = (yyvsp[(2) - (2)].i); if ((yyvsp[(2) - (2)].i)) rip_check_auth(); }
    break;

  case 821:
/* Line 1792 of yacc.c  */
#line 3164 "cf-parse.y"
    { rip_check_auth(); }
    break;

  case 822:
/* Line 1792 of yacc.c  */
#line 3168 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_NONE; }
    break;

  case 823:
/* Line 1792 of yacc.c  */
#line 3169 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_PLAIN; }
    break;

  case 824:
/* Line 1792 of yacc.c  */
#line 3170 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; }
    break;

  case 825:
/* Line 1792 of yacc.c  */
#line 3171 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; }
    break;

  case 831:
/* Line 1792 of yacc.c  */
#line 3192 "cf-parse.y"
    { rip_show_interfaces(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); }
    break;

  case 832:
/* Line 1792 of yacc.c  */
#line 3195 "cf-parse.y"
    { rip_show_neighbors(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); }
    break;

  case 833:
/* Line 1792 of yacc.c  */
#line 3201 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 836:
/* Line 1792 of yacc.c  */
#line 3210 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 837:
/* Line 1792 of yacc.c  */
#line 3211 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 838:
/* Line 1792 of yacc.c  */
#line 3212 "cf-parse.y"
    { static_route_finish(); }
    break;

  case 839:
/* Line 1792 of yacc.c  */
#line 3215 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
    break;

  case 840:
/* Line 1792 of yacc.c  */
#line 3225 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
    break;

  case 841:
/* Line 1792 of yacc.c  */
#line 3234 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 842:
/* Line 1792 of yacc.c  */
#line 3238 "cf-parse.y"
    {
     this_srt_nh->use_bfd = (yyvsp[(3) - (3)].i); cf_check_bfd((yyvsp[(3) - (3)].i));
   }
    break;

  case 843:
/* Line 1792 of yacc.c  */
#line 3244 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 844:
/* Line 1792 of yacc.c  */
#line 3245 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 845:
/* Line 1792 of yacc.c  */
#line 3249 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 846:
/* Line 1792 of yacc.c  */
#line 3254 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 847:
/* Line 1792 of yacc.c  */
#line 3260 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 848:
/* Line 1792 of yacc.c  */
#line 3263 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 849:
/* Line 1792 of yacc.c  */
#line 3268 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 850:
/* Line 1792 of yacc.c  */
#line 3269 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 851:
/* Line 1792 of yacc.c  */
#line 3270 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 852:
/* Line 1792 of yacc.c  */
#line 3271 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 853:
/* Line 1792 of yacc.c  */
#line 3272 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 854:
/* Line 1792 of yacc.c  */
#line 3276 "cf-parse.y"
    { *this_srt_last_cmd = (yyvsp[(1) - (1)].x); this_srt_last_cmd = &((yyvsp[(1) - (1)].x)->next); }
    break;

  case 855:
/* Line 1792 of yacc.c  */
#line 3277 "cf-parse.y"
    { this_srt->use_bfd = (yyvsp[(2) - (3)].i); cf_check_bfd((yyvsp[(2) - (3)].i)); }
    break;

  case 860:
/* Line 1792 of yacc.c  */
#line 3292 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 931:
/* Line 1792 of yacc.c  */
#line 3300 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 933:
/* Line 1792 of yacc.c  */
#line 3300 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 944:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 945:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 946:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 947:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 948:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
    break;

  case 949:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
    break;

  case 950:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
    break;

  case 951:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
    break;

  case 952:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
    break;

  case 953:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
    break;

  case 954:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
    break;

  case 955:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
    break;

  case 956:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
    break;

  case 957:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
    break;

  case 958:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
    break;

  case 959:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
    break;

  case 960:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
    break;

  case 961:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
    break;

  case 962:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
    break;

  case 963:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
    break;

  case 964:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
    break;

  case 965:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
    break;

  case 966:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
    break;

  case 967:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
    break;

  case 968:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
    break;

  case 969:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
    break;

  case 970:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
    break;

  case 971:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
    break;

  case 972:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
    break;

  case 973:
/* Line 1792 of yacc.c  */
#line 3303 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
    break;

  case 974:
/* Line 1792 of yacc.c  */
#line 3304 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 975:
/* Line 1792 of yacc.c  */
#line 3304 "cf-parse.y"
    { (yyval.fda) = (struct f_dynamic_attr) {}; }
    break;

  case 976:
/* Line 1792 of yacc.c  */
#line 3305 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 977:
/* Line 1792 of yacc.c  */
#line 3306 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 978:
/* Line 1792 of yacc.c  */
#line 3307 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 979:
/* Line 1792 of yacc.c  */
#line 3308 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 980:
/* Line 1792 of yacc.c  */
#line 3309 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 981:
/* Line 1792 of yacc.c  */
#line 3310 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 982:
/* Line 1792 of yacc.c  */
#line 3311 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 983:
/* Line 1792 of yacc.c  */
#line 3312 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 984:
/* Line 1792 of yacc.c  */
#line 3313 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 985:
/* Line 1792 of yacc.c  */
#line 3314 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 986:
/* Line 1792 of yacc.c  */
#line 3315 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 987:
/* Line 1792 of yacc.c  */
#line 3316 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
    break;

  case 988:
/* Line 1792 of yacc.c  */
#line 3316 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 989:
/* Line 1792 of yacc.c  */
#line 3316 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 990:
/* Line 1792 of yacc.c  */
#line 3316 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 991:
/* Line 1792 of yacc.c  */
#line 3316 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 992:
/* Line 1792 of yacc.c  */
#line 3316 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 993:
/* Line 1792 of yacc.c  */
#line 3316 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1792 of yacc.c  */
#line 10171 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3318 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/mrt/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

