/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_inst *e = f_new_inst(FI_EMPTY);

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  struct f_inst *s = f_new_inst_da(FI_EA_SET, dyn);
  s->a1.p = e;
  return s;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst(FI_CONSTANT);
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->fi_code == FI_CONSTANT_INDIRECT) {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst(FI_CONSTANT_INDIRECT);
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT_INDIRECT);

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->fi_code = FI_LC_CONSTRUCT;
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_path_mask *t)
{
  struct f_path_mask *tt;
  for (tt = t; tt; tt = tt->next) {
    if (tt->kind == PM_ASN_EXPR) {
      struct f_inst *mrv = f_new_inst(FI_PATHMASK_CONSTRUCT);
      mrv->a1.p = t;
      return mrv;
    }
  }

  NEW_F_VAL;
  val->type = T_PATH_MASK;
  val->val.path_mask = t;

  struct f_inst *rv = f_new_inst(FI_CONSTANT_INDIRECT);
  rv->a1.p = val;

  return rv;
}


/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from ../../proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}

/* Headers from ../../proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from ../../proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)


/* Line 371 of yacc.c  */
#line 735 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     NMA = 277,
     DEFINE = 278,
     ON = 279,
     OFF = 280,
     YES = 281,
     NO = 282,
     S = 283,
     MS = 284,
     US = 285,
     PORT = 286,
     LOG = 287,
     SYSLOG = 288,
     ALL = 289,
     DEBUG = 290,
     TRACE = 291,
     INFO = 292,
     REMOTE = 293,
     WARNING = 294,
     ERROR = 295,
     AUTH = 296,
     FATAL = 297,
     BUG = 298,
     STDERR = 299,
     SOFT = 300,
     TIMEFORMAT = 301,
     ISO = 302,
     OLD = 303,
     SHORT = 304,
     LONG = 305,
     BASE = 306,
     NAME = 307,
     CONFIRM = 308,
     UNDO = 309,
     CHECK = 310,
     TIMEOUT = 311,
     LATENCY = 312,
     LIMIT = 313,
     WATCHDOG = 314,
     CONFIGURE = 315,
     DOWN = 316,
     KERNEL = 317,
     PERSIST = 318,
     SCAN = 319,
     TIME = 320,
     LEARN = 321,
     DEVICE = 322,
     ROUTES = 323,
     GRACEFUL = 324,
     RESTART = 325,
     KRT_SOURCE = 326,
     KRT_METRIC = 327,
     MERGE = 328,
     PATHS = 329,
     TABLE = 330,
     METRIC = 331,
     KRT_PREFSRC = 332,
     KRT_REALM = 333,
     KRT_SCOPE = 334,
     KRT_MTU = 335,
     KRT_WINDOW = 336,
     KRT_RTT = 337,
     KRT_RTTVAR = 338,
     KRT_SSTRESH = 339,
     KRT_CWND = 340,
     KRT_ADVMSS = 341,
     KRT_REORDERING = 342,
     KRT_HOPLIMIT = 343,
     KRT_INITCWND = 344,
     KRT_RTO_MIN = 345,
     KRT_INITRWND = 346,
     KRT_QUICKACK = 347,
     KRT_LOCK_MTU = 348,
     KRT_LOCK_WINDOW = 349,
     KRT_LOCK_RTT = 350,
     KRT_LOCK_RTTVAR = 351,
     KRT_LOCK_SSTRESH = 352,
     KRT_LOCK_CWND = 353,
     KRT_LOCK_ADVMSS = 354,
     KRT_LOCK_REORDERING = 355,
     KRT_LOCK_HOPLIMIT = 356,
     KRT_LOCK_RTO_MIN = 357,
     KRT_FEATURE_ECN = 358,
     KRT_FEATURE_ALLFRAG = 359,
     ROUTER = 360,
     ID = 361,
     PROTOCOL = 362,
     TEMPLATE = 363,
     PREFERENCE = 364,
     DISABLED = 365,
     DIRECT = 366,
     INTERFACE = 367,
     IMPORT = 368,
     EXPORT = 369,
     FILTER = 370,
     NONE = 371,
     VRF = 372,
     STATES = 373,
     FILTERS = 374,
     RECEIVE = 375,
     ACTION = 376,
     WARN = 377,
     BLOCK = 378,
     DISABLE = 379,
     KEEP = 380,
     FILTERED = 381,
     PASSWORD = 382,
     FROM = 383,
     PASSIVE = 384,
     TO = 385,
     EVENTS = 386,
     PACKETS = 387,
     PROTOCOLS = 388,
     INTERFACES = 389,
     ALGORITHM = 390,
     KEYED = 391,
     HMAC = 392,
     MD5 = 393,
     SHA1 = 394,
     SHA256 = 395,
     SHA384 = 396,
     SHA512 = 397,
     PRIMARY = 398,
     STATS = 399,
     COUNT = 400,
     FOR = 401,
     COMMANDS = 402,
     PREEXPORT = 403,
     NOEXPORT = 404,
     GENERATE = 405,
     ROA = 406,
     LISTEN = 407,
     BGP = 408,
     V6ONLY = 409,
     DUAL = 410,
     ADDRESS = 411,
     PASSWORDS = 412,
     DESCRIPTION = 413,
     SORTED = 414,
     RELOAD = 415,
     IN = 416,
     OUT = 417,
     MRTDUMP = 418,
     MESSAGES = 419,
     RESTRICT = 420,
     MEMORY = 421,
     IGP_METRIC = 422,
     CLASS = 423,
     DSCP = 424,
     WAIT = 425,
     MAX = 426,
     FLUSH = 427,
     AS = 428,
     SHOW = 429,
     STATUS = 430,
     SUMMARY = 431,
     ROUTE = 432,
     SYMBOLS = 433,
     ADD = 434,
     DELETE = 435,
     DUMP = 436,
     RESOURCES = 437,
     SOCKETS = 438,
     NEIGHBORS = 439,
     ATTRIBUTES = 440,
     EVAL = 441,
     ECHO = 442,
     ENABLE = 443,
     FUNCTION = 444,
     PRINT = 445,
     PRINTN = 446,
     UNSET = 447,
     RETURN = 448,
     ACCEPT = 449,
     REJECT = 450,
     QUITBIRD = 451,
     INT = 452,
     BOOL = 453,
     IP = 454,
     PREFIX = 455,
     PAIR = 456,
     QUAD = 457,
     EC = 458,
     LC = 459,
     SET = 460,
     STRING = 461,
     BGPMASK = 462,
     BGPPATH = 463,
     CLIST = 464,
     ECLIST = 465,
     LCLIST = 466,
     IF = 467,
     THEN = 468,
     ELSE = 469,
     CASE = 470,
     TRUE = 471,
     FALSE = 472,
     RT = 473,
     RO = 474,
     UNKNOWN = 475,
     GENERIC = 476,
     GW = 477,
     NET = 478,
     MASK = 479,
     PROTO = 480,
     SOURCE = 481,
     SCOPE = 482,
     CAST = 483,
     DEST = 484,
     IFNAME = 485,
     IFINDEX = 486,
     LEN = 487,
     DEFINED = 488,
     CONTAINS = 489,
     RESET = 490,
     PREPEND = 491,
     FIRST = 492,
     LAST = 493,
     LAST_NONAGGREGATED = 494,
     MATCH = 495,
     ROA_CHECK = 496,
     EMPTY = 497,
     WHERE = 498,
     BFD = 499,
     MIN = 500,
     IDLE = 501,
     RX = 502,
     TX = 503,
     INTERVAL = 504,
     MULTIPLIER = 505,
     MULTIHOP = 506,
     NEIGHBOR = 507,
     DEV = 508,
     LOCAL = 509,
     AUTHENTICATION = 510,
     SIMPLE = 511,
     METICULOUS = 512,
     SESSIONS = 513,
     HOLD = 514,
     CONNECT = 515,
     RETRY = 516,
     KEEPALIVE = 517,
     STARTUP = 518,
     VIA = 519,
     NEXT = 520,
     HOP = 521,
     SELF = 522,
     DEFAULT = 523,
     PATH = 524,
     START = 525,
     DELAY = 526,
     FORGET = 527,
     AFTER = 528,
     BGP_PATH = 529,
     BGP_LOCAL_PREF = 530,
     BGP_MED = 531,
     BGP_ORIGIN = 532,
     BGP_NEXT_HOP = 533,
     BGP_ATOMIC_AGGR = 534,
     BGP_AGGREGATOR = 535,
     BGP_COMMUNITY = 536,
     BGP_EXT_COMMUNITY = 537,
     RR = 538,
     RS = 539,
     CLIENT = 540,
     CLUSTER = 541,
     AS4 = 542,
     ADVERTISE = 543,
     IPV4 = 544,
     CAPABILITIES = 545,
     PREFER = 546,
     OLDER = 547,
     MISSING = 548,
     LLADDR = 549,
     DROP = 550,
     IGNORE = 551,
     REFRESH = 552,
     INTERPRET = 553,
     COMMUNITIES = 554,
     BGP_ORIGINATOR_ID = 555,
     BGP_CLUSTER_LIST = 556,
     IGP = 557,
     GATEWAY = 558,
     RECURSIVE = 559,
     MED = 560,
     TTL = 561,
     SECURITY = 562,
     DETERMINISTIC = 563,
     SECONDARY = 564,
     ALLOW = 565,
     AWARE = 566,
     LINK = 567,
     EXTENDED = 568,
     SETKEY = 569,
     BGP_LARGE_COMMUNITY = 570,
     LIVED = 571,
     STALE = 572,
     CEASE = 573,
     HIT = 574,
     ADMINISTRATIVE = 575,
     SHUTDOWN = 576,
     PEER = 577,
     CONFIGURATION = 578,
     CHANGE = 579,
     DECONFIGURED = 580,
     CONNECTION = 581,
     REJECTED = 582,
     COLLISION = 583,
     OF = 584,
     MRT = 585,
     FILENAME = 586,
     PERIOD = 587,
     ALWAYS = 588,
     OSPF = 589,
     AREA = 590,
     OSPF_METRIC1 = 591,
     OSPF_METRIC2 = 592,
     OSPF_TAG = 593,
     OSPF_ROUTER_ID = 594,
     RFC1583COMPAT = 595,
     STUB = 596,
     TICK = 597,
     COST = 598,
     COST2 = 599,
     RETRANSMIT = 600,
     HELLO = 601,
     TRANSMIT = 602,
     PRIORITY = 603,
     DEAD = 604,
     TYPE = 605,
     BROADCAST = 606,
     BCAST = 607,
     NONBROADCAST = 608,
     NBMA = 609,
     POINTOPOINT = 610,
     PTP = 611,
     POINTOMULTIPOINT = 612,
     PTMP = 613,
     STRICT = 614,
     CRYPTOGRAPHIC = 615,
     ELIGIBLE = 616,
     POLL = 617,
     NETWORKS = 618,
     HIDDEN = 619,
     VIRTUAL = 620,
     ONLY = 621,
     BUFFER = 622,
     LARGE = 623,
     NORMAL = 624,
     STUBNET = 625,
     TAG = 626,
     EXTERNAL = 627,
     LSADB = 628,
     ECMP = 629,
     WEIGHT = 630,
     NSSA = 631,
     TRANSLATOR = 632,
     STABILITY = 633,
     GLOBAL = 634,
     LSID = 635,
     INSTANCE = 636,
     REAL = 637,
     NETMASK = 638,
     LENGTH = 639,
     LSA = 640,
     SUPPRESSION = 641,
     TOPOLOGY = 642,
     STATE = 643,
     PIPE = 644,
     MODE = 645,
     OPAQUE = 646,
     TRANSPARENT = 647,
     RADV = 648,
     RA = 649,
     MANAGED = 650,
     OTHER = 651,
     CONFIG = 652,
     LINGER = 653,
     MTU = 654,
     REACHABLE = 655,
     RETRANS = 656,
     TIMER = 657,
     CURRENT = 658,
     VALID = 659,
     PREFERRED = 660,
     MULT = 661,
     LIFETIME = 662,
     SKIP = 663,
     ONLINK = 664,
     AUTONOMOUS = 665,
     RDNSS = 666,
     DNSSL = 667,
     NS = 668,
     DOMAIN = 669,
     TRIGGER = 670,
     SENSITIVE = 671,
     LOW = 672,
     MEDIUM = 673,
     HIGH = 674,
     PROPAGATE = 675,
     RA_PREFERENCE = 676,
     RA_LIFETIME = 677,
     RIP = 678,
     INFINITY = 679,
     UPDATE = 680,
     GARBAGE = 681,
     MULTICAST = 682,
     VERSION = 683,
     SPLIT = 684,
     HORIZON = 685,
     POISON = 686,
     REVERSE = 687,
     ZERO = 688,
     PLAINTEXT = 689,
     RIP_METRIC = 690,
     RIP_TAG = 691,
     STATIC = 692,
     PROHIBIT = 693,
     MULTIPATH = 694,
     BLACKHOLE = 695,
     UNREACHABLE = 696,
     BABEL = 697,
     RXCOST = 698,
     WIRED = 699,
     WIRELESS = 700,
     BABEL_METRIC = 701,
     ENTRIES = 702
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 663 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct mrt_dump_data *md;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 1256 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1284 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  75
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3963

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  469
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  326
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1110
/* YYNRULES -- Number of states.  */
#define YYNSTATES  2110

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   702

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     460,   461,    29,    27,   465,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   462,   459,
      23,    22,    24,   466,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   467,     2,   468,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   463,     2,   464,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    30,    33,    36,    38,    40,    42,    44,    46,    47,
      49,    51,    52,    55,    58,    60,    62,    65,    68,    70,
      72,    74,    76,    77,    79,    80,    85,    88,    89,    91,
      94,    96,    98,   102,   104,   108,   110,   112,   114,   116,
     118,   120,   122,   124,   126,   131,   135,   137,   139,   141,
     143,   146,   151,   155,   159,   163,   167,   171,   175,   180,
     184,   188,   193,   199,   203,   207,   212,   215,   216,   218,
     219,   221,   224,   227,   228,   231,   234,   238,   241,   245,
     249,   254,   257,   261,   265,   269,   272,   277,   283,   285,
     289,   291,   293,   295,   300,   301,   304,   307,   310,   312,
     314,   320,   321,   323,   327,   331,   332,   341,   343,   348,
     350,   352,   353,   355,   358,   362,   363,   366,   369,   372,
     375,   378,   381,   385,   389,   393,   398,   401,   404,   408,
     411,   414,   416,   418,   420,   421,   424,   427,   430,   433,
     436,   438,   440,   444,   448,   449,   451,   453,   456,   457,
     459,   463,   465,   469,   471,   472,   475,   478,   481,   484,
     488,   492,   496,   502,   503,   507,   509,   511,   515,   517,
     521,   523,   525,   527,   529,   531,   533,   535,   537,   541,
     543,   547,   549,   551,   556,   558,   559,   563,   568,   570,
     573,   574,   580,   586,   592,   598,   603,   608,   613,   618,
     621,   624,   627,   630,   633,   636,   639,   642,   645,   648,
     652,   656,   661,   667,   669,   670,   674,   679,   684,   685,
     688,   692,   696,   700,   703,   706,   709,   712,   716,   720,
     723,   726,   728,   730,   732,   737,   738,   742,   746,   750,
     751,   753,   755,   760,   761,   764,   767,   770,   773,   776,
     779,   782,   783,   786,   796,   806,   811,   815,   819,   823,
     827,   831,   835,   839,   843,   847,   852,   854,   856,   860,
     861,   863,   868,   873,   878,   882,   887,   892,   897,   902,
     905,   907,   909,   911,   913,   914,   916,   917,   922,   925,
     927,   929,   931,   933,   935,   937,   939,   941,   943,   945,
     947,   949,   951,   953,   956,   959,   960,   964,   966,   970,
     972,   974,   976,   979,   983,   986,   991,   992,   998,   999,
    1001,  1003,  1006,  1008,  1012,  1014,  1016,  1018,  1020,  1022,
    1026,  1028,  1030,  1034,  1036,  1038,  1040,  1042,  1048,  1056,
    1062,  1070,  1080,  1088,  1094,  1102,  1108,  1120,  1122,  1124,
    1127,  1129,  1137,  1147,  1155,  1163,  1173,  1181,  1191,  1199,
    1209,  1217,  1233,  1235,  1237,  1239,  1241,  1245,  1247,  1249,
    1251,  1253,  1257,  1259,  1263,  1265,  1269,  1273,  1275,  1278,
    1281,  1288,  1290,  1294,  1295,  1300,  1304,  1306,  1310,  1314,
    1318,  1321,  1326,  1329,  1332,  1335,  1336,  1339,  1342,  1343,
    1345,  1347,  1349,  1351,  1353,  1355,  1357,  1361,  1365,  1367,
    1373,  1381,  1389,  1391,  1392,  1397,  1399,  1401,  1403,  1405,
    1407,  1409,  1411,  1413,  1415,  1417,  1419,  1423,  1427,  1431,
    1435,  1439,  1443,  1447,  1451,  1455,  1459,  1463,  1467,  1471,
    1475,  1479,  1482,  1487,  1489,  1491,  1493,  1495,  1498,  1501,
    1505,  1509,  1516,  1520,  1524,  1528,  1532,  1536,  1542,  1550,
    1557,  1564,  1571,  1578,  1583,  1592,  1597,  1599,  1601,  1603,
    1605,  1607,  1609,  1611,  1612,  1614,  1618,  1620,  1624,  1625,
    1627,  1632,  1639,  1644,  1648,  1654,  1660,  1665,  1672,  1676,
    1679,  1685,  1691,  1700,  1709,  1718,  1727,  1730,  1732,  1735,
    1738,  1741,  1742,  1746,  1752,  1753,  1754,  1757,  1762,  1767,
    1772,  1775,  1778,  1781,  1783,  1785,  1787,  1790,  1793,  1797,
    1801,  1802,  1806,  1807,  1811,  1816,  1820,  1821,  1824,  1827,
    1828,  1831,  1832,  1835,  1840,  1846,  1849,  1850,  1854,  1858,
    1860,  1864,  1866,  1870,  1872,  1876,  1879,  1882,  1885,  1888,
    1891,  1894,  1898,  1902,  1906,  1912,  1919,  1924,  1931,  1936,
    1943,  1948,  1953,  1959,  1966,  1970,  1974,  1979,  1985,  1991,
    1997,  2003,  2009,  2014,  2019,  2025,  2031,  2037,  2043,  2049,
    2055,  2061,  2067,  2074,  2081,  2088,  2094,  2101,  2110,  2117,
    2124,  2131,  2137,  2144,  2149,  2155,  2160,  2165,  2171,  2176,
    2182,  2187,  2193,  2199,  2205,  2211,  2217,  2224,  2230,  2236,
    2243,  2251,  2259,  2267,  2273,  2279,  2285,  2290,  2295,  2298,
    2300,  2303,  2306,  2308,  2311,  2314,  2319,  2320,  2324,  2330,
    2335,  2336,  2340,  2344,  2348,  2351,  2355,  2358,  2362,  2366,
    2368,  2371,  2375,  2378,  2383,  2387,  2390,  2394,  2396,  2399,
    2404,  2405,  2409,  2412,  2414,  2417,  2421,  2425,  2429,  2433,
    2436,  2440,  2441,  2447,  2448,  2454,  2457,  2460,  2462,  2467,
    2469,  2471,  2472,  2476,  2479,  2482,  2485,  2491,  2494,  2495,
    2499,  2500,  2503,  2506,  2510,  2513,  2516,  2520,  2523,  2526,
    2529,  2531,  2535,  2538,  2541,  2544,  2547,  2550,  2553,  2557,
    2560,  2563,  2566,  2569,  2572,  2575,  2578,  2581,  2585,  2589,
    2593,  2596,  2600,  2603,  2607,  2611,  2616,  2621,  2624,  2627,
    2630,  2634,  2638,  2642,  2645,  2649,  2653,  2657,  2662,  2665,
    2668,  2670,  2671,  2674,  2678,  2680,  2681,  2683,  2686,  2687,
    2690,  2691,  2693,  2697,  2698,  2699,  2702,  2703,  2707,  2708,
    2712,  2713,  2717,  2721,  2726,  2733,  2740,  2747,  2755,  2762,
    2770,  2776,  2777,  2780,  2784,  2787,  2791,  2795,  2798,  2802,
    2805,  2808,  2812,  2816,  2822,  2827,  2832,  2835,  2837,  2840,
    2843,  2844,  2848,  2849,  2853,  2856,  2860,  2861,  2865,  2871,
    2872,  2877,  2882,  2886,  2889,  2893,  2897,  2901,  2905,  2910,
    2915,  2920,  2924,  2928,  2933,  2938,  2941,  2942,  2946,  2947,
    2951,  2955,  2959,  2961,  2963,  2965,  2966,  2967,  2971,  2972,
    2976,  2981,  2983,  2986,  2989,  2992,  2997,  3002,  3003,  3004,
    3008,  3009,  3013,  3017,  3019,  3020,  3021,  3024,  3027,  3028,
    3029,  3033,  3035,  3041,  3043,  3044,  3045,  3048,  3051,  3052,
    3053,  3057,  3059,  3065,  3067,  3070,  3071,  3074,  3077,  3079,
    3082,  3087,  3090,  3093,  3094,  3098,  3104,  3105,  3106,  3109,
    3112,  3115,  3118,  3121,  3124,  3127,  3131,  3135,  3139,  3143,
    3147,  3151,  3155,  3159,  3163,  3167,  3170,  3174,  3178,  3183,
    3187,  3190,  3193,  3195,  3197,  3199,  3201,  3203,  3204,  3208,
    3209,  3213,  3218,  3225,  3232,  3235,  3239,  3243,  3249,  3255,
    3260,  3263,  3267,  3271,  3275,  3277,  3280,  3285,  3289,  3293,
    3297,  3300,  3303,  3306,  3309,  3312,  3314,  3318,  3319,  3322,
    3323,  3327,  3332,  3335,  3337,  3340,  3341,  3345,  3351,  3352,
    3353,  3354,  3357,  3360,  3364,  3368,  3371,  3374,  3378,  3382,
    3385,  3389,  3393,  3394,  3398,  3399,  3403,  3408,  3415,  3422,
    3429,  3431,  3433,  3435,  3437,  3439,  3441,  3443,  3445,  3447,
    3449,  3451,  3453,  3455,  3457,  3459,  3461,  3463,  3465,  3467,
    3469,  3471,  3473,  3475,  3477,  3479,  3481,  3483,  3485,  3487,
    3489,  3491,  3493,  3495,  3497,  3499,  3501,  3503,  3505,  3507,
    3509,  3511,  3513,  3515,  3517,  3519,  3521,  3523,  3525,  3527,
    3529,  3531,  3533,  3535,  3537,  3539,  3541,  3543,  3545,  3547,
    3549,  3551,  3553,  3555,  3557,  3559,  3561,  3563,  3565,  3567,
    3570,  3573,  3576,  3578,  3581,  3583,  3586,  3589,  3591,  3593,
    3596,  3598,  3602,  3606,  3610,  3614,  3618,  3622,  3626,  3628,
    3630,  3632,  3634,  3636,  3638,  3640,  3642,  3644,  3646,  3648,
    3650,  3652,  3654,  3656,  3658,  3660,  3662,  3664,  3666,  3668,
    3670,  3672,  3674,  3676,  3678,  3680,  3682,  3684,  3686,  3688,
    3690,  3692,  3694,  3696,  3698,  3700,  3702,  3704,  3706,  3708,
    3710,  3712,  3714,  3716,  3718,  3720,  3722,  3724,  3726,  3728,
    3730
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     470,     0,    -1,   471,     3,    -1,     4,   790,    -1,    -1,
     471,   789,    -1,    34,    19,    22,   639,   459,    -1,    15,
      -1,   460,   639,   461,    -1,    19,    -1,   473,    39,    -1,
     473,    40,    -1,   473,    41,    -1,   473,    -1,    35,    -1,
      37,    -1,    36,    -1,    38,    -1,    -1,    18,    -1,    19,
      -1,    -1,    31,    19,    -1,   476,   480,    -1,   478,    -1,
     476,    -1,    30,   473,    -1,   462,   476,    -1,    20,    -1,
      20,    -1,    19,    -1,    20,    -1,    -1,    20,    -1,    -1,
      43,   487,   488,   459,    -1,    63,   482,    -1,    -1,   482,
      -1,    44,   486,    -1,    55,    -1,    45,    -1,   463,   489,
     464,    -1,   490,    -1,   489,   465,   490,    -1,    46,    -1,
      47,    -1,    48,    -1,    49,    -1,    50,    -1,    51,    -1,
      52,    -1,    53,    -1,    54,    -1,   174,   144,   545,   459,
      -1,   174,   482,   459,    -1,   188,    -1,   118,    -1,    62,
      -1,    43,    -1,   492,    20,    -1,   492,    20,   473,    20,
      -1,   492,    58,    60,    -1,   492,    58,    61,    -1,   492,
      59,    60,    -1,   492,    59,    61,    -1,    57,   493,   459,
      -1,    46,    68,   475,    -1,    46,    68,    69,   474,    -1,
      70,    50,   474,    -1,    70,    67,   474,    -1,    71,   502,
     503,     3,    -1,    71,    56,   502,   503,     3,    -1,    71,
      64,     3,    -1,    71,    65,     3,    -1,    71,    66,   502,
       3,    -1,    72,     3,    -1,    -1,    20,    -1,    -1,    67,
      -1,    67,   473,    -1,   521,    73,    -1,    -1,    69,   473,
      -1,    74,   475,    -1,    75,    76,   473,    -1,    77,   475,
      -1,    78,    79,   475,    -1,    80,    81,   475,    -1,    84,
      85,   475,   505,    -1,   521,    78,    -1,    75,    76,   473,
      -1,   154,   484,   479,    -1,    73,    86,   473,    -1,    87,
     473,    -1,   116,   117,   511,   459,    -1,   116,   117,   139,
     536,   459,    -1,    15,    -1,   460,   639,   461,    -1,    17,
      -1,    18,    -1,    19,    -1,   163,   164,   513,   459,    -1,
      -1,   513,   514,    -1,   167,   476,    -1,    42,   473,    -1,
     165,    -1,   166,    -1,    80,    81,   181,   473,   459,    -1,
      -1,   170,    -1,    86,    19,   516,    -1,   162,    86,    19,
      -1,    -1,   519,   162,   478,   182,    15,   184,    15,   459,
      -1,   518,    -1,   518,   463,   519,   464,    -1,   118,    -1,
     119,    -1,    -1,    19,    -1,   139,    19,    -1,    19,   139,
      19,    -1,    -1,   120,   473,    -1,   121,   475,    -1,    46,
     542,    -1,   174,   545,    -1,   124,   524,    -1,   125,   524,
      -1,   131,    69,   526,    -1,   124,    69,   526,    -1,   125,
      69,   526,    -1,   124,   136,   137,   475,    -1,   128,   482,
      -1,    86,   527,    -1,   116,   117,   511,    -1,   169,   482,
      -1,   126,   604,    -1,   605,    -1,    45,    -1,   127,    -1,
      -1,   132,   133,    -1,   132,   134,    -1,   132,    81,    -1,
     132,   135,    -1,   473,   525,    -1,    36,    -1,    19,    -1,
      46,   144,   542,    -1,    46,   158,   473,    -1,    -1,    20,
      -1,   479,    -1,    20,   479,    -1,    -1,    28,    -1,   529,
     531,   530,    -1,   532,    -1,   533,   465,   532,    -1,   533,
      -1,    -1,   535,   533,    -1,   179,   473,    -1,   180,   473,
      -1,   521,   122,    -1,   538,   522,   463,    -1,   539,   523,
     459,    -1,   539,   541,   459,    -1,   539,    66,   323,   475,
     459,    -1,    -1,   123,   540,   533,    -1,    45,    -1,    36,
      -1,   463,   543,   464,    -1,   544,    -1,   543,   465,   544,
      -1,   129,    -1,    79,    -1,   130,    -1,   145,    -1,   142,
      -1,   143,    -1,    45,    -1,    36,    -1,   463,   546,   464,
      -1,   547,    -1,   546,   465,   547,    -1,   129,    -1,   175,
      -1,   168,   463,   549,   464,    -1,   550,    -1,    -1,   550,
     459,   549,    -1,   551,   463,   552,   464,    -1,   551,    -1,
     138,   482,    -1,    -1,   161,   139,   481,   459,   552,    -1,
     161,   141,   481,   459,   552,    -1,   205,   139,   481,   459,
     552,    -1,   205,   141,   481,   459,   552,    -1,   139,   481,
     459,   552,    -1,   141,   481,   459,   552,    -1,   117,   473,
     459,   552,    -1,   146,   553,   459,   552,    -1,   147,   149,
      -1,   147,   150,    -1,   147,   151,    -1,   147,   152,    -1,
     147,   153,    -1,   148,   149,    -1,   148,   150,    -1,   148,
     151,    -1,   148,   152,    -1,   148,   153,    -1,   185,   186,
       3,    -1,   185,   177,     3,    -1,   185,   144,   595,     3,
      -1,   185,   144,    45,   595,     3,    -1,    19,    -1,    -1,
     185,   145,     3,    -1,   185,   145,   187,     3,    -1,   185,
     188,   562,     3,    -1,    -1,   562,   478,    -1,   562,   157,
     479,    -1,   562,    86,    19,    -1,   562,   126,   604,    -1,
     562,   605,    -1,   562,    45,    -1,   562,   154,    -1,   562,
     137,    -1,   562,   563,    19,    -1,   562,   118,    19,    -1,
     562,   155,    -1,   562,   156,    -1,   159,    -1,   125,    -1,
     160,    -1,   185,   162,   565,     3,    -1,    -1,   565,   566,
     478,    -1,   565,   184,    15,    -1,   565,    86,    19,    -1,
      -1,   172,    -1,   157,    -1,   185,   189,   568,     3,    -1,
      -1,   568,    86,    -1,   568,   200,    -1,   568,   126,    -1,
     568,   118,    -1,   568,   119,    -1,   568,   162,    -1,   568,
      19,    -1,    -1,    86,    19,    -1,   190,   162,   478,   182,
      15,   184,    15,   569,     3,    -1,   191,   162,   478,   182,
      15,   184,    15,   569,     3,    -1,   183,   162,   569,     3,
      -1,   192,   193,     3,    -1,   192,   194,     3,    -1,   192,
     142,     3,    -1,   192,   145,     3,    -1,   192,   195,     3,
      -1,   192,   196,     3,    -1,   192,    79,     3,    -1,   192,
     144,     3,    -1,   197,   639,     3,    -1,   198,   583,   584,
       3,    -1,    45,    -1,    36,    -1,   463,   489,   464,    -1,
      -1,    15,    -1,   135,   594,   484,     3,    -1,   199,   594,
     484,     3,    -1,    81,   594,   484,     3,    -1,   171,   594,
       3,    -1,   171,   172,   594,     3,    -1,   171,   173,   594,
       3,    -1,    46,   594,   542,     3,    -1,   174,   594,   545,
       3,    -1,   176,     3,    -1,    19,    -1,    45,    -1,    20,
      -1,    19,    -1,    -1,    20,    -1,    -1,   126,    19,   597,
     603,    -1,   197,   639,    -1,   208,    -1,   209,    -1,   210,
      -1,   211,    -1,   212,    -1,   213,    -1,   214,    -1,   215,
      -1,   217,    -1,   218,    -1,   219,    -1,   220,    -1,   221,
      -1,   222,    -1,   599,   216,    -1,   599,    19,    -1,    -1,
     600,   459,   601,    -1,   600,    -1,   600,   459,   602,    -1,
     607,    -1,    19,    -1,   603,    -1,   254,   639,    -1,   460,
     602,   461,    -1,   460,   461,    -1,   601,   463,   610,   464,
      -1,    -1,   200,    19,   609,   606,   607,    -1,    -1,   611,
      -1,   645,    -1,   611,   645,    -1,   645,    -1,   463,   610,
     464,    -1,    18,    -1,    15,    -1,    17,    -1,   613,    -1,
      16,    -1,   460,   639,   461,    -1,    19,    -1,    15,    -1,
     460,   639,   461,    -1,    17,    -1,   613,    -1,    16,    -1,
     639,    -1,   460,   616,   465,   616,   461,    -1,   460,   616,
     465,   616,     7,   616,   461,    -1,   460,   616,   465,    29,
     461,    -1,   460,   616,     7,   616,   465,   616,   461,    -1,
     460,   616,     7,   616,   465,   616,     7,   616,   461,    -1,
     460,   616,     7,   616,   465,    29,   461,    -1,   460,    29,
     465,   616,   461,    -1,   460,    29,   465,   616,     7,   616,
     461,    -1,   460,    29,   465,    29,   461,    -1,   460,   616,
     465,   616,   461,     7,   460,   616,   465,   616,   461,    -1,
     229,    -1,   230,    -1,   231,    15,    -1,   232,    -1,   460,
     618,   465,   616,   465,   616,   461,    -1,   460,   618,   465,
     616,   465,   616,     7,   616,   461,    -1,   460,   618,   465,
     616,   465,    29,   461,    -1,   460,   616,   465,   616,   465,
     616,   461,    -1,   460,   616,   465,   616,   465,   616,     7,
     616,   461,    -1,   460,   616,   465,   616,   465,    29,   461,
      -1,   460,   616,   465,   616,     7,   616,   465,    29,   461,
      -1,   460,   616,   465,    29,   465,    29,   461,    -1,   460,
     616,     7,   616,   465,    29,   465,    29,   461,    -1,   460,
      29,   465,    29,   465,    29,   461,    -1,   460,   616,   465,
     616,   465,   616,   461,     7,   460,   616,   465,   616,   465,
     616,   461,    -1,   617,    -1,   619,    -1,   620,    -1,   614,
      -1,   614,     7,   614,    -1,   617,    -1,   619,    -1,   620,
      -1,   615,    -1,   615,     7,   615,    -1,   621,    -1,   623,
     465,   621,    -1,   622,    -1,   624,   465,   622,    -1,    18,
      30,    15,    -1,   625,    -1,   625,    27,    -1,   625,    28,
      -1,   625,   463,    15,   465,    15,   464,    -1,   626,    -1,
     627,   465,   626,    -1,    -1,   628,   624,   462,   610,    -1,
     628,     6,   610,    -1,   637,    -1,   460,   639,   461,    -1,
      13,   631,    14,    -1,    30,   632,    30,    -1,    15,   631,
      -1,    15,     7,    15,   631,    -1,    29,   631,    -1,   466,
     631,    -1,   629,   631,    -1,    -1,    15,   632,    -1,   466,
     632,    -1,    -1,    15,    -1,   227,    -1,   228,    -1,    20,
      -1,   613,    -1,   625,    -1,    17,    -1,   467,   623,   468,
      -1,   467,   627,   468,    -1,    16,    -1,   460,   639,   465,
     639,   461,    -1,   460,   618,   465,   639,   465,   639,   461,
      -1,   460,   639,   465,   639,   465,   639,   461,    -1,   630,
      -1,    -1,    19,   460,   644,   461,    -1,    19,    -1,   139,
      -1,   233,    -1,   234,    -1,   236,    -1,   237,    -1,   238,
      -1,   239,    -1,   240,    -1,   241,    -1,   242,    -1,   460,
     639,   461,    -1,   639,    27,   639,    -1,   639,    28,   639,
      -1,   639,    29,   639,    -1,   639,    30,   639,    -1,   639,
      11,   639,    -1,   639,    12,   639,    -1,   639,    22,   639,
      -1,   639,    10,   639,    -1,   639,    23,   639,    -1,   639,
       9,   639,    -1,   639,    24,   639,    -1,   639,     8,   639,
      -1,   639,    25,   639,    -1,   639,    26,   639,    -1,    32,
     639,    -1,   244,   460,   639,   461,    -1,   637,    -1,   633,
      -1,   634,    -1,   120,    -1,   635,   638,    -1,   635,   794,
      -1,   639,    33,   210,    -1,   639,    33,   243,    -1,   639,
      33,   235,   460,   639,   461,    -1,   639,    33,   248,    -1,
     639,    33,   249,    -1,   639,    33,   250,    -1,    27,   253,
      27,    -1,    28,   253,    28,    -1,    28,    28,   253,    28,
      28,    -1,    28,    28,    28,   253,    28,    28,    28,    -1,
     247,   460,   639,   465,   639,   461,    -1,   190,   460,   639,
     465,   639,   461,    -1,   191,   460,   639,   465,   639,   461,
      -1,   126,   460,   639,   465,   639,   461,    -1,   252,   460,
      19,   461,    -1,   252,   460,    19,   465,   639,   465,   639,
     461,    -1,    19,   460,   644,   461,    -1,   207,    -1,   205,
      -1,   206,    -1,    51,    -1,   201,    -1,   202,    -1,   639,
      -1,    -1,   641,    -1,   641,   465,   642,    -1,   639,    -1,
     639,   465,   643,    -1,    -1,   643,    -1,   223,   639,   224,
     612,    -1,   223,   639,   224,   612,   225,   612,    -1,    19,
      22,   639,   459,    -1,   204,   639,   459,    -1,   635,   794,
      22,   639,   459,    -1,   635,   638,    22,   639,   459,    -1,
     120,    22,   639,   459,    -1,   203,   460,   635,   794,   461,
     459,    -1,   640,   642,   459,    -1,   636,   459,    -1,   226,
     639,   463,   628,   464,    -1,   635,   794,    33,   253,   459,
      -1,   635,   794,    33,   247,   460,   639,   461,   459,    -1,
     635,   794,    33,   190,   460,   639,   461,   459,    -1,   635,
     794,    33,   191,   460,   639,   461,   459,    -1,   635,   794,
      33,   126,   460,   639,   461,   459,    -1,   521,   255,    -1,
     523,    -1,   123,   656,    -1,   262,   657,    -1,   263,   661,
      -1,    -1,   648,   647,   459,    -1,   646,   522,   463,   648,
     464,    -1,    -1,    -1,   260,   474,    -1,   256,   258,   260,
     474,    -1,   256,   259,   260,   474,    -1,   257,   259,   260,
     474,    -1,   261,   473,    -1,   140,   475,    -1,   266,   653,
      -1,   548,    -1,   127,    -1,   267,    -1,   147,   149,    -1,
     147,   150,    -1,   268,   147,   149,    -1,   268,   147,   150,
      -1,    -1,   654,   652,   459,    -1,    -1,   463,   654,   464,
      -1,   650,   534,   655,   651,    -1,   650,   655,   651,    -1,
      -1,    31,    19,    -1,   264,   482,    -1,    -1,   265,   476,
      -1,    -1,   262,   475,    -1,   476,   658,   659,   660,    -1,
     185,   255,   269,   558,     3,    -1,   521,   164,    -1,    -1,
     664,    42,   473,    -1,   664,   184,   473,    -1,   475,    -1,
     463,   666,   464,    -1,   667,    -1,   666,   465,   667,    -1,
     329,    -1,   211,    69,   330,    -1,   331,   332,    -1,   333,
     336,    -1,   331,   246,    -1,   337,   338,    -1,   334,   335,
      -1,   337,   339,    -1,   173,   340,   193,    -1,   663,   522,
     463,    -1,   668,   523,   459,    -1,   668,   265,   184,   473,
     459,    -1,   668,   265,   476,   184,   473,   459,    -1,   668,
     263,   664,   459,    -1,   668,   263,   476,   477,   664,   459,
      -1,   668,   123,    20,   459,    -1,   668,   294,   297,   117,
     511,   459,    -1,   668,   294,   296,   459,    -1,   668,   295,
     296,   459,    -1,   668,   270,    76,   473,   459,    -1,   668,
     274,   270,    76,   473,   459,    -1,   668,   122,   459,    -1,
     668,   262,   459,    -1,   668,   262,   473,   459,    -1,   668,
     276,   277,   278,   459,    -1,   668,   276,   277,   136,   459,
      -1,   668,   304,   305,   278,   459,    -1,   668,   304,   305,
     306,   459,    -1,   668,   304,   305,   307,   459,    -1,   668,
     314,   122,   459,    -1,   668,   314,   315,   459,    -1,   668,
     280,    87,   475,   459,    -1,   668,   316,    87,   475,   459,
      -1,   668,   313,    87,   475,   459,    -1,   668,   302,   303,
     475,   459,    -1,   668,   319,   316,   475,   459,    -1,   668,
     279,   287,   473,   459,    -1,   668,   279,   286,   473,   459,
      -1,   668,   237,   167,   476,   459,    -1,   668,   281,   282,
      76,   473,   459,    -1,   668,   271,   282,    76,   473,   459,
      -1,   668,   271,   272,    76,   473,   459,    -1,   668,   273,
      76,   473,   459,    -1,   668,    51,   283,    76,   473,   459,
      -1,   668,    51,   181,    76,   473,   465,   473,   459,    -1,
     668,   135,   284,    51,   475,   459,    -1,   668,   135,   284,
     329,   665,   459,    -1,   668,   199,   188,   308,   475,   459,
      -1,   668,   199,   298,   475,   459,    -1,   668,   199,   324,
     175,   475,   459,    -1,   668,   301,   475,   459,    -1,   668,
     299,   300,   475,   459,    -1,   668,   138,   482,   459,    -1,
     668,   325,   475,   459,    -1,   668,   188,    69,   473,   459,
      -1,   668,   140,   475,   459,    -1,   668,   309,   310,   475,
     459,    -1,   668,   320,   475,   459,    -1,   668,   190,    85,
     258,   459,    -1,   668,   190,    85,   259,   459,    -1,   668,
     190,    85,   475,   459,    -1,   668,   321,   286,   475,   459,
      -1,   668,   321,   265,   184,   459,    -1,   668,   321,   265,
     184,   473,   459,    -1,   668,    80,    81,   475,   459,    -1,
     668,    80,    81,   322,   459,    -1,   668,    80,    81,    76,
     473,   459,    -1,   668,    61,   327,    80,    81,   475,   459,
      -1,   668,    61,   327,    80,    81,   322,   459,    -1,   668,
      61,   327,   328,    76,   473,   459,    -1,   668,   313,    86,
     527,   459,    -1,   668,   317,   318,   475,   459,    -1,   668,
      66,   323,   475,   459,    -1,   668,   255,   475,   459,    -1,
     668,   255,    80,   459,    -1,   521,   341,    -1,   523,    -1,
      86,    20,    -1,   126,   604,    -1,   605,    -1,   342,   482,
      -1,   343,   473,    -1,   344,   190,   280,   475,    -1,    -1,
     671,   670,   459,    -1,   669,   522,   463,   671,   464,    -1,
     341,   192,   674,     3,    -1,    -1,   674,    86,   527,    -1,
     674,    86,    20,    -1,   674,   126,   604,    -1,   674,   605,
      -1,   674,   141,   482,    -1,   521,   345,    -1,   675,   522,
     463,    -1,   676,   677,   459,    -1,   523,    -1,   351,   475,
      -1,   352,   116,   475,    -1,   385,   475,    -1,   385,   475,
      69,   473,    -1,    84,   383,   475,    -1,   353,   473,    -1,
     392,   117,   473,    -1,   679,    -1,   346,   511,    -1,   678,
     463,   680,   464,    -1,    -1,   680,   681,   459,    -1,   352,
     475,    -1,   387,    -1,   187,   475,    -1,   279,   387,   475,
      -1,   279,   354,   473,    -1,   279,   355,   473,    -1,   352,
     354,   473,    -1,   388,   475,    -1,   388,   389,   473,    -1,
      -1,   374,   682,   463,   693,   464,    -1,    -1,   383,   683,
     463,   693,   464,    -1,   381,   684,    -1,   123,   706,    -1,
     688,    -1,   685,   463,   686,   464,    -1,   685,    -1,   478,
      -1,    -1,   686,   687,   459,    -1,   375,   475,    -1,   187,
     475,    -1,   354,   473,    -1,   691,   701,   463,   689,   464,
      -1,   691,   701,    -1,    -1,   689,   690,   459,    -1,    -1,
     357,   473,    -1,   356,   473,    -1,   358,   282,   473,    -1,
     181,   473,    -1,   360,   473,    -1,   360,   156,   473,    -1,
     266,   127,    -1,   266,   267,    -1,   266,   371,    -1,   548,
      -1,   376,   323,   511,    -1,   354,   473,    -1,   357,   473,
      -1,   373,   473,    -1,   356,   473,    -1,   181,   473,    -1,
     360,   473,    -1,   360,   156,   473,    -1,   361,   362,    -1,
     361,   363,    -1,   361,   364,    -1,   361,   365,    -1,   361,
     366,    -1,   361,   367,    -1,   361,   368,    -1,   361,   369,
      -1,   393,   362,   475,    -1,   367,   394,   475,    -1,   358,
     282,   473,    -1,   359,   473,    -1,   370,   364,   475,    -1,
     352,   475,    -1,    66,   323,   475,    -1,   385,   386,   473,
      -1,   323,   396,   397,   475,    -1,   195,   463,   697,   464,
      -1,   266,   127,    -1,   266,   267,    -1,   266,   371,    -1,
     258,   378,   380,    -1,   258,   378,   379,    -1,   258,   378,
     473,    -1,   259,   537,    -1,   259,   359,   473,    -1,   259,
     395,   473,    -1,   317,   318,   475,    -1,   317,   318,   259,
     377,    -1,   255,   475,    -1,   320,   475,    -1,   548,    -1,
      -1,   693,   694,    -1,   695,   696,   459,    -1,   478,    -1,
      -1,   375,    -1,   382,   473,    -1,    -1,   697,   699,    -1,
      -1,   372,    -1,   476,   698,   459,    -1,    -1,    -1,   392,
     473,    -1,    -1,   533,   703,   701,    -1,    -1,   704,   692,
     459,    -1,    -1,   463,   704,   464,    -1,   700,   702,   705,
      -1,   185,   345,   558,     3,    -1,   185,   345,   195,   558,
     483,     3,    -1,   185,   345,   123,   558,   483,     3,    -1,
     185,   345,   398,   558,   483,     3,    -1,   185,   345,   398,
      45,   558,   483,     3,    -1,   185,   345,   399,   558,   483,
       3,    -1,   185,   345,   399,    45,   558,   483,     3,    -1,
     185,   345,   384,   715,     3,    -1,    -1,   715,   390,    -1,
     715,   346,   511,    -1,   715,   323,    -1,   715,   361,    15,
      -1,   715,   391,   511,    -1,   715,   278,    -1,   715,   116,
     511,    -1,   715,    19,    -1,   521,   400,    -1,   716,   522,
     463,    -1,   717,   523,   459,    -1,   717,   333,    86,    19,
     459,    -1,   717,   401,   402,   459,    -1,   717,   401,   403,
     459,    -1,   521,   404,    -1,   523,    -1,   123,   732,    -1,
     211,   738,    -1,    -1,   422,   720,   744,    -1,    -1,   423,
     721,   750,    -1,   426,   478,    -1,   431,    79,   475,    -1,
      -1,   722,   719,   459,    -1,   718,   522,   463,   722,   464,
      -1,    -1,   256,   405,   260,   473,    -1,   182,   405,   260,
     473,    -1,   256,   282,   473,    -1,   406,   475,    -1,   407,
     408,   475,    -1,   323,   410,   473,    -1,   411,    76,   473,
      -1,   412,   413,   473,    -1,   414,   277,    69,   473,    -1,
     279,   418,   473,   752,    -1,   188,   418,   473,   752,    -1,
     279,   120,   728,    -1,   188,   120,   728,    -1,   211,   409,
      76,   473,    -1,   188,   409,    76,   473,    -1,   211,   738,
      -1,    -1,   422,   726,   744,    -1,    -1,   423,   727,   750,
      -1,   422,   265,   475,    -1,   423,   265,   475,    -1,   428,
      -1,   429,    -1,   430,    -1,    -1,    -1,   730,   725,   459,
      -1,    -1,   463,   730,   464,    -1,   724,   534,   731,   729,
      -1,   478,    -1,   419,   475,    -1,   420,   475,    -1,   421,
     475,    -1,   415,   418,   473,   752,    -1,   416,   418,   473,
     752,    -1,    -1,    -1,   736,   734,   459,    -1,    -1,   463,
     736,   464,    -1,   733,   737,   735,    -1,   476,    -1,    -1,
      -1,   424,   739,    -1,   418,   751,    -1,    -1,    -1,   743,
     741,   459,    -1,   739,    -1,   463,   740,   743,   464,   742,
      -1,    20,    -1,    -1,    -1,   425,   745,    -1,   418,   751,
      -1,    -1,    -1,   749,   747,   459,    -1,   745,    -1,   463,
     746,   749,   464,   748,    -1,   473,    -1,   417,   473,    -1,
      -1,   427,   475,    -1,   521,   434,    -1,   523,    -1,   385,
     475,    -1,   385,   475,    69,   473,    -1,   435,   473,    -1,
     123,   763,    -1,    -1,   755,   754,   459,    -1,   753,   522,
     463,   755,   464,    -1,    -1,    -1,    87,   473,    -1,   401,
     438,    -1,   401,   362,    -1,   140,   475,    -1,   167,   476,
      -1,    42,   473,    -1,   439,   473,    -1,   439,   377,   475,
      -1,   440,   441,   475,    -1,   442,   443,   475,    -1,    66,
     444,   475,    -1,   436,    76,   473,    -1,    67,    76,   473,
      -1,   437,    76,   473,    -1,   385,   386,   473,    -1,   258,
     378,   473,    -1,   259,   395,   473,    -1,   259,   537,    -1,
     259,   359,   473,    -1,   317,   318,   475,    -1,   317,   318,
     259,   377,    -1,    66,   323,   475,    -1,   255,   475,    -1,
     266,   760,    -1,   548,    -1,   127,    -1,   445,    -1,   371,
      -1,   149,    -1,    -1,   761,   759,   459,    -1,    -1,   463,
     761,   464,    -1,   757,   534,   762,   758,    -1,   185,   434,
     145,   558,   483,     3,    -1,   185,   434,   195,   558,   483,
       3,    -1,   521,   448,    -1,   766,   522,   463,    -1,   767,
     523,   459,    -1,   767,    66,   323,   475,   459,    -1,   767,
     313,    86,   527,   459,    -1,   767,   771,   774,   459,    -1,
     188,   478,    -1,   275,   476,   477,    -1,   769,   386,   473,
      -1,   769,   255,   475,    -1,   769,    -1,   770,   769,    -1,
     768,   275,   476,   477,    -1,   768,   275,    20,    -1,   768,
     450,   770,    -1,   768,   315,   476,    -1,   768,   306,    -1,
     768,   206,    -1,   768,   451,    -1,   768,   452,    -1,   768,
     449,    -1,   645,    -1,   255,   475,   459,    -1,    -1,   773,
     772,    -1,    -1,   463,   773,   464,    -1,   185,   448,   558,
       3,    -1,   521,   453,    -1,   523,    -1,   123,   785,    -1,
      -1,   778,   777,   459,    -1,   776,   522,   463,   778,   464,
      -1,    -1,    -1,    -1,    42,   473,    -1,   454,   473,    -1,
     357,   260,   473,    -1,   436,   260,   473,    -1,   361,   455,
      -1,   361,   456,    -1,   258,   378,   473,    -1,   259,   395,
     473,    -1,   259,   537,    -1,   259,   359,   473,    -1,    66,
     323,   475,    -1,    -1,   783,   782,   459,    -1,    -1,   463,
     783,   464,    -1,   780,   534,   784,   781,    -1,   185,   453,
     145,   558,   483,     3,    -1,   185,   453,   195,   558,   483,
       3,    -1,   185,   453,   458,   558,   483,     3,    -1,   459,
      -1,   472,    -1,   485,    -1,   491,    -1,   494,    -1,   495,
      -1,   510,    -1,   512,    -1,   515,    -1,   517,    -1,   520,
      -1,   791,    -1,   528,    -1,   596,    -1,   598,    -1,   608,
      -1,   496,    -1,   497,    -1,   498,    -1,   499,    -1,   500,
      -1,   501,    -1,   554,    -1,   555,    -1,   556,    -1,   557,
      -1,   559,    -1,   560,    -1,   561,    -1,   564,    -1,   567,
      -1,   570,    -1,   571,    -1,   572,    -1,   573,    -1,   574,
      -1,   575,    -1,   576,    -1,   577,    -1,   578,    -1,   579,
      -1,   580,    -1,   581,    -1,   582,    -1,   585,    -1,   586,
      -1,   587,    -1,   588,    -1,   589,    -1,   590,    -1,   591,
      -1,   592,    -1,   593,    -1,   662,    -1,   673,    -1,   707,
      -1,   708,    -1,   709,    -1,   710,    -1,   711,    -1,   712,
      -1,   713,    -1,   714,    -1,   764,    -1,   765,    -1,   775,
      -1,   786,    -1,   787,    -1,   788,    -1,   792,   464,    -1,
     793,   464,    -1,   539,   464,    -1,   649,    -1,   668,   464,
      -1,   672,    -1,   676,   464,    -1,   717,   464,    -1,   723,
      -1,   756,    -1,   767,   464,    -1,   779,    -1,   504,   522,
     463,    -1,   792,   523,   459,    -1,   792,   506,   459,    -1,
     792,   509,   459,    -1,   507,   522,   463,    -1,   793,   523,
     459,    -1,   793,   508,   459,    -1,    82,    -1,    83,    -1,
      88,    -1,    89,    -1,    90,    -1,    91,    -1,    92,    -1,
      93,    -1,    94,    -1,    95,    -1,    96,    -1,    97,    -1,
      98,    -1,    99,    -1,   100,    -1,   101,    -1,   102,    -1,
     103,    -1,   104,    -1,   105,    -1,   106,    -1,   107,    -1,
     108,    -1,   109,    -1,   110,    -1,   111,    -1,   112,    -1,
     113,    -1,   114,    -1,   115,    -1,   178,    -1,     5,    -1,
     288,    -1,   285,    -1,   289,    -1,   287,    -1,   286,    -1,
     290,    -1,   291,    -1,   292,    -1,   311,    -1,   312,    -1,
     293,    -1,   326,    -1,   347,    -1,   348,    -1,   349,    -1,
     350,    -1,   432,    -1,   433,    -1,   446,    -1,   447,    -1,
     457,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   882,   882,   883,   886,   888,   896,   905,   906,   907,
     914,   915,   916,   924,   925,   926,   927,   928,   929,   935,
     936,   943,   944,   948,   955,   956,   960,   964,   971,   979,
     980,   987,   988,   992,   993,   999,  1008,  1009,  1013,  1018,
    1019,  1023,  1024,  1028,  1029,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1047,  1048,  1058,  1059,  1060,  1061,
    1064,  1065,  1066,  1067,  1068,  1069,  1073,  1079,  1080,  1081,
    1082,  1090,  1093,  1100,  1103,  1106,  1109,  1113,  1114,  1118,
    1119,  1120,  1128,  1133,  1134,  1138,  1139,  1143,  1150,  1151,
    1152,  1164,  1169,  1173,  1187,  1188,  1202,  1203,  1207,  1208,
    1209,  1210,  1217,  1231,  1233,  1235,  1239,  1240,  1241,  1242,
    1247,  1253,  1254,  1258,  1266,  1270,  1272,  1278,  1279,  1286,
    1287,  1291,  1297,  1301,  1310,  1319,  1321,  1325,  1326,  1327,
    1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
    1341,  1342,  1343,  1344,  1348,  1349,  1350,  1351,  1352,  1356,
    1362,  1366,  1374,  1375,  1383,  1391,  1392,  1393,  1397,  1398,
    1402,  1407,  1408,  1412,  1414,  1422,  1426,  1427,  1433,  1440,
    1441,  1442,  1443,  1447,  1455,  1461,  1462,  1463,  1467,  1468,
    1472,  1473,  1474,  1475,  1476,  1477,  1483,  1484,  1485,  1489,
    1490,  1494,  1495,  1501,  1502,  1505,  1507,  1511,  1512,  1516,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,  1557,  1563,
    1566,  1569,  1572,  1576,  1577,  1580,  1583,  1587,  1591,  1596,
    1602,  1609,  1614,  1619,  1624,  1628,  1632,  1636,  1645,  1653,
    1657,  1664,  1665,  1666,  1671,  1675,  1682,  1689,  1693,  1701,
    1702,  1703,  1708,  1712,  1715,  1716,  1717,  1718,  1719,  1720,
    1721,  1726,  1731,  1739,  1746,  1753,  1761,  1763,  1765,  1767,
    1769,  1771,  1773,  1775,  1778,  1782,  1788,  1789,  1790,  1794,
    1795,  1801,  1803,  1805,  1807,  1809,  1811,  1815,  1819,  1822,
    1826,  1827,  1828,  1832,  1833,  1834,  1842,  1842,  1852,  1856,
    1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,
    1867,  1868,  1869,  1870,  1892,  1903,  1904,  1911,  1912,  1919,
    1928,  1932,  1936,  1957,  1958,  1962,  1974,  1974,  1990,  1991,
    1994,  1995,  1999,  2002,  2011,  2024,  2025,  2026,  2027,  2028,
    2032,  2040,  2041,  2042,  2043,  2044,  2048,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2065,  2066,  2067,
    2068,  2072,  2073,  2074,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2090,  2091,  2092,  2093,  2094,  2098,  2099,  2100,
    2101,  2102,  2106,  2107,  2111,  2112,  2116,  2123,  2124,  2125,
    2126,  2133,  2134,  2137,  2138,  2145,  2157,  2158,  2162,  2163,
    2167,  2168,  2169,  2170,  2171,  2172,  2176,  2177,  2178,  2182,
    2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,  2191,  2195,
    2196,  2197,  2198,  2208,  2212,  2234,  2246,  2247,  2248,  2249,
    2250,  2251,  2252,  2253,  2254,  2255,  2259,  2260,  2261,  2262,
    2263,  2264,  2265,  2266,  2267,  2268,  2269,  2270,  2271,  2272,
    2273,  2274,  2275,  2277,  2278,  2279,  2281,  2283,  2285,  2287,
    2288,  2289,  2290,  2291,  2292,  2302,  2303,  2304,  2305,  2306,
    2307,  2308,  2309,  2311,  2312,  2315,  2337,  2338,  2339,  2340,
    2341,  2342,  2346,  2349,  2350,  2351,  2359,  2365,  2373,  2374,
    2378,  2383,  2391,  2399,  2404,  2408,  2414,  2418,  2423,  2424,
    2425,  2432,  2433,  2434,  2435,  2436,  2442,  2454,  2455,  2456,
    2457,  2460,  2462,  2466,  2470,  2484,  2504,  2505,  2506,  2507,
    2508,  2509,  2510,  2511,  2515,  2516,  2517,  2518,  2519,  2520,
    2523,  2525,  2528,  2530,  2534,  2537,  2542,  2543,  2544,  2548,
    2549,  2553,  2554,  2557,  2576,  2582,  2609,  2611,  2612,  2617,
    2618,  2622,  2623,  2627,  2628,  2629,  2630,  2631,  2632,  2633,
    2634,  2635,  2639,  2640,  2641,  2642,  2643,  2644,  2650,  2651,
    2652,  2653,  2654,  2655,  2656,  2657,  2658,  2659,  2660,  2661,
    2662,  2663,  2664,  2665,  2666,  2667,  2668,  2669,  2670,  2671,
    2672,  2673,  2674,  2675,  2676,  2677,  2678,  2679,  2680,  2681,
    2682,  2683,  2684,  2685,  2686,  2687,  2688,  2689,  2695,  2696,
    2697,  2698,  2699,  2700,  2701,  2702,  2703,  2704,  2705,  2706,
    2707,  2708,  2709,  2710,  2711,  2712,  2713,  2714,  2725,  2731,
    2732,  2733,  2734,  2735,  2736,  2737,  2740,  2742,  2746,  2749,
    2753,  2754,  2755,  2756,  2757,  2758,  2765,  2775,  2776,  2780,
    2781,  2782,  2783,  2784,  2785,  2786,  2787,  2788,  2791,  2806,
    2809,  2811,  2815,  2816,  2817,  2818,  2819,  2820,  2821,  2822,
    2823,  2824,  2824,  2825,  2825,  2826,  2827,  2828,  2832,  2833,
    2837,  2845,  2847,  2851,  2852,  2853,  2857,  2858,  2861,  2863,
    2866,  2867,  2868,  2869,  2870,  2871,  2872,  2873,  2874,  2875,
    2876,  2879,  2899,  2900,  2901,  2902,  2903,  2904,  2905,  2906,
    2907,  2908,  2909,  2910,  2911,  2912,  2913,  2914,  2915,  2916,
    2917,  2918,  2919,  2920,  2921,  2922,  2923,  2924,  2925,  2926,
    2927,  2928,  2929,  2930,  2931,  2932,  2933,  2934,  2935,  2936,
    2937,  2940,  2942,  2945,  2947,  2956,  2958,  2959,  2962,  2964,
    2968,  2969,  2972,  2982,  3003,  3005,  3009,  3009,  3012,  3014,
    3017,  3019,  3023,  3028,  3031,  3034,  3039,  3042,  3047,  3050,
    3054,  3058,  3061,  3062,  3063,  3064,  3065,  3066,  3067,  3068,
    3074,  3081,  3082,  3083,  3088,  3089,  3095,  3105,  3106,  3107,
    3108,  3108,  3109,  3109,  3110,  3115,  3118,  3120,  3124,  3128,
    3151,  3152,  3153,  3154,  3155,  3156,  3157,  3158,  3159,  3160,
    3165,  3169,  3170,  3171,  3172,  3173,  3174,  3174,  3175,  3175,
    3176,  3177,  3181,  3182,  3183,  3186,  3224,  3226,  3229,  3231,
    3235,  3238,  3251,  3252,  3253,  3254,  3258,  3265,  3273,  3275,
    3278,  3280,  3284,  3288,  3298,  3303,  3304,  3305,  3309,  3321,
    3323,  3327,  3328,  3332,  3345,  3350,  3351,  3352,  3356,  3368,
    3370,  3374,  3375,  3380,  3381,  3385,  3386,  3393,  3406,  3407,
    3408,  3409,  3410,  3413,  3415,  3419,  3423,  3446,  3476,  3477,
    3478,  3479,  3480,  3481,  3482,  3486,  3487,  3488,  3489,  3490,
    3491,  3492,  3493,  3494,  3495,  3496,  3497,  3498,  3499,  3500,
    3501,  3502,  3503,  3507,  3508,  3509,  3510,  3513,  3515,  3518,
    3520,  3524,  3530,  3533,  3540,  3547,  3548,  3549,  3550,  3551,
    3554,  3564,  3573,  3577,  3583,  3584,  3588,  3593,  3599,  3602,
    3607,  3608,  3609,  3610,  3611,  3615,  3616,  3619,  3621,  3624,
    3626,  3630,  3636,  3643,  3644,  3647,  3649,  3653,  3657,  3670,
    3693,  3694,  3695,  3696,  3697,  3698,  3699,  3700,  3701,  3702,
    3703,  3704,  3707,  3709,  3712,  3714,  3719,  3724,  3727,  3730,
    3737,  3737,  3737,  3737,  3737,  3737,  3737,  3737,  3737,  3737,
    3737,  3737,  3737,  3737,  3737,  3737,  3738,  3738,  3738,  3738,
    3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,
    3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,
    3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,
    3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,
    3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3739,
    3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,
    3739,  3740,  3740,  3740,  3740,  3741,  3741,  3741,  3742,  3742,
    3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,
    3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,
    3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3743,
    3743,  3744,  3745,  3746,  3747,  3748,  3749,  3750,  3751,  3752,
    3753,  3754,  3755,  3755,  3755,  3755,  3755,  3755,  3755,  3755,
    3755
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "VRF", "STATES",
  "FILTERS", "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP",
  "FILTERED", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS",
  "PROTOCOLS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1",
  "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "FOR",
  "COMMANDS", "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED",
  "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY",
  "IGP_METRIC", "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "AWARE", "LINK",
  "EXTENDED", "SETKEY", "BGP_LARGE_COMMUNITY", "LIVED", "STALE", "CEASE",
  "HIT", "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE",
  "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF", "MRT",
  "FILENAME", "PERIOD", "ALWAYS", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL",
  "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL",
  "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA", "SUPPRESSION",
  "TOPOLOGY", "STATE", "PIPE", "MODE", "OPAQUE", "TRANSPARENT", "RADV",
  "RA", "MANAGED", "OTHER", "CONFIG", "LINGER", "MTU", "REACHABLE",
  "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME",
  "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN",
  "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "PROPAGATE",
  "RA_PREFERENCE", "RA_LIFETIME", "RIP", "INFINITY", "UPDATE", "GARBAGE",
  "MULTICAST", "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO",
  "PLAINTEXT", "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH",
  "BLACKHOLE", "UNREACHABLE", "BABEL", "RXCOST", "WIRED", "WIRELESS",
  "BABEL_METRIC", "ENTRIES", "';'", "'('", "')'", "':'", "'{'", "'}'",
  "','", "'?'", "'['", "']'", "$accept", "config", "conf_entries",
  "definition", "expr", "expr_us", "bool", "ipa", "ipa_scope", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text", "opttext", "text_or_none",
  "log_config", "syslog_name", "log_file", "log_mask", "log_mask_list",
  "log_cat", "mrtdump_base", "timeformat_which", "timeformat_spec",
  "timeformat_base", "debug_unix", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT",
  "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cfg_name", "cfg_timeout", "kern_proto_start",
  "kern_mp_limit", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "gr_opts", "tab_sorted", "newtab", "roa_table_start", "roa_table_opts",
  "roa_table", "proto_start", "proto_name", "proto_item", "imexport",
  "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "export_mode",
  "cmd_SHOW_ROA", "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args",
  "roa_table_arg", "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def",
  "$@1", "filter_eval", "type", "one_decl", "decls", "declsn",
  "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "cnum", "pair_item", "ec_kind",
  "ec_item", "lc_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_finish",
  "bfd_iface_item", "bfd_auth_type", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_nbr_opts",
  "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag", "bgp_proto",
  "mrt_proto_start", "mrt_proto_item", "mrt_proto_opts", "mrt_proto",
  "cmd_MRT_DUMP", "mrt_dump_args", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_proto_start", "rip_proto_item", "rip_proto_opts", "rip_proto",
  "rip_iface_start", "rip_iface_finish", "rip_iface_item", "rip_auth",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "stat_route_item", "stat_route_opts",
  "stat_route_opt_list", "cmd_SHOW_STATIC", "babel_proto_start",
  "babel_proto_item", "babel_proto_opts", "babel_proto",
  "babel_iface_start", "babel_iface_finish", "babel_iface_item",
  "babel_iface_opts", "babel_iface_opt_list", "babel_iface",
  "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "conf", "cli_cmd", "proto", "kern_proto",
  "kif_proto", "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    59,
      40,    41,    58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   469,   470,   470,   471,   471,   472,   473,   473,   473,
     474,   474,   474,   475,   475,   475,   475,   475,   475,   476,
     476,   477,   477,   478,   479,   479,   480,   480,   481,   482,
     482,   483,   483,   484,   484,   485,   486,   486,   487,   487,
     487,   488,   488,   489,   489,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   491,   491,   492,   492,   492,   492,
     493,   493,   493,   493,   493,   493,   494,   495,   495,   495,
     495,   496,   497,   498,   499,   500,   501,   502,   502,   503,
     503,   503,   504,   505,   505,   506,   506,   506,   506,   506,
     506,   507,   508,   508,   509,   509,   510,   510,   511,   511,
     511,   511,   511,   512,   513,   513,   514,   514,   514,   514,
     515,   516,   516,   517,   518,   519,   519,   520,   520,   521,
     521,   522,   522,   522,   522,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     524,   524,   524,   524,   525,   525,   525,   525,   525,   526,
     526,   527,   528,   528,   529,   530,   530,   530,   531,   531,
     532,   533,   533,   534,   535,   536,   537,   537,   538,   539,
     539,   539,   539,   540,   541,   542,   542,   542,   543,   543,
     544,   544,   544,   544,   544,   544,   545,   545,   545,   546,
     546,   547,   547,   548,   548,   549,   549,   550,   550,   551,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   553,
     553,   553,   553,   553,   553,   553,   553,   553,   553,   554,
     555,   556,   557,   558,   558,   559,   560,   561,   562,   562,
     562,   562,   562,   562,   562,   562,   562,   562,   562,   562,
     562,   563,   563,   563,   564,   565,   565,   565,   565,   566,
     566,   566,   567,   568,   568,   568,   568,   568,   568,   568,
     568,   569,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   583,   583,   584,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   594,   594,   595,   595,   595,   597,   596,   598,   599,
     599,   599,   599,   599,   599,   599,   599,   599,   599,   599,
     599,   599,   599,   599,   600,   601,   601,   602,   602,   603,
     604,   604,   605,   606,   606,   607,   609,   608,   610,   610,
     611,   611,   612,   612,   613,   614,   614,   614,   614,   614,
     614,   615,   615,   615,   615,   615,   616,   617,   617,   617,
     617,   617,   617,   617,   617,   617,   617,   618,   618,   618,
     618,   619,   619,   619,   620,   620,   620,   620,   620,   620,
     620,   620,   621,   621,   621,   621,   621,   622,   622,   622,
     622,   622,   623,   623,   624,   624,   625,   626,   626,   626,
     626,   627,   627,   628,   628,   628,   629,   629,   630,   630,
     631,   631,   631,   631,   631,   631,   632,   632,   632,   633,
     633,   633,   633,   633,   633,   633,   633,   633,   633,   634,
     634,   634,   634,   635,   636,   637,   638,   638,   638,   638,
     638,   638,   638,   638,   638,   638,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   640,   640,   640,   640,
     640,   640,   641,   642,   642,   642,   643,   643,   644,   644,
     645,   645,   645,   645,   645,   645,   645,   645,   645,   645,
     645,   645,   645,   645,   645,   645,   646,   647,   647,   647,
     647,   648,   648,   649,   650,   651,   652,   652,   652,   652,
     652,   652,   652,   652,   653,   653,   653,   653,   653,   653,
     654,   654,   655,   655,   656,   657,   658,   658,   658,   659,
     659,   660,   660,   661,   662,   663,   664,   664,   664,   665,
     665,   666,   666,   667,   667,   667,   667,   667,   667,   667,
     667,   667,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   669,   670,
     670,   670,   670,   670,   670,   670,   671,   671,   672,   673,
     674,   674,   674,   674,   674,   674,   675,   676,   676,   677,
     677,   677,   677,   677,   677,   677,   677,   677,   678,   679,
     680,   680,   681,   681,   681,   681,   681,   681,   681,   681,
     681,   682,   681,   683,   681,   681,   681,   681,   684,   684,
     685,   686,   686,   687,   687,   687,   688,   688,   689,   689,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   691,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   693,   693,   694,   695,   696,   696,   696,   697,   697,
     698,   698,   699,   700,   701,   701,   703,   702,   704,   704,
     705,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   715,   715,   715,   715,   715,   715,   715,   715,
     716,   717,   717,   717,   717,   717,   718,   719,   719,   719,
     720,   719,   721,   719,   719,   719,   722,   722,   723,   724,
     725,   725,   725,   725,   725,   725,   725,   725,   725,   725,
     725,   725,   725,   725,   725,   725,   726,   725,   727,   725,
     725,   725,   728,   728,   728,   729,   730,   730,   731,   731,
     732,   733,   734,   734,   734,   734,   734,   735,   736,   736,
     737,   737,   738,   739,   740,   741,   741,   741,   742,   743,
     743,   744,   744,   745,   746,   747,   747,   747,   748,   749,
     749,   750,   750,   751,   751,   752,   752,   753,   754,   754,
     754,   754,   754,   755,   755,   756,   757,   758,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   760,   760,   760,   760,   761,   761,   762,
     762,   763,   764,   765,   766,   767,   767,   767,   767,   767,
     768,   769,   769,   769,   770,   770,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   772,   772,   773,   773,   774,
     774,   775,   776,   777,   777,   778,   778,   779,   780,   781,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     782,   782,   783,   783,   784,   784,   785,   786,   787,   788,
     789,   789,   789,   789,   789,   789,   789,   789,   789,   789,
     789,   789,   789,   789,   789,   789,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   791,
     791,   791,   791,   791,   791,   791,   791,   791,   791,   791,
     791,   792,   792,   792,   792,   793,   793,   793,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     4,     5,     3,     3,     4,     2,     0,     1,     0,
       1,     2,     2,     0,     2,     2,     3,     2,     3,     3,
       4,     2,     3,     3,     3,     2,     4,     5,     1,     3,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     2,     3,     0,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     4,     2,     2,     3,     2,
       2,     1,     1,     1,     0,     2,     2,     2,     2,     2,
       1,     1,     3,     3,     0,     1,     1,     2,     0,     1,
       3,     1,     3,     1,     0,     2,     2,     2,     2,     3,
       3,     3,     5,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     4,     4,     4,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     1,     1,     4,     0,     3,     3,     3,     0,
       1,     1,     4,     0,     2,     2,     2,     2,     2,     2,
       2,     0,     2,     9,     9,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     3,     0,
       1,     4,     4,     4,     3,     4,     4,     4,     4,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     3,     1,     3,     1,
       1,     1,     2,     3,     2,     4,     0,     5,     0,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     5,     7,     5,
       7,     9,     7,     5,     7,     5,    11,     1,     1,     2,
       1,     7,     9,     7,     7,     9,     7,     9,     7,     9,
       7,    15,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     4,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     5,
       7,     7,     1,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     4,     1,     1,     1,     1,     2,     2,     3,
       3,     6,     3,     3,     3,     3,     3,     5,     7,     6,
       6,     6,     6,     4,     8,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     1,     3,     0,     1,
       4,     6,     4,     3,     5,     5,     4,     6,     3,     2,
       5,     5,     8,     8,     8,     8,     2,     1,     2,     2,
       2,     0,     3,     5,     0,     0,     2,     4,     4,     4,
       2,     2,     2,     1,     1,     1,     2,     2,     3,     3,
       0,     3,     0,     3,     4,     3,     0,     2,     2,     0,
       2,     0,     2,     4,     5,     2,     0,     3,     3,     1,
       3,     1,     3,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     5,     6,     4,     6,     4,     6,
       4,     4,     5,     6,     3,     3,     4,     5,     5,     5,
       5,     5,     4,     4,     5,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     6,     5,     6,     8,     6,     6,
       6,     5,     6,     4,     5,     4,     4,     5,     4,     5,
       4,     5,     5,     5,     5,     5,     6,     5,     5,     6,
       7,     7,     7,     5,     5,     5,     4,     4,     2,     1,
       2,     2,     1,     2,     2,     4,     0,     3,     5,     4,
       0,     3,     3,     3,     2,     3,     2,     3,     3,     1,
       2,     3,     2,     4,     3,     2,     3,     1,     2,     4,
       0,     3,     2,     1,     2,     3,     3,     3,     3,     2,
       3,     0,     5,     0,     5,     2,     2,     1,     4,     1,
       1,     0,     3,     2,     2,     2,     5,     2,     0,     3,
       0,     2,     2,     3,     2,     2,     3,     2,     2,     2,
       1,     3,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       2,     3,     2,     3,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     4,     2,     2,
       1,     0,     2,     3,     1,     0,     1,     2,     0,     2,
       0,     1,     3,     0,     0,     2,     0,     3,     0,     3,
       0,     3,     3,     4,     6,     6,     6,     7,     6,     7,
       5,     0,     2,     3,     2,     3,     3,     2,     3,     2,
       2,     3,     3,     5,     4,     4,     2,     1,     2,     2,
       0,     3,     0,     3,     2,     3,     0,     3,     5,     0,
       4,     4,     3,     2,     3,     3,     3,     3,     4,     4,
       4,     3,     3,     4,     4,     2,     0,     3,     0,     3,
       3,     3,     1,     1,     1,     0,     0,     3,     0,     3,
       4,     1,     2,     2,     2,     4,     4,     0,     0,     3,
       0,     3,     3,     1,     0,     0,     2,     2,     0,     0,
       3,     1,     5,     1,     0,     0,     2,     2,     0,     0,
       3,     1,     5,     1,     2,     0,     2,     2,     1,     2,
       4,     2,     2,     0,     3,     5,     0,     0,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     4,     3,
       2,     2,     1,     1,     1,     1,     1,     0,     3,     0,
       3,     4,     6,     6,     2,     3,     3,     5,     5,     4,
       2,     3,     3,     3,     1,     2,     4,     3,     3,     3,
       2,     2,     2,     2,     2,     1,     3,     0,     2,     0,
       3,     4,     2,     1,     2,     0,     3,     5,     0,     0,
       0,     2,     2,     3,     3,     2,     2,     3,     3,     2,
       3,     3,     0,     3,     0,     3,     4,     6,     6,     6,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     2,     1,     2,     2,     1,     1,     2,
       1,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   423,     0,     0,
       0,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,     3,     1,     2,     0,     0,     0,
       0,     0,     0,     0,     0,   119,   120,     0,     0,     0,
       0,   423,     0,   970,   971,   972,   973,   974,   975,   121,
     121,   976,   977,   978,   979,   117,   980,     0,   982,   121,
     125,   983,   984,   985,   121,  1042,   121,   125,   121,  1044,
     121,   125,   121,   125,   121,  1047,   121,  1048,   121,   125,
     121,  1050,     5,   981,   125,   125,   290,   292,   291,     0,
      78,    77,     0,     0,    77,    79,    76,    34,    34,     0,
       0,     0,     0,   289,   261,   294,     0,   245,     0,     0,
     228,   253,     0,   224,     0,   224,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   405,   409,   418,
     415,   334,   425,   412,     0,     0,   408,   423,   456,     0,
       0,     0,   410,   411,     0,     0,     0,   423,     0,   413,
     414,   422,   454,   455,     0,   453,     0,   277,   276,     0,
     279,    34,   640,     0,    30,    29,    37,    40,    38,     0,
      18,     0,     0,    59,    58,    57,    56,     0,     0,     0,
       0,     0,   111,     0,   296,     0,   104,     0,     0,   298,
     326,   122,     0,     0,     0,   115,    82,    91,   168,   545,
     506,   628,   646,   780,   786,   867,   914,   942,     0,     0,
       0,     0,     0,     0,    18,   173,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
      18,     0,   546,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,    18,     0,    18,  1043,     0,     0,
       0,     0,     0,    18,     0,     0,    18,     0,  1045,   649,
       0,     0,   657,     0,     0,     0,  1046,     0,     0,     0,
       0,     0,     0,     0,  1049,     0,     0,   939,     0,     0,
      18,     0,    18,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,    34,  1040,     0,     0,   176,   175,     0,     0,
      79,    73,    74,     0,    80,     0,    33,     0,     0,     0,
       0,   284,   187,   186,     0,     0,     0,     0,   293,   295,
     294,     0,   225,     0,   249,   220,   219,     0,     0,   224,
     223,   224,   224,   771,   224,   224,     0,   224,   224,     0,
     224,   224,   224,    19,    20,     0,     0,     0,   272,   268,
     273,   269,   266,   267,   270,   271,   405,   425,   405,   423,
     405,   405,     0,   396,     0,   423,     0,     0,     0,   408,
     408,     0,   451,   423,   423,   423,   423,   423,     0,   357,
     358,     0,   360,     0,     0,   335,   338,   336,   340,   423,
     337,   375,   372,   373,   374,   382,     0,   387,   391,     0,
    1089,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,   426,  1088,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  1091,  1094,  1093,  1090,  1092,  1095,  1096,  1097,
    1100,  1098,  1099,  1101,  1102,  1103,  1104,  1105,  1106,  1107,
    1108,  1109,  1110,   457,   458,   274,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
       0,    45,    46,    47,    48,    49,    50,    51,    52,    53,
       0,    43,   280,     0,     0,     0,   423,     0,    39,    41,
       0,     0,     7,     9,    14,    16,    15,    17,     0,   423,
      13,    67,   152,   153,    60,     0,     0,    66,     0,    69,
      70,     0,   112,   113,    98,   100,   101,   102,   164,   423,
       0,   315,   114,     0,     0,    55,     0,     0,   123,  1051,
    1055,     0,   169,   128,    18,   151,   137,     0,   126,   127,
     154,   142,     0,   315,   143,     0,   423,   130,   141,     0,
     131,   136,     0,   139,   129,   170,   171,   511,   562,     0,
       0,     0,    18,    18,   574,     0,     0,     0,     0,     0,
      18,     0,    18,     0,     0,     0,     0,   575,     0,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    18,     0,     0,     0,     0,    18,     0,    18,     0,
      18,     0,    18,     0,     0,    18,    18,    18,     0,     0,
      18,     0,   563,   636,   647,    18,   658,   650,    18,   655,
     652,     0,   648,   660,   781,     0,     0,     0,   782,   796,
     873,   915,    18,   920,     0,   916,   931,     0,   930,     0,
     934,     0,   932,   933,   937,     0,   945,     0,    85,     0,
      87,    18,    18,    18,    95,  1053,  1054,  1052,     0,     0,
    1057,  1056,   181,   180,   182,   184,   185,   183,     0,   178,
     287,     0,    75,    81,    71,   283,   281,   285,   286,   191,
     192,     0,   189,   288,   262,   265,     0,   221,   226,   244,
       0,   251,   250,     0,     0,   227,   234,     0,     0,   242,
     315,   236,   235,   239,   240,     0,   241,   243,   229,     0,
     233,   252,   260,   254,   257,   258,   256,   259,   255,     0,
      32,    32,     0,   224,    32,   224,    32,   763,    32,    32,
     941,    32,    32,    32,     0,     0,    23,     0,     0,     0,
     400,   402,     0,   403,   404,   398,   386,   486,   489,     0,
     465,     0,     0,   466,   406,   407,   399,     0,     0,     0,
       0,     0,     0,   359,   423,   436,   423,     0,     0,     0,
     346,     0,     0,   416,   388,   389,     0,     0,   417,   448,
     446,   444,   441,   442,   443,   445,   447,   449,   450,   437,
     438,   439,   440,   459,     0,   460,   462,   463,   464,   278,
       0,   275,   282,   639,     0,   315,     0,   644,     0,    36,
       0,    35,    68,     0,     0,    62,    63,    64,    65,    10,
      11,    12,     0,   154,     0,     0,    96,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   297,   319,     0,   108,   109,     0,
     103,   105,    54,     0,   315,   124,     0,   118,     0,   138,
     158,   161,   174,   150,   144,   133,   320,   321,   140,    18,
     322,   134,   132,   125,     0,     0,     0,     0,     0,     0,
       0,     0,   568,    18,    18,   605,   608,     0,     0,     0,
       0,    18,     0,    18,     0,   627,   626,   576,     0,   546,
       0,     0,   566,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   570,     0,   571,     0,
     603,     0,     0,     0,     0,     0,     0,     0,   582,   583,
       0,     0,     0,   610,     0,     0,   606,   125,   654,   651,
       0,   656,     0,     0,   784,   785,   125,   125,     0,     0,
     927,    21,   929,     0,   924,   928,   423,   919,   125,    94,
      86,    88,    89,    83,    92,    25,    24,    93,   177,     0,
      72,   188,     0,   222,   248,   247,   246,   231,   238,   232,
     230,   237,   544,    31,     0,     0,   770,   779,     0,   777,
     774,     0,     0,   772,     0,    32,     0,    32,     0,     0,
       0,     0,     0,     0,    26,    27,     0,     0,   405,   397,
     423,   475,     0,     0,   423,   423,   423,   452,   423,   473,
     423,     0,     0,   423,   423,   423,   423,   339,   334,   423,
     376,   383,     0,     0,   392,   423,    44,   642,   641,   643,
     645,     6,    42,     8,    61,   110,   165,    97,    99,   314,
     313,   315,   423,   107,   106,   324,   317,     0,   327,     0,
     172,   159,     0,   154,     0,   149,   135,   514,   514,     0,
     513,   507,     0,     0,     0,    18,     0,   625,     0,   618,
     617,     0,     0,   549,     0,   607,   611,   612,   613,     0,
     601,     0,   591,    22,     0,   547,   548,   564,     0,   572,
       0,     0,   595,     0,   578,   577,   590,   589,   584,     0,
       0,   604,   587,   579,   580,   581,   609,   623,   586,   585,
     624,   588,   615,     0,   614,     0,   315,     0,     0,     0,
     638,   629,   632,     0,   653,   753,    18,     0,    18,   671,
       0,     0,   673,   663,    18,   659,     0,   677,   754,   783,
     799,     0,   790,   792,     0,     0,   798,   787,     0,   876,
      18,     0,   875,   868,     0,   917,   918,   926,    21,    18,
       0,   925,     0,   479,     0,   480,   481,     0,   423,   477,
     478,   476,   423,   423,    18,   940,     0,     0,   423,   935,
     938,   948,   947,   943,     0,     0,    90,   179,   190,   765,
     764,   778,   773,   775,   776,     0,   766,     0,   768,   912,
     913,   967,   968,   969,     0,     0,   401,   487,     0,   467,
       0,     0,     0,     0,     0,   423,   419,   423,     0,     0,
     346,     0,     0,     0,     0,     0,     0,     0,   316,     0,
     423,   330,     0,   323,     0,   155,   156,   160,   162,   147,
     145,   146,   148,   154,   508,   532,   509,   536,   510,   512,
       0,   596,     0,     0,     0,   619,   598,     0,     0,   553,
       0,     0,     0,     0,     0,   551,   599,   600,   602,   567,
     565,   594,   593,   573,   592,   569,   616,   630,   631,   633,
     634,     0,   637,   154,   676,   664,     0,     0,    18,     0,
     662,     0,     0,   680,   675,   679,     0,     0,   669,   661,
       0,   687,   154,   788,   831,   840,   789,     0,     0,   794,
      18,   797,   154,   872,   869,   871,   874,   921,   923,   922,
     423,   423,   423,   423,     0,     0,     0,     0,     0,     0,
     499,   482,   484,     0,   154,   944,   946,    84,   767,   769,
     261,   261,     0,   472,   470,   471,   469,   423,     0,     0,
     355,     0,   423,   353,   423,   349,     0,   423,   347,   423,
     423,     0,   461,   325,   331,   318,     0,   157,   163,   532,
     530,   515,     0,     0,   539,     0,   621,   620,   622,     0,
       0,   557,   555,   556,   559,   558,   560,   550,     0,    18,
     756,   760,   666,   667,   665,   668,   741,   701,   681,   741,
     670,   755,   688,   828,   838,   837,   844,   843,   851,   791,
     853,   854,   861,   793,   795,   909,     0,     0,     0,     0,
       0,   493,   423,   393,   936,   423,   423,     0,   423,   498,
     964,     0,     0,   468,     0,   420,   421,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   390,     0,
     515,     0,   535,   537,   538,     0,   541,   597,   561,   554,
     552,   635,   754,   758,   762,     0,     0,     0,   690,   826,
     825,     0,   842,   849,   859,   907,   877,   870,   492,   424,
     496,     0,   423,   490,   332,     0,     0,     0,     0,     0,
       0,     0,     0,   485,   962,   949,   263,   264,   474,   370,
     354,   352,     0,   423,   350,   368,   348,     0,   423,   366,
     423,   364,   363,   423,   361,     0,   534,     0,    18,     0,
       0,     0,     0,     0,     0,   533,   523,   194,   198,     0,
     540,    18,   543,   757,     0,   672,   744,   742,   745,    18,
       0,    18,   678,     0,   674,     0,     0,     0,     0,     0,
       0,   686,   700,     0,     0,   830,     0,     0,    18,    18,
      18,   841,     0,   845,   855,     0,   911,     0,     0,   423,
     423,   341,   345,   343,   423,   500,   344,   380,   377,   378,
     379,   384,     0,   495,   494,   423,   423,   423,   423,   501,
     950,   966,     0,     0,     0,     0,     0,     0,     0,   116,
     199,   521,   195,     0,     0,     0,   516,   520,   524,     0,
     525,     0,   522,   200,   531,   542,     0,     0,     0,    18,
       0,     0,     0,     0,    18,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   761,
     740,     0,   746,     0,     0,   684,   685,   683,   682,   694,
     697,   698,   699,   692,   691,     0,     0,   695,   689,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
     816,   818,   829,     0,     0,     0,   832,   833,   834,   839,
       0,     0,   848,     0,     0,     0,   858,     0,     0,     0,
       0,     0,    18,     0,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   910,   902,     0,   497,
     333,   491,   395,   346,     0,   423,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   965,
       0,   369,   351,   367,   423,   365,   423,   362,     0,     0,
       0,     0,     0,   526,   527,     0,     0,     0,     0,     0,
       0,     0,     0,    18,   706,   748,   738,     0,     0,     0,
       0,     0,   733,   727,   728,   729,    18,   739,     0,   722,
     702,   705,   703,     0,   720,     0,   707,   709,   710,   711,
     712,   713,   714,   715,   716,    18,    18,   704,     0,    18,
     759,   747,   743,   693,   696,     0,     0,     0,     0,     0,
     815,     0,     0,     0,     0,     0,   803,    18,     0,     0,
       0,    18,     0,    18,     0,   827,   865,   865,     0,   863,
     847,   846,   852,   850,   857,   856,   862,   860,   883,    18,
      18,     0,   878,   881,   882,   900,     0,     0,     0,   895,
     903,   906,   905,   904,   901,    18,     0,   880,   879,     0,
       0,    18,   884,    18,    18,   908,   342,   423,   381,   394,
     385,     0,     0,     0,     0,   951,    18,     0,     0,     0,
     959,     0,   955,   956,     0,   952,   963,     0,     0,   193,
     195,   517,   518,   519,   528,   529,     0,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   197,   723,     0,
     731,   730,   732,   166,   167,   734,   735,     0,   736,    18,
     719,   708,   718,   721,   724,   717,     0,   822,   823,   824,
     812,     0,   865,     0,   802,     0,   811,   865,   805,   804,
     806,   807,     0,   820,   817,   821,   819,    18,   835,   836,
     864,   899,   888,   890,   893,   896,   894,     0,   897,   892,
     889,   891,   885,   886,   887,     0,   505,   503,   504,   502,
     961,   957,   960,   958,   953,   954,   356,   423,   196,   200,
     200,   200,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   200,     0,     0,     0,     0,   726,   750,   749,
     737,   725,   801,   814,   810,   813,   800,   809,   808,   866,
     898,     0,   207,   205,   206,   208,   200,   200,   200,   200,
     751,     0,   423,   201,   202,   203,   204,   752,     0,   371
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    94,   580,   589,   581,   415,   979,  1046,
    1047,   816,  1978,   218,  1064,   377,    95,   568,   219,   571,
     560,   561,    96,   227,   228,    97,    98,    21,    22,    23,
      24,    25,    26,   145,   375,    99,  1276,   358,   100,   364,
     359,   101,   600,   102,   603,   931,   103,   593,   104,   105,
     611,   106,   107,   243,   273,   627,  1145,   945,   616,   108,
     940,  1327,  1142,   941,  1458,  1459,   903,   904,  1852,   109,
     110,   620,   274,   369,   748,   749,   385,   761,   762,  1616,
    1828,  1617,  1618,  1842,  1982,    27,    28,    29,    30,   406,
      31,    32,    33,   397,   789,    34,   394,   774,    35,   398,
     387,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,   210,   563,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   139,   391,   111,   601,   112,
     921,   922,   923,  1137,   947,   948,   628,   934,   925,   113,
     606,  1319,  1320,  1573,   199,   461,  1667,   848,   462,   849,
     463,   464,   465,  1671,   466,  1672,   200,   468,   469,  1575,
     431,   201,   432,   441,   202,   203,   204,  1267,   205,   533,
    1310,  1268,  1422,  1423,   828,   829,  1321,   114,  1152,   953,
     115,  1333,  1542,  1619,  1702,  1541,  1461,  1334,  1336,  1464,
    1546,  1622,  1338,    58,   116,   660,  1164,  1354,  1355,   117,
     118,  1213,  1017,   119,    59,   565,   120,   121,   330,   331,
     332,  1022,  1226,  1381,  1386,  1384,  1385,  1556,  1633,  1227,
    1558,  1643,  1228,  1731,  1555,  1627,  1628,  1734,  1989,  2101,
    2079,  1373,  1391,  1481,  1552,  1624,  1554,  1374,    60,    61,
      62,    63,    64,    65,    66,    67,   802,   122,   123,   124,
    1238,  1397,  1398,  1026,   125,  1392,  1763,  1902,  1904,  2010,
    1645,  1644,  1560,  1393,  1395,  1652,  1562,  1561,  1495,  1396,
    1498,  1563,  1773,  1912,  1653,  1499,  1502,  1564,  1777,  1916,
    1654,  1503,  1910,  2028,   126,  1244,  1027,   127,  1402,  1656,
    1798,  1934,  1655,  1566,  1403,    68,    69,   128,   129,   346,
    1034,  1035,   347,  1270,  1036,   725,    70,   130,  1274,  1038,
     131,  1424,  1681,  1820,  1680,  1585,  1425,    71,    72,    73,
     132,    74,   133,   134,   135,   534
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1595
static const yytype_int16 yypact[] =
{
      78,  3503,   174,   908,   738,  1037,   188,   738,   738,   594,
     738,   301,    87,  1435,   156,   241,  1001,  2081,   128,   738,
     144, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595,   395,   557,   317,
     832,   489,   357,   452,   387, -1595, -1595,   532,   473,   419,
     612,  2081,   581, -1595, -1595, -1595, -1595, -1595, -1595,   243,
     243, -1595, -1595, -1595, -1595,   171, -1595,  2663, -1595,   243,
    3419, -1595, -1595, -1595,   243, -1595,   243,  3198,   243, -1595,
     243,  2783,   243,  3435,   243, -1595,   243, -1595,   243,  3176,
     243, -1595, -1595, -1595,  1933,  3452, -1595, -1595, -1595,   208,
   -1595,   647,   683,   720,   647,   629, -1595,   723,   723,   738,
     738,   757,   266, -1595,   698,   805,   247, -1595,   837,   842,
   -1595, -1595,   510,   194,   151,   836,   -68,   330,   330,   873,
     903,   914,   940,   952,  1002,  1016,  1038,    41, -1595, -1595,
   -1595,   870,   598, -1595,   808,   106,    44,  2081, -1595,   605,
     616,   628, -1595, -1595,   637,   640,   644,  1343,   120, -1595,
   -1595, -1595, -1595, -1595,  2514, -1595,  2865, -1595, -1595,  1287,
    1092,   723, -1595,  1090, -1595, -1595,  1056, -1595, -1595,    10,
     191,   208,   362, -1595, -1595, -1595, -1595,   352,   672,   362,
     362,   972,   985,    98, -1595,  1154, -1595,   266,   739,  3703,
   -1595,  1084,  1218,   786,   787, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   789,   208,
     924,  1234,  1138,   362,   441, -1595,   783,   667,   443,  1187,
     443,   266, -1595,   798,   800,   797,   806,   -35,   934,   945,
    1182,   813,  1253,   993,   443,   441,  1210,  1195,   168,  1114,
     278,    84,   330,    67,  1208,   370,  1209,  1012,  1009,   424,
    1200,  1007,   591,   995,   992,   441,   990,   991,   994,   839,
     -47,  1213,   984,   987,   441,   332,   441, -1595,   847,   846,
     848,   927,   160,   441,  1198,   362,   441,  1199, -1595, -1595,
     859,   852, -1595,   867,  1233,   577, -1595,   872,   880,   882,
     883,  1003,   330,  1262, -1595,   896,  1400,   894,   901,  1279,
     441,  1292,   441,  1293,  1295,  1297,   362, -1595,   926,   938,
     941,  1307,   723, -1595,   951,   954, -1595, -1595,   910,  1383,
     629, -1595, -1595,  1396,   362,  1408, -1595,  1411,  1412,  1418,
    1419, -1595, -1595, -1595,    82,  1420,  1413,  1430, -1595, -1595,
    1024,  1431, -1595,  1432,   550, -1595, -1595,  3187,   777,   836,
   -1595,   836,   836, -1595,   571,   627,  1434,   836,   836,  1436,
     836,   836,   836, -1595, -1595,    33,  1264,  1266, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595,    24, -1595,    41,  2081,
      41,    41,  1437, -1595,  1439,  1425,  1422,   179,  1428,    44,
      44,  1429,  1427,  2081,  2081,  2081,  2081,  2081,  1443, -1595,
   -1595,  1449, -1595,  1000,    96, -1595, -1595, -1595, -1595,  1122,
   -1595,  1451, -1595, -1595, -1595, -1595,   276,    37, -1595,   447,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595,  2081,  2081,  2081,  2081,
    2081,  2081,  2081,  2081,  2081,  2081,  2081,  2081,  2081,  2081,
     718, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
     586, -1595, -1595,  1463,  1464,   845,  2081,   443, -1595, -1595,
    1287,  1011, -1595, -1595, -1595, -1595, -1595, -1595,   362,  2081,
   -1595, -1595, -1595, -1595,   362,  1030,  1034, -1595,   758, -1595,
   -1595,   362, -1595, -1595, -1595, -1595, -1595, -1595, -1595,  2081,
    1013,  3572, -1595,   398,  1020, -1595,  1008,  1461, -1595, -1595,
   -1595,   -84, -1595, -1595,   441, -1595, -1595,   160, -1595, -1595,
   -1595, -1595,   350,  1610, -1595,  1344,  2081, -1595, -1595,   350,
   -1595, -1595,   350, -1595, -1595, -1595, -1595, -1595, -1595,  1406,
    1421,     4,   441,    95, -1595,  1025,    46,  1041,  1043,   362,
     157,  1181,   441,  1329,   330,  1046,  1057, -1595,  1059,  1488,
     126,   362,  1331,   362,  1444,  1452,   362,  1453,   308,   362,
     362,   441,  1456,  1068,  1433,  1076,   441,  1087,   441,   268,
     441,  1234,   441,  1093,  1095,   441,   441,   441,  1098,  1365,
     441,  1100, -1595, -1595, -1595,   441, -1595, -1595,   441, -1595,
    1491,   362, -1595, -1595, -1595,  1542,  1104,  1105, -1595, -1595,
   -1595, -1595,   441, -1595,  1234, -1595, -1595,  1049, -1595,   330,
   -1595,  1290, -1595, -1595, -1595,  1107, -1595,   362, -1595,   362,
   -1595,   441,   441,   441, -1595, -1595, -1595, -1595,   362,   330,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   645, -1595,
   -1595,  1564, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595,   658, -1595, -1595, -1595, -1595,  1565, -1595, -1595, -1595,
    1550, -1595, -1595,  1561,   330, -1595, -1595,  1558,  1562, -1595,
    1610, -1595, -1595, -1595, -1595,   330, -1595, -1595, -1595,  1566,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,  1580,
    1568,  1568,   381,   836,  1568,   836,  1568, -1595,  1568,  1568,
   -1595,  1568,  1568,  1568,   362,   330, -1595,  1571,  1579,  1581,
   -1595, -1595,  1152, -1595, -1595, -1595, -1595,   192, -1595,  1139,
   -1595,  1345,  1573, -1595, -1595, -1595, -1595,   297,   665,   691,
    1180,   779,   285, -1595,  2081, -1595,  2081,  1134,    15,  1140,
    1206,   135,   270, -1595, -1595, -1595,  1593,  1592, -1595,  2167,
    2167,  2167,  2291,  2291,  2167,  2167,  2167,  2167,  2167,   650,
     650,  1427,  1427, -1595,  1151, -1595, -1595, -1595, -1595, -1595,
    1287, -1595, -1595, -1595,  1128,  1610,   443, -1595,  2622, -1595,
     693, -1595, -1595,  1379,  1594, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595,  1158, -1595,  1159,  1484, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595,   227,  1160,  1157, -1595, -1595,   362, -1595, -1595,   330,
   -1595, -1595, -1595,  2874,  3572, -1595,   330, -1595,  1167, -1595,
    1599, -1595,  1163, -1595,  1498, -1595, -1595, -1595, -1595,   441,
    3703, -1595, -1595,  3271,   362,   362,  1551,  1555,  1174,   362,
    1175,  1179, -1595,   441,    52, -1595, -1595,  1183,  1184,  1186,
    1191,   441,  1196,   441,  1197, -1595, -1595, -1595,  1627, -1595,
     362,   362, -1595,  1203,   362,  1207,   362,   362,  1211,   362,
    1212,  1214,  1215,  1217,  1219,   362, -1595,   160, -1595,  1220,
   -1595,  1221,  1222,  1225,  1230,  1235,  1236,  1238, -1595, -1595,
    1239,  1241,  1242, -1595,   326,  1244, -1595,  2799, -1595, -1595,
     362, -1595,   737,  1248, -1595, -1595,  3024,  3285,  1249,  1254,
   -1595,  1488, -1595,   330,    -8,  1290,   244, -1595,  3499, -1595,
   -1595, -1595, -1595,  1585, -1595,    33, -1595, -1595, -1595,   910,
   -1595, -1595,    82, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595,  1654,  1662, -1595, -1595,   160, -1595,
   -1595,   160,  1653, -1595,   160,  1568,  1690,  1568,  1721,  1722,
    1723,  1724,  1725,  1727, -1595, -1595,  1553,  1554,    41, -1595,
    2081, -1595,  1706,  1707,  2081,  2081,  2081, -1595,  2081, -1595,
    2081,   809,   133,  1458,  2081,  1744,  2081, -1595, -1595,  2081,
   -1595, -1595,  1274,   870, -1595,  2081, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595,  1163, -1595, -1595, -1595,
   -1595,  3572,   807, -1595, -1595, -1595,  1281,  1280, -1595,  1560,
   -1595, -1595,  1096, -1595,   841, -1595, -1595, -1595, -1595,   330,
   -1595, -1595,  1284,  1282,  1285,   150,   362, -1595,  1286, -1595,
   -1595,  1294,   933, -1595,  1296, -1595, -1595, -1595, -1595,  1299,
   -1595,  1311, -1595, -1595,   203, -1595, -1595, -1595,  1316, -1595,
    1318,  1319, -1595,  1320, -1595, -1595, -1595, -1595, -1595,  1323,
    1325, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595,  1326, -1595,  1146,  1610,   443,   362,  1556,
   -1595, -1595, -1595,  1327, -1595, -1595,   441,   273,   386, -1595,
    1465,   330, -1595, -1595,   316, -1595,  1328, -1595,  1359, -1595,
   -1595,   330, -1595, -1595,   330,  1673, -1595, -1595,  1330, -1595,
     441,   362, -1595, -1595,  1332, -1595, -1595, -1595,  1488,   441,
     362,    -8,    14, -1595,  1734, -1595, -1595,  1333,  2081, -1595,
   -1595, -1595,  2081,  2081,   441, -1595,  2514,  1335,  1878, -1595,
   -1595, -1595, -1595, -1595,  1336,   362, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  1787, -1595,  1795, -1595, -1595,
   -1595, -1595, -1595, -1595,  1785,  1786, -1595, -1595,  1774, -1595,
    1514,  2128,  2204,  2265,   856,  2081, -1595,  2081,   409,    22,
    3703,  1339,   497,     3,  1340,  1206,  1792,  2331, -1595,  1347,
      29, -1595,  3572, -1595,  1793,   330, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  1351, -1595,    70, -1595, -1595,
     362, -1595,  1356,  1374,  1375, -1595, -1595,  1495,  1767, -1595,
     185,  1501,  1506,   831,   707, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595,  1563, -1595, -1595, -1595, -1595,   362,   362,   441,   362,
   -1595,  1384,   160, -1595, -1595,  1385,  1390,   362, -1595, -1595,
     362,  1392, -1595, -1595, -1595,  1393, -1595,    23,    71, -1595,
     441, -1595, -1595, -1595,  1773, -1595, -1595, -1595, -1595, -1595,
    2081,  1425,  2081, -1595,  2648,  2970,   973,  1401,  1837,   436,
   -1595,  3703,  1397,  1402, -1595, -1595, -1595, -1595, -1595, -1595,
     698,   698,  1835, -1595, -1595, -1595, -1595,  2081,  2357,  2383,
   -1595,  1839,  2081, -1595,  1936, -1595,  1842,  2081,  1859,  2015,
    2058,  1409, -1595, -1595, -1595, -1595,  1688, -1595,  1163,  1351,
   -1595, -1595,  1855,   443,  1613,  1440, -1595, -1595, -1595,  1687,
    1557, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   933,   441,
    1163,  1426, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595,  1438, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  1441,   362,  2674,  1423,  2705,
    2927, -1595,  1224, -1595, -1595,  2081,  2081,   782,  1878, -1595,
    1446,  1887,  1897, -1595,  2409, -1595, -1595,  1442,  1450,   526,
      26,  1454,   599,  1447,  1455,    27,  1459,    47, -1595,  1866,
   -1595,   703, -1595, -1595, -1595,   330,  1640, -1595, -1595, -1595,
   -1595, -1595,  1359, -1595, -1595,    39,   476,    50,   776, -1595,
   -1595,   602, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595,  1460,   807,  1689, -1595,    34,  2749,  2786,  1457,  1462,
    1467,  1468,  1473, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595,  1883,  2081, -1595, -1595, -1595,  1884,  2081, -1595,
    2081,  1912, -1595,  2081, -1595,  1477, -1595,   443,   441,  1474,
     925,  1664,   362,   362,   338, -1595, -1595, -1595,  1475,  1482,
   -1595,   441, -1595, -1595,  3386, -1595, -1595, -1595,   283,   441,
     362,   441, -1595,  1483, -1595,   362,   269,   362,   362,  1661,
     246, -1595, -1595,  1485,  2654, -1595,  1528,  1529,   441,   441,
     441, -1595,  1489,   184,   186,  2791, -1595,  1502,  1486,  1224,
      77, -1595, -1595, -1595,  1122, -1595, -1595,  1950, -1595, -1595,
   -1595, -1595,   286, -1595, -1595,  2081,  2081,  2081,  2081, -1595,
     595, -1595,  1499,  1508,  1509,  1511,  1512,  1507,  1513, -1595,
   -1595, -1595,  1840,  1717,  1729,  1730, -1595, -1595, -1595,  1050,
   -1595,  1834, -1595,  1137, -1595, -1595,  1659,   362,  1520,   441,
    1607,   274,   293,  1669,   441,  1596,   441,   362,   362,   362,
    1711,   362,   389,  1354,  1600,  1631,   362,  1611,  1637, -1595,
   -1595,  1541, -1595,   362,  1546, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,   362,   362, -1595, -1595,  1604,
     -11,    43,  -206,   -39,  1591,   441,  1606,  1939,  1603,  1735,
    1756,  1757, -1595,  1570,   362,   362, -1595, -1595, -1595, -1595,
     314,   330, -1595,  1577,   314,  2003, -1595,  1578,   362,   -52,
    1949,   362,   441,   330,   441,  1660,   464,   264,  1728,  1655,
     -71,  1964,  1972,   351,  1609,  1608, -1595, -1595,  1601, -1595,
   -1595, -1595, -1595,  2435,   224,    77,   322,  2461,  2487,  2527,
    2553,   362,  1732,  1674,   502,  1799,   731,  1803,   362, -1595,
    1620, -1595, -1595, -1595,  2081, -1595,  2081, -1595,  1602,  1621,
     362,   362,   362, -1595, -1595,  1062,   362,  2045,  2045,  1072,
     851,   897,  1617,   441, -1595, -1595, -1595,   193,   362,   362,
     362,   362, -1595, -1595, -1595, -1595,   533, -1595,  1670, -1595,
   -1595, -1595, -1595,   362, -1595,   362, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,   441,   441, -1595,   362,   441,
   -1595, -1595, -1595, -1595, -1595,  1810,   699,  1996,   362,  2007,
   -1595,   362,  1824,   699,   362,   362, -1595,   441,   362,   362,
    2020,   441,    23,   441,    71, -1595,  1665,  1665,   362, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   441,
     441,   362, -1595, -1595, -1595, -1595,   362,   362,   362, -1595,
   -1595, -1595, -1595, -1595, -1595,   588,   362, -1595, -1595,   362,
     362,   441, -1595,   441,   441, -1595, -1595,  2081, -1595, -1595,
   -1595,  1632,  1634,  1636,  1644, -1595,   441,   362,   362,   362,
   -1595,   362, -1595, -1595,   362, -1595, -1595,  1643,  1647, -1595,
    1840, -1595, -1595, -1595, -1595, -1595,  1656, -1595,  1657,  1658,
     784,   796,  1672,  2045,  2045,  2045,  2045, -1595, -1595,    54,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595,  1737, -1595,   441,
   -1595, -1595, -1595, -1595, -1595, -1595,   362, -1595, -1595, -1595,
   -1595,   362,  1665,   362, -1595,   362, -1595,  1665, -1595, -1595,
   -1595, -1595,   362, -1595, -1595, -1595, -1595,   441, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595,  1741, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  2435, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595,  2081, -1595,  1137,
    1137,  1137, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595,  1137,  1675,  1683,  1684,  1685, -1595,  1747, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595,  1663, -1595, -1595, -1595, -1595,  1137,  1137,  1137,  1137,
   -1595,  1686,  2081, -1595, -1595, -1595, -1595, -1595,  1668, -1595
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1595, -1595, -1595, -1595,   -82,  -228,    83,  -280,  -807,  -159,
    -771, -1595, -1093,   -86,   516,   385, -1595, -1595, -1595, -1595,
    1576,  1240, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595,   863,  1751, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595,  -319, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595,  3303,   -97,  1856, -1595,   396,  -491, -1595,
   -1595, -1595, -1595,   981,  -609,  -803, -1595, -1595, -1248, -1595,
   -1595, -1595, -1595,   198, -1595,  1083,   124, -1595,  1081, -1230,
     177, -1594, -1595,  -680, -1595, -1595, -1595, -1595, -1595,  -135,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
    -209, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  1077,  1758, -1595, -1595, -1595,
   -1595,  -867,  1018,   838,  1567,  -584,  -376, -1595,  1228, -1595,
   -1595, -1493, -1595,   500,  -197,  1314,   363, -1087, -1464,  1969,
   -1463, -1370,  1317,   364, -1595, -1595,  -191,  1315, -1595, -1595,
   -1595, -1595,  -403,   785, -1595, -1595, -1030, -1595,  -172,   905,
     -17, -1595, -1595,   655,  1089,   763, -1021, -1595, -1595, -1595,
   -1595,  1033,   642, -1595, -1595, -1595,   726, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  1223, -1595, -1595,   708, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595,   709, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595,   635, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   306,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   457,
     432, -1595, -1595, -1595, -1595,   307,   435, -1595, -1595, -1595,
   -1595,   313,   444, -1094, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
    1185, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1166
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -489
static const yytype_int16 yytable[] =
{
     206,   460,   590,   696,   238,   433,  1266,   467,   416,   417,
    1447,   942,   659,   662,  1060,  1269,  1309,  1311,  1313,  1314,
     318,   790,  1104,   820,   329,   821,   337,   823,   824,  1442,
     409,   819,   345,  1593,  1600,  -329,  1410,   360,   365,   426,
    1660,   413,   414,   427,  -329,  -329,  -329,  -329,  1252,  1661,
    1662,  1663,  1108,   428,  1603,   569,   426,   413,   414,   439,
     427,   413,   414,   814,   854,   855,  1136,   572,   413,   414,
     428,   573,   413,   414,   239,   683,  1891,   410,   936,  1658,
    1253,  1893,     1,  -328,   956,   413,   414,   574,   575,   576,
     577,  1500,  -328,  -328,  -328,  -328,  1252,   963,  1829,   572,
    1419,  1462,  1266,   573,   536,   537,   538,   539,   540,  1886,
     572,  1668,  1669,   594,   573,   595,   596,   597,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   411,  1253,   550,
     574,   575,   576,   577,   437,   455,   456,   457,   181,   458,
     583,   536,   537,   538,   539,   540,   639,   588,   588,  1254,
     455,   456,   457,  1108,   458,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   207,   572,   550,  1802,   980,   573,
     442,   959,   572,   208,    75,   594,   573,   595,   596,   597,
     454,   618,   631,   713,   633,   574,   575,   576,   577,   887,
    1006,   146,   574,   575,   576,   577,  1059,  1254,   647,  1892,
     536,   537,   538,   539,   540,  1670,   572,   831,   572,   658,
     573,   759,   573,   400,   541,   542,   543,   544,   545,   546,
     547,   548,   549,  1029,  1247,   550,   574,   575,   576,   577,
    1255,  1256,  1257,  1258,  1259,  1260,  1261,   598,   788,  1661,
    1662,  1663,  1108,   699,   366,   980,  1129,  1249,   640,   154,
     392,   661,  1262,   367,   433,  1263,   433,   760,   433,   433,
     578,   572,   241,  1252,   799,   573,   800,   801,   684,   804,
     806,  1919,   808,   809,   734,   811,   812,   813,  1255,  1256,
    1257,  1258,  1259,  1260,  1261,   455,   456,   457,  1108,   458,
    1266,  1937,   753,   572,  1126,  1253,   407,   573,   939,  1454,
    1262,  1119,   382,  1263,   153,   536,   537,   538,   539,   540,
     981,   383,  1949,   574,   575,   576,   577,   401,   167,   541,
     542,   543,   544,   545,   546,   547,   548,   549,  1642,   572,
     550,   572,   957,   573,  1463,   573,   212,  1661,  1662,  1663,
    1108,   572,  1668,  1669,  1571,   573,   408,   619,   413,   414,
     892,   574,   575,   576,   577,  1528,   651,  1530,   655,   438,
    1532,   604,  1535,  1537,  1254,   572,   572,  1938,   648,   573,
     573,  1326,   584,   656,   974,   964,  1829,   572,  1250,  1894,
     937,   573,   242,  1510,  1066,   220,   943,   981,   677,   402,
     412,  1930,  1920,  1118,  1730,   634,  1740,   688,  1887,   691,
    1067,   572,  1746,   168,   572,   573,   697,  1888,   573,   700,
     585,   586,   822,  1931,   213,   968,   969,   960,   827,   582,
    1853,   574,   575,   576,   577,  1797,   837,   838,   839,   840,
     841,  1471,   832,   728,   393,   730,  1670,  1031,   231,  1032,
     926,  1407,   850,  1130,   990,  1255,  1256,  1257,  1258,  1259,
    1260,  1261,  1889,  1848,  1849,  1136,   572,   613,  1516,  1045,
     573,   221,   214,   215,  1448,  1698,   652,  1262,  1449,  1517,
    1263,   232,  1342,   570,  1411,   222,   574,   575,   576,   577,
    1105,   889,  1266,  1443,   429,  1699,  1496,  1594,  1601,  -329,
     430,  1574,   653,  -329,  1664,   815,   588,  1068,  1665,  1264,
     856,   429,   894,  1625,   233,  1045,  1683,   430,  1604,   902,
     440,  1685,   579,  1686,  1634,  1162,  1688,  1472,  2077,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     870,   871,   872,   378,  1501,  1085,  1741,  -328,  1929,   229,
     944,  -328,  1266,   657,   579,  1865,  1002,   944,   572,   888,
     944,   234,   573,   769,  1457,   579,   230,   845,   599,   235,
    1854,   846,   893,   927,   928,   929,  1960,   967,   574,   575,
     576,   577,  1990,  1991,  1003,  1004,   214,   215,   403,   983,
     459,   985,   905,   236,   988,   982,   991,   992,   993,  1493,
     400,   209,   404,   405,  1306,  1109,   564,   689,  1307,  1505,
     240,   216,  1770,   572,  1774,  1700,  1701,   573,  1771,   950,
     579,  1775,   217,   136,   137,  1056,   803,   579,   690,  1021,
     599,  1520,  1368,   574,   575,   576,   577,  1376,  1377,  1266,
    1266,   214,   215,  1850,   245,  1932,   770,  1811,  1574,   138,
    1742,  1212,   664,  1848,  1849,  1039,   400,  1040,  1772,  1134,
    1776,   579,   665,   579,   460,   460,  1044,  1090,  1732,  1069,
    1378,  1812,  1359,  1629,  1855,  1733,   467,   140,  1075,  1851,
    1077,   368,   805,   536,   537,   538,   539,   540,  1190,   548,
     549,  1848,  1849,   550,  1947,  1296,   371,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   374,   938,   550,   536,
     537,   538,   539,   540,  1070,  1387,   579,   771,  1265,  1933,
     669,   670,   621,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   772,   372,   550,   958,   961,  1071,  1941,   384,
     459,  1908,  1084,   970,   773,   972,   629,  1967,   579,  1968,
    1379,   852,  1072,   376,   853,  1979,  1099,   739,  1805,  1281,
    1100,  1806,  1282,  1248,   994,  1284,   237,   136,   137,   999,
     381,  1001,  1094,  1005,  1480,  1007,   149,   150,  1010,  1011,
    1012,  1073,  1074,  1015,   579,  1266,   579,  1139,  1018,   399,
     791,  1019,  1664,   138,   386,  1202,   579,   536,   537,   538,
     539,   540,  1997,   623,   624,  1028,   792,   899,   900,   901,
    1120,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     579,   579,   550,  2029,  1041,  1042,  1043,   536,   537,   538,
     539,   540,   579,  1927,   388,   389,  1252,  1101,   621,  1102,
    1630,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     395,  1607,   550,  1608,  1133,   396,   579,  2037,   883,   579,
     390,  1631,   622,  1813,  1814,   400,  1151,   930,  1253,  1928,
    1215,  1958,  1045,   793,   536,   537,   538,   539,   540,  1337,
    1440,  1609,  1153,  1154,  1441,   223,   418,  1158,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   673,   674,   550,
    2073,  2074,  2075,  2076,   224,   794,   795,  1959,  1175,  1176,
     434,   579,  1178,   796,  1180,  1181,   419,  1183,  1578,   623,
     624,    76,   857,  1189,  1607,   858,   433,   420,  2084,   625,
    1211,   626,  1329,  2087,  1216,   681,   682,  1254,   873,  1237,
    1243,   884,  1203,  2062,  2063,  2064,  2065,  2066,  1214,   797,
    1632,  1273,    77,   421,  1609,  2067,  2068,  2069,  2070,  2071,
     225,    78,  1815,   874,    79,   422,  1816,  1635,  1445,  1610,
    1611,   875,  1446,  1612,  1613,    80,   876,   877,   878,  1614,
    2091,   885,  1579,  1580,  1330,  1331,  1332,   798,    81,   706,
     707,   536,   537,   538,   539,   540,   886,  1591,    82,   742,
    1983,  1592,  1984,   579,    83,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   370,   423,   550,   373,  1255,  1256,
    1257,  1258,  1259,  1260,  1261,  2108,  1217,  1646,  1647,   424,
     226,  1648,  1649,  1650,    84,   951,    85,    86,   952,  1581,
    1262,  1817,  1146,  1263,    87,  1582,  1985,   626,  1986,   743,
     744,   425,  1636,   388,   389,  1045,  1161,  1163,   579,  1818,
     879,   880,   745,   746,  1169,   747,  1171,   140,   435,  1819,
    1596,   436,  1383,  1487,  1597,   443,  1651,   413,   414,  1030,
      88,    89,  1394,   827,  1344,  1399,   444,  1300,  1301,  1302,
     169,  1303,    90,  1304,   147,   148,   151,   152,   445,  1218,
     895,   896,  1315,   141,   897,   898,   211,   446,  1317,   626,
     447,   142,   143,   144,   448,    91,  1347,   562,    92,  1048,
    1049,  1219,   566,  1220,   413,   414,  1325,  1497,  1221,   567,
    1222,  1369,  1051,  1052,  1223,  1224,  1370,  2007,  2008,  2009,
    1095,   587,  1637,  1638,  1639,   177,  1640,   178,   179,   180,
     181,   182,   183,   170,  1348,   171,   172,   615,  1117,   184,
     185,   847,   186,   591,   187,   592,  1096,  1122,   880,  1405,
     536,   537,   538,   539,   540,   615,  1367,  1615,  1409,  1475,
    1476,  1477,  1478,   602,   541,   542,   543,   544,   545,   546,
     547,   548,   549,  1693,  1694,   550,  1962,  1963,   536,   537,
     538,   539,   540,  1427,   173,   174,   175,   176,   605,  1833,
    1834,  1225,   541,   542,   543,   544,   545,   546,   547,   548,
     549,  1974,  1975,   550,   536,   537,   538,   539,   540,  1980,
    1981,  1521,  1522,   607,   834,   835,   379,   380,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   608,  1343,   550,
    1641,  1414,   188,  1252,  1098,  1415,  1416,   614,   189,   609,
     610,  1421,   612,   615,  1836,   617,   632,   635,  1465,   636,
     637,   641,  1349,   643,  1350,  1620,  1351,  1352,   642,   638,
    1353,  -328,   644,   645,  1305,  1253,  1837,   646,  1838,   649,
     650,   654,   667,  1839,   663,   666,   668,   671,  1438,   672,
    1439,   675,   676,   678,  1482,  1483,   679,  1485,  1840,  1375,
     685,  1380,   686,   687,   680,  1490,   692,  1388,  1491,   693,
     695,   694,   190,   191,   698,   703,   701,  1065,   702,   705,
    1076,  1437,  1078,  1404,  1079,  1080,   712,  1081,  1082,  1083,
     704,   708,  1408,   551,   552,   553,   554,   555,   556,   557,
     558,   559,  1841,   709,  1254,   710,   711,  1417,   714,   192,
     193,   449,   450,   451,   452,   715,   177,   724,   178,   179,
     180,   181,   182,   183,   726,   727,   194,    93,   729,   195,
     184,   185,   731,   186,   196,   187,   732,  1544,  1666,  2092,
    2093,  2094,   733,   738,  1696,   735,   750,   536,   537,   538,
     539,   540,  2095,  1507,   827,  1509,  1626,   736,  1626,   752,
     737,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     740,   754,   550,   741,   755,   756,  2103,  2104,  2105,  2106,
    1524,   757,   758,   763,  1567,  1255,  1256,  1257,  1258,  1259,
    1260,  1261,   764,   765,   767,   768,  1513,   807,   177,   810,
     178,   179,   180,   181,   182,   183,   817,  1262,   818,   830,
    1263,   825,   184,   185,   826,   186,   833,   187,   851,   836,
     550,  1484,   842,   188,   843,   844,   881,   882,   933,   189,
     891,   177,   906,   178,   179,   180,   181,   182,   183,   932,
     935,   949,   954,  1504,   962,   184,   185,  1308,   186,   971,
     187,  1497,   536,   537,   538,   539,   540,   955,  1576,  1577,
     965,  1421,   966,  1924,   973,   975,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   984,   976,   550,   977,   978,
     986,  1690,   536,   537,   538,   539,   540,   996,   987,   989,
     588,  1697,   995,   190,   191,   998,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   188,  1000,   550,  1736,  1014,
     997,   189,  1008,  1739,  1009,  1743,  1744,  1013,  1747,  1016,
    1020,  1023,  1551,  1024,  1025,  1033,  1037,  1050,  1053,  1054,
     192,   193,   449,   450,   451,   452,  1055,  1057,   188,   155,
     156,  1058,   197,  1062,   189,  1061,  1086,   194,  1063,   198,
     195,  1285,  1394,  1287,  1087,   196,  1088,   157,  1092,  1103,
    1091,  1093,  1971,  1972,  1973,  1106,   716,  1666,  1112,  1666,
    1113,  1115,   158,  1089,  1124,   190,   191,  1125,  1127,  1131,
    1132,   159,  1497,   160,   161,  1844,  1140,  1141,  1143,   946,
    1144,  1156,  1155,  1157,  1159,  1860,  1861,  1862,  1160,  1864,
    1866,  1097,  1165,  1166,  1877,  1167,  1173,  1803,   190,   191,
    1168,  1881,   192,   193,  1275,  1170,  1172,  1279,  1807,  1808,
    1809,  1810,  1177,  1883,  1884,  1280,  1179,  1107,  1283,   194,
    1182,  1184,   195,  1185,  1186,   717,  1187,   196,  1188,  1191,
    1192,  1193,  1906,  1907,  1194,   192,   193,  1572,  1909,  1195,
     162,  1691,  1909,  1286,  1196,  1197,  1918,  1198,  1199,  1922,
    1200,  1201,   194,  1204,  1705,   195,   718,  1229,  1245,  2078,
     196,  1942,  1735,  1246,  1737,   719,  1867,  1868,  1869,  1870,
    1871,  1872,  1873,  1874,  1288,  1289,  1290,  1291,  1292,  1955,
    1293,  1766,  1767,  1768,  1298,  1299,  1965,  1294,  1295,  1316,
    1322,  1323,  1324,  1339,  1341,  1345,  1371,  1340,   588,   588,
     588,  1390,  1400,  1346,  1976,  1356,  1412,   177,  1357,   178,
     179,   180,   181,   182,   183,  1992,  1993,  1994,  1995,  1996,
    1358,   184,   185,  1312,   186,  1360,   187,  1361,  1362,  1363,
     163,  2000,  1364,  2001,  1365,  1366,  1372,  1389,  1382,  1401,
    1428,  1406,  1846,  1413,  1420,  1426,  2004,  1857,  1429,  1859,
    1430,  1431,  1432,   197,  1444,  1450,  2012,  1451,  1456,  2014,
     198,  1453,  2017,  2018,  1460,  1466,  2020,  2021,   907,   908,
     909,   910,   911,   912,   913,   914,  2030,   915,   916,   917,
     918,   919,   920,  1467,  1468,  1469,  1470,  1473,  1896,  2033,
    1123,  1474,  1506,  1479,  2034,  2035,  2036,  1486,  1488,   720,
     721,   722,   723,  1489,  2039,  1492,  1494,  2040,  2041,  1515,
    1514,  1519,  1518,  1523,   188,  1923,  1533,  1925,  1527,   164,
     189,  1531,  1539,  1538,  1543,  2051,  2052,  2053,  1545,  2054,
    1548,  1605,  2055,   165,  1569,   197,  -488,  1549,   166,  1553,
    1586,   177,   198,   178,   179,   180,   181,   182,   183,  1547,
    1587,  1559,  1621,  1589,  1565,   184,   185,  1598,   186,  1584,
     187,  1590,  1682,  1684,  1659,  1595,  1599,  1675,   197,  1687,
    1602,  1657,  1676,  1695,  2082,   198,  1988,  1677,  1678,  2083,
    2045,  2085,  1679,  2086,   190,   191,  1689,  1692,  1703,  1998,
    2088,  1704,  1738,  1745,  1748,  1128,  1764,  1765,  1769,   177,
    1800,   178,   179,   180,   181,   182,   183,  1804,  2002,  2003,
    1821,  1799,  2005,   184,   185,  1529,   186,  1826,   187,  1822,
    1823,   192,   193,  1825,  1827,  1433,  1824,  1830,  1607,   259,
    2019,  1835,  1843,  1845,  2023,  1847,  2025,  1856,   194,  1831,
    1832,   195,  1858,  1863,  1875,  1876,   196,  1878,   188,  1879,
    1880,  1895,  2031,  2032,   189,  1882,   349,   350,   351,  1885,
     352,   353,  1900,   354,  1897,  1898,  1899,   355,  2038,   261,
     356,  1901,  1903,  1500,  2042,  1921,  2043,  2044,   177,  1905,
     178,   179,   180,   181,   182,   183,  1913,  1917,  1926,  2050,
    1939,  1936,   184,   185,  1534,   186,  1935,   187,  1940,   262,
    1943,  1944,  1957,   263,   264,  1956,   188,   266,   267,  1961,
    1945,   268,   189,  1964,   269,  1977,  1969,  1999,   190,   191,
    2006,   177,  2011,   178,   179,   180,   181,   182,   183,  1966,
    1970,  1987,  2081,  2013,  2015,   184,   185,  1536,   186,  2022,
     187,  2046,  2027,  2047,   177,  2048,   178,   179,   180,   181,
     182,   183,   270,  2049,  2056,   192,   193,   271,   184,   185,
    2089,   186,  2057,   187,  2080,  2059,  2060,  2061,  2090,  2100,
    1116,   751,   194,   630,  1328,   195,   190,   191,  2102,  2109,
     196,  2072,  1277,  1278,  2096,   188,   536,   537,   538,   539,
     540,   189,  2097,  2098,  2099,  2107,   890,  2058,   766,  1318,
     541,   542,   543,   544,   545,   546,   547,   548,   549,  1801,
    1455,   550,  1138,   192,   193,  1110,   453,  1948,   924,  1111,
    1950,  1418,  1114,  1583,  1508,  -489,  -489,  -489,   188,  1297,
     194,  1335,  1606,   195,   189,  1540,  1550,  1623,   196,  -489,
    -489,  -489,  -489,  -489,   546,   547,   548,   549,  1557,  2016,
     550,   188,  1174,  1911,   197,   190,   191,   189,  1890,  2024,
    1915,   198,   536,   537,   538,   539,   540,  2026,  1914,     0,
    1251,     0,     0,     0,     0,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,     0,   550,     0,     0,
       0,     0,   192,   193,     0,     0,     0,     0,   190,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   194,
       0,     0,   195,     0,     0,     0,     0,   196,     0,     0,
       0,   190,   191,   536,   537,   538,   539,   540,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   541,   542,   543,
     544,   545,   546,   547,   548,   549,     0,     0,   550,   536,
     537,   538,   194,     0,     0,   195,     0,     0,   192,   193,
     196,     0,     0,   541,   542,   543,   544,   545,   546,   547,
     548,   549,     0,     0,   550,   194,     0,     0,   195,     0,
       0,     0,     0,   196,     0,     0,     0,  -483,   197,   536,
     537,   538,   539,   540,     0,   198,     0,     0,     0,     0,
       0,     0,     0,   541,   542,   543,   544,   545,   546,   547,
     548,   549,     0,     0,   550,   536,   537,   538,   539,   540,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,     0,     0,
     550,   536,   537,   538,   539,   540,   197,   357,     0,     0,
       0,     0,     0,   198,     0,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,     0,   550,   536,   537,   538,
     539,   540,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,     0,   550,   536,   537,   538,   539,   540,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,     0,     0,   550,   536,
     537,   538,   539,   540,     0,   197,     0,     0,     0,     0,
       0,     0,   198,   541,   542,   543,   544,   545,   546,   547,
     548,   549,     0,     0,   550,   536,   537,   538,   539,   540,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   197,   470,
     550,     0,     0,     0,     0,   198,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   536,   537,   538,   539,   540,
       0,   197,     0,     0,     0,     0,     0,     0,   198,   541,
     542,   543,   544,   545,   546,   547,   548,   549,     0,     0,
     550,   536,   537,   538,   539,   540,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,     0,   550,     0,     0,  1434,
       0,     0,     0,     0,     0,     0,   471,   472,     0,     0,
       0,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     536,   537,   538,   539,   540,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   501,     0,   550,   536,   537,   538,   539,
     540,     0,     0,     0,     0,  1435,     0,     0,     0,     0,
     541,   542,   543,   544,   545,   546,   547,   548,   549,     0,
       0,   550,   536,   537,   538,   539,   540,     0,     0,     0,
       0,     0,   502,     0,     0,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,     0,   550,     0,     0,
       0,     0,     0,   536,   537,   538,   539,   540,     0,     0,
       0,     0,     0,     0,     0,     0,  1436,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   246,     0,   550,     0,
       0,   247,     0,     0,     0,     0,     0,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   536,   537,   538,
     539,   540,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,     0,   550,     0,     0,   248,     0,     0,     0,     0,
       0,     0,  1452,     0,   536,   537,   538,   539,   540,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   541,   542,
     543,   544,   545,   546,   547,   548,   549,     0,  1525,   550,
       0,     0,     0,     0,     0,   521,   522,   249,     0,   259,
       0,     0,     0,  1778,     0,     0,  1749,     0,     0,     0,
     523,     0,  1750,     0,  1526,   259,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1779,  1780,     0,
       0,   524,   525,   526,   527,  1751,     0,   321,   535,   261,
    1588,     0,     0,   536,   537,   538,   539,   540,  1781,     0,
       0,     0,     0,     0,     0,  1205,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,  1946,     0,   550,   262,
       0,     0,     0,   263,   264,     0,     0,   266,   267,     0,
    1752,   268,     0,     0,   269,   262,     0,     0,   250,   263,
     264,     0,  1951,   266,   267,  1206,     0,   268,     0,  1607,
     269,  1782,   470,  1753,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   528,   529,  1952,     0,
       0,     0,   270,     0,     0,     0,     0,   271,  1783,  1609,
     530,   531,     0,     0,     0,     0,     0,     0,   270,     0,
       0,   532,     0,   271,     0,     0,     0,  1754,   536,   537,
     538,   539,   540,     0,     0,     0,     0,     0,  1953,     0,
       0,     0,   541,   542,   543,   544,   545,   546,   547,   548,
     549,     0,     0,   550,   251,     0,     0,     0,   252,   471,
     472,     0,     0,     0,  1954,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,     0,     0,     0,  1784,     0,     0,  1785,
    1786,     0,     0,   626,     0,     0,     0,  1787,     0,     0,
    1755,  1756,     0,   253,     0,  1757,  1758,   254,  1759,     0,
     259,     0,     0,     0,     0,     0,  1760,  1761,     0,     0,
       0,  1121,   907,   908,   909,   910,   911,   912,   913,   914,
       0,   915,   916,   917,   918,   919,   920,   255,     0,     0,
       0,     0,     0,     0,     0,   502,     0,  1511,  1788,     0,
     261,   256,     0,     0,     0,     0,   257,     0,  1762,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   322,
       0,     0,     0,  1568,   323,   324,   325,     0,     0,     0,
     262,  1207,  1208,  1209,   263,   264,     0,  1230,   266,   267,
       0,     0,   268,     0,     0,   269,     0,     0,     0,     0,
       0,     0,     0,     0,  1570,     0,     0,     0,   326,     0,
       0,     0,     0,     0,     0,   327,  1789,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     775,     0,  1790,   270,  1512,     0,     0,     0,   271,     0,
       0,     0,     0,     0,     0,   413,   414,     0,  1673,     0,
       0,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   259,     0,     0,     0,     0,  1791,  1792,     0,
    1793,  1794,   776,  1795,     0,  1231,     0,     0,   521,   522,
       0,     0,   341,     0,   259,  1674,     0,   328,     0,   277,
       0,     0,     0,   523,     0,  1796,     0,     0,     0,   278,
       0,     0,   261,  1210,   279,     0,     0,     0,     0,     0,
       0,     0,     0,   777,   524,   525,   526,   527,   280,     0,
       0,     0,     0,     0,   261,     0,     0,     0,     0,     0,
       0,     0,   262,     0,     0,     0,   263,   264,     0,     0,
     266,   267,     0,     0,   268,   778,     0,   269,     0,     0,
       0,     0,   779,   780,   262,     0,     0,   259,   263,   264,
     281,   282,   266,   267,   781,     0,   268,     0,     0,   269,
       0,   259,     0,   283,     0,  1135,   284,     0,   285,     0,
       0,   782,   783,   784,   785,   270,   786,   787,     0,     0,
     271,     0,     0,     0,     0,     0,     0,   261,     0,   528,
     529,     0,     0,     0,   342,     0,     0,   270,     0,     0,
       0,   261,   271,   530,   531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   532,     0,   286,   262,   287,     0,
       0,   263,   264,     0,  1147,   266,   267,   288,     0,   268,
       0,   262,   269,   244,     0,   263,   264,     0,  1239,   266,
     267,     0,   258,   268,     0,     0,   269,   275,     0,   276,
       0,   319,     0,   320,     0,   333,     0,   338,     0,   339,
       0,   340,     0,   348,     0,   289,     0,     0,     0,     0,
     270,   626,     0,     0,     0,   271,  1232,  1233,     0,     0,
    1234,     0,  1706,   290,   270,  1235,     0,     0,     0,   271,
     291,   292,     0,   293,     0,   259,     0,     0,   294,   295,
       0,   296,   297,     0,   298,     0,     0,   299,   300,   301,
       0,   259,     0,     0,     0,   260,     0,     0,  1236,   343,
       0,     0,   302,   303,     0,     0,     0,   304,   259,   305,
     306,     0,   307,     0,     0,   261,     0,   308,     0,     0,
       0,   309,   310,     0,   311,   312,     0,   313,   314,   315,
       0,   261,     0,   316,  1607,     0,     0,   361,     0,     0,
       0,     0,     0,  1148,  1149,   262,     0,     0,   261,   263,
     264,     0,   265,   266,   267,   259,     0,   268,     0,     4,
     269,   262,     0,     0,  1609,   263,   264,     0,     0,   266,
     267,     0,     0,   268,     0,     0,   269,  1707,   262,     0,
       0,     0,   263,   264,     5,     6,   266,   267,     0,     0,
     268,  1708,     0,   269,     7,   261,     0,     0,   270,     0,
       0,     0,     0,   271,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   270,     0,   362,     0,     0,   271,
       0,     0,     0,     0,     0,   262,     0,     0,     0,   263,
     264,   270,  1271,   266,   267,     0,   271,   268,     0,     0,
     269,     0,     0,     0,     0,     0,     0,     0,     8,     0,
     344,  1709,     0,     0,  1710,  1711,     0,     0,     0,     0,
       0,     0,  1712,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   317,     0,     0,     0,     0,     0,   270,     0,
    1240,     0,     0,   271,     9,     0,     0,    10,     0,    11,
       0,     0,     0,     0,     0,     0,    12,     0,    13,     0,
       0,     0,     0,    14,    15,    16,     0,     0,     0,     0,
      17,    18,    19,  1713,     0,     0,  1714,     0,     0,  1715,
       0,   536,   537,   538,   539,   540,     0,     0,     0,     0,
    1241,     0,     0,     0,     0,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,  1150,   550,     0,  1716,     0,
    1717,     0,  1718,  1719,  1720,  1721,  1722,  1723,     0,  1242,
       0,     0,     0,  1724,     0,     0,  1725,     0,     0,  1726,
       0,     0,     0,     0,     0,     0,     0,     0,   334,     0,
       0,  1727,     0,     0,     0,     0,     0,     0,     0,  1728,
     907,   908,   909,   910,   911,   912,   913,   914,     0,   915,
     916,   917,   918,   919,   920,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,     0,     0,     0,    20,     0,     0,     0,     0,     0,
    1729,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   272,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   336,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   363,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1272
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1595)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-489)))

static const yytype_int16 yycheck[] =
{
      17,   198,   230,   322,    90,   177,  1036,   198,   167,   168,
       7,   620,   292,   293,   785,  1036,  1103,  1104,  1105,  1106,
     117,   397,     7,   426,   121,   428,   123,   430,   431,     7,
     165,     7,   129,     7,     7,     6,    22,   134,   135,    15,
       6,    18,    19,    19,    15,    16,    17,    18,    19,    15,
      16,    17,    18,    29,     7,    45,    15,    18,    19,    15,
      19,    18,    19,    30,    27,    28,   933,    15,    18,    19,
      29,    19,    18,    19,    91,   122,   282,   145,   162,  1572,
      51,   120,     4,     6,    80,    18,    19,    35,    36,    37,
      38,    20,    15,    16,    17,    18,    19,    51,  1692,    15,
    1266,    31,  1132,    19,     8,     9,    10,    11,    12,   120,
      15,  1575,  1575,    15,    19,    17,    18,    19,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   195,    51,    33,
      35,    36,    37,    38,    28,    15,    16,    17,    18,    19,
     222,     8,     9,    10,    11,    12,   181,   229,   230,   120,
      15,    16,    17,    18,    19,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    36,    15,    33,  1660,    42,    19,
     187,    76,    15,    45,     0,    15,    19,    17,    18,    19,
     197,   263,   268,   342,   270,    35,    36,    37,    38,   565,
     681,     3,    35,    36,    37,    38,   780,   120,   284,   405,
       8,     9,    10,    11,    12,  1575,    15,    28,    15,   291,
      19,   129,    19,    19,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   714,  1031,    33,    35,    36,    37,    38,
     201,   202,   203,   204,   205,   206,   207,   139,   397,    15,
      16,    17,    18,   325,    36,    42,    19,   255,   283,   162,
       3,   184,   223,    45,   426,   226,   428,   175,   430,   431,
      69,    15,    19,    19,   399,    19,   401,   402,   315,   404,
     405,   323,   407,   408,   356,   410,   411,   412,   201,   202,
     203,   204,   205,   206,   207,    15,    16,    17,    18,    19,
    1320,   362,   374,    15,   903,    51,   145,    19,   617,  1320,
     223,   885,    36,   226,     3,     8,     9,    10,    11,    12,
     184,    45,  1805,    35,    36,    37,    38,   123,   162,    22,
      23,    24,    25,    26,    27,    28,    29,    30,  1558,    15,
      33,    15,   328,    19,   264,    19,   192,    15,    16,    17,
      18,    15,  1806,  1806,  1510,    19,   195,   264,    18,    19,
     578,    35,    36,    37,    38,  1442,   188,  1444,    80,   253,
    1447,   237,  1449,  1450,   120,    15,    15,   438,   285,    19,
      19,  1142,    20,   290,   654,   329,  1970,    15,   386,   418,
     464,    19,   139,  1413,     3,    68,    36,   184,   305,   195,
     458,   127,   444,   884,  1624,   271,   127,   314,   409,   316,
      19,    15,   156,   162,    15,    19,   323,   418,    19,   326,
      58,    59,   429,   149,    19,   258,   259,   322,   435,   221,
     127,    35,    36,    37,    38,  1655,   443,   444,   445,   446,
     447,   246,   253,   350,   187,   352,  1806,   717,    81,   719,
      42,  1248,   459,   216,   136,   201,   202,   203,   204,   205,
     206,   207,   409,   179,   180,  1322,    15,   259,    22,   739,
      19,   144,    19,    20,   461,   127,   298,   223,   465,    33,
     226,    19,   322,   463,   460,   158,    35,    36,    37,    38,
     465,   567,  1512,   461,   460,   147,   463,   461,   461,   460,
     466,  1512,   324,   464,   460,   462,   578,   116,   464,   255,
     463,   460,   584,   464,   117,   785,  1593,   466,   461,   591,
     466,  1598,   460,  1600,   464,   463,  1603,   332,   464,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   148,   463,   815,   267,   460,  1786,    50,
     622,   464,  1572,   459,   460,   156,   278,   629,    15,   566,
     632,    19,    19,     3,  1325,   460,    67,   461,   460,    86,
     267,   465,   579,   165,   166,   167,  1814,   649,    35,    36,
      37,    38,   379,   380,   306,   307,    19,    20,   384,   661,
     460,   663,   599,   164,   666,   459,   278,   669,   670,  1392,
      19,   463,   398,   399,   461,   460,   211,   265,   465,  1402,
      19,    44,   418,    15,   418,   267,   268,    19,   424,   626,
     460,   425,    55,    19,    20,   774,    45,   460,   286,   701,
     460,  1424,  1206,    35,    36,    37,    38,   354,   355,  1659,
    1660,    19,    20,   359,   463,   371,    86,    42,  1659,    45,
     371,  1017,   272,   179,   180,   727,    19,   729,   464,   929,
     464,   460,   282,   460,   851,   852,   738,   465,   375,   278,
     387,    66,   459,   187,   371,   382,   857,    20,   803,   395,
     805,   463,    45,     8,     9,    10,    11,    12,   997,    29,
      30,   179,   180,    33,   460,  1088,     3,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    67,   614,    33,     8,
       9,    10,    11,    12,   323,   389,   460,   157,   464,   445,
     286,   287,    45,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   172,     3,    33,   642,   643,   346,   377,   463,
     460,   417,   814,   650,   184,   652,    69,  1824,   460,  1826,
     354,   465,   361,    20,   468,  1838,   461,   362,   462,  1068,
     465,   465,  1071,  1033,   671,  1074,   144,    19,    20,   676,
       3,   678,   465,   680,  1373,   682,   172,   173,   685,   686,
     687,   390,   391,   690,   460,  1805,   460,   936,   695,   269,
       3,   698,   460,    45,    86,   459,   460,     8,     9,    10,
      11,    12,   259,   126,   127,   712,    19,    39,    40,    41,
     886,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     460,   460,    33,  1907,   731,   732,   733,     8,     9,    10,
      11,    12,   460,   359,    19,    20,    19,   844,    45,   846,
     354,    22,    23,    24,    25,    26,    27,    28,    29,    30,
       3,   138,    33,   140,   926,     3,   460,   259,     3,   460,
      45,   375,    69,   258,   259,    19,   953,   459,    51,   395,
     123,   359,  1142,    86,     8,     9,    10,    11,    12,  1149,
     461,   168,   954,   955,   465,    43,     3,   959,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   296,   297,    33,
    1983,  1984,  1985,  1986,    62,   118,   119,   395,   980,   981,
      30,   460,   984,   126,   986,   987,     3,   989,   126,   126,
     127,     3,   465,   995,   138,   468,  1088,     3,  2012,   136,
    1017,   254,    81,  2017,   187,    86,    87,   120,   210,  1026,
    1027,    86,  1014,   149,   150,   151,   152,   153,  1020,   162,
     464,  1038,    34,     3,   168,   149,   150,   151,   152,   153,
     118,    43,   357,   235,    46,     3,   361,   181,   461,   256,
     257,   243,   465,   260,   261,    57,   248,   249,   250,   266,
    2057,   126,   190,   191,   133,   134,   135,   200,    70,   402,
     403,     8,     9,    10,    11,    12,   141,   461,    80,    79,
     139,   465,   141,   460,    86,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   141,     3,    33,   144,   201,   202,
     203,   204,   205,   206,   207,  2102,   279,   415,   416,     3,
     188,   419,   420,   421,   116,   629,   118,   119,   632,   247,
     223,   436,   949,   226,   126,   253,   139,   254,   141,   129,
     130,     3,   266,    19,    20,  1325,   963,   964,   460,   454,
     464,   465,   142,   143,   971,   145,   973,    20,   460,   464,
     461,   253,  1221,  1382,   465,   460,   464,    18,    19,    20,
     162,   163,  1231,  1090,  1156,  1234,   460,  1094,  1095,  1096,
      79,  1098,   174,  1100,     7,     8,     9,    10,   460,   352,
      60,    61,  1109,    56,    60,    61,    19,   460,  1115,   254,
     460,    64,    65,    66,   460,   197,   173,    15,   200,   464,
     465,   374,    22,   376,    18,    19,    20,  1397,   381,    63,
     383,  1207,   464,   465,   387,   388,  1208,   428,   429,   430,
     465,   459,   356,   357,   358,    13,   360,    15,    16,    17,
      18,    19,    20,   142,   211,   144,   145,    19,    20,    27,
      28,    29,    30,   181,    32,   170,   465,   464,   465,  1241,
       8,     9,    10,    11,    12,    19,    20,   464,  1250,   338,
     339,   464,   465,    19,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   258,   259,    33,   455,   456,     8,     9,
      10,    11,    12,  1275,   193,   194,   195,   196,   459,   149,
     150,   464,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   149,   150,    33,     8,     9,    10,    11,    12,   147,
     148,  1430,  1431,   139,   439,   440,   149,   150,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    19,  1155,    33,
     464,  1258,   120,    19,   465,  1262,  1263,   323,   126,   463,
     463,  1268,   463,    19,   117,   117,    69,   459,  1340,   459,
     463,   327,   329,    81,   331,  1545,   333,   334,   323,   463,
     337,   464,   459,    20,   465,    51,   139,   284,   141,    69,
      85,   167,   270,   146,    76,    76,   277,    87,  1305,   282,
    1307,   296,   300,   303,  1376,  1377,   305,  1379,   161,  1216,
      87,  1218,   318,   316,   310,  1387,   459,  1224,  1390,   463,
     383,   463,   190,   191,   116,   463,   117,   801,   459,    86,
     804,   465,   806,  1240,   808,   809,   323,   811,   812,   813,
     463,   459,  1249,    46,    47,    48,    49,    50,    51,    52,
      53,    54,   205,   463,   120,   463,   463,  1264,    86,   227,
     228,   229,   230,   231,   232,   459,    13,   463,    15,    16,
      17,    18,    19,    20,   463,    86,   244,   459,    76,   247,
      27,    28,    79,    30,   252,    32,    81,  1463,  1575,  2059,
    2060,  2061,    85,    76,  1612,   459,     3,     8,     9,    10,
      11,    12,  2072,  1410,  1411,  1412,  1555,   459,  1557,     3,
     459,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     459,     3,    33,   459,     3,     3,  2096,  2097,  2098,  2099,
    1437,     3,     3,     3,  1506,   201,   202,   203,   204,   205,
     206,   207,    19,     3,     3,     3,   463,     3,    13,     3,
      15,    16,    17,    18,    19,    20,   182,   223,   182,    27,
     226,    14,    27,    28,    15,    30,    28,    32,     7,    30,
      33,  1378,    19,   120,    15,   465,     3,     3,   460,   126,
     459,    13,   459,    15,    16,    17,    18,    19,    20,   459,
      19,   137,    76,  1400,   459,    27,    28,    29,    30,   308,
      32,  1771,     8,     9,    10,    11,    12,    76,  1515,  1516,
     459,  1518,   459,  1783,   175,   459,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   184,   459,    33,   459,    31,
      76,  1607,     8,     9,    10,    11,    12,   459,    76,    76,
    1612,  1613,    76,   190,   191,   459,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   120,   459,    33,  1630,   184,
     117,   126,   459,  1635,   459,  1637,  1638,   459,  1640,   459,
      69,    19,  1479,   459,   459,   275,   459,     3,     3,    19,
     227,   228,   229,   230,   231,   232,    15,    19,   120,   144,
     145,    19,   460,     3,   126,    19,    15,   244,    20,   467,
     247,  1075,  1751,  1077,    15,   252,    15,   162,   253,   465,
     461,    28,  1830,  1831,  1832,   465,   206,  1804,    15,  1806,
      18,   460,   177,   461,    20,   190,   191,   459,   459,   459,
     463,   186,  1902,   188,   189,  1707,   459,    28,   465,    19,
     132,    76,    81,   459,   459,  1717,  1718,  1719,   459,  1721,
    1722,   461,   459,   459,  1726,   459,    19,  1664,   190,   191,
     459,  1733,   227,   228,    69,   459,   459,     3,  1675,  1676,
    1677,  1678,   459,  1745,  1746,     3,   459,   461,    15,   244,
     459,   459,   247,   459,   459,   275,   459,   252,   459,   459,
     459,   459,  1764,  1765,   459,   227,   228,   463,  1770,   459,
     255,  1608,  1774,     3,   459,   459,  1778,   459,   459,  1781,
     459,   459,   244,   459,  1621,   247,   306,   459,   459,  1989,
     252,  1793,  1629,   459,  1631,   315,   362,   363,   364,   365,
     366,   367,   368,   369,     3,     3,     3,     3,     3,  1811,
       3,  1648,  1649,  1650,    28,    28,  1818,   184,   184,   465,
     459,   461,   182,   459,   459,   459,   190,   465,  1830,  1831,
    1832,   392,    79,   459,  1836,   459,    22,    13,   459,    15,
      16,    17,    18,    19,    20,  1847,  1848,  1849,  1850,  1851,
     459,    27,    28,    29,    30,   459,    32,   459,   459,   459,
     345,  1863,   459,  1865,   459,   459,   459,   459,   323,   459,
       3,   459,  1709,   460,   459,   459,  1878,  1714,     3,  1716,
      15,    15,    28,   460,   465,   465,  1888,    15,    15,  1891,
     467,   464,  1894,  1895,   463,   459,  1898,  1899,   208,   209,
     210,   211,   212,   213,   214,   215,  1908,   217,   218,   219,
     220,   221,   222,   459,   459,   340,    69,   336,  1755,  1921,
     461,   335,    69,   280,  1926,  1927,  1928,   463,   463,   449,
     450,   451,   452,   463,  1936,   463,   463,  1939,  1940,    22,
     459,   459,   465,    28,   120,  1782,     7,  1784,    29,   434,
     126,    29,   184,   464,    19,  1957,  1958,  1959,   265,  1961,
     193,    15,  1964,   448,   461,   460,   461,   330,   453,   463,
       3,    13,   467,    15,    16,    17,    18,    19,    20,   459,
       3,   463,   262,   461,   463,    27,    28,   460,    30,   463,
      32,   461,    29,    29,   225,   461,   461,   460,   460,     7,
     461,   461,   460,   259,  2006,   467,  1843,   460,   460,  2011,
    1947,  2013,   459,  2015,   190,   191,   459,   463,   463,  1856,
    2022,   459,   459,   282,   459,   461,   418,   418,   459,    13,
     464,    15,    16,    17,    18,    19,    20,     7,  1875,  1876,
     461,   459,  1879,    27,    28,    29,    30,   460,    32,   461,
     461,   227,   228,   461,   461,   461,   465,   260,   138,    46,
    1897,   147,   323,   463,  1901,   378,  1903,   318,   244,   260,
     260,   247,   396,   282,   394,   364,   252,   386,   120,   362,
     459,   410,  1919,  1920,   126,   459,    73,    74,    75,   405,
      77,    78,   277,    80,   408,    76,   413,    84,  1935,    86,
      87,   265,   265,    20,  1941,    76,  1943,  1944,    13,   459,
      15,    16,    17,    18,    19,    20,   459,   459,   378,  1956,
      76,   386,    27,    28,    29,    30,   318,    32,    76,   116,
     441,   443,   378,   120,   121,   323,   120,   124,   125,   260,
     459,   128,   126,   260,   131,    20,   464,   397,   190,   191,
     260,    13,    76,    15,    16,    17,    18,    19,    20,   459,
     459,   464,  1999,    76,   260,    27,    28,    29,    30,    69,
      32,   459,   427,   459,    13,   459,    15,    16,    17,    18,
      19,    20,   169,   459,   461,   227,   228,   174,    27,    28,
    2027,    30,   465,    32,   377,   459,   459,   459,   377,   372,
     880,   370,   244,   267,  1143,   247,   190,   191,   465,   461,
     252,   459,  1049,  1052,   459,   120,     8,     9,    10,    11,
      12,   126,   459,   459,   459,   459,   570,  1970,   390,  1131,
      22,    23,    24,    25,    26,    27,    28,    29,    30,  1659,
    1322,    33,   934,   227,   228,   851,   197,  1804,   601,   852,
    1806,  1266,   857,  1518,  1411,     8,     9,    10,   120,  1090,
     244,  1148,  1540,   247,   126,  1459,  1478,  1552,   252,    22,
      23,    24,    25,    26,    27,    28,    29,    30,  1489,  1893,
      33,   120,   979,  1771,   460,   190,   191,   126,  1751,  1902,
    1775,   467,     8,     9,    10,    11,    12,  1904,  1774,    -1,
    1035,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,
      -1,    -1,   227,   228,    -1,    -1,    -1,    -1,   190,   191,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,
      -1,    -1,   247,    -1,    -1,    -1,    -1,   252,    -1,    -1,
      -1,   190,   191,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   227,   228,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,   244,    -1,    -1,   247,    -1,    -1,   227,   228,
     252,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,   244,    -1,    -1,   247,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,   459,   460,     8,
       9,    10,    11,    12,    -1,   467,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,   460,   464,    -1,    -1,
      -1,    -1,    -1,   467,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,   460,    -1,    -1,    -1,    -1,
      -1,    -1,   467,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   460,     5,
      33,    -1,    -1,    -1,    -1,   467,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      -1,   460,    -1,    -1,    -1,    -1,    -1,    -1,   467,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,   461,
      -1,    -1,    -1,    -1,    -1,    -1,    82,    83,    -1,    -1,
      -1,    -1,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   139,    -1,    33,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,   461,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,   178,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,
      -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   461,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    73,    -1,    33,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,   233,   234,    -1,
     236,   237,   238,   239,   240,   241,   242,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,   461,    -1,     8,     9,    10,    11,    12,   285,
     286,   287,   288,   289,   290,   291,   292,   293,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,   461,    33,
      -1,    -1,    -1,    -1,    -1,   311,   312,   164,    -1,    46,
      -1,    -1,    -1,    42,    -1,    -1,   182,    -1,    -1,    -1,
     326,    -1,   188,    -1,   461,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    -1,
      -1,   347,   348,   349,   350,   211,    -1,    84,     3,    86,
     461,    -1,    -1,     8,     9,    10,    11,    12,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    86,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   461,    -1,    33,   116,
      -1,    -1,    -1,   120,   121,    -1,    -1,   124,   125,    -1,
     256,   128,    -1,    -1,   131,   116,    -1,    -1,   255,   120,
     121,    -1,   461,   124,   125,   126,    -1,   128,    -1,   138,
     131,   140,     5,   279,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   432,   433,   461,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,   167,   168,
     446,   447,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,   457,    -1,   174,    -1,    -1,    -1,   323,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,   461,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,   341,    -1,    -1,    -1,   345,    82,
      83,    -1,    -1,    -1,   461,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,    -1,    -1,    -1,   255,    -1,    -1,   258,
     259,    -1,    -1,   254,    -1,    -1,    -1,   266,    -1,    -1,
     406,   407,    -1,   400,    -1,   411,   412,   404,   414,    -1,
      46,    -1,    -1,    -1,    -1,    -1,   422,   423,    -1,    -1,
      -1,   459,   208,   209,   210,   211,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,   222,   434,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   178,    -1,   459,   317,    -1,
      86,   448,    -1,    -1,    -1,    -1,   453,    -1,   464,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,
      -1,    -1,    -1,   459,   351,   352,   353,    -1,    -1,    -1,
     116,   342,   343,   344,   120,   121,    -1,   123,   124,   125,
      -1,    -1,   128,    -1,    -1,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   459,    -1,    -1,    -1,   385,    -1,
      -1,    -1,    -1,    -1,    -1,   392,   385,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,   401,   169,   224,    -1,    -1,    -1,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    -1,   459,    -1,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,    -1,    46,    -1,    -1,    -1,    -1,   436,   437,    -1,
     439,   440,    45,   442,    -1,   211,    -1,    -1,   311,   312,
      -1,    -1,    66,    -1,    46,   459,    -1,   464,    -1,    51,
      -1,    -1,    -1,   326,    -1,   464,    -1,    -1,    -1,    61,
      -1,    -1,    86,   464,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    86,   347,   348,   349,   350,    80,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,    -1,   120,   121,    -1,    -1,
     124,   125,    -1,    -1,   128,   118,    -1,   131,    -1,    -1,
      -1,    -1,   125,   126,   116,    -1,    -1,    46,   120,   121,
     122,   123,   124,   125,   137,    -1,   128,    -1,    -1,   131,
      -1,    46,    -1,   135,    -1,   461,   138,    -1,   140,    -1,
      -1,   154,   155,   156,   157,   169,   159,   160,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,   432,
     433,    -1,    -1,    -1,   188,    -1,    -1,   169,    -1,    -1,
      -1,    86,   174,   446,   447,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   457,    -1,   188,   116,   190,    -1,
      -1,   120,   121,    -1,   123,   124,   125,   199,    -1,   128,
      -1,   116,   131,   100,    -1,   120,   121,    -1,   123,   124,
     125,    -1,   109,   128,    -1,    -1,   131,   114,    -1,   116,
      -1,   118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,
      -1,   128,    -1,   130,    -1,   237,    -1,    -1,    -1,    -1,
     169,   254,    -1,    -1,    -1,   174,   422,   423,    -1,    -1,
     426,    -1,    66,   255,   169,   431,    -1,    -1,    -1,   174,
     262,   263,    -1,   265,    -1,    46,    -1,    -1,   270,   271,
      -1,   273,   274,    -1,   276,    -1,    -1,   279,   280,   281,
      -1,    46,    -1,    -1,    -1,    66,    -1,    -1,   464,   313,
      -1,    -1,   294,   295,    -1,    -1,    -1,   299,    46,   301,
     302,    -1,   304,    -1,    -1,    86,    -1,   309,    -1,    -1,
      -1,   313,   314,    -1,   316,   317,    -1,   319,   320,   321,
      -1,    86,    -1,   325,   138,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,   262,   263,   116,    -1,    -1,    86,   120,
     121,    -1,   123,   124,   125,    46,    -1,   128,    -1,    46,
     131,   116,    -1,    -1,   168,   120,   121,    -1,    -1,   124,
     125,    -1,    -1,   128,    -1,    -1,   131,   181,   116,    -1,
      -1,    -1,   120,   121,    71,    72,   124,   125,    -1,    -1,
     128,   195,    -1,   131,    81,    86,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,   154,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,
     121,   169,   123,   124,   125,    -1,   174,   128,    -1,    -1,
     131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
     464,   255,    -1,    -1,   258,   259,    -1,    -1,    -1,    -1,
      -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   464,    -1,    -1,    -1,    -1,    -1,   169,    -1,
     385,    -1,    -1,   174,   171,    -1,    -1,   174,    -1,   176,
      -1,    -1,    -1,    -1,    -1,    -1,   183,    -1,   185,    -1,
      -1,    -1,    -1,   190,   191,   192,    -1,    -1,    -1,    -1,
     197,   198,   199,   317,    -1,    -1,   320,    -1,    -1,   323,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
     435,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,   464,    33,    -1,   352,    -1,
     354,    -1,   356,   357,   358,   359,   360,   361,    -1,   464,
      -1,    -1,    -1,   367,    -1,    -1,   370,    -1,    -1,   373,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   333,    -1,
      -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   393,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,   222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   401,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   341,    -1,    -1,    -1,    -1,    -1,
     464,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   464,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   464,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   464
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   470,   471,    46,    71,    72,    81,   135,   171,
     174,   176,   183,   185,   190,   191,   192,   197,   198,   199,
     341,   496,   497,   498,   499,   500,   501,   554,   555,   556,
     557,   559,   560,   561,   564,   567,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   662,   673,
     707,   708,   709,   710,   711,   712,   713,   714,   764,   765,
     775,   786,   787,   788,   790,     0,     3,    34,    43,    46,
      57,    70,    80,    86,   116,   118,   119,   126,   162,   163,
     174,   197,   200,   459,   472,   485,   491,   494,   495,   504,
     507,   510,   512,   515,   517,   518,   520,   521,   528,   538,
     539,   596,   598,   608,   646,   649,   663,   668,   669,   672,
     675,   676,   716,   717,   718,   723,   753,   756,   766,   767,
     776,   779,   789,   791,   792,   793,    19,    20,    45,   594,
      20,    56,    64,    65,    66,   502,     3,   594,   594,   172,
     173,   594,   594,     3,   162,   144,   145,   162,   177,   186,
     188,   189,   255,   345,   434,   448,   453,   162,   162,    79,
     142,   144,   145,   193,   194,   195,   196,    13,    15,    16,
      17,    18,    19,    20,    27,    28,    30,    32,   120,   126,
     190,   191,   227,   228,   244,   247,   252,   460,   467,   613,
     625,   630,   633,   634,   635,   637,   639,    36,    45,   463,
     583,   594,   192,    19,    19,    20,    44,    55,   482,   487,
      68,   144,   158,    43,    62,   118,   188,   492,   493,    50,
      67,    81,    19,   117,    19,    86,   164,   144,   482,   639,
      19,    19,   139,   522,   522,   463,    73,    78,   122,   164,
     255,   341,   345,   400,   404,   434,   448,   453,   522,    46,
      66,    86,   116,   120,   121,   123,   124,   125,   128,   131,
     169,   174,   464,   523,   541,   522,   522,    51,    61,    66,
      80,   122,   123,   135,   138,   140,   188,   190,   199,   237,
     255,   262,   263,   265,   270,   271,   273,   274,   276,   279,
     280,   281,   294,   295,   299,   301,   302,   304,   309,   313,
     314,   316,   317,   319,   320,   321,   325,   464,   523,   522,
     522,    84,   346,   351,   352,   353,   385,   392,   464,   523,
     677,   678,   679,   522,   333,   401,   464,   523,   522,   522,
     522,    66,   188,   313,   464,   523,   768,   771,   522,    73,
      74,    75,    77,    78,    80,    84,    87,   464,   506,   509,
     523,    75,   154,   464,   508,   523,    36,    45,   463,   542,
     502,     3,     3,   502,    67,   503,    20,   484,   484,   594,
     594,     3,    36,    45,   463,   545,    86,   569,    19,    20,
      45,   595,     3,   187,   565,     3,     3,   562,   568,   269,
      19,   123,   195,   384,   398,   399,   558,   145,   195,   558,
     145,   195,   458,    18,    19,   476,   478,   478,     3,     3,
       3,     3,     3,     3,     3,     3,    15,    19,    29,   460,
     466,   629,   631,   637,    30,   460,   253,    28,   253,    15,
     466,   632,   639,   460,   460,   460,   460,   460,   460,   229,
     230,   231,   232,   618,   639,    15,    16,    17,    19,   460,
     613,   614,   617,   619,   620,   621,   623,   625,   626,   627,
       5,    82,    83,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   139,   178,   233,   234,   236,   237,   238,   239,   240,
     241,   242,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   311,   312,   326,   347,   348,   349,   350,   432,   433,
     446,   447,   457,   638,   794,     3,     8,     9,    10,    11,
      12,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      33,    46,    47,    48,    49,    50,    51,    52,    53,    54,
     489,   490,    15,   584,   484,   674,    22,    63,   486,    45,
     463,   488,    15,    19,    35,    36,    37,    38,    69,   460,
     473,   475,   542,   473,    20,    58,    59,   459,   473,   474,
     474,   181,   170,   516,    15,    17,    18,    19,   139,   460,
     511,   597,    19,   513,   545,   459,   609,   139,    19,   463,
     463,   519,   463,   542,   323,    19,   527,   117,   473,   475,
     540,    45,    69,   126,   127,   136,   254,   524,   605,    69,
     524,   482,    69,   482,   545,   459,   459,   463,   463,   181,
     283,   327,   323,    81,   459,    20,   284,   482,   475,    69,
      85,   188,   298,   324,   167,    80,   475,   459,   473,   476,
     664,   184,   476,    76,   272,   282,    76,   270,   277,   286,
     287,    87,   282,   296,   297,   296,   300,   475,   303,   305,
     310,    86,    87,   122,   315,    87,   318,   316,   475,   265,
     286,   475,   459,   463,   463,   383,   511,   475,   116,   473,
     475,   117,   459,   463,   463,    86,   402,   403,   459,   463,
     463,   463,   323,   478,    86,   459,   206,   275,   306,   315,
     449,   450,   451,   452,   463,   774,   463,    86,   475,    76,
     475,    79,    81,    85,   473,   459,   459,   459,    76,   484,
     459,   459,    79,   129,   130,   142,   143,   145,   543,   544,
       3,   503,     3,   473,     3,     3,     3,     3,     3,   129,
     175,   546,   547,     3,    19,     3,   595,     3,     3,     3,
      86,   157,   172,   184,   566,     3,    45,    86,   118,   125,
     126,   137,   154,   155,   156,   157,   159,   160,   478,   563,
     605,     3,    19,    86,   118,   119,   126,   162,   200,   558,
     558,   558,   715,    45,   558,    45,   558,     3,   558,   558,
       3,   558,   558,   558,    30,   462,   480,   182,   182,     7,
     631,   631,   639,   631,   631,    14,    15,   639,   643,   644,
      27,    28,   253,    28,   632,   632,    30,   639,   639,   639,
     639,   639,    19,    15,   465,   461,   465,    29,   616,   618,
     639,     7,   465,   468,    27,    28,   463,   465,   468,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   210,   235,   243,   248,   249,   250,   464,
     465,     3,     3,     3,    86,   126,   141,   605,   639,   482,
     489,   459,   474,   639,   473,    60,    61,    60,    61,    39,
      40,    41,   473,   535,   536,   639,   459,   208,   209,   210,
     211,   212,   213,   214,   215,   217,   218,   219,   220,   221,
     222,   599,   600,   601,   603,   607,    42,   165,   166,   167,
     459,   514,   459,   460,   606,    19,   162,   464,   475,   511,
     529,   532,   533,    36,   473,   526,    19,   603,   604,   137,
     639,   526,   526,   648,    76,    76,    80,   328,   475,    76,
     322,   475,   459,    51,   329,   459,   459,   473,   258,   259,
     475,   308,   475,   175,   476,   459,   459,   459,    31,   477,
      42,   184,   459,   473,   184,   473,    76,    76,   473,    76,
     136,   278,   473,   473,   475,    76,   459,   117,   459,   475,
     459,   475,   278,   306,   307,   475,   527,   475,   459,   459,
     475,   475,   475,   459,   184,   475,   459,   671,   475,   475,
      69,   473,   680,    19,   459,   459,   722,   755,   475,   527,
      20,   476,   476,   275,   769,   770,   773,   459,   778,   473,
     473,   475,   475,   475,   473,   476,   478,   479,   464,   465,
       3,   464,   465,     3,    19,    15,   478,    19,    19,   604,
     479,    19,     3,    20,   483,   483,     3,    19,   116,   278,
     323,   346,   361,   390,   391,   558,   483,   558,   483,   483,
     483,   483,   483,   483,   473,   476,    15,    15,    15,   461,
     465,   461,   253,    28,   465,   465,   465,   461,   465,   461,
     465,   639,   639,   465,     7,   465,   465,   461,    18,   460,
     614,   621,    15,    18,   626,   460,   490,    20,   527,   604,
     482,   459,   464,   461,    20,   459,   533,   459,   461,    19,
     216,   459,   463,   473,   476,   461,   600,   602,   607,   478,
     459,    28,   531,   465,   132,   525,   475,   123,   262,   263,
     464,   523,   647,   473,   473,    81,    76,   459,   473,   459,
     459,   475,   463,   475,   665,   459,   459,   459,   459,   475,
     459,   475,   459,    19,   664,   473,   473,   459,   473,   459,
     473,   473,   459,   473,   459,   459,   459,   459,   459,   473,
     511,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   473,   459,    86,   126,   342,   343,   344,
     464,   523,   605,   670,   473,   123,   187,   279,   352,   374,
     376,   381,   383,   387,   388,   464,   681,   688,   691,   459,
     123,   211,   422,   423,   426,   431,   464,   523,   719,   123,
     385,   435,   464,   523,   754,   459,   459,   477,   476,   255,
     386,   769,    19,    51,   120,   201,   202,   203,   204,   205,
     206,   207,   223,   226,   255,   464,   635,   636,   640,   645,
     772,   123,   464,   523,   777,    69,   505,   544,   547,     3,
       3,   511,   511,    15,   511,   483,     3,   483,     3,     3,
       3,     3,     3,     3,   184,   184,   631,   643,    28,    28,
     639,   639,   639,   639,   639,   465,   461,   465,    29,   616,
     639,   616,    29,   616,   616,   639,   465,   639,   601,   610,
     611,   645,   459,   461,   182,    20,   479,   530,   532,    81,
     133,   134,   135,   650,   656,   650,   657,   476,   661,   459,
     465,   459,   322,   475,   473,   459,   459,   173,   211,   329,
     331,   333,   334,   337,   666,   667,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,    20,   604,   482,
     473,   190,   459,   700,   706,   475,   354,   355,   387,   354,
     475,   682,   323,   478,   684,   685,   683,   389,   475,   459,
     392,   701,   724,   732,   478,   733,   738,   720,   721,   478,
      79,   459,   757,   763,   475,   473,   459,   477,   475,   473,
      22,   460,    22,   460,   639,   639,   639,   475,   638,   794,
     459,   639,   641,   642,   780,   785,   459,   473,     3,     3,
      15,    15,    28,   461,   461,   461,   461,   465,   639,   639,
     461,   465,     7,   461,   465,   461,   465,     7,   461,   465,
     465,    15,   461,   464,   645,   602,    15,   479,   533,   534,
     463,   655,    31,   264,   658,   473,   459,   459,   459,   340,
      69,   246,   332,   336,   335,   338,   339,   464,   465,   280,
     533,   702,   473,   473,   475,   473,   463,   511,   463,   463,
     473,   473,   463,   534,   463,   737,   463,   476,   739,   744,
      20,   463,   745,   750,   475,   534,    69,   639,   644,   639,
     635,   459,   224,   463,   459,    22,    22,    33,   465,   459,
     534,   569,   569,    28,   639,   461,   461,    29,   616,    29,
     616,    29,   616,     7,    29,   616,    29,   616,   464,   184,
     655,   654,   651,    19,   482,   265,   659,   459,   193,   330,
     667,   475,   703,   463,   705,   693,   686,   693,   689,   463,
     731,   736,   735,   740,   746,   463,   762,   473,   459,   461,
     459,   794,   463,   612,   645,   628,   639,   639,   126,   190,
     191,   247,   253,   642,   463,   784,     3,     3,   461,   461,
     461,   461,   465,     7,   461,   461,   461,   465,   460,   461,
       7,   461,   461,     7,   461,    15,   651,   138,   140,   168,
     256,   257,   260,   261,   266,   464,   548,   550,   551,   652,
     476,   262,   660,   701,   704,   464,   478,   694,   695,   187,
     354,   375,   464,   687,   464,   181,   266,   356,   357,   358,
     360,   464,   548,   690,   730,   729,   415,   416,   419,   420,
     421,   464,   734,   743,   749,   761,   758,   461,   610,   225,
       6,    15,    16,    17,   460,   464,   613,   615,   617,   619,
     620,   622,   624,   459,   459,   460,   460,   460,   460,   459,
     783,   781,    29,   616,    29,   616,   616,     7,   616,   459,
     482,   475,   463,   258,   259,   259,   474,   473,   127,   147,
     267,   268,   653,   463,   459,   475,    66,   181,   195,   255,
     258,   259,   266,   317,   320,   323,   352,   354,   356,   357,
     358,   359,   360,   361,   367,   370,   373,   385,   393,   464,
     548,   692,   375,   382,   696,   475,   473,   475,   459,   473,
     127,   267,   371,   473,   473,   282,   156,   473,   459,   182,
     188,   211,   256,   279,   323,   406,   407,   411,   412,   414,
     422,   423,   464,   725,   418,   418,   475,   475,   475,   459,
     418,   424,   464,   741,   418,   425,   464,   747,    42,    66,
      67,    87,   140,   167,   255,   258,   259,   266,   317,   385,
     401,   436,   437,   439,   440,   442,   464,   548,   759,   459,
     464,   612,   610,   639,     7,   462,   465,   639,   639,   639,
     639,    42,    66,   258,   259,   357,   361,   436,   454,   464,
     782,   461,   461,   461,   465,   461,   460,   461,   549,   550,
     260,   260,   260,   149,   150,   147,   117,   139,   141,   146,
     161,   205,   552,   323,   473,   463,   475,   378,   179,   180,
     359,   395,   537,   127,   267,   371,   318,   475,   396,   475,
     473,   473,   473,   282,   473,   156,   473,   362,   363,   364,
     365,   366,   367,   368,   369,   394,   364,   473,   386,   362,
     459,   473,   459,   473,   473,   405,   120,   409,   418,   409,
     738,   282,   405,   120,   418,   410,   475,   408,    76,   413,
     277,   265,   726,   265,   727,   459,   473,   473,   417,   473,
     751,   739,   742,   459,   751,   745,   748,   459,   473,   323,
     444,    76,   473,   475,   476,   475,   378,   359,   395,   537,
     127,   149,   371,   445,   760,   318,   386,   362,   438,    76,
      76,   377,   473,   441,   443,   459,   461,   460,   615,   610,
     622,   461,   461,   461,   461,   473,   323,   378,   359,   395,
     537,   260,   455,   456,   260,   473,   459,   616,   616,   464,
     459,   474,   474,   474,   149,   150,   473,    20,   481,   481,
     147,   148,   553,   139,   141,   139,   141,   464,   475,   697,
     379,   380,   473,   473,   473,   473,   473,   259,   475,   397,
     473,   473,   475,   475,   473,   475,   260,   428,   429,   430,
     728,    76,   473,    76,   473,   260,   728,   473,   473,   475,
     473,   473,    69,   475,   744,   475,   750,   427,   752,   752,
     473,   475,   475,   473,   473,   473,   473,   259,   475,   473,
     473,   473,   475,   475,   475,   639,   459,   459,   459,   459,
     475,   473,   473,   473,   473,   473,   461,   465,   549,   459,
     459,   459,   149,   150,   151,   152,   153,   149,   150,   151,
     152,   153,   459,   481,   481,   481,   481,   464,   476,   699,
     377,   475,   473,   473,   752,   473,   473,   752,   473,   475,
     377,   616,   552,   552,   552,   552,   459,   459,   459,   459,
     372,   698,   465,   552,   552,   552,   552,   459,   616,   461
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 882 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 883 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 896 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 906 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 907 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 914 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000000; }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 915 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 916 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 924 "cf-parse.y"
    { (yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 925 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 926 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 927 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 928 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 929 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 936 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 943 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 944 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 948 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 956 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 960 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 964 "cf-parse.y"
    {
     (yyval.i) = ipa_masklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 971 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 980 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[(1) - (1)].s)).s;
   }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 988 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 992 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 993 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 999 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 1008 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 1009 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 1013 "cf-parse.y"
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = rf_file(f);
   }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 1018 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 1019 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 1023 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 1024 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 1028 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 1029 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 1033 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 1034 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 1035 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 1036 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 1037 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 1038 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 1039 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 1040 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 1041 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 1047 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 1048 "cf-parse.y"
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = rf_fileno(f);
   }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 1058 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 1059 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 1060 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 1061 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 1064 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 1065 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 1066 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 1067 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 1068 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){NULL, NULL, 0}; }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 1069 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 1079 "cf-parse.y"
    { new_config->latency_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 1080 "cf-parse.y"
    { new_config->latency_limit = (yyvsp[(4) - (4)].i32); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 1081 "cf-parse.y"
    { new_config->watchdog_warning = (yyvsp[(3) - (3)].i32); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 1082 "cf-parse.y"
    { new_config->watchdog_timeout = ((yyvsp[(3) - (3)].i32) + 999999) TO_S; }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 1091 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 1094 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 1101 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 1104 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 1107 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 1110 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 1113 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 1118 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 1119 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 1120 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 1128 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 1133 "cf-parse.y"
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 1134 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) <= 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 1138 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 1139 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 1143 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 1150 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 1151 "cf-parse.y"
    { THIS_KRT->graceful_restart = (yyvsp[(3) - (3)].i); }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 1152 "cf-parse.y"
    {
      THIS_KRT->merge_paths = (yyvsp[(3) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[(3) - (4)].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 1164 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1169 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 1173 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 1187 "cf-parse.y"
    { THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i); }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1188 "cf-parse.y"
    { THIS_KRT->sys.metric = (yyvsp[(2) - (2)].i); }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1202 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1203 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1207 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1208 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1210 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 1217 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[(1) - (1)].s)).i;
#ifndef IPV6
     else if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[(1) - (1)].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1239 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1240 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1241 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1242 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1247 "cf-parse.y"
    { new_config->gr_wait = (yyvsp[(4) - (5)].i); }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1253 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1254 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1258 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 1266 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1272 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1286 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1287 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1291 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1297 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1301 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[(2) - (2)].s)->class != SYM_TEMPLATE) && ((yyvsp[(2) - (2)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(2) - (2)].s)->def);
   }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1310 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1321 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1325 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1326 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1327 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1328 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1329 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1330 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1331 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1332 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1333 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1334 "cf-parse.y"
    { this_proto->vrf = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1335 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1336 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 1337 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1341 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1343 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1344 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1348 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1349 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 1350 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1351 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1352 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 1356 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1362 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1366 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1374 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1375 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1383 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1391 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1392 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 1393 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 1397 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 1398 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1412 "cf-parse.y"
    { iface_patt_check(); }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1414 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1426 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1427 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1433 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 1443 "cf-parse.y"
    { DIRECT_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1447 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1461 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 1462 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1463 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1468 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1472 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1473 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1474 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1475 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1476 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 1477 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1483 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1484 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1485 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1490 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1494 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1495 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1516 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->length = strlen((yyvsp[(2) - (2)].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1536 "cf-parse.y"
    { }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1537 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1538 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1539 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1540 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1541 "cf-parse.y"
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[(2) - (4)].time); }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1542 "cf-parse.y"
    { this_p_item->gento = this_p_item->accto = (yyvsp[(2) - (4)].time); }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1543 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1544 "cf-parse.y"
    { this_p_item->alg = (yyvsp[(2) - (4)].i); }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1548 "cf-parse.y"
    { (yyval.i) = ALG_MD5; }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1549 "cf-parse.y"
    { (yyval.i) = ALG_SHA1; }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1550 "cf-parse.y"
    { (yyval.i) = ALG_SHA256; }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1551 "cf-parse.y"
    { (yyval.i) = ALG_SHA384; }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1552 "cf-parse.y"
    { (yyval.i) = ALG_SHA512; }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1553 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_MD5; }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1554 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA1; }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1555 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA256; }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1556 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA384; }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1557 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA512; }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1564 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1567 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1570 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1573 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1577 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1581 "cf-parse.y"
    { if_show(); }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1584 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1588 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1591 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1596 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1602 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1609 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1614 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1619 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1624 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1628 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1632 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1636 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1645 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1653 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1657 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1664 "cf-parse.y"
    { (yyval.i) = RSEM_PREEXPORT; }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1665 "cf-parse.y"
    { (yyval.i) = RSEM_EXPORT; }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1666 "cf-parse.y"
    { (yyval.i) = RSEM_NOEXPORT; }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1672 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1675 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1682 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1689 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1693 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1701 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1702 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1703 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1709 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1712 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1715 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1716 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1717 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1718 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1719 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1720 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1721 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1726 "cf-parse.y"
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1731 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1740 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1747 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1754 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1762 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1764 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1766 "cf-parse.y"
    { io_log_dump(); cli_msg(0, ""); }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1768 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1770 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1772 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1774 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1776 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1779 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1782 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1788 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1789 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1790 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1794 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1795 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1802 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[(3) - (4)].t)); }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1804 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[(3) - (4)].t)); }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1806 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[(3) - (4)].t)); }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1808 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1810 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1812 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1816 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1820 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1823 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1826 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1827 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1832 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1833 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1834 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1842 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1843 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1852 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1856 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1857 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1858 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 1859 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 1860 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 1861 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 1862 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1863 "cf-parse.y"
    { (yyval.i) = T_LC; }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1864 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 1865 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1866 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1867 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1868 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1869 "cf-parse.y"
    { (yyval.i) = T_LCLIST; }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1870 "cf-parse.y"
    {
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1892 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1903 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 1904 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 1911 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 1912 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1919 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 1928 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 1936 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst(FI_PRINT_AND_DIE);	/* ACCEPT */
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst(FI_PRINT_AND_DIE);	/* REJECT */
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst(FI_CONDITION);			/* IF */
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1957 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 1958 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 1962 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst(FI_CLEAR_LOCAL_VARS);
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 1974 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1977 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name);
     cf_pop_scope();
   }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 1990 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 1991 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1994 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 1995 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 1999 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 2002 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 2011 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 2024 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 2025 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 2026 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 2027 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 2028 "cf-parse.y"
    {
     (yyval.v) = f_eval((yyvsp[(2) - (3)].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 2032 "cf-parse.y"
    {
     if (!cf_symbol_is_constant((yyvsp[(1) - (1)].s))) cf_error("%s: constant expected", (yyvsp[(1) - (1)].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[(1) - (1)].s)))) cf_error("%s: set-incompatible type", (yyvsp[(1) - (1)].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[(1) - (1)].s)->def);
   }
    break;

  case 341:
/* Line 1792 of yacc.c  */
#line 2040 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 2041 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 2042 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 2048 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 2051 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 2052 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 2053 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), 0, CC_ALL); }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 2054 "cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 2055 "cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 2056 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, CC_ALL); }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 2057 "cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 2058 "cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 2059 "cf-parse.y"
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 2061 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (11)].i32), (yyvsp[(8) - (11)].i32), (yyvsp[(4) - (11)].i32), (yyvsp[(10) - (11)].i32)); }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 2065 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 2066 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 2067 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 2068 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 2072 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 2073 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 2074 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 2078 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 2079 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 2080 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, LC_ALL); }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 2081 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), 0, LC_ALL); }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 2082 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), 0, LC_ALL, 0, LC_ALL); }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 2083 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), 0, LC_ALL, 0, LC_ALL); }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 2084 "cf-parse.y"
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 2086 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (15)].i32), (yyvsp[(10) - (15)].i32), (yyvsp[(4) - (15)].i32), (yyvsp[(12) - (15)].i32), (yyvsp[(6) - (15)].i32), (yyvsp[(14) - (15)].i32)); }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 2093 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 2094 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 2101 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 2102 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2107 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2112 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2116 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2123 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2124 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2125 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2126 "cf-parse.y"
    {
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2133 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 2134 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 2137 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2138 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2145 "cf-parse.y"
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 2157 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 2158 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 2162 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 2163 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2167 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2168 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(4) - (4)].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[(1) - (4)].i); (yyval.h)->val2 = (yyvsp[(3) - (4)].i); }
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 2169 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2170 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; }
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 2171 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2172 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2176 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2177 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2178 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2182 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2183 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2184 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2185 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2186 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2187 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2188 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2189 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2190 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2191 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2195 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2196 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2197 "cf-parse.y"
    { (yyval.x) = f_generate_lc((yyvsp[(2) - (7)].x), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2198 "cf-parse.y"
    { (yyval.x) = f_generate_path_mask((yyvsp[(1) - (1)].h)); }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2212 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2234 "cf-parse.y"
    {
     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); break;
       case SYM_VARIABLE: (yyval.x) = f_new_inst(FI_VARIABLE); break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2246 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	1); }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2247 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	1); }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2248 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_PREFIX,     SA_NET,	0); }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2249 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	0); }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2250 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	0); }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2251 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	1); }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2252 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTC,   SA_CAST,	0); }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2253 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	1); }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2254 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	1); }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2255 "cf-parse.y"
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	0); }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2259 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2260 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_ADD);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2261 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_SUBTRACT);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2262 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_MULTIPLY);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2263 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_DIVIDE);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2264 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AND);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2265 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_OR);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 2266 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EQ);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2267 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_NEQ);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2268 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2269 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2270 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2271 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2272 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_MATCH);	(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2273 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_NOT_MATCH);(yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2274 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_NOT);	(yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2275 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_DEFINED);	(yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2277 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 2278 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 2279 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2281 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PREF_GET); }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2283 "cf-parse.y"
    { (yyval.x) = f_new_inst_sa(FI_RTA_GET, (yyvsp[(2) - (2)].fsa)); }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2285 "cf-parse.y"
    { (yyval.x) = f_new_inst_da(FI_EA_GET, (yyvsp[(2) - (2)].fda)); }
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 2287 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_IP); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 2288 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_LENGTH); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 2289 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_IP_MASK); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 2290 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 2291 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 2292 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 2302 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_PATH; }
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 2303 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_CLIST; }
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 2304 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_ECLIST; }
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 2305 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_LCLIST; }
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 2306 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2307 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2308 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2309 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 2311 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 2312 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 2315 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 2337 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2338 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2339 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 2340 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2342 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 2346 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PRINT); (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 2349 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2350 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2351 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2359 "cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 2365 "cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 2373 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 2374 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 2378 "cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2383 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst(FI_CONDITION);
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2391 "cf-parse.y"
    {
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2399 "cf-parse.y"
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN);
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2404 "cf-parse.y"
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[(2) - (5)].fda));
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 2408 "cf-parse.y"
    {
     (yyval.x) = f_new_inst_sa(FI_RTA_SET, (yyvsp[(2) - (5)].fsa));
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2414 "cf-parse.y"
    {
     (yyval.x) = f_new_inst(FI_PREF_SET);
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2418 "cf-parse.y"
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[(4) - (6)].fda));
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 2423 "cf-parse.y"
    { (yyval.x) = f_new_inst(FI_PRINT_AND_DIE); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 2424 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2425 "cf-parse.y"
    {
      (yyval.x) = f_new_inst(FI_SWITCH);
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2432 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].fda)); }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2433 "cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, 'x', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2434 "cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'a', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 2435 "cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'd', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 2436 "cf-parse.y"
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'f', (yyvsp[(2) - (8)].fda), (yyvsp[(6) - (8)].x) ); }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 2443 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 2470 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 2484 "cf-parse.y"
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 2504 "cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].i32); }
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 2505 "cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2506 "cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 2507 "cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 2508 "cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); }
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2509 "cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2510 "cf-parse.y"
    { BFD_IFACE->auth_type = (yyvsp[(2) - (2)].i); }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2511 "cf-parse.y"
    {}
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2515 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_NONE; }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2516 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_SIMPLE; }
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 2517 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
    break;

  case 527:
/* Line 1792 of yacc.c  */
#line 2518 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
    break;

  case 528:
/* Line 1792 of yacc.c  */
#line 2519 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 2520 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2538 "cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; }
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 2542 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 2543 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 2544 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 2548 "cf-parse.y"
    { (yyval.a) = IPA_NONE; }
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 2549 "cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); }
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2553 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2554 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 2558 "cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
}
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 2577 "cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); }
    break;

  case 545:
/* Line 1792 of yacc.c  */
#line 2582 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[(1) - (2)].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
 }
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 2611 "cf-parse.y"
    { BGP_CFG->remote_port = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Invalid port number");  }
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 2612 "cf-parse.y"
    { BGP_CFG->remote_as = (yyvsp[(3) - (3)].i); }
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 2617 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i) ? ~(1 << 7) : 0; }
    break;

  case 550:
/* Line 1792 of yacc.c  */
#line 2618 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 2623 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 553:
/* Line 1792 of yacc.c  */
#line 2627 "cf-parse.y"
    { (yyval.i) = 1 << 0; }
    break;

  case 554:
/* Line 1792 of yacc.c  */
#line 2628 "cf-parse.y"
    { (yyval.i) = 1 << 1; }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 2629 "cf-parse.y"
    { (yyval.i) = 1 << 2; }
    break;

  case 556:
/* Line 1792 of yacc.c  */
#line 2630 "cf-parse.y"
    { (yyval.i) = 1 << 3; }
    break;

  case 557:
/* Line 1792 of yacc.c  */
#line 2631 "cf-parse.y"
    { (yyval.i) = 1 << 4; }
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 2632 "cf-parse.y"
    { (yyval.i) = 1 << 5; }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2633 "cf-parse.y"
    { (yyval.i) = 1 << 6; }
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 2634 "cf-parse.y"
    { (yyval.i) = 1 << 7; }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 2635 "cf-parse.y"
    { (yyval.i) = 1 << 8; }
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 2641 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 2642 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 2644 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     if ((yyvsp[(4) - (6)].iface)) BGP_CFG->iface = (yyvsp[(4) - (6)].iface);
   }
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 2650 "cf-parse.y"
    { BGP_CFG->iface = if_get_by_name((yyvsp[(3) - (4)].t)); }
    break;

  case 569:
/* Line 1792 of yacc.c  */
#line 2651 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 570:
/* Line 1792 of yacc.c  */
#line 2652 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 2653 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 2654 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 573:
/* Line 1792 of yacc.c  */
#line 2655 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 574:
/* Line 1792 of yacc.c  */
#line 2656 "cf-parse.y"
    { BGP_CFG->multihop = 0; }
    break;

  case 575:
/* Line 1792 of yacc.c  */
#line 2657 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 576:
/* Line 1792 of yacc.c  */
#line 2658 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 577:
/* Line 1792 of yacc.c  */
#line 2659 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 578:
/* Line 1792 of yacc.c  */
#line 2660 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 2661 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2662 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2663 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 2664 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 2665 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 2666 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 2667 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 2668 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2669 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 2670 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2671 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 2672 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 2673 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 2674 "cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 2675 "cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2676 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 2677 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 2678 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2679 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2680 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2681 "cf-parse.y"
    { BGP_CFG->disable_after_cease = (yyvsp[(5) - (6)].i); }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2682 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2683 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2684 "cf-parse.y"
    { BGP_CFG->enable_extended_messages = (yyvsp[(5) - (6)].i); }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2685 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 2686 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2687 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2688 "cf-parse.y"
    { BGP_CFG->setkey = (yyvsp[(3) - (4)].i); }
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 2689 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 2695 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 2696 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2697 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2698 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_RX; }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2699 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_TX; }
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 2700 "cf-parse.y"
    { BGP_CFG->add_path = (yyvsp[(4) - (5)].i) ? ADD_PATH_FULL : 0; }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2701 "cf-parse.y"
    { BGP_CFG->allow_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 2702 "cf-parse.y"
    { BGP_CFG->allow_local_as = -1; }
    break;

  case 616:
/* Line 1792 of yacc.c  */
#line 2703 "cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 2704 "cf-parse.y"
    { BGP_CFG->gr_mode = (yyvsp[(4) - (5)].i); }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 2705 "cf-parse.y"
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 2706 "cf-parse.y"
    { BGP_CFG->gr_time = (yyvsp[(5) - (6)].i); }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 2707 "cf-parse.y"
    { BGP_CFG->llgr_mode = (yyvsp[(6) - (7)].i); }
    break;

  case 621:
/* Line 1792 of yacc.c  */
#line 2708 "cf-parse.y"
    { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 2709 "cf-parse.y"
    { BGP_CFG->llgr_time = (yyvsp[(6) - (7)].i); }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2710 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 2711 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 2712 "cf-parse.y"
    { BGP_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2713 "cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); }
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 2714 "cf-parse.y"
    { BGP_CFG->bfd = BGP_BFD_GRACEFUL; cf_check_bfd(1); }
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 2726 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_mrt, (yyvsp[(1) - (2)].i));
}
    break;

  case 630:
/* Line 1792 of yacc.c  */
#line 2732 "cf-parse.y"
    { MRT_CFG->table_expr = (yyvsp[(2) - (2)].t); }
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 2733 "cf-parse.y"
    { MRT_CFG->filter = (yyvsp[(2) - (2)].f); }
    break;

  case 632:
/* Line 1792 of yacc.c  */
#line 2734 "cf-parse.y"
    { MRT_CFG->filter = (yyvsp[(1) - (1)].f); }
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 2735 "cf-parse.y"
    { MRT_CFG->filename = (yyvsp[(2) - (2)].t); }
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 2736 "cf-parse.y"
    { MRT_CFG->period = (yyvsp[(2) - (2)].i); }
    break;

  case 635:
/* Line 1792 of yacc.c  */
#line 2737 "cf-parse.y"
    { MRT_CFG->always_add_path = (yyvsp[(4) - (4)].i); }
    break;

  case 638:
/* Line 1792 of yacc.c  */
#line 2746 "cf-parse.y"
    { mrt_check_config(this_proto); }
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 2750 "cf-parse.y"
    { mrt_dump_cmd((yyvsp[(3) - (4)].md)); }
    break;

  case 640:
/* Line 1792 of yacc.c  */
#line 2753 "cf-parse.y"
    { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 2754 "cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->table_ptr = (yyvsp[(3) - (3)].r)->table; }
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 2755 "cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->table_expr = (yyvsp[(3) - (3)].t); }
    break;

  case 643:
/* Line 1792 of yacc.c  */
#line 2756 "cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->filter = (yyvsp[(3) - (3)].f); }
    break;

  case 644:
/* Line 1792 of yacc.c  */
#line 2757 "cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (2)].md); (yyval.md)->filter = (yyvsp[(2) - (2)].f); }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 2758 "cf-parse.y"
    { (yyval.md) = (yyvsp[(1) - (3)].md); (yyval.md)->filename = (yyvsp[(3) - (3)].t); }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 2765 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 2781 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 2782 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 652:
/* Line 1792 of yacc.c  */
#line 2783 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 2784 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 654:
/* Line 1792 of yacc.c  */
#line 2785 "cf-parse.y"
    { OSPF_CFG->merge_external = (yyvsp[(3) - (3)].i); }
    break;

  case 655:
/* Line 1792 of yacc.c  */
#line 2786 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 2787 "cf-parse.y"
    { OSPF_CFG->instance_id = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<0) || ((yyvsp[(3) - (3)].i)>255)) cf_error("Instance ID must be in range 0-255"); }
    break;

  case 658:
/* Line 1792 of yacc.c  */
#line 2791 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 2806 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 2815 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 2816 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 664:
/* Line 1792 of yacc.c  */
#line 2817 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 2818 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 2819 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 2820 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2821 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2822 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 2823 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 671:
/* Line 1792 of yacc.c  */
#line 2824 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 673:
/* Line 1792 of yacc.c  */
#line 2825 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 2837 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 2851 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 684:
/* Line 1792 of yacc.c  */
#line 2852 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 685:
/* Line 1792 of yacc.c  */
#line 2853 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 686:
/* Line 1792 of yacc.c  */
#line 2857 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 2858 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 2867 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 692:
/* Line 1792 of yacc.c  */
#line 2868 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); }
    break;

  case 693:
/* Line 1792 of yacc.c  */
#line 2869 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 694:
/* Line 1792 of yacc.c  */
#line 2870 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); }
    break;

  case 695:
/* Line 1792 of yacc.c  */
#line 2871 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 696:
/* Line 1792 of yacc.c  */
#line 2872 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 2873 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 2874 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 2875 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 2876 "cf-parse.y"
    { ospf_check_auth(); }
    break;

  case 701:
/* Line 1792 of yacc.c  */
#line 2880 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 2899 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 703:
/* Line 1792 of yacc.c  */
#line 2900 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 2901 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 705:
/* Line 1792 of yacc.c  */
#line 2902 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); }
    break;

  case 706:
/* Line 1792 of yacc.c  */
#line 2903 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); }
    break;

  case 707:
/* Line 1792 of yacc.c  */
#line 2904 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 708:
/* Line 1792 of yacc.c  */
#line 2905 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 709:
/* Line 1792 of yacc.c  */
#line 2906 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 2907 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 2908 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 712:
/* Line 1792 of yacc.c  */
#line 2909 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 713:
/* Line 1792 of yacc.c  */
#line 2910 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 714:
/* Line 1792 of yacc.c  */
#line 2911 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 2912 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 2913 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 717:
/* Line 1792 of yacc.c  */
#line 2914 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 718:
/* Line 1792 of yacc.c  */
#line 2915 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
    break;

  case 719:
/* Line 1792 of yacc.c  */
#line 2916 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 720:
/* Line 1792 of yacc.c  */
#line 2917 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 721:
/* Line 1792 of yacc.c  */
#line 2918 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 722:
/* Line 1792 of yacc.c  */
#line 2919 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 723:
/* Line 1792 of yacc.c  */
#line 2920 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 724:
/* Line 1792 of yacc.c  */
#line 2921 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 725:
/* Line 1792 of yacc.c  */
#line 2922 "cf-parse.y"
    { OSPF_PATT->link_lsa_suppression = (yyvsp[(4) - (4)].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 2924 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
    break;

  case 728:
/* Line 1792 of yacc.c  */
#line 2925 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
    break;

  case 729:
/* Line 1792 of yacc.c  */
#line 2926 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 2927 "cf-parse.y"
    { OSPF_PATT->rx_buffer = 0; }
    break;

  case 731:
/* Line 1792 of yacc.c  */
#line 2928 "cf-parse.y"
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
    break;

  case 732:
/* Line 1792 of yacc.c  */
#line 2929 "cf-parse.y"
    { OSPF_PATT->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 2930 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 2931 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 735:
/* Line 1792 of yacc.c  */
#line 2932 "cf-parse.y"
    { OSPF_PATT->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 736:
/* Line 1792 of yacc.c  */
#line 2933 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 737:
/* Line 1792 of yacc.c  */
#line 2934 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 2935 "cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 2936 "cf-parse.y"
    { OSPF_PATT->bsd_secondary = (yyvsp[(2) - (2)].i); }
    break;

  case 740:
/* Line 1792 of yacc.c  */
#line 2937 "cf-parse.y"
    { ospf_check_auth(); }
    break;

  case 744:
/* Line 1792 of yacc.c  */
#line 2948 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 746:
/* Line 1792 of yacc.c  */
#line 2958 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 747:
/* Line 1792 of yacc.c  */
#line 2959 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 2968 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 751:
/* Line 1792 of yacc.c  */
#line 2969 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 752:
/* Line 1792 of yacc.c  */
#line 2973 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 753:
/* Line 1792 of yacc.c  */
#line 2982 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 3005 "cf-parse.y"
    { OSPF_PATT->instance_id = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Instance ID must be in range 0-255"); }
    break;

  case 756:
/* Line 1792 of yacc.c  */
#line 3009 "cf-parse.y"
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 3023 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 763:
/* Line 1792 of yacc.c  */
#line 3029 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 764:
/* Line 1792 of yacc.c  */
#line 3032 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 765:
/* Line 1792 of yacc.c  */
#line 3035 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 766:
/* Line 1792 of yacc.c  */
#line 3040 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 767:
/* Line 1792 of yacc.c  */
#line 3043 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 768:
/* Line 1792 of yacc.c  */
#line 3048 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 769:
/* Line 1792 of yacc.c  */
#line 3051 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 770:
/* Line 1792 of yacc.c  */
#line 3055 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 771:
/* Line 1792 of yacc.c  */
#line 3058 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 772:
/* Line 1792 of yacc.c  */
#line 3061 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 773:
/* Line 1792 of yacc.c  */
#line 3062 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 774:
/* Line 1792 of yacc.c  */
#line 3063 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 775:
/* Line 1792 of yacc.c  */
#line 3064 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 776:
/* Line 1792 of yacc.c  */
#line 3065 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 777:
/* Line 1792 of yacc.c  */
#line 3066 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 778:
/* Line 1792 of yacc.c  */
#line 3067 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 779:
/* Line 1792 of yacc.c  */
#line 3068 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 780:
/* Line 1792 of yacc.c  */
#line 3074 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 783:
/* Line 1792 of yacc.c  */
#line 3083 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 784:
/* Line 1792 of yacc.c  */
#line 3088 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 785:
/* Line 1792 of yacc.c  */
#line 3089 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 786:
/* Line 1792 of yacc.c  */
#line 3096 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[(1) - (2)].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
    break;

  case 789:
/* Line 1792 of yacc.c  */
#line 3107 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
    break;

  case 790:
/* Line 1792 of yacc.c  */
#line 3108 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 791:
/* Line 1792 of yacc.c  */
#line 3108 "cf-parse.y"
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
    break;

  case 792:
/* Line 1792 of yacc.c  */
#line 3109 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 793:
/* Line 1792 of yacc.c  */
#line 3109 "cf-parse.y"
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
    break;

  case 794:
/* Line 1792 of yacc.c  */
#line 3110 "cf-parse.y"
    {
     RADV_CFG->trigger_prefix = (yyvsp[(2) - (2)].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[(2) - (2)].px).len;
     RADV_CFG->trigger_valid = 1;
   }
    break;

  case 795:
/* Line 1792 of yacc.c  */
#line 3115 "cf-parse.y"
    { RADV_CFG->propagate_routes = (yyvsp[(3) - (3)].i); }
    break;

  case 799:
/* Line 1792 of yacc.c  */
#line 3128 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = -1;
  RADV_IFACE->route_linger_time = -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
}
    break;

  case 800:
/* Line 1792 of yacc.c  */
#line 3151 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); }
    break;

  case 801:
/* Line 1792 of yacc.c  */
#line 3152 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
    break;

  case 802:
/* Line 1792 of yacc.c  */
#line 3153 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); }
    break;

  case 803:
/* Line 1792 of yacc.c  */
#line 3154 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); }
    break;

  case 804:
/* Line 1792 of yacc.c  */
#line 3155 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); }
    break;

  case 805:
/* Line 1792 of yacc.c  */
#line 3156 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); }
    break;

  case 806:
/* Line 1792 of yacc.c  */
#line 3157 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
    break;

  case 807:
/* Line 1792 of yacc.c  */
#line 3158 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
    break;

  case 808:
/* Line 1792 of yacc.c  */
#line 3159 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
    break;

  case 809:
/* Line 1792 of yacc.c  */
#line 3160 "cf-parse.y"
    {
     RADV_IFACE->default_lifetime = (yyvsp[(3) - (4)].i);
     if (((yyvsp[(3) - (4)].i) < 0) || ((yyvsp[(3) - (4)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 810:
/* Line 1792 of yacc.c  */
#line 3165 "cf-parse.y"
    {
     RADV_IFACE->route_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(4) - (4)].i) != -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 811:
/* Line 1792 of yacc.c  */
#line 3169 "cf-parse.y"
    { RADV_IFACE->default_preference = (yyvsp[(3) - (3)].i); }
    break;

  case 812:
/* Line 1792 of yacc.c  */
#line 3170 "cf-parse.y"
    { RADV_IFACE->route_preference = (yyvsp[(3) - (3)].i); }
    break;

  case 813:
/* Line 1792 of yacc.c  */
#line 3171 "cf-parse.y"
    { RADV_IFACE->prefix_linger_time = (yyvsp[(4) - (4)].i); }
    break;

  case 814:
/* Line 1792 of yacc.c  */
#line 3172 "cf-parse.y"
    { RADV_IFACE->route_linger_time = (yyvsp[(4) - (4)].i); }
    break;

  case 815:
/* Line 1792 of yacc.c  */
#line 3173 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
    break;

  case 816:
/* Line 1792 of yacc.c  */
#line 3174 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 817:
/* Line 1792 of yacc.c  */
#line 3174 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
    break;

  case 818:
/* Line 1792 of yacc.c  */
#line 3175 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 819:
/* Line 1792 of yacc.c  */
#line 3175 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
    break;

  case 820:
/* Line 1792 of yacc.c  */
#line 3176 "cf-parse.y"
    { RADV_IFACE->rdnss_local = (yyvsp[(3) - (3)].i); }
    break;

  case 821:
/* Line 1792 of yacc.c  */
#line 3177 "cf-parse.y"
    { RADV_IFACE->dnssl_local = (yyvsp[(3) - (3)].i); }
    break;

  case 822:
/* Line 1792 of yacc.c  */
#line 3181 "cf-parse.y"
    { (yyval.i) = RA_PREF_LOW; }
    break;

  case 823:
/* Line 1792 of yacc.c  */
#line 3182 "cf-parse.y"
    { (yyval.i) = RA_PREF_MEDIUM; }
    break;

  case 824:
/* Line 1792 of yacc.c  */
#line 3183 "cf-parse.y"
    { (yyval.i) = RA_PREF_HIGH; }
    break;

  case 825:
/* Line 1792 of yacc.c  */
#line 3186 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
}
    break;

  case 831:
/* Line 1792 of yacc.c  */
#line 3239 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
    break;

  case 832:
/* Line 1792 of yacc.c  */
#line 3251 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); }
    break;

  case 833:
/* Line 1792 of yacc.c  */
#line 3252 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); }
    break;

  case 834:
/* Line 1792 of yacc.c  */
#line 3253 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); }
    break;

  case 835:
/* Line 1792 of yacc.c  */
#line 3254 "cf-parse.y"
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 836:
/* Line 1792 of yacc.c  */
#line 3258 "cf-parse.y"
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 837:
/* Line 1792 of yacc.c  */
#line 3265 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
    break;

  case 843:
/* Line 1792 of yacc.c  */
#line 3289 "cf-parse.y"
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[(1) - (1)].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 844:
/* Line 1792 of yacc.c  */
#line 3298 "cf-parse.y"
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 847:
/* Line 1792 of yacc.c  */
#line 3305 "cf-parse.y"
    { RADV_RDNSS->lifetime = (yyvsp[(2) - (2)].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
    break;

  case 848:
/* Line 1792 of yacc.c  */
#line 3309 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
    break;

  case 853:
/* Line 1792 of yacc.c  */
#line 3333 "cf-parse.y"
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[(1) - (1)].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
    break;

  case 854:
/* Line 1792 of yacc.c  */
#line 3345 "cf-parse.y"
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 857:
/* Line 1792 of yacc.c  */
#line 3352 "cf-parse.y"
    { RADV_DNSSL->lifetime = (yyvsp[(2) - (2)].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
    break;

  case 858:
/* Line 1792 of yacc.c  */
#line 3356 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
    break;

  case 863:
/* Line 1792 of yacc.c  */
#line 3380 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); radv_mult_val = 0; }
    break;

  case 864:
/* Line 1792 of yacc.c  */
#line 3381 "cf-parse.y"
    { (yyval.i) = 0; radv_mult_val = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
    break;

  case 865:
/* Line 1792 of yacc.c  */
#line 3385 "cf-parse.y"
    { (yyval.i) = -1; }
    break;

  case 866:
/* Line 1792 of yacc.c  */
#line 3386 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 867:
/* Line 1792 of yacc.c  */
#line 3394 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[(1) - (2)].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
    break;

  case 869:
/* Line 1792 of yacc.c  */
#line 3407 "cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (2)].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 870:
/* Line 1792 of yacc.c  */
#line 3408 "cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 871:
/* Line 1792 of yacc.c  */
#line 3409 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(2) - (2)].i); }
    break;

  case 876:
/* Line 1792 of yacc.c  */
#line 3423 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
    break;

  case 877:
/* Line 1792 of yacc.c  */
#line 3446 "cf-parse.y"
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
    break;

  case 878:
/* Line 1792 of yacc.c  */
#line 3476 "cf-parse.y"
    { RIP_IFACE->metric = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Metric must be in range 1-255"); }
    break;

  case 879:
/* Line 1792 of yacc.c  */
#line 3477 "cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
    break;

  case 880:
/* Line 1792 of yacc.c  */
#line 3478 "cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
    break;

  case 881:
/* Line 1792 of yacc.c  */
#line 3479 "cf-parse.y"
    { RIP_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 882:
/* Line 1792 of yacc.c  */
#line 3480 "cf-parse.y"
    { RIP_IFACE->address = (yyvsp[(2) - (2)].a); }
    break;

  case 883:
/* Line 1792 of yacc.c  */
#line 3481 "cf-parse.y"
    { RIP_IFACE->port = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid port number"); }
    break;

  case 884:
/* Line 1792 of yacc.c  */
#line 3482 "cf-parse.y"
    { RIP_IFACE->version = (yyvsp[(2) - (2)].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[(2) - (2)].i) != RIP_V1) && ((yyvsp[(2) - (2)].i) != RIP_V2)) cf_error("Unsupported version");
			}
    break;

  case 885:
/* Line 1792 of yacc.c  */
#line 3486 "cf-parse.y"
    { RIP_IFACE->version_only = (yyvsp[(3) - (3)].i); }
    break;

  case 886:
/* Line 1792 of yacc.c  */
#line 3487 "cf-parse.y"
    { RIP_IFACE->split_horizon = (yyvsp[(3) - (3)].i); }
    break;

  case 887:
/* Line 1792 of yacc.c  */
#line 3488 "cf-parse.y"
    { RIP_IFACE->poison_reverse = (yyvsp[(3) - (3)].i); }
    break;

  case 888:
/* Line 1792 of yacc.c  */
#line 3489 "cf-parse.y"
    { RIP_IFACE->check_zero = (yyvsp[(3) - (3)].i); }
    break;

  case 889:
/* Line 1792 of yacc.c  */
#line 3490 "cf-parse.y"
    { RIP_IFACE->update_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Update time must be positive"); }
    break;

  case 890:
/* Line 1792 of yacc.c  */
#line 3491 "cf-parse.y"
    { RIP_IFACE->timeout_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Timeout time must be positive"); }
    break;

  case 891:
/* Line 1792 of yacc.c  */
#line 3492 "cf-parse.y"
    { RIP_IFACE->garbage_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Garbage time must be positive"); }
    break;

  case 892:
/* Line 1792 of yacc.c  */
#line 3493 "cf-parse.y"
    { RIP_IFACE->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 893:
/* Line 1792 of yacc.c  */
#line 3494 "cf-parse.y"
    { RIP_IFACE->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("RX length must be in range 256-65535"); }
    break;

  case 894:
/* Line 1792 of yacc.c  */
#line 3495 "cf-parse.y"
    { RIP_IFACE->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 895:
/* Line 1792 of yacc.c  */
#line 3496 "cf-parse.y"
    { RIP_IFACE->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 896:
/* Line 1792 of yacc.c  */
#line 3497 "cf-parse.y"
    { RIP_IFACE->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 897:
/* Line 1792 of yacc.c  */
#line 3498 "cf-parse.y"
    { RIP_IFACE->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 898:
/* Line 1792 of yacc.c  */
#line 3499 "cf-parse.y"
    { RIP_IFACE->ttl_security = 2; }
    break;

  case 899:
/* Line 1792 of yacc.c  */
#line 3500 "cf-parse.y"
    { RIP_IFACE->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 900:
/* Line 1792 of yacc.c  */
#line 3501 "cf-parse.y"
    { RIP_IFACE->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 901:
/* Line 1792 of yacc.c  */
#line 3502 "cf-parse.y"
    { RIP_IFACE->auth_type = (yyvsp[(2) - (2)].i); if ((yyvsp[(2) - (2)].i)) rip_check_auth(); }
    break;

  case 902:
/* Line 1792 of yacc.c  */
#line 3503 "cf-parse.y"
    { rip_check_auth(); }
    break;

  case 903:
/* Line 1792 of yacc.c  */
#line 3507 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_NONE; }
    break;

  case 904:
/* Line 1792 of yacc.c  */
#line 3508 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_PLAIN; }
    break;

  case 905:
/* Line 1792 of yacc.c  */
#line 3509 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; }
    break;

  case 906:
/* Line 1792 of yacc.c  */
#line 3510 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; }
    break;

  case 912:
/* Line 1792 of yacc.c  */
#line 3531 "cf-parse.y"
    { rip_show_interfaces(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); }
    break;

  case 913:
/* Line 1792 of yacc.c  */
#line 3534 "cf-parse.y"
    { rip_show_neighbors(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); }
    break;

  case 914:
/* Line 1792 of yacc.c  */
#line 3540 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 917:
/* Line 1792 of yacc.c  */
#line 3549 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 918:
/* Line 1792 of yacc.c  */
#line 3550 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 919:
/* Line 1792 of yacc.c  */
#line 3551 "cf-parse.y"
    { static_route_finish(); }
    break;

  case 920:
/* Line 1792 of yacc.c  */
#line 3554 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
    break;

  case 921:
/* Line 1792 of yacc.c  */
#line 3564 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
    break;

  case 922:
/* Line 1792 of yacc.c  */
#line 3573 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 923:
/* Line 1792 of yacc.c  */
#line 3577 "cf-parse.y"
    {
     this_srt_nh->use_bfd = (yyvsp[(3) - (3)].i); cf_check_bfd((yyvsp[(3) - (3)].i));
   }
    break;

  case 924:
/* Line 1792 of yacc.c  */
#line 3583 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 925:
/* Line 1792 of yacc.c  */
#line 3584 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 926:
/* Line 1792 of yacc.c  */
#line 3588 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 927:
/* Line 1792 of yacc.c  */
#line 3593 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 928:
/* Line 1792 of yacc.c  */
#line 3599 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 929:
/* Line 1792 of yacc.c  */
#line 3602 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 930:
/* Line 1792 of yacc.c  */
#line 3607 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 931:
/* Line 1792 of yacc.c  */
#line 3608 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 932:
/* Line 1792 of yacc.c  */
#line 3609 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 933:
/* Line 1792 of yacc.c  */
#line 3610 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 934:
/* Line 1792 of yacc.c  */
#line 3611 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 935:
/* Line 1792 of yacc.c  */
#line 3615 "cf-parse.y"
    { *this_srt_last_cmd = (yyvsp[(1) - (1)].x); this_srt_last_cmd = &((yyvsp[(1) - (1)].x)->next); }
    break;

  case 936:
/* Line 1792 of yacc.c  */
#line 3616 "cf-parse.y"
    { this_srt->use_bfd = (yyvsp[(2) - (3)].i); cf_check_bfd((yyvsp[(2) - (3)].i)); }
    break;

  case 941:
/* Line 1792 of yacc.c  */
#line 3631 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 942:
/* Line 1792 of yacc.c  */
#line 3637 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_babel, (yyvsp[(1) - (2)].i));
  init_list(&BABEL_CFG->iface_list);
}
    break;

  case 948:
/* Line 1792 of yacc.c  */
#line 3657 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
    break;

  case 949:
/* Line 1792 of yacc.c  */
#line 3670 "cf-parse.y"
    {
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
}
    break;

  case 951:
/* Line 1792 of yacc.c  */
#line 3694 "cf-parse.y"
    { BABEL_IFACE->port = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid port number"); }
    break;

  case 952:
/* Line 1792 of yacc.c  */
#line 3695 "cf-parse.y"
    { BABEL_IFACE->rxcost = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid rxcost"); }
    break;

  case 953:
/* Line 1792 of yacc.c  */
#line 3696 "cf-parse.y"
    { BABEL_IFACE->hello_interval = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid hello interval"); }
    break;

  case 954:
/* Line 1792 of yacc.c  */
#line 3697 "cf-parse.y"
    { BABEL_IFACE->update_interval = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid update interval"); }
    break;

  case 955:
/* Line 1792 of yacc.c  */
#line 3698 "cf-parse.y"
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
    break;

  case 956:
/* Line 1792 of yacc.c  */
#line 3699 "cf-parse.y"
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
    break;

  case 957:
/* Line 1792 of yacc.c  */
#line 3700 "cf-parse.y"
    { BABEL_IFACE->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
    break;

  case 958:
/* Line 1792 of yacc.c  */
#line 3701 "cf-parse.y"
    { BABEL_IFACE->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 959:
/* Line 1792 of yacc.c  */
#line 3702 "cf-parse.y"
    { BABEL_IFACE->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 960:
/* Line 1792 of yacc.c  */
#line 3703 "cf-parse.y"
    { BABEL_IFACE->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 961:
/* Line 1792 of yacc.c  */
#line 3704 "cf-parse.y"
    { BABEL_IFACE->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 967:
/* Line 1792 of yacc.c  */
#line 3725 "cf-parse.y"
    { babel_show_interfaces(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel), (yyvsp[(5) - (6)].t)); }
    break;

  case 968:
/* Line 1792 of yacc.c  */
#line 3728 "cf-parse.y"
    { babel_show_neighbors(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel), (yyvsp[(5) - (6)].t)); }
    break;

  case 969:
/* Line 1792 of yacc.c  */
#line 3731 "cf-parse.y"
    { babel_show_entries(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel)); }
    break;

  case 1043:
/* Line 1792 of yacc.c  */
#line 3739 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 1045:
/* Line 1792 of yacc.c  */
#line 3739 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 1058:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 1059:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 1060:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 1061:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 1062:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
    break;

  case 1063:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
    break;

  case 1064:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
    break;

  case 1065:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
    break;

  case 1066:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
    break;

  case 1067:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
    break;

  case 1068:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
    break;

  case 1069:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
    break;

  case 1070:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
    break;

  case 1071:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
    break;

  case 1072:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
    break;

  case 1073:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
    break;

  case 1074:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
    break;

  case 1075:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
    break;

  case 1076:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
    break;

  case 1077:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
    break;

  case 1078:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
    break;

  case 1079:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
    break;

  case 1080:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
    break;

  case 1081:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
    break;

  case 1082:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
    break;

  case 1083:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
    break;

  case 1084:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
    break;

  case 1085:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
    break;

  case 1086:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
    break;

  case 1087:
/* Line 1792 of yacc.c  */
#line 3742 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
    break;

  case 1088:
/* Line 1792 of yacc.c  */
#line 3743 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 1089:
/* Line 1792 of yacc.c  */
#line 3743 "cf-parse.y"
    { (yyval.fda) = (struct f_dynamic_attr) {}; }
    break;

  case 1090:
/* Line 1792 of yacc.c  */
#line 3744 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 1091:
/* Line 1792 of yacc.c  */
#line 3745 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 1092:
/* Line 1792 of yacc.c  */
#line 3746 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 1093:
/* Line 1792 of yacc.c  */
#line 3747 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 1094:
/* Line 1792 of yacc.c  */
#line 3748 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 1095:
/* Line 1792 of yacc.c  */
#line 3749 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 1096:
/* Line 1792 of yacc.c  */
#line 3750 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 1097:
/* Line 1792 of yacc.c  */
#line 3751 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 1098:
/* Line 1792 of yacc.c  */
#line 3752 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 1099:
/* Line 1792 of yacc.c  */
#line 3753 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 1100:
/* Line 1792 of yacc.c  */
#line 3754 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 1101:
/* Line 1792 of yacc.c  */
#line 3755 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
    break;

  case 1102:
/* Line 1792 of yacc.c  */
#line 3755 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 1103:
/* Line 1792 of yacc.c  */
#line 3755 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 1104:
/* Line 1792 of yacc.c  */
#line 3755 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 1105:
/* Line 1792 of yacc.c  */
#line 3755 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 1106:
/* Line 1792 of yacc.c  */
#line 3755 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); }
    break;

  case 1107:
/* Line 1792 of yacc.c  */
#line 3755 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); }
    break;

  case 1108:
/* Line 1792 of yacc.c  */
#line 3755 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 1109:
/* Line 1792 of yacc.c  */
#line 3755 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;

  case 1110:
/* Line 1792 of yacc.c  */
#line 3755 "cf-parse.y"
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_BABEL_METRIC); }
    break;


/* Line 1792 of yacc.c  */
#line 11111 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3757 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/mrt/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

/* C Code from ../../proto/babel/config.Y */

